/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*116 cases */, 44|128,9/*1196*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1201
/*     5*/  OPC_Scope, 32|128,9/*1184*/, /*->1192*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0, 
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0, 
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0, 
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0, 
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0, 
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0, 
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0, 
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0, 
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0, 
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0, 
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0, 
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0, 
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0, 
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0, 
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0, 
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0, 
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0, 
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0, 
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0, 
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0, 
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0, 
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0, 
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0, 
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0, 
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0, 
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0, 
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0, 
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0, 
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0, 
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0, 
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0, 
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0, 
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0, 
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0, 
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0, 
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0, 
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0, 
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0, 
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0, 
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0, 
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 121, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1191
/*  1070*/    OPC_RecordMemRef,
/*  1071*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1072*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1073*/    OPC_Scope, 57, /*->1132*/ // 2 children in Scope
/*  1075*/     OPC_CheckChild1TypeI32,
/*  1076*/     OPC_Scope, 17, /*->1095*/ // 3 children in Scope
/*  1078*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1079*/      OPC_MoveParent,
/*  1080*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1083*/      OPC_EmitMergeInputChains1_0,
/*  1084*/      OPC_EmitInteger32, 0, 
/*  1086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1095*/     /*Scope*/ 17, /*->1113*/
/*  1096*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1099*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1101*/      OPC_EmitMergeInputChains1_0,
/*  1102*/      OPC_EmitInteger32, 0, 
/*  1104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1113*/     /*Scope*/ 17, /*->1131*/
/*  1114*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1117*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1119*/      OPC_EmitMergeInputChains1_0,
/*  1120*/      OPC_EmitInteger32, 0, 
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1131*/     0, /*End of Scope*/
/*  1132*/    /*Scope*/ 57, /*->1190*/
/*  1133*/     OPC_CheckChild1TypeI64,
/*  1134*/     OPC_Scope, 17, /*->1153*/ // 3 children in Scope
/*  1136*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1139*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1141*/      OPC_EmitMergeInputChains1_0,
/*  1142*/      OPC_EmitInteger32, 0, 
/*  1144*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1153*/     /*Scope*/ 17, /*->1171*/
/*  1154*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1155*/      OPC_MoveParent,
/*  1156*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1157*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1159*/      OPC_EmitMergeInputChains1_0,
/*  1160*/      OPC_EmitInteger32, 0, 
/*  1162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1171*/     /*Scope*/ 17, /*->1189*/
/*  1172*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1175*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1177*/      OPC_EmitMergeInputChains1_0,
/*  1178*/      OPC_EmitInteger32, 0, 
/*  1180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1189*/     0, /*End of Scope*/
/*  1190*/    0, /*End of Scope*/
/*  1191*/   0, // EndSwitchOpcode
/*  1192*/  /*Scope*/ 7, /*->1200*/
/*  1193*/   OPC_RecordChild0, // #0 = $src
/*  1194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1200*/  0, /*End of Scope*/
/*  1201*/ /*SwitchOpcode*/ 86|128,6/*854*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2059
/*  1205*/  OPC_Scope, 74|128,6/*842*/, /*->2050*/ // 2 children in Scope
/*  1208*/   OPC_MoveChild0,
/*  1209*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1337
/*  1213*/    OPC_MoveChild0,
/*  1214*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1217*/    OPC_RecordMemRef,
/*  1218*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1219*/    OPC_CheckFoldableChainNode,
/*  1220*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1221*/    OPC_Scope, 56, /*->1279*/ // 2 children in Scope
/*  1223*/     OPC_CheckChild1TypeI32,
/*  1224*/     OPC_MoveChild2,
/*  1225*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1228*/     OPC_RecordChild0, // #2 = $exp
/*  1229*/     OPC_MoveSibling3,
/*  1230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1233*/     OPC_RecordChild0, // #3 = $new
/*  1234*/     OPC_MoveParent,
/*  1235*/     OPC_Scope, 20, /*->1257*/ // 2 children in Scope
/*  1237*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1238*/      OPC_MoveParent,
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1241*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger32, 0, 
/*  1246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1257*/     /*Scope*/ 20, /*->1278*/
/*  1258*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1259*/      OPC_MoveParent,
/*  1260*/      OPC_MoveParent,
/*  1261*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1262*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1264*/      OPC_EmitMergeInputChains1_0,
/*  1265*/      OPC_EmitInteger32, 0, 
/*  1267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    /*Scope*/ 56, /*->1336*/
/*  1280*/     OPC_CheckChild1TypeI64,
/*  1281*/     OPC_MoveChild2,
/*  1282*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1285*/     OPC_RecordChild0, // #2 = $exp
/*  1286*/     OPC_MoveSibling3,
/*  1287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1290*/     OPC_RecordChild0, // #3 = $new
/*  1291*/     OPC_MoveParent,
/*  1292*/     OPC_Scope, 20, /*->1314*/ // 2 children in Scope
/*  1294*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1295*/      OPC_MoveParent,
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1298*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1300*/      OPC_EmitMergeInputChains1_0,
/*  1301*/      OPC_EmitInteger32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1316*/      OPC_MoveParent,
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1319*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger32, 0, 
/*  1324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1441
/*  1340*/    OPC_RecordMemRef,
/*  1341*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1342*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1343*/    OPC_Scope, 47, /*->1392*/ // 2 children in Scope
/*  1345*/     OPC_CheckChild1TypeI32,
/*  1346*/     OPC_MoveChild2,
/*  1347*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1350*/     OPC_RecordChild0, // #2 = $val
/*  1351*/     OPC_MoveParent,
/*  1352*/     OPC_Scope, 18, /*->1372*/ // 2 children in Scope
/*  1354*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1357*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1359*/      OPC_EmitMergeInputChains1_0,
/*  1360*/      OPC_EmitInteger32, 0, 
/*  1362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1372*/     /*Scope*/ 18, /*->1391*/
/*  1373*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1374*/      OPC_MoveParent,
/*  1375*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1378*/      OPC_EmitMergeInputChains1_0,
/*  1379*/      OPC_EmitInteger32, 0, 
/*  1381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1391*/     0, /*End of Scope*/
/*  1392*/    /*Scope*/ 47, /*->1440*/
/*  1393*/     OPC_CheckChild1TypeI64,
/*  1394*/     OPC_MoveChild2,
/*  1395*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1398*/     OPC_RecordChild0, // #2 = $val
/*  1399*/     OPC_MoveParent,
/*  1400*/     OPC_Scope, 18, /*->1420*/ // 2 children in Scope
/*  1402*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1403*/      OPC_MoveParent,
/*  1404*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1405*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1407*/      OPC_EmitMergeInputChains1_0,
/*  1408*/      OPC_EmitInteger32, 0, 
/*  1410*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1420*/     /*Scope*/ 18, /*->1439*/
/*  1421*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1422*/      OPC_MoveParent,
/*  1423*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1424*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1426*/      OPC_EmitMergeInputChains1_0,
/*  1427*/      OPC_EmitInteger32, 0, 
/*  1429*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1439*/     0, /*End of Scope*/
/*  1440*/    0, /*End of Scope*/
/*  1441*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1545
/*  1444*/    OPC_RecordMemRef,
/*  1445*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1446*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1447*/    OPC_Scope, 47, /*->1496*/ // 2 children in Scope
/*  1449*/     OPC_CheckChild1TypeI32,
/*  1450*/     OPC_MoveChild2,
/*  1451*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1454*/     OPC_RecordChild0, // #2 = $val
/*  1455*/     OPC_MoveParent,
/*  1456*/     OPC_Scope, 18, /*->1476*/ // 2 children in Scope
/*  1458*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1461*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1463*/      OPC_EmitMergeInputChains1_0,
/*  1464*/      OPC_EmitInteger32, 0, 
/*  1466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1476*/     /*Scope*/ 18, /*->1495*/
/*  1477*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1478*/      OPC_MoveParent,
/*  1479*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1480*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1482*/      OPC_EmitMergeInputChains1_0,
/*  1483*/      OPC_EmitInteger32, 0, 
/*  1485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1495*/     0, /*End of Scope*/
/*  1496*/    /*Scope*/ 47, /*->1544*/
/*  1497*/     OPC_CheckChild1TypeI64,
/*  1498*/     OPC_MoveChild2,
/*  1499*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1502*/     OPC_RecordChild0, // #2 = $val
/*  1503*/     OPC_MoveParent,
/*  1504*/     OPC_Scope, 18, /*->1524*/ // 2 children in Scope
/*  1506*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1507*/      OPC_MoveParent,
/*  1508*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1509*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1511*/      OPC_EmitMergeInputChains1_0,
/*  1512*/      OPC_EmitInteger32, 0, 
/*  1514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1524*/     /*Scope*/ 18, /*->1543*/
/*  1525*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1530*/      OPC_EmitMergeInputChains1_0,
/*  1531*/      OPC_EmitInteger32, 0, 
/*  1533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1543*/     0, /*End of Scope*/
/*  1544*/    0, /*End of Scope*/
/*  1545*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1649
/*  1548*/    OPC_RecordMemRef,
/*  1549*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1550*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1551*/    OPC_Scope, 47, /*->1600*/ // 2 children in Scope
/*  1553*/     OPC_CheckChild1TypeI32,
/*  1554*/     OPC_MoveChild2,
/*  1555*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1558*/     OPC_RecordChild0, // #2 = $val
/*  1559*/     OPC_MoveParent,
/*  1560*/     OPC_Scope, 18, /*->1580*/ // 2 children in Scope
/*  1562*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1563*/      OPC_MoveParent,
/*  1564*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1565*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1567*/      OPC_EmitMergeInputChains1_0,
/*  1568*/      OPC_EmitInteger32, 0, 
/*  1570*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1580*/     /*Scope*/ 18, /*->1599*/
/*  1581*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1582*/      OPC_MoveParent,
/*  1583*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1584*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1586*/      OPC_EmitMergeInputChains1_0,
/*  1587*/      OPC_EmitInteger32, 0, 
/*  1589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1599*/     0, /*End of Scope*/
/*  1600*/    /*Scope*/ 47, /*->1648*/
/*  1601*/     OPC_CheckChild1TypeI64,
/*  1602*/     OPC_MoveChild2,
/*  1603*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/     OPC_RecordChild0, // #2 = $val
/*  1607*/     OPC_MoveParent,
/*  1608*/     OPC_Scope, 18, /*->1628*/ // 2 children in Scope
/*  1610*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1613*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1615*/      OPC_EmitMergeInputChains1_0,
/*  1616*/      OPC_EmitInteger32, 0, 
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1628*/     /*Scope*/ 18, /*->1647*/
/*  1629*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1630*/      OPC_MoveParent,
/*  1631*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1632*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1634*/      OPC_EmitMergeInputChains1_0,
/*  1635*/      OPC_EmitInteger32, 0, 
/*  1637*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1647*/     0, /*End of Scope*/
/*  1648*/    0, /*End of Scope*/
/*  1649*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1753
/*  1652*/    OPC_RecordMemRef,
/*  1653*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1654*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1655*/    OPC_Scope, 47, /*->1704*/ // 2 children in Scope
/*  1657*/     OPC_CheckChild1TypeI32,
/*  1658*/     OPC_MoveChild2,
/*  1659*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1662*/     OPC_RecordChild0, // #2 = $val
/*  1663*/     OPC_MoveParent,
/*  1664*/     OPC_Scope, 18, /*->1684*/ // 2 children in Scope
/*  1666*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1669*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1671*/      OPC_EmitMergeInputChains1_0,
/*  1672*/      OPC_EmitInteger32, 0, 
/*  1674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1684*/     /*Scope*/ 18, /*->1703*/
/*  1685*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1686*/      OPC_MoveParent,
/*  1687*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1690*/      OPC_EmitMergeInputChains1_0,
/*  1691*/      OPC_EmitInteger32, 0, 
/*  1693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1703*/     0, /*End of Scope*/
/*  1704*/    /*Scope*/ 47, /*->1752*/
/*  1705*/     OPC_CheckChild1TypeI64,
/*  1706*/     OPC_MoveChild2,
/*  1707*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1710*/     OPC_RecordChild0, // #2 = $val
/*  1711*/     OPC_MoveParent,
/*  1712*/     OPC_Scope, 18, /*->1732*/ // 2 children in Scope
/*  1714*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1715*/      OPC_MoveParent,
/*  1716*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1717*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1719*/      OPC_EmitMergeInputChains1_0,
/*  1720*/      OPC_EmitInteger32, 0, 
/*  1722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1732*/     /*Scope*/ 18, /*->1751*/
/*  1733*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1736*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1738*/      OPC_EmitMergeInputChains1_0,
/*  1739*/      OPC_EmitInteger32, 0, 
/*  1741*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1751*/     0, /*End of Scope*/
/*  1752*/    0, /*End of Scope*/
/*  1753*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1857
/*  1756*/    OPC_RecordMemRef,
/*  1757*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1758*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1759*/    OPC_Scope, 47, /*->1808*/ // 2 children in Scope
/*  1761*/     OPC_CheckChild1TypeI32,
/*  1762*/     OPC_MoveChild2,
/*  1763*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1766*/     OPC_RecordChild0, // #2 = $val
/*  1767*/     OPC_MoveParent,
/*  1768*/     OPC_Scope, 18, /*->1788*/ // 2 children in Scope
/*  1770*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1771*/      OPC_MoveParent,
/*  1772*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0, 
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     /*Scope*/ 18, /*->1807*/
/*  1789*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1790*/      OPC_MoveParent,
/*  1791*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1792*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1794*/      OPC_EmitMergeInputChains1_0,
/*  1795*/      OPC_EmitInteger32, 0, 
/*  1797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1807*/     0, /*End of Scope*/
/*  1808*/    /*Scope*/ 47, /*->1856*/
/*  1809*/     OPC_CheckChild1TypeI64,
/*  1810*/     OPC_MoveChild2,
/*  1811*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1814*/     OPC_RecordChild0, // #2 = $val
/*  1815*/     OPC_MoveParent,
/*  1816*/     OPC_Scope, 18, /*->1836*/ // 2 children in Scope
/*  1818*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1819*/      OPC_MoveParent,
/*  1820*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1823*/      OPC_EmitMergeInputChains1_0,
/*  1824*/      OPC_EmitInteger32, 0, 
/*  1826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1836*/     /*Scope*/ 18, /*->1855*/
/*  1837*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1838*/      OPC_MoveParent,
/*  1839*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1840*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1842*/      OPC_EmitMergeInputChains1_0,
/*  1843*/      OPC_EmitInteger32, 0, 
/*  1845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1855*/     0, /*End of Scope*/
/*  1856*/    0, /*End of Scope*/
/*  1857*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1961
/*  1860*/    OPC_RecordMemRef,
/*  1861*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1862*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1863*/    OPC_Scope, 47, /*->1912*/ // 2 children in Scope
/*  1865*/     OPC_CheckChild1TypeI32,
/*  1866*/     OPC_MoveChild2,
/*  1867*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1870*/     OPC_RecordChild0, // #2 = $val
/*  1871*/     OPC_MoveParent,
/*  1872*/     OPC_Scope, 18, /*->1892*/ // 2 children in Scope
/*  1874*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1875*/      OPC_MoveParent,
/*  1876*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1877*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1879*/      OPC_EmitMergeInputChains1_0,
/*  1880*/      OPC_EmitInteger32, 0, 
/*  1882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1892*/     /*Scope*/ 18, /*->1911*/
/*  1893*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1894*/      OPC_MoveParent,
/*  1895*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1896*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1898*/      OPC_EmitMergeInputChains1_0,
/*  1899*/      OPC_EmitInteger32, 0, 
/*  1901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1911*/     0, /*End of Scope*/
/*  1912*/    /*Scope*/ 47, /*->1960*/
/*  1913*/     OPC_CheckChild1TypeI64,
/*  1914*/     OPC_MoveChild2,
/*  1915*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1918*/     OPC_RecordChild0, // #2 = $val
/*  1919*/     OPC_MoveParent,
/*  1920*/     OPC_Scope, 18, /*->1940*/ // 2 children in Scope
/*  1922*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1923*/      OPC_MoveParent,
/*  1924*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1925*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1927*/      OPC_EmitMergeInputChains1_0,
/*  1928*/      OPC_EmitInteger32, 0, 
/*  1930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1940*/     /*Scope*/ 18, /*->1959*/
/*  1941*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1942*/      OPC_MoveParent,
/*  1943*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1946*/      OPC_EmitMergeInputChains1_0,
/*  1947*/      OPC_EmitInteger32, 0, 
/*  1949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1959*/     0, /*End of Scope*/
/*  1960*/    0, /*End of Scope*/
/*  1961*/   /*SwitchOpcode*/ 85, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2049
/*  1964*/    OPC_RecordMemRef,
/*  1965*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1966*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1967*/    OPC_Scope, 39, /*->2008*/ // 2 children in Scope
/*  1969*/     OPC_CheckChild1TypeI32,
/*  1970*/     OPC_Scope, 17, /*->1989*/ // 2 children in Scope
/*  1972*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1975*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger32, 0, 
/*  1980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1989*/     /*Scope*/ 17, /*->2007*/
/*  1990*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1991*/      OPC_MoveParent,
/*  1992*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1993*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1995*/      OPC_EmitMergeInputChains1_0,
/*  1996*/      OPC_EmitInteger32, 0, 
/*  1998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2007*/     0, /*End of Scope*/
/*  2008*/    /*Scope*/ 39, /*->2048*/
/*  2009*/     OPC_CheckChild1TypeI64,
/*  2010*/     OPC_Scope, 17, /*->2029*/ // 2 children in Scope
/*  2012*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  2013*/      OPC_MoveParent,
/*  2014*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2015*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2017*/      OPC_EmitMergeInputChains1_0,
/*  2018*/      OPC_EmitInteger32, 0, 
/*  2020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2029*/     /*Scope*/ 17, /*->2047*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0, 
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2047*/     0, /*End of Scope*/
/*  2048*/    0, /*End of Scope*/
/*  2049*/   0, // EndSwitchOpcode
/*  2050*/  /*Scope*/ 7, /*->2058*/
/*  2051*/   OPC_RecordChild0, // #0 = $src
/*  2052*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2058*/  0, /*End of Scope*/
/*  2059*/ /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::STORE),// ->2981
/*  2063*/  OPC_RecordMemRef,
/*  2064*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2065*/  OPC_Scope, 127|128,1/*255*/, /*->2323*/ // 2 children in Scope
/*  2068*/   OPC_MoveChild1,
/*  2069*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2072*/   OPC_RecordChild0, // #1 = $vec
/*  2073*/   OPC_Scope, 64, /*->2139*/ // 4 children in Scope
/*  2075*/    OPC_CheckChild0Type, MVT::v16i8,
/*  2077*/    OPC_RecordChild1, // #2 = $idx
/*  2078*/    OPC_MoveChild1,
/*  2079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2082*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/*  2084*/    OPC_CheckTypeI32,
/*  2085*/    OPC_MoveParent,
/*  2086*/    OPC_CheckTypeI32,
/*  2087*/    OPC_MoveParent,
/*  2088*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2089*/    OPC_Scope, 23, /*->2114*/ // 2 children in Scope
/*  2091*/     OPC_CheckChild2TypeI32,
/*  2092*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2093*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2095*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2097*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2098*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2100*/     OPC_EmitMergeInputChains1_0,
/*  2101*/     OPC_EmitInteger32, 0, 
/*  2103*/     OPC_EmitConvertToTarget2,
/*  2104*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2114*/    /*Scope*/ 23, /*->2138*/
/*  2115*/     OPC_CheckChild2TypeI64,
/*  2116*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2117*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2119*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2121*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2122*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2124*/     OPC_EmitMergeInputChains1_0,
/*  2125*/     OPC_EmitInteger32, 0, 
/*  2127*/     OPC_EmitConvertToTarget2,
/*  2128*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2138*/    0, /*End of Scope*/
/*  2139*/   /*Scope*/ 64, /*->2204*/
/*  2140*/    OPC_CheckChild0Type, MVT::v8i16,
/*  2142*/    OPC_RecordChild1, // #2 = $idx
/*  2143*/    OPC_MoveChild1,
/*  2144*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2147*/    OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  2149*/    OPC_CheckTypeI32,
/*  2150*/    OPC_MoveParent,
/*  2151*/    OPC_CheckTypeI32,
/*  2152*/    OPC_MoveParent,
/*  2153*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2154*/    OPC_Scope, 23, /*->2179*/ // 2 children in Scope
/*  2156*/     OPC_CheckChild2TypeI32,
/*  2157*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2158*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2160*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2162*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2163*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2165*/     OPC_EmitMergeInputChains1_0,
/*  2166*/     OPC_EmitInteger32, 0, 
/*  2168*/     OPC_EmitConvertToTarget2,
/*  2169*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2179*/    /*Scope*/ 23, /*->2203*/
/*  2180*/     OPC_CheckChild2TypeI64,
/*  2181*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2182*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2184*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2186*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2187*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2189*/     OPC_EmitMergeInputChains1_0,
/*  2190*/     OPC_EmitInteger32, 0, 
/*  2192*/     OPC_EmitConvertToTarget2,
/*  2193*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2203*/    0, /*End of Scope*/
/*  2204*/   /*Scope*/ 58, /*->2263*/
/*  2205*/    OPC_CheckChild0Type, MVT::v4i32,
/*  2207*/    OPC_RecordChild1, // #2 = $idx
/*  2208*/    OPC_MoveChild1,
/*  2209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2212*/    OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/*  2214*/    OPC_CheckTypeI32,
/*  2215*/    OPC_MoveParent,
/*  2216*/    OPC_CheckTypeI32,
/*  2217*/    OPC_MoveParent,
/*  2218*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2219*/    OPC_Scope, 20, /*->2241*/ // 2 children in Scope
/*  2221*/     OPC_CheckChild2TypeI32,
/*  2222*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2223*/     OPC_CheckPredicate5,  // Predicate_store
/*  2224*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2225*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2227*/     OPC_EmitMergeInputChains1_0,
/*  2228*/     OPC_EmitInteger32, 0, 
/*  2230*/     OPC_EmitConvertToTarget2,
/*  2231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2241*/    /*Scope*/ 20, /*->2262*/
/*  2242*/     OPC_CheckChild2TypeI64,
/*  2243*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2244*/     OPC_CheckPredicate5,  // Predicate_store
/*  2245*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2246*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2248*/     OPC_EmitMergeInputChains1_0,
/*  2249*/     OPC_EmitInteger32, 0, 
/*  2251*/     OPC_EmitConvertToTarget2,
/*  2252*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2262*/    0, /*End of Scope*/
/*  2263*/   /*Scope*/ 58, /*->2322*/
/*  2264*/    OPC_CheckChild0Type, MVT::v2i64,
/*  2266*/    OPC_RecordChild1, // #2 = $idx
/*  2267*/    OPC_MoveChild1,
/*  2268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2271*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/*  2273*/    OPC_CheckTypeI32,
/*  2274*/    OPC_MoveParent,
/*  2275*/    OPC_CheckTypeI64,
/*  2276*/    OPC_MoveParent,
/*  2277*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2278*/    OPC_Scope, 20, /*->2300*/ // 2 children in Scope
/*  2280*/     OPC_CheckChild2TypeI32,
/*  2281*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2282*/     OPC_CheckPredicate5,  // Predicate_store
/*  2283*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2284*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2286*/     OPC_EmitMergeInputChains1_0,
/*  2287*/     OPC_EmitInteger32, 0, 
/*  2289*/     OPC_EmitConvertToTarget2,
/*  2290*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2300*/    /*Scope*/ 20, /*->2321*/
/*  2301*/     OPC_CheckChild2TypeI64,
/*  2302*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2303*/     OPC_CheckPredicate5,  // Predicate_store
/*  2304*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2305*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2307*/     OPC_EmitMergeInputChains1_0,
/*  2308*/     OPC_EmitInteger32, 0, 
/*  2310*/     OPC_EmitConvertToTarget2,
/*  2311*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2321*/    0, /*End of Scope*/
/*  2322*/   0, /*End of Scope*/
/*  2323*/  /*Scope*/ 15|128,5/*655*/, /*->2980*/
/*  2325*/   OPC_RecordChild1, // #1 = $val
/*  2326*/   OPC_Scope, 2|128,1/*130*/, /*->2459*/ // 10 children in Scope
/*  2329*/    OPC_CheckChild1TypeI32,
/*  2330*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2331*/    OPC_Scope, 62, /*->2395*/ // 2 children in Scope
/*  2333*/     OPC_CheckChild2TypeI32,
/*  2334*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2335*/     OPC_Scope, 16, /*->2353*/ // 2 children in Scope
/*  2337*/      OPC_CheckPredicate5,  // Predicate_store
/*  2338*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2339*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2341*/      OPC_EmitMergeInputChains1_0,
/*  2342*/      OPC_EmitInteger32, 0, 
/*  2344*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2353*/     /*Scope*/ 40, /*->2394*/
/*  2354*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2356*/      OPC_Scope, 17, /*->2375*/ // 2 children in Scope
/*  2358*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2360*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2361*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2363*/       OPC_EmitMergeInputChains1_0,
/*  2364*/       OPC_EmitInteger32, 0, 
/*  2366*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2375*/      /*Scope*/ 17, /*->2393*/
/*  2376*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2378*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2379*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2381*/       OPC_EmitMergeInputChains1_0,
/*  2382*/       OPC_EmitInteger32, 0, 
/*  2384*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2393*/      0, /*End of Scope*/
/*  2394*/     0, /*End of Scope*/
/*  2395*/    /*Scope*/ 62, /*->2458*/
/*  2396*/     OPC_CheckChild2TypeI64,
/*  2397*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2398*/     OPC_Scope, 16, /*->2416*/ // 2 children in Scope
/*  2400*/      OPC_CheckPredicate5,  // Predicate_store
/*  2401*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2402*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2404*/      OPC_EmitMergeInputChains1_0,
/*  2405*/      OPC_EmitInteger32, 0, 
/*  2407*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2416*/     /*Scope*/ 40, /*->2457*/
/*  2417*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2419*/      OPC_Scope, 17, /*->2438*/ // 2 children in Scope
/*  2421*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2423*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2424*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2426*/       OPC_EmitMergeInputChains1_0,
/*  2427*/       OPC_EmitInteger32, 0, 
/*  2429*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2438*/      /*Scope*/ 17, /*->2456*/
/*  2439*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2441*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2442*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2444*/       OPC_EmitMergeInputChains1_0,
/*  2445*/       OPC_EmitInteger32, 0, 
/*  2447*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2456*/      0, /*End of Scope*/
/*  2457*/     0, /*End of Scope*/
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 38|128,1/*166*/, /*->2627*/
/*  2461*/    OPC_CheckChild1TypeI64,
/*  2462*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2463*/    OPC_Scope, 80, /*->2545*/ // 2 children in Scope
/*  2465*/     OPC_CheckChild2TypeI32,
/*  2466*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2467*/     OPC_Scope, 16, /*->2485*/ // 2 children in Scope
/*  2469*/      OPC_CheckPredicate5,  // Predicate_store
/*  2470*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2471*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2473*/      OPC_EmitMergeInputChains1_0,
/*  2474*/      OPC_EmitInteger32, 0, 
/*  2476*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2485*/     /*Scope*/ 58, /*->2544*/
/*  2486*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2488*/      OPC_Scope, 17, /*->2507*/ // 3 children in Scope
/*  2490*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2492*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2493*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2495*/       OPC_EmitMergeInputChains1_0,
/*  2496*/       OPC_EmitInteger32, 0, 
/*  2498*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2507*/      /*Scope*/ 17, /*->2525*/
/*  2508*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2510*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2511*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2513*/       OPC_EmitMergeInputChains1_0,
/*  2514*/       OPC_EmitInteger32, 0, 
/*  2516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2525*/      /*Scope*/ 17, /*->2543*/
/*  2526*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2528*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2529*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2531*/       OPC_EmitMergeInputChains1_0,
/*  2532*/       OPC_EmitInteger32, 0, 
/*  2534*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2543*/      0, /*End of Scope*/
/*  2544*/     0, /*End of Scope*/
/*  2545*/    /*Scope*/ 80, /*->2626*/
/*  2546*/     OPC_CheckChild2TypeI64,
/*  2547*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2548*/     OPC_Scope, 16, /*->2566*/ // 2 children in Scope
/*  2550*/      OPC_CheckPredicate5,  // Predicate_store
/*  2551*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2552*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2554*/      OPC_EmitMergeInputChains1_0,
/*  2555*/      OPC_EmitInteger32, 0, 
/*  2557*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2566*/     /*Scope*/ 58, /*->2625*/
/*  2567*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2569*/      OPC_Scope, 17, /*->2588*/ // 3 children in Scope
/*  2571*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2573*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2574*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2576*/       OPC_EmitMergeInputChains1_0,
/*  2577*/       OPC_EmitInteger32, 0, 
/*  2579*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2588*/      /*Scope*/ 17, /*->2606*/
/*  2589*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2591*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2592*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2594*/       OPC_EmitMergeInputChains1_0,
/*  2595*/       OPC_EmitInteger32, 0, 
/*  2597*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2606*/      /*Scope*/ 17, /*->2624*/
/*  2607*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2609*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2610*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2612*/       OPC_EmitMergeInputChains1_0,
/*  2613*/       OPC_EmitInteger32, 0, 
/*  2615*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2624*/      0, /*End of Scope*/
/*  2625*/     0, /*End of Scope*/
/*  2626*/    0, /*End of Scope*/
/*  2627*/   /*Scope*/ 43, /*->2671*/
/*  2628*/    OPC_CheckChild1Type, MVT::f32,
/*  2630*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2631*/    OPC_Scope, 18, /*->2651*/ // 2 children in Scope
/*  2633*/     OPC_CheckChild2TypeI32,
/*  2634*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2635*/     OPC_CheckPredicate5,  // Predicate_store
/*  2636*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2637*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2639*/     OPC_EmitMergeInputChains1_0,
/*  2640*/     OPC_EmitInteger32, 0, 
/*  2642*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2651*/    /*Scope*/ 18, /*->2670*/
/*  2652*/     OPC_CheckChild2TypeI64,
/*  2653*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2654*/     OPC_CheckPredicate5,  // Predicate_store
/*  2655*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2656*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2658*/     OPC_EmitMergeInputChains1_0,
/*  2659*/     OPC_EmitInteger32, 0, 
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2670*/    0, /*End of Scope*/
/*  2671*/   /*Scope*/ 43, /*->2715*/
/*  2672*/    OPC_CheckChild1Type, MVT::f64,
/*  2674*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2675*/    OPC_Scope, 18, /*->2695*/ // 2 children in Scope
/*  2677*/     OPC_CheckChild2TypeI32,
/*  2678*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2679*/     OPC_CheckPredicate5,  // Predicate_store
/*  2680*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2681*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2683*/     OPC_EmitMergeInputChains1_0,
/*  2684*/     OPC_EmitInteger32, 0, 
/*  2686*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2695*/    /*Scope*/ 18, /*->2714*/
/*  2696*/     OPC_CheckChild2TypeI64,
/*  2697*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate5,  // Predicate_store
/*  2699*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2700*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger32, 0, 
/*  2705*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2714*/    0, /*End of Scope*/
/*  2715*/   /*Scope*/ 43, /*->2759*/
/*  2716*/    OPC_CheckChild1Type, MVT::v16i8,
/*  2718*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2719*/    OPC_Scope, 18, /*->2739*/ // 2 children in Scope
/*  2721*/     OPC_CheckChild2TypeI32,
/*  2722*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate5,  // Predicate_store
/*  2724*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2725*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2727*/     OPC_EmitMergeInputChains1_0,
/*  2728*/     OPC_EmitInteger32, 0, 
/*  2730*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2739*/    /*Scope*/ 18, /*->2758*/
/*  2740*/     OPC_CheckChild2TypeI64,
/*  2741*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2742*/     OPC_CheckPredicate5,  // Predicate_store
/*  2743*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2744*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2746*/     OPC_EmitMergeInputChains1_0,
/*  2747*/     OPC_EmitInteger32, 0, 
/*  2749*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2758*/    0, /*End of Scope*/
/*  2759*/   /*Scope*/ 43, /*->2803*/
/*  2760*/    OPC_CheckChild1Type, MVT::v8i16,
/*  2762*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2763*/    OPC_Scope, 18, /*->2783*/ // 2 children in Scope
/*  2765*/     OPC_CheckChild2TypeI32,
/*  2766*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2767*/     OPC_CheckPredicate5,  // Predicate_store
/*  2768*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2769*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2771*/     OPC_EmitMergeInputChains1_0,
/*  2772*/     OPC_EmitInteger32, 0, 
/*  2774*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2783*/    /*Scope*/ 18, /*->2802*/
/*  2784*/     OPC_CheckChild2TypeI64,
/*  2785*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2786*/     OPC_CheckPredicate5,  // Predicate_store
/*  2787*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2788*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2790*/     OPC_EmitMergeInputChains1_0,
/*  2791*/     OPC_EmitInteger32, 0, 
/*  2793*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2802*/    0, /*End of Scope*/
/*  2803*/   /*Scope*/ 43, /*->2847*/
/*  2804*/    OPC_CheckChild1Type, MVT::v4i32,
/*  2806*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2807*/    OPC_Scope, 18, /*->2827*/ // 2 children in Scope
/*  2809*/     OPC_CheckChild2TypeI32,
/*  2810*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2811*/     OPC_CheckPredicate5,  // Predicate_store
/*  2812*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2813*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2815*/     OPC_EmitMergeInputChains1_0,
/*  2816*/     OPC_EmitInteger32, 0, 
/*  2818*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2827*/    /*Scope*/ 18, /*->2846*/
/*  2828*/     OPC_CheckChild2TypeI64,
/*  2829*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2830*/     OPC_CheckPredicate5,  // Predicate_store
/*  2831*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2832*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2834*/     OPC_EmitMergeInputChains1_0,
/*  2835*/     OPC_EmitInteger32, 0, 
/*  2837*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2846*/    0, /*End of Scope*/
/*  2847*/   /*Scope*/ 43, /*->2891*/
/*  2848*/    OPC_CheckChild1Type, MVT::v2i64,
/*  2850*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2851*/    OPC_Scope, 18, /*->2871*/ // 2 children in Scope
/*  2853*/     OPC_CheckChild2TypeI32,
/*  2854*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2855*/     OPC_CheckPredicate5,  // Predicate_store
/*  2856*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2857*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2859*/     OPC_EmitMergeInputChains1_0,
/*  2860*/     OPC_EmitInteger32, 0, 
/*  2862*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2871*/    /*Scope*/ 18, /*->2890*/
/*  2872*/     OPC_CheckChild2TypeI64,
/*  2873*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2874*/     OPC_CheckPredicate5,  // Predicate_store
/*  2875*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2876*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2878*/     OPC_EmitMergeInputChains1_0,
/*  2879*/     OPC_EmitInteger32, 0, 
/*  2881*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2890*/    0, /*End of Scope*/
/*  2891*/   /*Scope*/ 43, /*->2935*/
/*  2892*/    OPC_CheckChild1Type, MVT::v4f32,
/*  2894*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2895*/    OPC_Scope, 18, /*->2915*/ // 2 children in Scope
/*  2897*/     OPC_CheckChild2TypeI32,
/*  2898*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2899*/     OPC_CheckPredicate5,  // Predicate_store
/*  2900*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2901*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2903*/     OPC_EmitMergeInputChains1_0,
/*  2904*/     OPC_EmitInteger32, 0, 
/*  2906*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2915*/    /*Scope*/ 18, /*->2934*/
/*  2916*/     OPC_CheckChild2TypeI64,
/*  2917*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2918*/     OPC_CheckPredicate5,  // Predicate_store
/*  2919*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2920*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2922*/     OPC_EmitMergeInputChains1_0,
/*  2923*/     OPC_EmitInteger32, 0, 
/*  2925*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2934*/    0, /*End of Scope*/
/*  2935*/   /*Scope*/ 43, /*->2979*/
/*  2936*/    OPC_CheckChild1Type, MVT::v2f64,
/*  2938*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2939*/    OPC_Scope, 18, /*->2959*/ // 2 children in Scope
/*  2941*/     OPC_CheckChild2TypeI32,
/*  2942*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2943*/     OPC_CheckPredicate5,  // Predicate_store
/*  2944*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2945*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2947*/     OPC_EmitMergeInputChains1_0,
/*  2948*/     OPC_EmitInteger32, 0, 
/*  2950*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2959*/    /*Scope*/ 18, /*->2978*/
/*  2960*/     OPC_CheckChild2TypeI64,
/*  2961*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2962*/     OPC_CheckPredicate5,  // Predicate_store
/*  2963*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2964*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2966*/     OPC_EmitMergeInputChains1_0,
/*  2967*/     OPC_EmitInteger32, 0, 
/*  2969*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2978*/    0, /*End of Scope*/
/*  2979*/   0, /*End of Scope*/
/*  2980*/  0, /*End of Scope*/
/*  2981*/ /*SwitchOpcode*/ 7|128,2/*263*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3248
/*  2985*/  OPC_Scope, 40, /*->3027*/ // 3 children in Scope
/*  2987*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  2988*/   OPC_CheckChild1Integer, 88|128,66|128,1/*24920*/, 
/*  2992*/   OPC_MoveChild2,
/*  2993*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2996*/   OPC_RecordChild0, // #1 = $table1
/*  2997*/   OPC_MoveChild0,
/*  2998*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3001*/   OPC_MoveParent,
/*  3002*/   OPC_MoveSibling3,
/*  3003*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3006*/   OPC_RecordChild0, // #2 = $table2
/*  3007*/   OPC_MoveChild0,
/*  3008*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3011*/   OPC_MoveParent,
/*  3012*/   OPC_MoveParent,
/*  3013*/   OPC_RecordChild4, // #3 = $d
/*  3014*/   OPC_RecordChild5, // #4 = $s
/*  3015*/   OPC_RecordChild6, // #5 = $n
/*  3016*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3017*/   OPC_EmitMergeInputChains1_0,
/*  3018*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 12460:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3027*/  /*Scope*/ 44, /*->3072*/
/*  3028*/   OPC_RecordMemRef,
/*  3029*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3030*/   OPC_CheckChild1Integer, 80|128,66|128,1/*24912*/, 
/*  3034*/   OPC_RecordChild2, // #1 = $val
/*  3035*/   OPC_RecordChild3, // #2 = $AddrOps32:offset:addr
/*  3036*/   OPC_Scope, 16, /*->3054*/ // 2 children in Scope
/*  3038*/    OPC_CheckChild3TypeI32,
/*  3039*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  3040*/    OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3042*/    OPC_EmitMergeInputChains1_0,
/*  3043*/    OPC_EmitInteger32, 0, 
/*  3045*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12456:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3054*/   /*Scope*/ 16, /*->3071*/
/*  3055*/    OPC_CheckChild3TypeI64,
/*  3056*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  3057*/    OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3059*/    OPC_EmitMergeInputChains1_0,
/*  3060*/    OPC_EmitInteger32, 0, 
/*  3062*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12456:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3071*/   0, /*End of Scope*/
/*  3072*/  /*Scope*/ 45|128,1/*173*/, /*->3247*/
/*  3074*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3075*/   OPC_Scope, 26, /*->3103*/ // 6 children in Scope
/*  3077*/    OPC_CheckChild1Integer, 112|128,66|128,1/*24944*/, 
/*  3081*/    OPC_MoveChild2,
/*  3082*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3085*/    OPC_RecordChild0, // #1 = $table
/*  3086*/    OPC_MoveChild0,
/*  3087*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3090*/    OPC_MoveParent,
/*  3091*/    OPC_MoveParent,
/*  3092*/    OPC_RecordChild3, // #2 = $i
/*  3093*/    OPC_RecordChild4, // #3 = $val
/*  3094*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3095*/    OPC_EmitMergeInputChains1_0,
/*  3096*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12472:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3103*/   /*Scope*/ 28, /*->3132*/
/*  3104*/    OPC_CheckChild1Integer, 94|128,66|128,1/*24926*/, 
/*  3108*/    OPC_MoveChild2,
/*  3109*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3112*/    OPC_RecordChild0, // #1 = $table
/*  3113*/    OPC_MoveChild0,
/*  3114*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3117*/    OPC_MoveParent,
/*  3118*/    OPC_MoveParent,
/*  3119*/    OPC_RecordChild3, // #2 = $i
/*  3120*/    OPC_RecordChild4, // #3 = $val
/*  3121*/    OPC_RecordChild5, // #4 = $n
/*  3122*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3123*/    OPC_EmitMergeInputChains1_0,
/*  3124*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12463:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3132*/   /*Scope*/ 26, /*->3159*/
/*  3133*/    OPC_CheckChild1Integer, 110|128,66|128,1/*24942*/, 
/*  3137*/    OPC_MoveChild2,
/*  3138*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3141*/    OPC_RecordChild0, // #1 = $table
/*  3142*/    OPC_MoveChild0,
/*  3143*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3146*/    OPC_MoveParent,
/*  3147*/    OPC_MoveParent,
/*  3148*/    OPC_RecordChild3, // #2 = $i
/*  3149*/    OPC_RecordChild4, // #3 = $val
/*  3150*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3151*/    OPC_EmitMergeInputChains1_0,
/*  3152*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12471:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3159*/   /*Scope*/ 28, /*->3188*/
/*  3160*/    OPC_CheckChild1Integer, 92|128,66|128,1/*24924*/, 
/*  3164*/    OPC_MoveChild2,
/*  3165*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3168*/    OPC_RecordChild0, // #1 = $table
/*  3169*/    OPC_MoveChild0,
/*  3170*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3173*/    OPC_MoveParent,
/*  3174*/    OPC_MoveParent,
/*  3175*/    OPC_RecordChild3, // #2 = $i
/*  3176*/    OPC_RecordChild4, // #3 = $val
/*  3177*/    OPC_RecordChild5, // #4 = $n
/*  3178*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3179*/    OPC_EmitMergeInputChains1_0,
/*  3180*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12462:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3188*/   /*Scope*/ 27, /*->3216*/
/*  3189*/    OPC_CheckChild1Integer, 108|128,66|128,1/*24940*/, 
/*  3193*/    OPC_MoveChild2,
/*  3194*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3197*/    OPC_RecordChild0, // #1 = $table
/*  3198*/    OPC_MoveChild0,
/*  3199*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3202*/    OPC_MoveParent,
/*  3203*/    OPC_MoveParent,
/*  3204*/    OPC_RecordChild3, // #2 = $i
/*  3205*/    OPC_RecordChild4, // #3 = $val
/*  3206*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3208*/    OPC_EmitMergeInputChains1_0,
/*  3209*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12470:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val)
/*  3216*/   /*Scope*/ 29, /*->3246*/
/*  3217*/    OPC_CheckChild1Integer, 90|128,66|128,1/*24922*/, 
/*  3221*/    OPC_MoveChild2,
/*  3222*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3225*/    OPC_RecordChild0, // #1 = $table
/*  3226*/    OPC_MoveChild0,
/*  3227*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3230*/    OPC_MoveParent,
/*  3231*/    OPC_MoveParent,
/*  3232*/    OPC_RecordChild3, // #2 = $i
/*  3233*/    OPC_RecordChild4, // #3 = $val
/*  3234*/    OPC_RecordChild5, // #4 = $n
/*  3235*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3237*/    OPC_EmitMergeInputChains1_0,
/*  3238*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12461:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3246*/   0, /*End of Scope*/
/*  3247*/  0, /*End of Scope*/
/*  3248*/ /*SwitchOpcode*/ 78|128,3/*462*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3714
/*  3252*/  OPC_Scope, 22|128,1/*150*/, /*->3405*/ // 3 children in Scope
/*  3255*/   OPC_RecordMemRef,
/*  3256*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3257*/   OPC_Scope, 45, /*->3304*/ // 3 children in Scope
/*  3259*/    OPC_CheckChild1Integer, 14|128,66|128,1/*24846*/, 
/*  3263*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3264*/    OPC_Scope, 18, /*->3284*/ // 2 children in Scope
/*  3266*/     OPC_CheckChild2TypeI32,
/*  3267*/     OPC_RecordChild3, // #2 = $count
/*  3268*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3269*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3271*/     OPC_EmitMergeInputChains1_0,
/*  3272*/     OPC_EmitInteger32, 0, 
/*  3274*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12423:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3284*/    /*Scope*/ 18, /*->3303*/
/*  3285*/     OPC_CheckChild2TypeI64,
/*  3286*/     OPC_RecordChild3, // #2 = $count
/*  3287*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3288*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3290*/     OPC_EmitMergeInputChains1_0,
/*  3291*/     OPC_EmitInteger32, 0, 
/*  3293*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12423:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3303*/    0, /*End of Scope*/
/*  3304*/   /*Scope*/ 49, /*->3354*/
/*  3305*/    OPC_CheckChild1Integer, 16|128,66|128,1/*24848*/, 
/*  3309*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3310*/    OPC_Scope, 20, /*->3332*/ // 2 children in Scope
/*  3312*/     OPC_CheckChild2TypeI32,
/*  3313*/     OPC_RecordChild3, // #2 = $exp
/*  3314*/     OPC_RecordChild4, // #3 = $timeout
/*  3315*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3316*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3318*/     OPC_EmitMergeInputChains1_0,
/*  3319*/     OPC_EmitInteger32, 0, 
/*  3321*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12424:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3332*/    /*Scope*/ 20, /*->3353*/
/*  3333*/     OPC_CheckChild2TypeI64,
/*  3334*/     OPC_RecordChild3, // #2 = $exp
/*  3335*/     OPC_RecordChild4, // #3 = $timeout
/*  3336*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3337*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3339*/     OPC_EmitMergeInputChains1_0,
/*  3340*/     OPC_EmitInteger32, 0, 
/*  3342*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12424:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3353*/    0, /*End of Scope*/
/*  3354*/   /*Scope*/ 49, /*->3404*/
/*  3355*/    OPC_CheckChild1Integer, 18|128,66|128,1/*24850*/, 
/*  3359*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3360*/    OPC_Scope, 20, /*->3382*/ // 2 children in Scope
/*  3362*/     OPC_CheckChild2TypeI32,
/*  3363*/     OPC_RecordChild3, // #2 = $exp
/*  3364*/     OPC_RecordChild4, // #3 = $timeout
/*  3365*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3366*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3368*/     OPC_EmitMergeInputChains1_0,
/*  3369*/     OPC_EmitInteger32, 0, 
/*  3371*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12425:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3382*/    /*Scope*/ 20, /*->3403*/
/*  3383*/     OPC_CheckChild2TypeI64,
/*  3384*/     OPC_RecordChild3, // #2 = $exp
/*  3385*/     OPC_RecordChild4, // #3 = $timeout
/*  3386*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3387*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3389*/     OPC_EmitMergeInputChains1_0,
/*  3390*/     OPC_EmitInteger32, 0, 
/*  3392*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12425:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3403*/    0, /*End of Scope*/
/*  3404*/   0, /*End of Scope*/
/*  3405*/  /*Scope*/ 6|128,2/*262*/, /*->3669*/
/*  3407*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3408*/   OPC_Scope, 25, /*->3435*/ // 9 children in Scope
/*  3410*/    OPC_CheckChild1Integer, 100|128,66|128,1/*24932*/, 
/*  3414*/    OPC_MoveChild2,
/*  3415*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3418*/    OPC_RecordChild0, // #1 = $table
/*  3419*/    OPC_MoveChild0,
/*  3420*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3423*/    OPC_MoveParent,
/*  3424*/    OPC_MoveParent,
/*  3425*/    OPC_RecordChild3, // #2 = $i
/*  3426*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3427*/    OPC_EmitMergeInputChains1_0,
/*  3428*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  MVT::funcref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 12466:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3435*/   /*Scope*/ 27, /*->3463*/
/*  3436*/    OPC_CheckChild1Integer, 106|128,66|128,1/*24938*/, 
/*  3440*/    OPC_MoveChild2,
/*  3441*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3444*/    OPC_RecordChild0, // #1 = $table
/*  3445*/    OPC_MoveChild0,
/*  3446*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3449*/    OPC_MoveParent,
/*  3450*/    OPC_MoveParent,
/*  3451*/    OPC_RecordChild3, // #2 = $val
/*  3452*/    OPC_RecordChild4, // #3 = $n
/*  3453*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3454*/    OPC_EmitMergeInputChains1_0,
/*  3455*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12469:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3463*/   /*Scope*/ 25, /*->3489*/
/*  3464*/    OPC_CheckChild1Integer, 98|128,66|128,1/*24930*/, 
/*  3468*/    OPC_MoveChild2,
/*  3469*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3472*/    OPC_RecordChild0, // #1 = $table
/*  3473*/    OPC_MoveChild0,
/*  3474*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3477*/    OPC_MoveParent,
/*  3478*/    OPC_MoveParent,
/*  3479*/    OPC_RecordChild3, // #2 = $i
/*  3480*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3481*/    OPC_EmitMergeInputChains1_0,
/*  3482*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  MVT::externref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 12465:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3489*/   /*Scope*/ 27, /*->3517*/
/*  3490*/    OPC_CheckChild1Integer, 104|128,66|128,1/*24936*/, 
/*  3494*/    OPC_MoveChild2,
/*  3495*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3498*/    OPC_RecordChild0, // #1 = $table
/*  3499*/    OPC_MoveChild0,
/*  3500*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3503*/    OPC_MoveParent,
/*  3504*/    OPC_MoveParent,
/*  3505*/    OPC_RecordChild3, // #2 = $val
/*  3506*/    OPC_RecordChild4, // #3 = $n
/*  3507*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3508*/    OPC_EmitMergeInputChains1_0,
/*  3509*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12468:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3517*/   /*Scope*/ 26, /*->3544*/
/*  3518*/    OPC_CheckChild1Integer, 96|128,66|128,1/*24928*/, 
/*  3522*/    OPC_MoveChild2,
/*  3523*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3526*/    OPC_RecordChild0, // #1 = $table
/*  3527*/    OPC_MoveChild0,
/*  3528*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3531*/    OPC_MoveParent,
/*  3532*/    OPC_MoveParent,
/*  3533*/    OPC_RecordChild3, // #2 = $i
/*  3534*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3536*/    OPC_EmitMergeInputChains1_0,
/*  3537*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  MVT::exnref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[exnref] } 12464:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3544*/   /*Scope*/ 28, /*->3573*/
/*  3545*/    OPC_CheckChild1Integer, 102|128,66|128,1/*24934*/, 
/*  3549*/    OPC_MoveChild2,
/*  3550*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3553*/    OPC_RecordChild0, // #1 = $table
/*  3554*/    OPC_MoveChild0,
/*  3555*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3558*/    OPC_MoveParent,
/*  3559*/    OPC_MoveParent,
/*  3560*/    OPC_RecordChild3, // #2 = $val
/*  3561*/    OPC_RecordChild4, // #3 = $n
/*  3562*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3564*/    OPC_EmitMergeInputChains1_0,
/*  3565*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12467:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3573*/   /*Scope*/ 23, /*->3597*/
/*  3574*/    OPC_CheckChild1Integer, 114|128,66|128,1/*24946*/, 
/*  3578*/    OPC_MoveChild2,
/*  3579*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3582*/    OPC_RecordChild0, // #1 = $table
/*  3583*/    OPC_MoveChild0,
/*  3584*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3587*/    OPC_MoveParent,
/*  3588*/    OPC_MoveParent,
/*  3589*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3590*/    OPC_EmitMergeInputChains1_0,
/*  3591*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  MVT::i32, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12473:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3597*/   /*Scope*/ 32, /*->3630*/
/*  3598*/    OPC_CheckChild1Integer, 22|128,66|128,1/*24854*/, 
/*  3602*/    OPC_RecordChild2, // #1 = $flags
/*  3603*/    OPC_MoveChild2,
/*  3604*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3607*/    OPC_MoveParent,
/*  3608*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->3619
/*  3611*/     OPC_EmitMergeInputChains1_0,
/*  3612*/     OPC_EmitConvertToTarget1,
/*  3613*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8187MEMORY_SIZE_A32),
                   MVT::i32, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12427:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8187MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3619*/    /*SwitchType*/ 8, MVT::i64,// ->3629
/*  3621*/     OPC_EmitMergeInputChains1_0,
/*  3622*/     OPC_EmitConvertToTarget1,
/*  3623*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8188MEMORY_SIZE_A64),
                   MVT::i64, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12427:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8188MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3629*/    0, // EndSwitchType
/*  3630*/   /*Scope*/ 37, /*->3668*/
/*  3631*/    OPC_CheckChild1Integer, 20|128,66|128,1/*24852*/, 
/*  3635*/    OPC_RecordChild2, // #1 = $flags
/*  3636*/    OPC_MoveChild2,
/*  3637*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3640*/    OPC_MoveParent,
/*  3641*/    OPC_RecordChild3, // #2 = $delta
/*  3642*/    OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->3655
/*  3645*/     OPC_CheckChild3TypeI32,
/*  3646*/     OPC_EmitMergeInputChains1_0,
/*  3647*/     OPC_EmitConvertToTarget1,
/*  3648*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8187MEMORY_GROW_A32),
                   MVT::i32, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12426:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_8187MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3655*/    /*SwitchType*/ 10, MVT::i64,// ->3667
/*  3657*/     OPC_CheckChild3TypeI64,
/*  3658*/     OPC_EmitMergeInputChains1_0,
/*  3659*/     OPC_EmitConvertToTarget1,
/*  3660*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8188MEMORY_GROW_A64),
                   MVT::i64, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12426:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_8188MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3667*/    0, // EndSwitchType
/*  3668*/   0, /*End of Scope*/
/*  3669*/  /*Scope*/ 43, /*->3713*/
/*  3670*/   OPC_RecordMemRef,
/*  3671*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3672*/   OPC_CheckChild1Integer, 10|128,66|128,1/*24842*/, 
/*  3676*/   OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3677*/   OPC_Scope, 16, /*->3695*/ // 2 children in Scope
/*  3679*/    OPC_CheckChild2TypeI32,
/*  3680*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  3681*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  3683*/    OPC_EmitMergeInputChains1_0,
/*  3684*/    OPC_EmitInteger32, 0, 
/*  3686*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::f32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12421:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  3695*/   /*Scope*/ 16, /*->3712*/
/*  3696*/    OPC_CheckChild2TypeI64,
/*  3697*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  3698*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  3700*/    OPC_EmitMergeInputChains1_0,
/*  3701*/    OPC_EmitInteger32, 0, 
/*  3703*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::f32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12421:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  3712*/   0, /*End of Scope*/
/*  3713*/  0, /*End of Scope*/
/*  3714*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4003
/*  3718*/  OPC_RecordMemRef,
/*  3719*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3720*/  OPC_Scope, 119, /*->3841*/ // 2 children in Scope
/*  3722*/   OPC_MoveChild1,
/*  3723*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3726*/   OPC_RecordChild0, // #1 = $val
/*  3727*/   OPC_MoveParent,
/*  3728*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3729*/   OPC_Scope, 54, /*->3785*/ // 2 children in Scope
/*  3731*/    OPC_CheckChild2TypeI32,
/*  3732*/    OPC_Scope, 16, /*->3750*/ // 3 children in Scope
/*  3734*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3735*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3736*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3738*/     OPC_EmitMergeInputChains1_0,
/*  3739*/     OPC_EmitInteger32, 0, 
/*  3741*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3750*/    /*Scope*/ 16, /*->3767*/
/*  3751*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3752*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3753*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3755*/     OPC_EmitMergeInputChains1_0,
/*  3756*/     OPC_EmitInteger32, 0, 
/*  3758*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3767*/    /*Scope*/ 16, /*->3784*/
/*  3768*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3769*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3770*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3772*/     OPC_EmitMergeInputChains1_0,
/*  3773*/     OPC_EmitInteger32, 0, 
/*  3775*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3784*/    0, /*End of Scope*/
/*  3785*/   /*Scope*/ 54, /*->3840*/
/*  3786*/    OPC_CheckChild2TypeI64,
/*  3787*/    OPC_Scope, 16, /*->3805*/ // 3 children in Scope
/*  3789*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3790*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3791*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3793*/     OPC_EmitMergeInputChains1_0,
/*  3794*/     OPC_EmitInteger32, 0, 
/*  3796*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3805*/    /*Scope*/ 16, /*->3822*/
/*  3806*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3807*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3808*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3810*/     OPC_EmitMergeInputChains1_0,
/*  3811*/     OPC_EmitInteger32, 0, 
/*  3813*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3822*/    /*Scope*/ 16, /*->3839*/
/*  3823*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3824*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3825*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3827*/     OPC_EmitMergeInputChains1_0,
/*  3828*/     OPC_EmitInteger32, 0, 
/*  3830*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3839*/    0, /*End of Scope*/
/*  3840*/   0, /*End of Scope*/
/*  3841*/  /*Scope*/ 31|128,1/*159*/, /*->4002*/
/*  3843*/   OPC_RecordChild1, // #1 = $val
/*  3844*/   OPC_Scope, 114, /*->3960*/ // 2 children in Scope
/*  3846*/    OPC_CheckChild1TypeI32,
/*  3847*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3848*/    OPC_Scope, 54, /*->3904*/ // 2 children in Scope
/*  3850*/     OPC_CheckChild2TypeI32,
/*  3851*/     OPC_Scope, 16, /*->3869*/ // 3 children in Scope
/*  3853*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3854*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3855*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3857*/      OPC_EmitMergeInputChains1_0,
/*  3858*/      OPC_EmitInteger32, 0, 
/*  3860*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3869*/     /*Scope*/ 16, /*->3886*/
/*  3870*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3871*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3872*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3874*/      OPC_EmitMergeInputChains1_0,
/*  3875*/      OPC_EmitInteger32, 0, 
/*  3877*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3886*/     /*Scope*/ 16, /*->3903*/
/*  3887*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3888*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3889*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3891*/      OPC_EmitMergeInputChains1_0,
/*  3892*/      OPC_EmitInteger32, 0, 
/*  3894*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3903*/     0, /*End of Scope*/
/*  3904*/    /*Scope*/ 54, /*->3959*/
/*  3905*/     OPC_CheckChild2TypeI64,
/*  3906*/     OPC_Scope, 16, /*->3924*/ // 3 children in Scope
/*  3908*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3909*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3910*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3912*/      OPC_EmitMergeInputChains1_0,
/*  3913*/      OPC_EmitInteger32, 0, 
/*  3915*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3924*/     /*Scope*/ 16, /*->3941*/
/*  3925*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3926*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3927*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3929*/      OPC_EmitMergeInputChains1_0,
/*  3930*/      OPC_EmitInteger32, 0, 
/*  3932*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3941*/     /*Scope*/ 16, /*->3958*/
/*  3942*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3943*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3944*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3946*/      OPC_EmitMergeInputChains1_0,
/*  3947*/      OPC_EmitInteger32, 0, 
/*  3949*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3958*/     0, /*End of Scope*/
/*  3959*/    0, /*End of Scope*/
/*  3960*/   /*Scope*/ 40, /*->4001*/
/*  3961*/    OPC_CheckChild1TypeI64,
/*  3962*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3963*/    OPC_Scope, 17, /*->3982*/ // 2 children in Scope
/*  3965*/     OPC_CheckChild2TypeI32,
/*  3966*/     OPC_CheckPredicate6,  // Predicate_atomic_store_64
/*  3967*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3968*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3970*/     OPC_EmitMergeInputChains1_0,
/*  3971*/     OPC_EmitInteger32, 0, 
/*  3973*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3982*/    /*Scope*/ 17, /*->4000*/
/*  3983*/     OPC_CheckChild2TypeI64,
/*  3984*/     OPC_CheckPredicate6,  // Predicate_atomic_store_64
/*  3985*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3986*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3988*/     OPC_EmitMergeInputChains1_0,
/*  3989*/     OPC_EmitInteger32, 0, 
/*  3991*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4000*/    0, /*End of Scope*/
/*  4001*/   0, /*End of Scope*/
/*  4002*/  0, /*End of Scope*/
/*  4003*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4353
/*  4007*/  OPC_Scope, 118, /*->4127*/ // 6 children in Scope
/*  4009*/   OPC_MoveChild0,
/*  4010*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4013*/   OPC_Scope, 55, /*->4070*/ // 2 children in Scope
/*  4015*/    OPC_CheckChild0Integer, 114|128,65|128,1/*24818*/, 
/*  4019*/    OPC_RecordChild1, // #0 = $x
/*  4020*/    OPC_Scope, 11, /*->4033*/ // 4 children in Scope
/*  4022*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4024*/     OPC_MoveParent,
/*  4025*/     OPC_CheckChild1Integer, 2, 
/*  4027*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4033*/    /*Scope*/ 11, /*->4045*/
/*  4034*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4036*/     OPC_MoveParent,
/*  4037*/     OPC_CheckChild1Integer, 2, 
/*  4039*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4045*/    /*Scope*/ 11, /*->4057*/
/*  4046*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4048*/     OPC_MoveParent,
/*  4049*/     OPC_CheckChild1Integer, 2, 
/*  4051*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4057*/    /*Scope*/ 11, /*->4069*/
/*  4058*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4060*/     OPC_MoveParent,
/*  4061*/     OPC_CheckChild1Integer, 2, 
/*  4063*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4069*/    0, /*End of Scope*/
/*  4070*/   /*Scope*/ 55, /*->4126*/
/*  4071*/    OPC_CheckChild0Integer, 112|128,65|128,1/*24816*/, 
/*  4075*/    OPC_RecordChild1, // #0 = $x
/*  4076*/    OPC_Scope, 11, /*->4089*/ // 4 children in Scope
/*  4078*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4080*/     OPC_MoveParent,
/*  4081*/     OPC_CheckChild1Integer, 2, 
/*  4083*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4089*/    /*Scope*/ 11, /*->4101*/
/*  4090*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4092*/     OPC_MoveParent,
/*  4093*/     OPC_CheckChild1Integer, 2, 
/*  4095*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4101*/    /*Scope*/ 11, /*->4113*/
/*  4102*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4104*/     OPC_MoveParent,
/*  4105*/     OPC_CheckChild1Integer, 2, 
/*  4107*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4113*/    /*Scope*/ 11, /*->4125*/
/*  4114*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4116*/     OPC_MoveParent,
/*  4117*/     OPC_CheckChild1Integer, 2, 
/*  4119*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4125*/    0, /*End of Scope*/
/*  4126*/   0, /*End of Scope*/
/*  4127*/  /*Scope*/ 29, /*->4157*/
/*  4128*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4131*/   OPC_MoveChild0,
/*  4132*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4135*/   OPC_RecordChild0, // #0 = $vec
/*  4136*/   OPC_CheckChild0Type, MVT::v16i8,
/*  4138*/   OPC_RecordChild1, // #1 = $idx
/*  4139*/   OPC_MoveChild1,
/*  4140*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4143*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/*  4145*/   OPC_CheckTypeI32,
/*  4146*/   OPC_MoveParent,
/*  4147*/   OPC_MoveParent,
/*  4148*/   OPC_CheckTypeI32,
/*  4149*/   OPC_EmitConvertToTarget1,
/*  4150*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4157*/  /*Scope*/ 30, /*->4188*/
/*  4158*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4162*/   OPC_MoveChild0,
/*  4163*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4166*/   OPC_RecordChild0, // #0 = $vec
/*  4167*/   OPC_CheckChild0Type, MVT::v8i16,
/*  4169*/   OPC_RecordChild1, // #1 = $idx
/*  4170*/   OPC_MoveChild1,
/*  4171*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4174*/   OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  4176*/   OPC_CheckTypeI32,
/*  4177*/   OPC_MoveParent,
/*  4178*/   OPC_MoveParent,
/*  4179*/   OPC_CheckTypeI32,
/*  4180*/   OPC_EmitConvertToTarget1,
/*  4181*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4188*/  /*Scope*/ 73, /*->4262*/
/*  4189*/   OPC_RecordChild0, // #0 = $lhs
/*  4190*/   OPC_Scope, 21, /*->4213*/ // 2 children in Scope
/*  4192*/    OPC_RecordChild1, // #1 = $rhs
/*  4193*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->4203
/*  4196*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   MVT::i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4203*/    /*SwitchType*/ 7, MVT::i64,// ->4212
/*  4205*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   MVT::i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4212*/    0, // EndSwitchType
/*  4213*/   /*Scope*/ 47, /*->4261*/
/*  4214*/    OPC_MoveChild1,
/*  4215*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4218*/    OPC_RecordChild0, // #1 = $rhs
/*  4219*/    OPC_MoveChild1,
/*  4220*/    OPC_CheckImmAllOnesV,
/*  4221*/    OPC_MoveParent,
/*  4222*/    OPC_MoveParent,
/*  4223*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4233
/*  4226*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4233*/    /*SwitchType*/ 7, MVT::v8i16,// ->4242
/*  4235*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4242*/    /*SwitchType*/ 7, MVT::v4i32,// ->4251
/*  4244*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4251*/    /*SwitchType*/ 7, MVT::v2i64,// ->4260
/*  4253*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4260*/    0, // EndSwitchType
/*  4261*/   0, /*End of Scope*/
/*  4262*/  /*Scope*/ 48, /*->4311*/
/*  4263*/   OPC_MoveChild0,
/*  4264*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4267*/   OPC_RecordChild0, // #0 = $rhs
/*  4268*/   OPC_MoveChild1,
/*  4269*/   OPC_CheckImmAllOnesV,
/*  4270*/   OPC_MoveParent,
/*  4271*/   OPC_MoveParent,
/*  4272*/   OPC_RecordChild1, // #1 = $lhs
/*  4273*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4283
/*  4276*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v16i8, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4283*/   /*SwitchType*/ 7, MVT::v8i16,// ->4292
/*  4285*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v8i16, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4292*/   /*SwitchType*/ 7, MVT::v4i32,// ->4301
/*  4294*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v4i32, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4301*/   /*SwitchType*/ 7, MVT::v2i64,// ->4310
/*  4303*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v2i64, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4310*/   0, // EndSwitchType
/*  4311*/  /*Scope*/ 40, /*->4352*/
/*  4312*/   OPC_RecordChild0, // #0 = $lhs
/*  4313*/   OPC_RecordChild1, // #1 = $rhs
/*  4314*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4324
/*  4317*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4324*/   /*SwitchType*/ 7, MVT::v8i16,// ->4333
/*  4326*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4333*/   /*SwitchType*/ 7, MVT::v4i32,// ->4342
/*  4335*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4342*/   /*SwitchType*/ 7, MVT::v2i64,// ->4351
/*  4344*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4351*/   0, // EndSwitchType
/*  4352*/  0, /*End of Scope*/
/*  4353*/ /*SwitchOpcode*/ 124|128,11/*1532*/, TARGET_VAL(ISD::SETCC),// ->5889
/*  4357*/  OPC_Scope, 126|128,1/*254*/, /*->4614*/ // 2 children in Scope
/*  4360*/   OPC_MoveChild0,
/*  4361*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4364*/   OPC_Scope, 123, /*->4489*/ // 2 children in Scope
/*  4366*/    OPC_CheckChild0Integer, 114|128,65|128,1/*24818*/, 
/*  4370*/    OPC_RecordChild1, // #0 = $x
/*  4371*/    OPC_Scope, 28, /*->4401*/ // 4 children in Scope
/*  4373*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4375*/     OPC_MoveParent,
/*  4376*/     OPC_CheckTypeI32,
/*  4377*/     OPC_Scope, 10, /*->4389*/ // 2 children in Scope
/*  4379*/      OPC_CheckChild1Integer, 0, 
/*  4381*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4383*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4389*/     /*Scope*/ 10, /*->4400*/
/*  4390*/      OPC_CheckChild1Integer, 2, 
/*  4392*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4394*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4400*/     0, /*End of Scope*/
/*  4401*/    /*Scope*/ 28, /*->4430*/
/*  4402*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4404*/     OPC_MoveParent,
/*  4405*/     OPC_CheckTypeI32,
/*  4406*/     OPC_Scope, 10, /*->4418*/ // 2 children in Scope
/*  4408*/      OPC_CheckChild1Integer, 0, 
/*  4410*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4412*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4418*/     /*Scope*/ 10, /*->4429*/
/*  4419*/      OPC_CheckChild1Integer, 2, 
/*  4421*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4423*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4429*/     0, /*End of Scope*/
/*  4430*/    /*Scope*/ 28, /*->4459*/
/*  4431*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4433*/     OPC_MoveParent,
/*  4434*/     OPC_CheckTypeI32,
/*  4435*/     OPC_Scope, 10, /*->4447*/ // 2 children in Scope
/*  4437*/      OPC_CheckChild1Integer, 0, 
/*  4439*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4441*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4447*/     /*Scope*/ 10, /*->4458*/
/*  4448*/      OPC_CheckChild1Integer, 2, 
/*  4450*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4452*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4458*/     0, /*End of Scope*/
/*  4459*/    /*Scope*/ 28, /*->4488*/
/*  4460*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4462*/     OPC_MoveParent,
/*  4463*/     OPC_CheckTypeI32,
/*  4464*/     OPC_Scope, 10, /*->4476*/ // 2 children in Scope
/*  4466*/      OPC_CheckChild1Integer, 0, 
/*  4468*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4470*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4476*/     /*Scope*/ 10, /*->4487*/
/*  4477*/      OPC_CheckChild1Integer, 2, 
/*  4479*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4481*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4487*/     0, /*End of Scope*/
/*  4488*/    0, /*End of Scope*/
/*  4489*/   /*Scope*/ 123, /*->4613*/
/*  4490*/    OPC_CheckChild0Integer, 112|128,65|128,1/*24816*/, 
/*  4494*/    OPC_RecordChild1, // #0 = $x
/*  4495*/    OPC_Scope, 28, /*->4525*/ // 4 children in Scope
/*  4497*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4499*/     OPC_MoveParent,
/*  4500*/     OPC_CheckTypeI32,
/*  4501*/     OPC_Scope, 10, /*->4513*/ // 2 children in Scope
/*  4503*/      OPC_CheckChild1Integer, 0, 
/*  4505*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4507*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4513*/     /*Scope*/ 10, /*->4524*/
/*  4514*/      OPC_CheckChild1Integer, 2, 
/*  4516*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4518*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4524*/     0, /*End of Scope*/
/*  4525*/    /*Scope*/ 28, /*->4554*/
/*  4526*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4528*/     OPC_MoveParent,
/*  4529*/     OPC_CheckTypeI32,
/*  4530*/     OPC_Scope, 10, /*->4542*/ // 2 children in Scope
/*  4532*/      OPC_CheckChild1Integer, 0, 
/*  4534*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4536*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4542*/     /*Scope*/ 10, /*->4553*/
/*  4543*/      OPC_CheckChild1Integer, 2, 
/*  4545*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4547*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4553*/     0, /*End of Scope*/
/*  4554*/    /*Scope*/ 28, /*->4583*/
/*  4555*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4557*/     OPC_MoveParent,
/*  4558*/     OPC_CheckTypeI32,
/*  4559*/     OPC_Scope, 10, /*->4571*/ // 2 children in Scope
/*  4561*/      OPC_CheckChild1Integer, 0, 
/*  4563*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4565*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4571*/     /*Scope*/ 10, /*->4582*/
/*  4572*/      OPC_CheckChild1Integer, 2, 
/*  4574*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4576*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4582*/     0, /*End of Scope*/
/*  4583*/    /*Scope*/ 28, /*->4612*/
/*  4584*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4586*/     OPC_MoveParent,
/*  4587*/     OPC_CheckTypeI32,
/*  4588*/     OPC_Scope, 10, /*->4600*/ // 2 children in Scope
/*  4590*/      OPC_CheckChild1Integer, 0, 
/*  4592*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4594*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4600*/     /*Scope*/ 10, /*->4611*/
/*  4601*/      OPC_CheckChild1Integer, 2, 
/*  4603*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4605*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4611*/     0, /*End of Scope*/
/*  4612*/    0, /*End of Scope*/
/*  4613*/   0, /*End of Scope*/
/*  4614*/  /*Scope*/ 120|128,9/*1272*/, /*->5888*/
/*  4616*/   OPC_RecordChild0, // #0 = $src
/*  4617*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, MVT::i32,// ->5113
/*  4621*/    OPC_Scope, 118, /*->4741*/ // 4 children in Scope
/*  4623*/     OPC_CheckChild0TypeI32,
/*  4624*/     OPC_Scope, 10, /*->4636*/ // 2 children in Scope
/*  4626*/      OPC_CheckChild1Integer, 0, 
/*  4628*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4630*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4636*/     /*Scope*/ 103, /*->4740*/
/*  4637*/      OPC_RecordChild1, // #1 = $rhs
/*  4638*/      OPC_Scope, 9, /*->4649*/ // 10 children in Scope
/*  4640*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4642*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4649*/      /*Scope*/ 9, /*->4659*/
/*  4650*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4652*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4659*/      /*Scope*/ 9, /*->4669*/
/*  4660*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4662*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4669*/      /*Scope*/ 9, /*->4679*/
/*  4670*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4672*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4679*/      /*Scope*/ 9, /*->4689*/
/*  4680*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4682*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4689*/      /*Scope*/ 9, /*->4699*/
/*  4690*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4692*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4699*/      /*Scope*/ 9, /*->4709*/
/*  4700*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4702*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4709*/      /*Scope*/ 9, /*->4719*/
/*  4710*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4712*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4719*/      /*Scope*/ 9, /*->4729*/
/*  4720*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4722*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4729*/      /*Scope*/ 9, /*->4739*/
/*  4730*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4732*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4739*/      0, /*End of Scope*/
/*  4740*/     0, /*End of Scope*/
/*  4741*/    /*Scope*/ 118, /*->4860*/
/*  4742*/     OPC_CheckChild0TypeI64,
/*  4743*/     OPC_Scope, 10, /*->4755*/ // 2 children in Scope
/*  4745*/      OPC_CheckChild1Integer, 0, 
/*  4747*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4749*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4755*/     /*Scope*/ 103, /*->4859*/
/*  4756*/      OPC_RecordChild1, // #1 = $rhs
/*  4757*/      OPC_Scope, 9, /*->4768*/ // 10 children in Scope
/*  4759*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4761*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4768*/      /*Scope*/ 9, /*->4778*/
/*  4769*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4771*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4778*/      /*Scope*/ 9, /*->4788*/
/*  4779*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4781*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4788*/      /*Scope*/ 9, /*->4798*/
/*  4789*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4791*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4798*/      /*Scope*/ 9, /*->4808*/
/*  4799*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4801*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4808*/      /*Scope*/ 9, /*->4818*/
/*  4809*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4811*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4818*/      /*Scope*/ 9, /*->4828*/
/*  4819*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4821*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4828*/      /*Scope*/ 9, /*->4838*/
/*  4829*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4831*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4838*/      /*Scope*/ 9, /*->4848*/
/*  4839*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4841*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4848*/      /*Scope*/ 9, /*->4858*/
/*  4849*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4851*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4858*/      0, /*End of Scope*/
/*  4859*/     0, /*End of Scope*/
/*  4860*/    /*Scope*/ 125, /*->4986*/
/*  4861*/     OPC_CheckChild0Type, MVT::f32,
/*  4863*/     OPC_RecordChild1, // #1 = $rhs
/*  4864*/     OPC_Scope, 9, /*->4875*/ // 12 children in Scope
/*  4866*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4868*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4875*/     /*Scope*/ 9, /*->4885*/
/*  4876*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4878*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4885*/     /*Scope*/ 9, /*->4895*/
/*  4886*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4888*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4895*/     /*Scope*/ 9, /*->4905*/
/*  4896*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4898*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4905*/     /*Scope*/ 9, /*->4915*/
/*  4906*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4908*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4915*/     /*Scope*/ 9, /*->4925*/
/*  4916*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4918*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4925*/     /*Scope*/ 9, /*->4935*/
/*  4926*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4928*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4935*/     /*Scope*/ 9, /*->4945*/
/*  4936*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4938*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4945*/     /*Scope*/ 9, /*->4955*/
/*  4946*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  4948*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4955*/     /*Scope*/ 9, /*->4965*/
/*  4956*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  4958*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4965*/     /*Scope*/ 9, /*->4975*/
/*  4966*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  4968*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4975*/     /*Scope*/ 9, /*->4985*/
/*  4976*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  4978*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4985*/     0, /*End of Scope*/
/*  4986*/    /*Scope*/ 125, /*->5112*/
/*  4987*/     OPC_CheckChild0Type, MVT::f64,
/*  4989*/     OPC_RecordChild1, // #1 = $rhs
/*  4990*/     OPC_Scope, 9, /*->5001*/ // 12 children in Scope
/*  4992*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4994*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5001*/     /*Scope*/ 9, /*->5011*/
/*  5002*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5004*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5011*/     /*Scope*/ 9, /*->5021*/
/*  5012*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5014*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5021*/     /*Scope*/ 9, /*->5031*/
/*  5022*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5024*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5031*/     /*Scope*/ 9, /*->5041*/
/*  5032*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5034*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5041*/     /*Scope*/ 9, /*->5051*/
/*  5042*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5044*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5051*/     /*Scope*/ 9, /*->5061*/
/*  5052*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5054*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5061*/     /*Scope*/ 9, /*->5071*/
/*  5062*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5064*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5071*/     /*Scope*/ 9, /*->5081*/
/*  5072*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5074*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5081*/     /*Scope*/ 9, /*->5091*/
/*  5082*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5084*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5091*/     /*Scope*/ 9, /*->5101*/
/*  5092*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5094*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5101*/     /*Scope*/ 9, /*->5111*/
/*  5102*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5104*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5111*/     0, /*End of Scope*/
/*  5112*/    0, /*End of Scope*/
/*  5113*/   /*SwitchType*/ 115, MVT::v16i8,// ->5230
/*  5115*/    OPC_CheckChild0Type, MVT::v16i8,
/*  5117*/    OPC_RecordChild1, // #1 = $rhs
/*  5118*/    OPC_Scope, 10, /*->5130*/ // 10 children in Scope
/*  5120*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5122*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5123*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5130*/    /*Scope*/ 10, /*->5141*/
/*  5131*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5133*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5134*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5141*/    /*Scope*/ 10, /*->5152*/
/*  5142*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5144*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5145*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5152*/    /*Scope*/ 10, /*->5163*/
/*  5153*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5155*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5156*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5163*/    /*Scope*/ 10, /*->5174*/
/*  5164*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5166*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5167*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5174*/    /*Scope*/ 10, /*->5185*/
/*  5175*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5177*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5178*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5185*/    /*Scope*/ 10, /*->5196*/
/*  5186*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5188*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5189*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5196*/    /*Scope*/ 10, /*->5207*/
/*  5197*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5199*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5200*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5207*/    /*Scope*/ 10, /*->5218*/
/*  5208*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5210*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5211*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5218*/    /*Scope*/ 10, /*->5229*/
/*  5219*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5221*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5222*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5229*/    0, /*End of Scope*/
/*  5230*/   /*SwitchType*/ 62|128,1/*190*/, MVT::v8i16,// ->5423
/*  5233*/    OPC_Scope, 115, /*->5350*/ // 2 children in Scope
/*  5235*/     OPC_CheckChild0Type, MVT::v8i16,
/*  5237*/     OPC_RecordChild1, // #1 = $rhs
/*  5238*/     OPC_Scope, 10, /*->5250*/ // 10 children in Scope
/*  5240*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5242*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5243*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5250*/     /*Scope*/ 10, /*->5261*/
/*  5251*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5253*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5254*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5261*/     /*Scope*/ 10, /*->5272*/
/*  5262*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5264*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5265*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5272*/     /*Scope*/ 10, /*->5283*/
/*  5273*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5275*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5276*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5283*/     /*Scope*/ 10, /*->5294*/
/*  5284*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5286*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5287*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5294*/     /*Scope*/ 10, /*->5305*/
/*  5295*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5297*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5298*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5305*/     /*Scope*/ 10, /*->5316*/
/*  5306*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5308*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5309*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5316*/     /*Scope*/ 10, /*->5327*/
/*  5317*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5319*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5320*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5327*/     /*Scope*/ 10, /*->5338*/
/*  5328*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5330*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5331*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5338*/     /*Scope*/ 10, /*->5349*/
/*  5339*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5341*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5342*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5349*/     0, /*End of Scope*/
/*  5350*/    /*Scope*/ 71, /*->5422*/
/*  5351*/     OPC_CheckChild0Type, MVT::v8f16,
/*  5353*/     OPC_RecordChild1, // #1 = $rhs
/*  5354*/     OPC_Scope, 10, /*->5366*/ // 6 children in Scope
/*  5356*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5358*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5359*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5366*/     /*Scope*/ 10, /*->5377*/
/*  5367*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5369*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5370*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5377*/     /*Scope*/ 10, /*->5388*/
/*  5378*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5380*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5381*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5388*/     /*Scope*/ 10, /*->5399*/
/*  5389*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5391*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5392*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5399*/     /*Scope*/ 10, /*->5410*/
/*  5400*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5402*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5403*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5410*/     /*Scope*/ 10, /*->5421*/
/*  5411*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5413*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5414*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5421*/     0, /*End of Scope*/
/*  5422*/    0, /*End of Scope*/
/*  5423*/   /*SwitchType*/ 123|128,1/*251*/, MVT::v4i32,// ->5677
/*  5426*/    OPC_Scope, 115, /*->5543*/ // 2 children in Scope
/*  5428*/     OPC_CheckChild0Type, MVT::v4i32,
/*  5430*/     OPC_RecordChild1, // #1 = $rhs
/*  5431*/     OPC_Scope, 10, /*->5443*/ // 10 children in Scope
/*  5433*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5435*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5436*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5443*/     /*Scope*/ 10, /*->5454*/
/*  5444*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5446*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5447*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5454*/     /*Scope*/ 10, /*->5465*/
/*  5455*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5457*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5458*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5465*/     /*Scope*/ 10, /*->5476*/
/*  5466*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5468*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5469*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5476*/     /*Scope*/ 10, /*->5487*/
/*  5477*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5479*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5480*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5487*/     /*Scope*/ 10, /*->5498*/
/*  5488*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5490*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5491*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5498*/     /*Scope*/ 10, /*->5509*/
/*  5499*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5501*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5502*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5509*/     /*Scope*/ 10, /*->5520*/
/*  5510*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5512*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5513*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5520*/     /*Scope*/ 10, /*->5531*/
/*  5521*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5523*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5524*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5531*/     /*Scope*/ 10, /*->5542*/
/*  5532*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5534*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5535*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5542*/     0, /*End of Scope*/
/*  5543*/    /*Scope*/ 3|128,1/*131*/, /*->5676*/
/*  5545*/     OPC_CheckChild0Type, MVT::v4f32,
/*  5547*/     OPC_RecordChild1, // #1 = $rhs
/*  5548*/     OPC_Scope, 10, /*->5560*/ // 12 children in Scope
/*  5550*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5552*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5553*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5560*/     /*Scope*/ 10, /*->5571*/
/*  5561*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5563*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5564*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5571*/     /*Scope*/ 10, /*->5582*/
/*  5572*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5574*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5575*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5582*/     /*Scope*/ 10, /*->5593*/
/*  5583*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5585*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5586*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5593*/     /*Scope*/ 10, /*->5604*/
/*  5594*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5596*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5597*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5604*/     /*Scope*/ 10, /*->5615*/
/*  5605*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5607*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5608*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5615*/     /*Scope*/ 9, /*->5625*/
/*  5616*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5618*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5625*/     /*Scope*/ 9, /*->5635*/
/*  5626*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5628*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5635*/     /*Scope*/ 9, /*->5645*/
/*  5636*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5638*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5645*/     /*Scope*/ 9, /*->5655*/
/*  5646*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5648*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5655*/     /*Scope*/ 9, /*->5665*/
/*  5656*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5658*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5665*/     /*Scope*/ 9, /*->5675*/
/*  5666*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5668*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5675*/     0, /*End of Scope*/
/*  5676*/    0, /*End of Scope*/
/*  5677*/   /*SwitchType*/ 79|128,1/*207*/, MVT::v2i64,// ->5887
/*  5680*/    OPC_Scope, 71, /*->5753*/ // 2 children in Scope
/*  5682*/     OPC_CheckChild0Type, MVT::v2i64,
/*  5684*/     OPC_RecordChild1, // #1 = $rhs
/*  5685*/     OPC_Scope, 10, /*->5697*/ // 6 children in Scope
/*  5687*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5689*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5690*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5697*/     /*Scope*/ 10, /*->5708*/
/*  5698*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5700*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5701*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5708*/     /*Scope*/ 10, /*->5719*/
/*  5709*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5711*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5712*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5719*/     /*Scope*/ 10, /*->5730*/
/*  5720*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5722*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5723*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5730*/     /*Scope*/ 10, /*->5741*/
/*  5731*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5733*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5734*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5741*/     /*Scope*/ 10, /*->5752*/
/*  5742*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5744*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5745*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5752*/     0, /*End of Scope*/
/*  5753*/    /*Scope*/ 3|128,1/*131*/, /*->5886*/
/*  5755*/     OPC_CheckChild0Type, MVT::v2f64,
/*  5757*/     OPC_RecordChild1, // #1 = $rhs
/*  5758*/     OPC_Scope, 10, /*->5770*/ // 12 children in Scope
/*  5760*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5762*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5763*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5770*/     /*Scope*/ 10, /*->5781*/
/*  5771*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5773*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5774*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5781*/     /*Scope*/ 10, /*->5792*/
/*  5782*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5784*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5785*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5792*/     /*Scope*/ 10, /*->5803*/
/*  5793*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5795*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5796*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5803*/     /*Scope*/ 10, /*->5814*/
/*  5804*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5806*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5807*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5814*/     /*Scope*/ 10, /*->5825*/
/*  5815*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5817*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5818*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5825*/     /*Scope*/ 9, /*->5835*/
/*  5826*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5828*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5835*/     /*Scope*/ 9, /*->5845*/
/*  5836*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5838*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5845*/     /*Scope*/ 9, /*->5855*/
/*  5846*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5848*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5855*/     /*Scope*/ 9, /*->5865*/
/*  5856*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5858*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5865*/     /*Scope*/ 9, /*->5875*/
/*  5866*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5868*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5875*/     /*Scope*/ 9, /*->5885*/
/*  5876*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5878*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5885*/     0, /*End of Scope*/
/*  5886*/    0, /*End of Scope*/
/*  5887*/   0, // EndSwitchType
/*  5888*/  0, /*End of Scope*/
/*  5889*/ /*SwitchOpcode*/ 17|128,11/*1425*/, TARGET_VAL(ISD::LOAD),// ->7318
/*  5893*/  OPC_RecordMemRef,
/*  5894*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  5895*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  5896*/  OPC_Scope, 68|128,5/*708*/, /*->6607*/ // 2 children in Scope
/*  5899*/   OPC_CheckChild1TypeI32,
/*  5900*/   OPC_CheckPredicate, 9, // Predicate_unindexedload
/*  5902*/   OPC_Scope, 37, /*->5941*/ // 16 children in Scope
/*  5904*/    OPC_CheckPredicate7,  // Predicate_load
/*  5905*/    OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->5923
/*  5908*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5909*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5911*/     OPC_EmitMergeInputChains1_0,
/*  5912*/     OPC_EmitInteger32, 0, 
/*  5914*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5923*/    /*SwitchType*/ 15, MVT::i64,// ->5940
/*  5925*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5926*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5928*/     OPC_EmitMergeInputChains1_0,
/*  5929*/     OPC_EmitInteger32, 0, 
/*  5931*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5940*/    0, // EndSwitchType
/*  5941*/   /*Scope*/ 97, /*->6039*/
/*  5942*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  5944*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->5983
/*  5947*/     OPC_Scope, 16, /*->5965*/ // 2 children in Scope
/*  5949*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  5950*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5951*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5953*/      OPC_EmitMergeInputChains1_0,
/*  5954*/      OPC_EmitInteger32, 0, 
/*  5956*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5965*/     /*Scope*/ 16, /*->5982*/
/*  5966*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  5967*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5968*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5970*/      OPC_EmitMergeInputChains1_0,
/*  5971*/      OPC_EmitInteger32, 0, 
/*  5973*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5982*/     0, /*End of Scope*/
/*  5983*/    /*SwitchType*/ 53, MVT::i64,// ->6038
/*  5985*/     OPC_Scope, 16, /*->6003*/ // 3 children in Scope
/*  5987*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  5988*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5989*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5991*/      OPC_EmitMergeInputChains1_0,
/*  5992*/      OPC_EmitInteger32, 0, 
/*  5994*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6003*/     /*Scope*/ 16, /*->6020*/
/*  6004*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6005*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6006*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6008*/      OPC_EmitMergeInputChains1_0,
/*  6009*/      OPC_EmitInteger32, 0, 
/*  6011*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6020*/     /*Scope*/ 16, /*->6037*/
/*  6021*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6022*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6023*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6025*/      OPC_EmitMergeInputChains1_0,
/*  6026*/      OPC_EmitInteger32, 0, 
/*  6028*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6037*/     0, /*End of Scope*/
/*  6038*/    0, // EndSwitchType
/*  6039*/   /*Scope*/ 97, /*->6137*/
/*  6040*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6042*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6081
/*  6045*/     OPC_Scope, 16, /*->6063*/ // 2 children in Scope
/*  6047*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6048*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6049*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6051*/      OPC_EmitMergeInputChains1_0,
/*  6052*/      OPC_EmitInteger32, 0, 
/*  6054*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6063*/     /*Scope*/ 16, /*->6080*/
/*  6064*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6065*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6066*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6068*/      OPC_EmitMergeInputChains1_0,
/*  6069*/      OPC_EmitInteger32, 0, 
/*  6071*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6080*/     0, /*End of Scope*/
/*  6081*/    /*SwitchType*/ 53, MVT::i64,// ->6136
/*  6083*/     OPC_Scope, 16, /*->6101*/ // 3 children in Scope
/*  6085*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6086*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6087*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6089*/      OPC_EmitMergeInputChains1_0,
/*  6090*/      OPC_EmitInteger32, 0, 
/*  6092*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6101*/     /*Scope*/ 16, /*->6118*/
/*  6102*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6103*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6104*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6106*/      OPC_EmitMergeInputChains1_0,
/*  6107*/      OPC_EmitInteger32, 0, 
/*  6109*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6118*/     /*Scope*/ 16, /*->6135*/
/*  6119*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6120*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6121*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6123*/      OPC_EmitMergeInputChains1_0,
/*  6124*/      OPC_EmitInteger32, 0, 
/*  6126*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6135*/     0, /*End of Scope*/
/*  6136*/    0, // EndSwitchType
/*  6137*/   /*Scope*/ 97, /*->6235*/
/*  6138*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6140*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6179
/*  6143*/     OPC_Scope, 16, /*->6161*/ // 2 children in Scope
/*  6145*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6146*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6147*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6149*/      OPC_EmitMergeInputChains1_0,
/*  6150*/      OPC_EmitInteger32, 0, 
/*  6152*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6161*/     /*Scope*/ 16, /*->6178*/
/*  6162*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6163*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6164*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6166*/      OPC_EmitMergeInputChains1_0,
/*  6167*/      OPC_EmitInteger32, 0, 
/*  6169*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6178*/     0, /*End of Scope*/
/*  6179*/    /*SwitchType*/ 53, MVT::i64,// ->6234
/*  6181*/     OPC_Scope, 16, /*->6199*/ // 3 children in Scope
/*  6183*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6184*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6185*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6187*/      OPC_EmitMergeInputChains1_0,
/*  6188*/      OPC_EmitInteger32, 0, 
/*  6190*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6199*/     /*Scope*/ 16, /*->6216*/
/*  6200*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6201*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6202*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6204*/      OPC_EmitMergeInputChains1_0,
/*  6205*/      OPC_EmitInteger32, 0, 
/*  6207*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6216*/     /*Scope*/ 16, /*->6233*/
/*  6217*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6218*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6219*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6221*/      OPC_EmitMergeInputChains1_0,
/*  6222*/      OPC_EmitInteger32, 0, 
/*  6224*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6233*/     0, /*End of Scope*/
/*  6234*/    0, // EndSwitchType
/*  6235*/   /*Scope*/ 105, /*->6341*/
/*  6236*/    OPC_CheckPredicate7,  // Predicate_load
/*  6237*/    OPC_SwitchType /*6 cases */, 15, MVT::f32,// ->6255
/*  6240*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6241*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6243*/     OPC_EmitMergeInputChains1_0,
/*  6244*/     OPC_EmitInteger32, 0, 
/*  6246*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6255*/    /*SwitchType*/ 15, MVT::f64,// ->6272
/*  6257*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6258*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6260*/     OPC_EmitMergeInputChains1_0,
/*  6261*/     OPC_EmitInteger32, 0, 
/*  6263*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6272*/    /*SwitchType*/ 15, MVT::v16i8,// ->6289
/*  6274*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6275*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6277*/     OPC_EmitMergeInputChains1_0,
/*  6278*/     OPC_EmitInteger32, 0, 
/*  6280*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6289*/    /*SwitchType*/ 15, MVT::v8i16,// ->6306
/*  6291*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6292*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6294*/     OPC_EmitMergeInputChains1_0,
/*  6295*/     OPC_EmitInteger32, 0, 
/*  6297*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6306*/    /*SwitchType*/ 15, MVT::v4i32,// ->6323
/*  6308*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6309*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6311*/     OPC_EmitMergeInputChains1_0,
/*  6312*/     OPC_EmitInteger32, 0, 
/*  6314*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6323*/    /*SwitchType*/ 15, MVT::v2i64,// ->6340
/*  6325*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6326*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6328*/     OPC_EmitMergeInputChains1_0,
/*  6329*/     OPC_EmitInteger32, 0, 
/*  6331*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6340*/    0, // EndSwitchType
/*  6341*/   /*Scope*/ 21, /*->6363*/
/*  6342*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6344*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6346*/    OPC_CheckType, MVT::v8i16,
/*  6348*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6349*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6351*/    OPC_EmitMergeInputChains1_0,
/*  6352*/    OPC_EmitInteger32, 0, 
/*  6354*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6363*/   /*Scope*/ 21, /*->6385*/
/*  6364*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6366*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6368*/    OPC_CheckType, MVT::v8i16,
/*  6370*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6371*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6373*/    OPC_EmitMergeInputChains1_0,
/*  6374*/    OPC_EmitInteger32, 0, 
/*  6376*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6385*/   /*Scope*/ 21, /*->6407*/
/*  6386*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6388*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6390*/    OPC_CheckType, MVT::v8i16,
/*  6392*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6393*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6395*/    OPC_EmitMergeInputChains1_0,
/*  6396*/    OPC_EmitInteger32, 0, 
/*  6398*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6407*/   /*Scope*/ 21, /*->6429*/
/*  6408*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6410*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6412*/    OPC_CheckType, MVT::v4i32,
/*  6414*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6415*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6417*/    OPC_EmitMergeInputChains1_0,
/*  6418*/    OPC_EmitInteger32, 0, 
/*  6420*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6429*/   /*Scope*/ 21, /*->6451*/
/*  6430*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6432*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6434*/    OPC_CheckType, MVT::v4i32,
/*  6436*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6437*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6439*/    OPC_EmitMergeInputChains1_0,
/*  6440*/    OPC_EmitInteger32, 0, 
/*  6442*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6451*/   /*Scope*/ 21, /*->6473*/
/*  6452*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6454*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6456*/    OPC_CheckType, MVT::v4i32,
/*  6458*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6459*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6461*/    OPC_EmitMergeInputChains1_0,
/*  6462*/    OPC_EmitInteger32, 0, 
/*  6464*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6473*/   /*Scope*/ 21, /*->6495*/
/*  6474*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6476*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6478*/    OPC_CheckType, MVT::v2i64,
/*  6480*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6481*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6483*/    OPC_EmitMergeInputChains1_0,
/*  6484*/    OPC_EmitInteger32, 0, 
/*  6486*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6495*/   /*Scope*/ 21, /*->6517*/
/*  6496*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6498*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6500*/    OPC_CheckType, MVT::v2i64,
/*  6502*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6503*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6505*/    OPC_EmitMergeInputChains1_0,
/*  6506*/    OPC_EmitInteger32, 0, 
/*  6508*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6517*/   /*Scope*/ 21, /*->6539*/
/*  6518*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6520*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6522*/    OPC_CheckType, MVT::v2i64,
/*  6524*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6525*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6527*/    OPC_EmitMergeInputChains1_0,
/*  6528*/    OPC_EmitInteger32, 0, 
/*  6530*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6539*/   /*Scope*/ 37, /*->6577*/
/*  6540*/    OPC_CheckPredicate7,  // Predicate_load
/*  6541*/    OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->6559
/*  6544*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6545*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6547*/     OPC_EmitMergeInputChains1_0,
/*  6548*/     OPC_EmitInteger32, 0, 
/*  6550*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6559*/    /*SwitchType*/ 15, MVT::v2f64,// ->6576
/*  6561*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6562*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6564*/     OPC_EmitMergeInputChains1_0,
/*  6565*/     OPC_EmitInteger32, 0, 
/*  6567*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6576*/    0, // EndSwitchType
/*  6577*/   /*Scope*/ 28, /*->6606*/
/*  6578*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6580*/    OPC_CheckType, MVT::v2f64,
/*  6582*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6583*/    OPC_EmitMergeInputChains1_0,
/*  6584*/    OPC_EmitInteger32, 0, 
/*  6586*/    OPC_EmitInteger32, 0, 
/*  6588*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6597*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  6603*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6606*/   0, /*End of Scope*/
/*  6607*/  /*Scope*/ 68|128,5/*708*/, /*->7317*/
/*  6609*/   OPC_CheckChild1TypeI64,
/*  6610*/   OPC_CheckPredicate, 9, // Predicate_unindexedload
/*  6612*/   OPC_Scope, 37, /*->6651*/ // 16 children in Scope
/*  6614*/    OPC_CheckPredicate7,  // Predicate_load
/*  6615*/    OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->6633
/*  6618*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6619*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6621*/     OPC_EmitMergeInputChains1_0,
/*  6622*/     OPC_EmitInteger32, 0, 
/*  6624*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6633*/    /*SwitchType*/ 15, MVT::i64,// ->6650
/*  6635*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6636*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6638*/     OPC_EmitMergeInputChains1_0,
/*  6639*/     OPC_EmitInteger32, 0, 
/*  6641*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6650*/    0, // EndSwitchType
/*  6651*/   /*Scope*/ 97, /*->6749*/
/*  6652*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6654*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6693
/*  6657*/     OPC_Scope, 16, /*->6675*/ // 2 children in Scope
/*  6659*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6660*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6661*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6663*/      OPC_EmitMergeInputChains1_0,
/*  6664*/      OPC_EmitInteger32, 0, 
/*  6666*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6675*/     /*Scope*/ 16, /*->6692*/
/*  6676*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6677*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6678*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6680*/      OPC_EmitMergeInputChains1_0,
/*  6681*/      OPC_EmitInteger32, 0, 
/*  6683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6692*/     0, /*End of Scope*/
/*  6693*/    /*SwitchType*/ 53, MVT::i64,// ->6748
/*  6695*/     OPC_Scope, 16, /*->6713*/ // 3 children in Scope
/*  6697*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6698*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6699*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6701*/      OPC_EmitMergeInputChains1_0,
/*  6702*/      OPC_EmitInteger32, 0, 
/*  6704*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6713*/     /*Scope*/ 16, /*->6730*/
/*  6714*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6715*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6716*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6718*/      OPC_EmitMergeInputChains1_0,
/*  6719*/      OPC_EmitInteger32, 0, 
/*  6721*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6730*/     /*Scope*/ 16, /*->6747*/
/*  6731*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6732*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6733*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6735*/      OPC_EmitMergeInputChains1_0,
/*  6736*/      OPC_EmitInteger32, 0, 
/*  6738*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6747*/     0, /*End of Scope*/
/*  6748*/    0, // EndSwitchType
/*  6749*/   /*Scope*/ 97, /*->6847*/
/*  6750*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6752*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6791
/*  6755*/     OPC_Scope, 16, /*->6773*/ // 2 children in Scope
/*  6757*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6758*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6759*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6761*/      OPC_EmitMergeInputChains1_0,
/*  6762*/      OPC_EmitInteger32, 0, 
/*  6764*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6773*/     /*Scope*/ 16, /*->6790*/
/*  6774*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6775*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6776*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6778*/      OPC_EmitMergeInputChains1_0,
/*  6779*/      OPC_EmitInteger32, 0, 
/*  6781*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6790*/     0, /*End of Scope*/
/*  6791*/    /*SwitchType*/ 53, MVT::i64,// ->6846
/*  6793*/     OPC_Scope, 16, /*->6811*/ // 3 children in Scope
/*  6795*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6796*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6797*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6799*/      OPC_EmitMergeInputChains1_0,
/*  6800*/      OPC_EmitInteger32, 0, 
/*  6802*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6811*/     /*Scope*/ 16, /*->6828*/
/*  6812*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6813*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6814*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6816*/      OPC_EmitMergeInputChains1_0,
/*  6817*/      OPC_EmitInteger32, 0, 
/*  6819*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6828*/     /*Scope*/ 16, /*->6845*/
/*  6829*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6830*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6831*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6833*/      OPC_EmitMergeInputChains1_0,
/*  6834*/      OPC_EmitInteger32, 0, 
/*  6836*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6845*/     0, /*End of Scope*/
/*  6846*/    0, // EndSwitchType
/*  6847*/   /*Scope*/ 97, /*->6945*/
/*  6848*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6850*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6889
/*  6853*/     OPC_Scope, 16, /*->6871*/ // 2 children in Scope
/*  6855*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6856*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6857*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6859*/      OPC_EmitMergeInputChains1_0,
/*  6860*/      OPC_EmitInteger32, 0, 
/*  6862*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6871*/     /*Scope*/ 16, /*->6888*/
/*  6872*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6873*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6874*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6876*/      OPC_EmitMergeInputChains1_0,
/*  6877*/      OPC_EmitInteger32, 0, 
/*  6879*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6888*/     0, /*End of Scope*/
/*  6889*/    /*SwitchType*/ 53, MVT::i64,// ->6944
/*  6891*/     OPC_Scope, 16, /*->6909*/ // 3 children in Scope
/*  6893*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6894*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6895*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6897*/      OPC_EmitMergeInputChains1_0,
/*  6898*/      OPC_EmitInteger32, 0, 
/*  6900*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6909*/     /*Scope*/ 16, /*->6926*/
/*  6910*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6911*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6912*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6914*/      OPC_EmitMergeInputChains1_0,
/*  6915*/      OPC_EmitInteger32, 0, 
/*  6917*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6926*/     /*Scope*/ 16, /*->6943*/
/*  6927*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6928*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6929*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6931*/      OPC_EmitMergeInputChains1_0,
/*  6932*/      OPC_EmitInteger32, 0, 
/*  6934*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6943*/     0, /*End of Scope*/
/*  6944*/    0, // EndSwitchType
/*  6945*/   /*Scope*/ 105, /*->7051*/
/*  6946*/    OPC_CheckPredicate7,  // Predicate_load
/*  6947*/    OPC_SwitchType /*6 cases */, 15, MVT::f32,// ->6965
/*  6950*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6951*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6953*/     OPC_EmitMergeInputChains1_0,
/*  6954*/     OPC_EmitInteger32, 0, 
/*  6956*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6965*/    /*SwitchType*/ 15, MVT::f64,// ->6982
/*  6967*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6968*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6970*/     OPC_EmitMergeInputChains1_0,
/*  6971*/     OPC_EmitInteger32, 0, 
/*  6973*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6982*/    /*SwitchType*/ 15, MVT::v16i8,// ->6999
/*  6984*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6985*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6987*/     OPC_EmitMergeInputChains1_0,
/*  6988*/     OPC_EmitInteger32, 0, 
/*  6990*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6999*/    /*SwitchType*/ 15, MVT::v8i16,// ->7016
/*  7001*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7002*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7004*/     OPC_EmitMergeInputChains1_0,
/*  7005*/     OPC_EmitInteger32, 0, 
/*  7007*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7016*/    /*SwitchType*/ 15, MVT::v4i32,// ->7033
/*  7018*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7019*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7021*/     OPC_EmitMergeInputChains1_0,
/*  7022*/     OPC_EmitInteger32, 0, 
/*  7024*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7033*/    /*SwitchType*/ 15, MVT::v2i64,// ->7050
/*  7035*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7036*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7038*/     OPC_EmitMergeInputChains1_0,
/*  7039*/     OPC_EmitInteger32, 0, 
/*  7041*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7050*/    0, // EndSwitchType
/*  7051*/   /*Scope*/ 21, /*->7073*/
/*  7052*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7054*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  7056*/    OPC_CheckType, MVT::v8i16,
/*  7058*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7059*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7061*/    OPC_EmitMergeInputChains1_0,
/*  7062*/    OPC_EmitInteger32, 0, 
/*  7064*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7073*/   /*Scope*/ 21, /*->7095*/
/*  7074*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7076*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  7078*/    OPC_CheckType, MVT::v8i16,
/*  7080*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7081*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7083*/    OPC_EmitMergeInputChains1_0,
/*  7084*/    OPC_EmitInteger32, 0, 
/*  7086*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7095*/   /*Scope*/ 21, /*->7117*/
/*  7096*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7098*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  7100*/    OPC_CheckType, MVT::v8i16,
/*  7102*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7103*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7105*/    OPC_EmitMergeInputChains1_0,
/*  7106*/    OPC_EmitInteger32, 0, 
/*  7108*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7117*/   /*Scope*/ 21, /*->7139*/
/*  7118*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7120*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  7122*/    OPC_CheckType, MVT::v4i32,
/*  7124*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7125*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7127*/    OPC_EmitMergeInputChains1_0,
/*  7128*/    OPC_EmitInteger32, 0, 
/*  7130*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7139*/   /*Scope*/ 21, /*->7161*/
/*  7140*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7142*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  7144*/    OPC_CheckType, MVT::v4i32,
/*  7146*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7147*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7149*/    OPC_EmitMergeInputChains1_0,
/*  7150*/    OPC_EmitInteger32, 0, 
/*  7152*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7161*/   /*Scope*/ 21, /*->7183*/
/*  7162*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7164*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  7166*/    OPC_CheckType, MVT::v4i32,
/*  7168*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7169*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7171*/    OPC_EmitMergeInputChains1_0,
/*  7172*/    OPC_EmitInteger32, 0, 
/*  7174*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7183*/   /*Scope*/ 21, /*->7205*/
/*  7184*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7186*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  7188*/    OPC_CheckType, MVT::v2i64,
/*  7190*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7191*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7193*/    OPC_EmitMergeInputChains1_0,
/*  7194*/    OPC_EmitInteger32, 0, 
/*  7196*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7205*/   /*Scope*/ 21, /*->7227*/
/*  7206*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7208*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  7210*/    OPC_CheckType, MVT::v2i64,
/*  7212*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7213*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7215*/    OPC_EmitMergeInputChains1_0,
/*  7216*/    OPC_EmitInteger32, 0, 
/*  7218*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7227*/   /*Scope*/ 21, /*->7249*/
/*  7228*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7230*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  7232*/    OPC_CheckType, MVT::v2i64,
/*  7234*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7235*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7237*/    OPC_EmitMergeInputChains1_0,
/*  7238*/    OPC_EmitInteger32, 0, 
/*  7240*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7249*/   /*Scope*/ 37, /*->7287*/
/*  7250*/    OPC_CheckPredicate7,  // Predicate_load
/*  7251*/    OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->7269
/*  7254*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7255*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7257*/     OPC_EmitMergeInputChains1_0,
/*  7258*/     OPC_EmitInteger32, 0, 
/*  7260*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7269*/    /*SwitchType*/ 15, MVT::v2f64,// ->7286
/*  7271*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7272*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7274*/     OPC_EmitMergeInputChains1_0,
/*  7275*/     OPC_EmitInteger32, 0, 
/*  7277*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7286*/    0, // EndSwitchType
/*  7287*/   /*Scope*/ 28, /*->7316*/
/*  7288*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7290*/    OPC_CheckType, MVT::v2f64,
/*  7292*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7293*/    OPC_EmitMergeInputChains1_0,
/*  7294*/    OPC_EmitInteger32, 0, 
/*  7296*/    OPC_EmitInteger64, 0, 
/*  7298*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7307*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  7313*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7316*/   0, /*End of Scope*/
/*  7317*/  0, /*End of Scope*/
/*  7318*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7481
/*  7322*/  OPC_RecordMemRef,
/*  7323*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7324*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7325*/  OPC_Scope, 76, /*->7403*/ // 2 children in Scope
/*  7327*/   OPC_CheckChild1TypeI32,
/*  7328*/   OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->7384
/*  7331*/    OPC_Scope, 16, /*->7349*/ // 3 children in Scope
/*  7333*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7334*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7335*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7337*/     OPC_EmitMergeInputChains1_0,
/*  7338*/     OPC_EmitInteger32, 0, 
/*  7340*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7349*/    /*Scope*/ 16, /*->7366*/
/*  7350*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7351*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7352*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7354*/     OPC_EmitMergeInputChains1_0,
/*  7355*/     OPC_EmitInteger32, 0, 
/*  7357*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7366*/    /*Scope*/ 16, /*->7383*/
/*  7367*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7368*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7369*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7371*/     OPC_EmitMergeInputChains1_0,
/*  7372*/     OPC_EmitInteger32, 0, 
/*  7374*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7383*/    0, /*End of Scope*/
/*  7384*/   /*SwitchType*/ 16, MVT::i64,// ->7402
/*  7386*/    OPC_CheckPredicate6,  // Predicate_atomic_load_64
/*  7387*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7388*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7390*/    OPC_EmitMergeInputChains1_0,
/*  7391*/    OPC_EmitInteger32, 0, 
/*  7393*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7402*/   0, // EndSwitchType
/*  7403*/  /*Scope*/ 76, /*->7480*/
/*  7404*/   OPC_CheckChild1TypeI64,
/*  7405*/   OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->7461
/*  7408*/    OPC_Scope, 16, /*->7426*/ // 3 children in Scope
/*  7410*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7411*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7412*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7414*/     OPC_EmitMergeInputChains1_0,
/*  7415*/     OPC_EmitInteger32, 0, 
/*  7417*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7426*/    /*Scope*/ 16, /*->7443*/
/*  7427*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7428*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7429*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7431*/     OPC_EmitMergeInputChains1_0,
/*  7432*/     OPC_EmitInteger32, 0, 
/*  7434*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7443*/    /*Scope*/ 16, /*->7460*/
/*  7444*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7445*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7446*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7448*/     OPC_EmitMergeInputChains1_0,
/*  7449*/     OPC_EmitInteger32, 0, 
/*  7451*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7460*/    0, /*End of Scope*/
/*  7461*/   /*SwitchType*/ 16, MVT::i64,// ->7479
/*  7463*/    OPC_CheckPredicate6,  // Predicate_atomic_load_64
/*  7464*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7465*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7467*/    OPC_EmitMergeInputChains1_0,
/*  7468*/    OPC_EmitInteger32, 0, 
/*  7470*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7479*/   0, // EndSwitchType
/*  7480*/  0, /*End of Scope*/
/*  7481*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7726
/*  7485*/  OPC_RecordMemRef,
/*  7486*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7487*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7488*/  OPC_Scope, 117, /*->7607*/ // 2 children in Scope
/*  7490*/   OPC_CheckChild1TypeI32,
/*  7491*/   OPC_RecordChild2, // #2 = $val
/*  7492*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7587
/*  7495*/    OPC_Scope, 17, /*->7514*/ // 5 children in Scope
/*  7497*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7498*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7499*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7501*/     OPC_EmitMergeInputChains1_0,
/*  7502*/     OPC_EmitInteger32, 0, 
/*  7504*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7514*/    /*Scope*/ 17, /*->7532*/
/*  7515*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7516*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7517*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7519*/     OPC_EmitMergeInputChains1_0,
/*  7520*/     OPC_EmitInteger32, 0, 
/*  7522*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7532*/    /*Scope*/ 17, /*->7550*/
/*  7533*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7534*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7535*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7537*/     OPC_EmitMergeInputChains1_0,
/*  7538*/     OPC_EmitInteger32, 0, 
/*  7540*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7550*/    /*Scope*/ 17, /*->7568*/
/*  7551*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7552*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7553*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7555*/     OPC_EmitMergeInputChains1_0,
/*  7556*/     OPC_EmitInteger32, 0, 
/*  7558*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7568*/    /*Scope*/ 17, /*->7586*/
/*  7569*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7570*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7571*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7573*/     OPC_EmitMergeInputChains1_0,
/*  7574*/     OPC_EmitInteger32, 0, 
/*  7576*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7586*/    0, /*End of Scope*/
/*  7587*/   /*SwitchType*/ 17, MVT::i64,// ->7606
/*  7589*/    OPC_CheckPredicate6,  // Predicate_atomic_load_add_i64
/*  7590*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7591*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7593*/    OPC_EmitMergeInputChains1_0,
/*  7594*/    OPC_EmitInteger32, 0, 
/*  7596*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7606*/   0, // EndSwitchType
/*  7607*/  /*Scope*/ 117, /*->7725*/
/*  7608*/   OPC_CheckChild1TypeI64,
/*  7609*/   OPC_RecordChild2, // #2 = $val
/*  7610*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7705
/*  7613*/    OPC_Scope, 17, /*->7632*/ // 5 children in Scope
/*  7615*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7616*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7617*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7619*/     OPC_EmitMergeInputChains1_0,
/*  7620*/     OPC_EmitInteger32, 0, 
/*  7622*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7632*/    /*Scope*/ 17, /*->7650*/
/*  7633*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7634*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7635*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7637*/     OPC_EmitMergeInputChains1_0,
/*  7638*/     OPC_EmitInteger32, 0, 
/*  7640*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7650*/    /*Scope*/ 17, /*->7668*/
/*  7651*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7652*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7653*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7655*/     OPC_EmitMergeInputChains1_0,
/*  7656*/     OPC_EmitInteger32, 0, 
/*  7658*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7668*/    /*Scope*/ 17, /*->7686*/
/*  7669*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7670*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7671*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7673*/     OPC_EmitMergeInputChains1_0,
/*  7674*/     OPC_EmitInteger32, 0, 
/*  7676*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7686*/    /*Scope*/ 17, /*->7704*/
/*  7687*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7688*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7689*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7691*/     OPC_EmitMergeInputChains1_0,
/*  7692*/     OPC_EmitInteger32, 0, 
/*  7694*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7704*/    0, /*End of Scope*/
/*  7705*/   /*SwitchType*/ 17, MVT::i64,// ->7724
/*  7707*/    OPC_CheckPredicate6,  // Predicate_atomic_load_add_i64
/*  7708*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7709*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7711*/    OPC_EmitMergeInputChains1_0,
/*  7712*/    OPC_EmitInteger32, 0, 
/*  7714*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7724*/   0, // EndSwitchType
/*  7725*/  0, /*End of Scope*/
/*  7726*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->7971
/*  7730*/  OPC_RecordMemRef,
/*  7731*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7732*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7733*/  OPC_Scope, 117, /*->7852*/ // 2 children in Scope
/*  7735*/   OPC_CheckChild1TypeI32,
/*  7736*/   OPC_RecordChild2, // #2 = $val
/*  7737*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7832
/*  7740*/    OPC_Scope, 17, /*->7759*/ // 5 children in Scope
/*  7742*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7743*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7744*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7746*/     OPC_EmitMergeInputChains1_0,
/*  7747*/     OPC_EmitInteger32, 0, 
/*  7749*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7759*/    /*Scope*/ 17, /*->7777*/
/*  7760*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7761*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7762*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7764*/     OPC_EmitMergeInputChains1_0,
/*  7765*/     OPC_EmitInteger32, 0, 
/*  7767*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7777*/    /*Scope*/ 17, /*->7795*/
/*  7778*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7779*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7780*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7782*/     OPC_EmitMergeInputChains1_0,
/*  7783*/     OPC_EmitInteger32, 0, 
/*  7785*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7795*/    /*Scope*/ 17, /*->7813*/
/*  7796*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7797*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7798*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7800*/     OPC_EmitMergeInputChains1_0,
/*  7801*/     OPC_EmitInteger32, 0, 
/*  7803*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7813*/    /*Scope*/ 17, /*->7831*/
/*  7814*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7815*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7816*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7818*/     OPC_EmitMergeInputChains1_0,
/*  7819*/     OPC_EmitInteger32, 0, 
/*  7821*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7831*/    0, /*End of Scope*/
/*  7832*/   /*SwitchType*/ 17, MVT::i64,// ->7851
/*  7834*/    OPC_CheckPredicate6,  // Predicate_atomic_load_sub_i64
/*  7835*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7836*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7838*/    OPC_EmitMergeInputChains1_0,
/*  7839*/    OPC_EmitInteger32, 0, 
/*  7841*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7851*/   0, // EndSwitchType
/*  7852*/  /*Scope*/ 117, /*->7970*/
/*  7853*/   OPC_CheckChild1TypeI64,
/*  7854*/   OPC_RecordChild2, // #2 = $val
/*  7855*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7950
/*  7858*/    OPC_Scope, 17, /*->7877*/ // 5 children in Scope
/*  7860*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7861*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7862*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7864*/     OPC_EmitMergeInputChains1_0,
/*  7865*/     OPC_EmitInteger32, 0, 
/*  7867*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7877*/    /*Scope*/ 17, /*->7895*/
/*  7878*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7879*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7880*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7882*/     OPC_EmitMergeInputChains1_0,
/*  7883*/     OPC_EmitInteger32, 0, 
/*  7885*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7895*/    /*Scope*/ 17, /*->7913*/
/*  7896*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7897*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7898*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7900*/     OPC_EmitMergeInputChains1_0,
/*  7901*/     OPC_EmitInteger32, 0, 
/*  7903*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7913*/    /*Scope*/ 17, /*->7931*/
/*  7914*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7915*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7916*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7918*/     OPC_EmitMergeInputChains1_0,
/*  7919*/     OPC_EmitInteger32, 0, 
/*  7921*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7931*/    /*Scope*/ 17, /*->7949*/
/*  7932*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7933*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7934*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7936*/     OPC_EmitMergeInputChains1_0,
/*  7937*/     OPC_EmitInteger32, 0, 
/*  7939*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7949*/    0, /*End of Scope*/
/*  7950*/   /*SwitchType*/ 17, MVT::i64,// ->7969
/*  7952*/    OPC_CheckPredicate6,  // Predicate_atomic_load_sub_i64
/*  7953*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7954*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7956*/    OPC_EmitMergeInputChains1_0,
/*  7957*/    OPC_EmitInteger32, 0, 
/*  7959*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7969*/   0, // EndSwitchType
/*  7970*/  0, /*End of Scope*/
/*  7971*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8216
/*  7975*/  OPC_RecordMemRef,
/*  7976*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  7977*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7978*/  OPC_Scope, 117, /*->8097*/ // 2 children in Scope
/*  7980*/   OPC_CheckChild1TypeI32,
/*  7981*/   OPC_RecordChild2, // #2 = $val
/*  7982*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8077
/*  7985*/    OPC_Scope, 17, /*->8004*/ // 5 children in Scope
/*  7987*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  7988*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7989*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7991*/     OPC_EmitMergeInputChains1_0,
/*  7992*/     OPC_EmitInteger32, 0, 
/*  7994*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8004*/    /*Scope*/ 17, /*->8022*/
/*  8005*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8006*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8007*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8009*/     OPC_EmitMergeInputChains1_0,
/*  8010*/     OPC_EmitInteger32, 0, 
/*  8012*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8022*/    /*Scope*/ 17, /*->8040*/
/*  8023*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8024*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8025*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8027*/     OPC_EmitMergeInputChains1_0,
/*  8028*/     OPC_EmitInteger32, 0, 
/*  8030*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8040*/    /*Scope*/ 17, /*->8058*/
/*  8041*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8042*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8043*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8045*/     OPC_EmitMergeInputChains1_0,
/*  8046*/     OPC_EmitInteger32, 0, 
/*  8048*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8058*/    /*Scope*/ 17, /*->8076*/
/*  8059*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8060*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8061*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8063*/     OPC_EmitMergeInputChains1_0,
/*  8064*/     OPC_EmitInteger32, 0, 
/*  8066*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8076*/    0, /*End of Scope*/
/*  8077*/   /*SwitchType*/ 17, MVT::i64,// ->8096
/*  8079*/    OPC_CheckPredicate6,  // Predicate_atomic_load_and_i64
/*  8080*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8081*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8083*/    OPC_EmitMergeInputChains1_0,
/*  8084*/    OPC_EmitInteger32, 0, 
/*  8086*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8096*/   0, // EndSwitchType
/*  8097*/  /*Scope*/ 117, /*->8215*/
/*  8098*/   OPC_CheckChild1TypeI64,
/*  8099*/   OPC_RecordChild2, // #2 = $val
/*  8100*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8195
/*  8103*/    OPC_Scope, 17, /*->8122*/ // 5 children in Scope
/*  8105*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8106*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8107*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8109*/     OPC_EmitMergeInputChains1_0,
/*  8110*/     OPC_EmitInteger32, 0, 
/*  8112*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8122*/    /*Scope*/ 17, /*->8140*/
/*  8123*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8124*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8125*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8127*/     OPC_EmitMergeInputChains1_0,
/*  8128*/     OPC_EmitInteger32, 0, 
/*  8130*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8140*/    /*Scope*/ 17, /*->8158*/
/*  8141*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8142*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8143*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8145*/     OPC_EmitMergeInputChains1_0,
/*  8146*/     OPC_EmitInteger32, 0, 
/*  8148*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8158*/    /*Scope*/ 17, /*->8176*/
/*  8159*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8160*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8161*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8163*/     OPC_EmitMergeInputChains1_0,
/*  8164*/     OPC_EmitInteger32, 0, 
/*  8166*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8176*/    /*Scope*/ 17, /*->8194*/
/*  8177*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8178*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8179*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8181*/     OPC_EmitMergeInputChains1_0,
/*  8182*/     OPC_EmitInteger32, 0, 
/*  8184*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8194*/    0, /*End of Scope*/
/*  8195*/   /*SwitchType*/ 17, MVT::i64,// ->8214
/*  8197*/    OPC_CheckPredicate6,  // Predicate_atomic_load_and_i64
/*  8198*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8199*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8201*/    OPC_EmitMergeInputChains1_0,
/*  8202*/    OPC_EmitInteger32, 0, 
/*  8204*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8214*/   0, // EndSwitchType
/*  8215*/  0, /*End of Scope*/
/*  8216*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8461
/*  8220*/  OPC_RecordMemRef,
/*  8221*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8222*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8223*/  OPC_Scope, 117, /*->8342*/ // 2 children in Scope
/*  8225*/   OPC_CheckChild1TypeI32,
/*  8226*/   OPC_RecordChild2, // #2 = $val
/*  8227*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8322
/*  8230*/    OPC_Scope, 17, /*->8249*/ // 5 children in Scope
/*  8232*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8233*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8234*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8236*/     OPC_EmitMergeInputChains1_0,
/*  8237*/     OPC_EmitInteger32, 0, 
/*  8239*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8249*/    /*Scope*/ 17, /*->8267*/
/*  8250*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8251*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8252*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8254*/     OPC_EmitMergeInputChains1_0,
/*  8255*/     OPC_EmitInteger32, 0, 
/*  8257*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8267*/    /*Scope*/ 17, /*->8285*/
/*  8268*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8269*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8270*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8272*/     OPC_EmitMergeInputChains1_0,
/*  8273*/     OPC_EmitInteger32, 0, 
/*  8275*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8285*/    /*Scope*/ 17, /*->8303*/
/*  8286*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8287*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8288*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8290*/     OPC_EmitMergeInputChains1_0,
/*  8291*/     OPC_EmitInteger32, 0, 
/*  8293*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8303*/    /*Scope*/ 17, /*->8321*/
/*  8304*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8305*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8306*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8308*/     OPC_EmitMergeInputChains1_0,
/*  8309*/     OPC_EmitInteger32, 0, 
/*  8311*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8321*/    0, /*End of Scope*/
/*  8322*/   /*SwitchType*/ 17, MVT::i64,// ->8341
/*  8324*/    OPC_CheckPredicate6,  // Predicate_atomic_load_or_i64
/*  8325*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8326*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8328*/    OPC_EmitMergeInputChains1_0,
/*  8329*/    OPC_EmitInteger32, 0, 
/*  8331*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8341*/   0, // EndSwitchType
/*  8342*/  /*Scope*/ 117, /*->8460*/
/*  8343*/   OPC_CheckChild1TypeI64,
/*  8344*/   OPC_RecordChild2, // #2 = $val
/*  8345*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8440
/*  8348*/    OPC_Scope, 17, /*->8367*/ // 5 children in Scope
/*  8350*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8351*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8352*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8354*/     OPC_EmitMergeInputChains1_0,
/*  8355*/     OPC_EmitInteger32, 0, 
/*  8357*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8367*/    /*Scope*/ 17, /*->8385*/
/*  8368*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8369*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8370*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8372*/     OPC_EmitMergeInputChains1_0,
/*  8373*/     OPC_EmitInteger32, 0, 
/*  8375*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8385*/    /*Scope*/ 17, /*->8403*/
/*  8386*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8387*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8388*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8390*/     OPC_EmitMergeInputChains1_0,
/*  8391*/     OPC_EmitInteger32, 0, 
/*  8393*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8403*/    /*Scope*/ 17, /*->8421*/
/*  8404*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8405*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8406*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8408*/     OPC_EmitMergeInputChains1_0,
/*  8409*/     OPC_EmitInteger32, 0, 
/*  8411*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8421*/    /*Scope*/ 17, /*->8439*/
/*  8422*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8423*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8424*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8426*/     OPC_EmitMergeInputChains1_0,
/*  8427*/     OPC_EmitInteger32, 0, 
/*  8429*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8439*/    0, /*End of Scope*/
/*  8440*/   /*SwitchType*/ 17, MVT::i64,// ->8459
/*  8442*/    OPC_CheckPredicate6,  // Predicate_atomic_load_or_i64
/*  8443*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8444*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8446*/    OPC_EmitMergeInputChains1_0,
/*  8447*/    OPC_EmitInteger32, 0, 
/*  8449*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8459*/   0, // EndSwitchType
/*  8460*/  0, /*End of Scope*/
/*  8461*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8706
/*  8465*/  OPC_RecordMemRef,
/*  8466*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8467*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8468*/  OPC_Scope, 117, /*->8587*/ // 2 children in Scope
/*  8470*/   OPC_CheckChild1TypeI32,
/*  8471*/   OPC_RecordChild2, // #2 = $val
/*  8472*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8567
/*  8475*/    OPC_Scope, 17, /*->8494*/ // 5 children in Scope
/*  8477*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8478*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8479*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8481*/     OPC_EmitMergeInputChains1_0,
/*  8482*/     OPC_EmitInteger32, 0, 
/*  8484*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8494*/    /*Scope*/ 17, /*->8512*/
/*  8495*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8496*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8497*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8499*/     OPC_EmitMergeInputChains1_0,
/*  8500*/     OPC_EmitInteger32, 0, 
/*  8502*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8512*/    /*Scope*/ 17, /*->8530*/
/*  8513*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8514*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8515*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8517*/     OPC_EmitMergeInputChains1_0,
/*  8518*/     OPC_EmitInteger32, 0, 
/*  8520*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8530*/    /*Scope*/ 17, /*->8548*/
/*  8531*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8532*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8533*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8535*/     OPC_EmitMergeInputChains1_0,
/*  8536*/     OPC_EmitInteger32, 0, 
/*  8538*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8548*/    /*Scope*/ 17, /*->8566*/
/*  8549*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8550*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8551*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8553*/     OPC_EmitMergeInputChains1_0,
/*  8554*/     OPC_EmitInteger32, 0, 
/*  8556*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8566*/    0, /*End of Scope*/
/*  8567*/   /*SwitchType*/ 17, MVT::i64,// ->8586
/*  8569*/    OPC_CheckPredicate6,  // Predicate_atomic_load_xor_i64
/*  8570*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8571*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8573*/    OPC_EmitMergeInputChains1_0,
/*  8574*/    OPC_EmitInteger32, 0, 
/*  8576*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8586*/   0, // EndSwitchType
/*  8587*/  /*Scope*/ 117, /*->8705*/
/*  8588*/   OPC_CheckChild1TypeI64,
/*  8589*/   OPC_RecordChild2, // #2 = $val
/*  8590*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8685
/*  8593*/    OPC_Scope, 17, /*->8612*/ // 5 children in Scope
/*  8595*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8596*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8597*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8599*/     OPC_EmitMergeInputChains1_0,
/*  8600*/     OPC_EmitInteger32, 0, 
/*  8602*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8612*/    /*Scope*/ 17, /*->8630*/
/*  8613*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8614*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8615*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8617*/     OPC_EmitMergeInputChains1_0,
/*  8618*/     OPC_EmitInteger32, 0, 
/*  8620*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8630*/    /*Scope*/ 17, /*->8648*/
/*  8631*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8632*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8633*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8635*/     OPC_EmitMergeInputChains1_0,
/*  8636*/     OPC_EmitInteger32, 0, 
/*  8638*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8648*/    /*Scope*/ 17, /*->8666*/
/*  8649*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8650*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8651*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8653*/     OPC_EmitMergeInputChains1_0,
/*  8654*/     OPC_EmitInteger32, 0, 
/*  8656*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8666*/    /*Scope*/ 17, /*->8684*/
/*  8667*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8668*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8669*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8671*/     OPC_EmitMergeInputChains1_0,
/*  8672*/     OPC_EmitInteger32, 0, 
/*  8674*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8684*/    0, /*End of Scope*/
/*  8685*/   /*SwitchType*/ 17, MVT::i64,// ->8704
/*  8687*/    OPC_CheckPredicate6,  // Predicate_atomic_load_xor_i64
/*  8688*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8689*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8691*/    OPC_EmitMergeInputChains1_0,
/*  8692*/    OPC_EmitInteger32, 0, 
/*  8694*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8704*/   0, // EndSwitchType
/*  8705*/  0, /*End of Scope*/
/*  8706*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->8951
/*  8710*/  OPC_RecordMemRef,
/*  8711*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8712*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8713*/  OPC_Scope, 117, /*->8832*/ // 2 children in Scope
/*  8715*/   OPC_CheckChild1TypeI32,
/*  8716*/   OPC_RecordChild2, // #2 = $val
/*  8717*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8812
/*  8720*/    OPC_Scope, 17, /*->8739*/ // 5 children in Scope
/*  8722*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8723*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8724*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8726*/     OPC_EmitMergeInputChains1_0,
/*  8727*/     OPC_EmitInteger32, 0, 
/*  8729*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8739*/    /*Scope*/ 17, /*->8757*/
/*  8740*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8741*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8742*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8744*/     OPC_EmitMergeInputChains1_0,
/*  8745*/     OPC_EmitInteger32, 0, 
/*  8747*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8757*/    /*Scope*/ 17, /*->8775*/
/*  8758*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8759*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8760*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8762*/     OPC_EmitMergeInputChains1_0,
/*  8763*/     OPC_EmitInteger32, 0, 
/*  8765*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8775*/    /*Scope*/ 17, /*->8793*/
/*  8776*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8777*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8778*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8780*/     OPC_EmitMergeInputChains1_0,
/*  8781*/     OPC_EmitInteger32, 0, 
/*  8783*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8793*/    /*Scope*/ 17, /*->8811*/
/*  8794*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8795*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8796*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8798*/     OPC_EmitMergeInputChains1_0,
/*  8799*/     OPC_EmitInteger32, 0, 
/*  8801*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8811*/    0, /*End of Scope*/
/*  8812*/   /*SwitchType*/ 17, MVT::i64,// ->8831
/*  8814*/    OPC_CheckPredicate6,  // Predicate_atomic_swap_i64
/*  8815*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8816*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8818*/    OPC_EmitMergeInputChains1_0,
/*  8819*/    OPC_EmitInteger32, 0, 
/*  8821*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8831*/   0, // EndSwitchType
/*  8832*/  /*Scope*/ 117, /*->8950*/
/*  8833*/   OPC_CheckChild1TypeI64,
/*  8834*/   OPC_RecordChild2, // #2 = $val
/*  8835*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8930
/*  8838*/    OPC_Scope, 17, /*->8857*/ // 5 children in Scope
/*  8840*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8841*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8842*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8844*/     OPC_EmitMergeInputChains1_0,
/*  8845*/     OPC_EmitInteger32, 0, 
/*  8847*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8857*/    /*Scope*/ 17, /*->8875*/
/*  8858*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8859*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8860*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8862*/     OPC_EmitMergeInputChains1_0,
/*  8863*/     OPC_EmitInteger32, 0, 
/*  8865*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8875*/    /*Scope*/ 17, /*->8893*/
/*  8876*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8877*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8878*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8880*/     OPC_EmitMergeInputChains1_0,
/*  8881*/     OPC_EmitInteger32, 0, 
/*  8883*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8893*/    /*Scope*/ 17, /*->8911*/
/*  8894*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8895*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8896*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8898*/     OPC_EmitMergeInputChains1_0,
/*  8899*/     OPC_EmitInteger32, 0, 
/*  8901*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8911*/    /*Scope*/ 17, /*->8929*/
/*  8912*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8913*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8914*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8916*/     OPC_EmitMergeInputChains1_0,
/*  8917*/     OPC_EmitInteger32, 0, 
/*  8919*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8929*/    0, /*End of Scope*/
/*  8930*/   /*SwitchType*/ 17, MVT::i64,// ->8949
/*  8932*/    OPC_CheckPredicate6,  // Predicate_atomic_swap_i64
/*  8933*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8934*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8936*/    OPC_EmitMergeInputChains1_0,
/*  8937*/    OPC_EmitInteger32, 0, 
/*  8939*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8949*/   0, // EndSwitchType
/*  8950*/  0, /*End of Scope*/
/*  8951*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9210
/*  8955*/  OPC_RecordMemRef,
/*  8956*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  8957*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8958*/  OPC_Scope, 124, /*->9084*/ // 2 children in Scope
/*  8960*/   OPC_CheckChild1TypeI32,
/*  8961*/   OPC_RecordChild2, // #2 = $exp
/*  8962*/   OPC_RecordChild3, // #3 = $new
/*  8963*/   OPC_SwitchType /*2 cases */, 97, MVT::i32,// ->9063
/*  8966*/    OPC_Scope, 18, /*->8986*/ // 5 children in Scope
/*  8968*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  8969*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8970*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8972*/     OPC_EmitMergeInputChains1_0,
/*  8973*/     OPC_EmitInteger32, 0, 
/*  8975*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8986*/    /*Scope*/ 18, /*->9005*/
/*  8987*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  8988*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8989*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8991*/     OPC_EmitMergeInputChains1_0,
/*  8992*/     OPC_EmitInteger32, 0, 
/*  8994*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9005*/    /*Scope*/ 18, /*->9024*/
/*  9006*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9007*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9008*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9010*/     OPC_EmitMergeInputChains1_0,
/*  9011*/     OPC_EmitInteger32, 0, 
/*  9013*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9024*/    /*Scope*/ 18, /*->9043*/
/*  9025*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9026*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9027*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9029*/     OPC_EmitMergeInputChains1_0,
/*  9030*/     OPC_EmitInteger32, 0, 
/*  9032*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9043*/    /*Scope*/ 18, /*->9062*/
/*  9044*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9045*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9046*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9048*/     OPC_EmitMergeInputChains1_0,
/*  9049*/     OPC_EmitInteger32, 0, 
/*  9051*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9062*/    0, /*End of Scope*/
/*  9063*/   /*SwitchType*/ 18, MVT::i64,// ->9083
/*  9065*/    OPC_CheckPredicate6,  // Predicate_atomic_cmp_swap_i64
/*  9066*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9067*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9069*/    OPC_EmitMergeInputChains1_0,
/*  9070*/    OPC_EmitInteger32, 0, 
/*  9072*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9083*/   0, // EndSwitchType
/*  9084*/  /*Scope*/ 124, /*->9209*/
/*  9085*/   OPC_CheckChild1TypeI64,
/*  9086*/   OPC_RecordChild2, // #2 = $exp
/*  9087*/   OPC_RecordChild3, // #3 = $new
/*  9088*/   OPC_SwitchType /*2 cases */, 97, MVT::i32,// ->9188
/*  9091*/    OPC_Scope, 18, /*->9111*/ // 5 children in Scope
/*  9093*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9094*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9095*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9097*/     OPC_EmitMergeInputChains1_0,
/*  9098*/     OPC_EmitInteger32, 0, 
/*  9100*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9111*/    /*Scope*/ 18, /*->9130*/
/*  9112*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9113*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9114*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9116*/     OPC_EmitMergeInputChains1_0,
/*  9117*/     OPC_EmitInteger32, 0, 
/*  9119*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9130*/    /*Scope*/ 18, /*->9149*/
/*  9131*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9132*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9133*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9135*/     OPC_EmitMergeInputChains1_0,
/*  9136*/     OPC_EmitInteger32, 0, 
/*  9138*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9149*/    /*Scope*/ 18, /*->9168*/
/*  9150*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9151*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9152*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9154*/     OPC_EmitMergeInputChains1_0,
/*  9155*/     OPC_EmitInteger32, 0, 
/*  9157*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9168*/    /*Scope*/ 18, /*->9187*/
/*  9169*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9170*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9171*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9173*/     OPC_EmitMergeInputChains1_0,
/*  9174*/     OPC_EmitInteger32, 0, 
/*  9176*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9187*/    0, /*End of Scope*/
/*  9188*/   /*SwitchType*/ 18, MVT::i64,// ->9208
/*  9190*/    OPC_CheckPredicate6,  // Predicate_atomic_cmp_swap_i64
/*  9191*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9192*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9194*/    OPC_EmitMergeInputChains1_0,
/*  9195*/    OPC_EmitInteger32, 0, 
/*  9197*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9208*/   0, // EndSwitchType
/*  9209*/  0, /*End of Scope*/
/*  9210*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9302
/*  9213*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9214*/  OPC_Scope, 69, /*->9285*/ // 2 children in Scope
/*  9216*/   OPC_MoveChild1,
/*  9217*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9242
/*  9221*/    OPC_RecordChild0, // #1 = $cond
/*  9222*/    OPC_MoveChild0,
/*  9223*/    OPC_CheckPredicate, 26, // Predicate_bool_node
/*  9225*/    OPC_MoveParent,
/*  9226*/    OPC_CheckChild1Integer, 2, 
/*  9228*/    OPC_CheckTypeI32,
/*  9229*/    OPC_MoveSibling2,
/*  9230*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9233*/    OPC_RecordNode, // #2 = $dst
/*  9234*/    OPC_MoveParent,
/*  9235*/    OPC_EmitMergeInputChains1_0,
/*  9236*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9242*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9284
/*  9245*/    OPC_RecordChild0, // #1 = $cond
/*  9246*/    OPC_CheckChild0TypeI32,
/*  9247*/    OPC_CheckChild1Integer, 0, 
/*  9249*/    OPC_CheckTypeI32,
/*  9250*/    OPC_Scope, 15, /*->9267*/ // 2 children in Scope
/*  9252*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9254*/     OPC_MoveSibling2,
/*  9255*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9258*/     OPC_RecordNode, // #2 = $dst
/*  9259*/     OPC_MoveParent,
/*  9260*/     OPC_EmitMergeInputChains1_0,
/*  9261*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9267*/    /*Scope*/ 15, /*->9283*/
/*  9268*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9270*/     OPC_MoveSibling2,
/*  9271*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9274*/     OPC_RecordNode, // #2 = $dst
/*  9275*/     OPC_MoveParent,
/*  9276*/     OPC_EmitMergeInputChains1_0,
/*  9277*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9283*/    0, /*End of Scope*/
/*  9284*/   0, // EndSwitchOpcode
/*  9285*/  /*Scope*/ 15, /*->9301*/
/*  9286*/   OPC_RecordChild1, // #1 = $cond
/*  9287*/   OPC_CheckChild1TypeI32,
/*  9288*/   OPC_RecordChild2, // #2 = $dst
/*  9289*/   OPC_MoveChild2,
/*  9290*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9293*/   OPC_MoveParent,
/*  9294*/   OPC_EmitMergeInputChains1_0,
/*  9295*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9301*/  0, /*End of Scope*/
/*  9302*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9364
/*  9305*/  OPC_RecordChild0, // #0 = $lhs
/*  9306*/  OPC_Scope, 31, /*->9339*/ // 2 children in Scope
/*  9308*/   OPC_MoveChild1,
/*  9309*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9324
/*  9312*/    OPC_CheckAndImm, 31, 
/*  9314*/    OPC_RecordChild0, // #1 = $rhs
/*  9315*/    OPC_MoveParent,
/*  9316*/    OPC_CheckTypeI32,
/*  9317*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9324*/   /*SwitchType*/ 12, MVT::i64,// ->9338
/*  9326*/    OPC_CheckAndImm, 63, 
/*  9328*/    OPC_RecordChild0, // #1 = $rhs
/*  9329*/    OPC_MoveParent,
/*  9330*/    OPC_CheckTypeI64,
/*  9331*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9338*/   0, // EndSwitchType
/*  9339*/  /*Scope*/ 23, /*->9363*/
/*  9340*/   OPC_RecordChild1, // #1 = $rhs
/*  9341*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9352
/*  9344*/    OPC_CheckChild1TypeI32,
/*  9345*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9352*/   /*SwitchType*/ 8, MVT::i64,// ->9362
/*  9354*/    OPC_CheckChild1TypeI64,
/*  9355*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9362*/   0, // EndSwitchType
/*  9363*/  0, /*End of Scope*/
/*  9364*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9426
/*  9367*/  OPC_RecordChild0, // #0 = $lhs
/*  9368*/  OPC_Scope, 31, /*->9401*/ // 2 children in Scope
/*  9370*/   OPC_MoveChild1,
/*  9371*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9386
/*  9374*/    OPC_CheckAndImm, 31, 
/*  9376*/    OPC_RecordChild0, // #1 = $rhs
/*  9377*/    OPC_MoveParent,
/*  9378*/    OPC_CheckTypeI32,
/*  9379*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9386*/   /*SwitchType*/ 12, MVT::i64,// ->9400
/*  9388*/    OPC_CheckAndImm, 63, 
/*  9390*/    OPC_RecordChild0, // #1 = $rhs
/*  9391*/    OPC_MoveParent,
/*  9392*/    OPC_CheckTypeI64,
/*  9393*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9400*/   0, // EndSwitchType
/*  9401*/  /*Scope*/ 23, /*->9425*/
/*  9402*/   OPC_RecordChild1, // #1 = $rhs
/*  9403*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9414
/*  9406*/    OPC_CheckChild1TypeI32,
/*  9407*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9414*/   /*SwitchType*/ 8, MVT::i64,// ->9424
/*  9416*/    OPC_CheckChild1TypeI64,
/*  9417*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9424*/   0, // EndSwitchType
/*  9425*/  0, /*End of Scope*/
/*  9426*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9488
/*  9429*/  OPC_RecordChild0, // #0 = $lhs
/*  9430*/  OPC_Scope, 31, /*->9463*/ // 2 children in Scope
/*  9432*/   OPC_MoveChild1,
/*  9433*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9448
/*  9436*/    OPC_CheckAndImm, 31, 
/*  9438*/    OPC_RecordChild0, // #1 = $rhs
/*  9439*/    OPC_MoveParent,
/*  9440*/    OPC_CheckTypeI32,
/*  9441*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9448*/   /*SwitchType*/ 12, MVT::i64,// ->9462
/*  9450*/    OPC_CheckAndImm, 63, 
/*  9452*/    OPC_RecordChild0, // #1 = $rhs
/*  9453*/    OPC_MoveParent,
/*  9454*/    OPC_CheckTypeI64,
/*  9455*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9462*/   0, // EndSwitchType
/*  9463*/  /*Scope*/ 23, /*->9487*/
/*  9464*/   OPC_RecordChild1, // #1 = $rhs
/*  9465*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9476
/*  9468*/    OPC_CheckChild1TypeI32,
/*  9469*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9476*/   /*SwitchType*/ 8, MVT::i64,// ->9486
/*  9478*/    OPC_CheckChild1TypeI64,
/*  9479*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9486*/   0, // EndSwitchType
/*  9487*/  0, /*End of Scope*/
/*  9488*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9550
/*  9491*/  OPC_RecordChild0, // #0 = $lhs
/*  9492*/  OPC_Scope, 31, /*->9525*/ // 2 children in Scope
/*  9494*/   OPC_MoveChild1,
/*  9495*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9510
/*  9498*/    OPC_CheckAndImm, 31, 
/*  9500*/    OPC_RecordChild0, // #1 = $rhs
/*  9501*/    OPC_MoveParent,
/*  9502*/    OPC_CheckTypeI32,
/*  9503*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9510*/   /*SwitchType*/ 12, MVT::i64,// ->9524
/*  9512*/    OPC_CheckAndImm, 63, 
/*  9514*/    OPC_RecordChild0, // #1 = $rhs
/*  9515*/    OPC_MoveParent,
/*  9516*/    OPC_CheckTypeI64,
/*  9517*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9524*/   0, // EndSwitchType
/*  9525*/  /*Scope*/ 23, /*->9549*/
/*  9526*/   OPC_RecordChild1, // #1 = $rhs
/*  9527*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9538
/*  9530*/    OPC_CheckChild1TypeI32,
/*  9531*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9538*/   /*SwitchType*/ 8, MVT::i64,// ->9548
/*  9540*/    OPC_CheckChild1TypeI64,
/*  9541*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9548*/   0, // EndSwitchType
/*  9549*/  0, /*End of Scope*/
/*  9550*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9612
/*  9553*/  OPC_RecordChild0, // #0 = $lhs
/*  9554*/  OPC_Scope, 31, /*->9587*/ // 2 children in Scope
/*  9556*/   OPC_MoveChild1,
/*  9557*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9572
/*  9560*/    OPC_CheckAndImm, 31, 
/*  9562*/    OPC_RecordChild0, // #1 = $rhs
/*  9563*/    OPC_MoveParent,
/*  9564*/    OPC_CheckTypeI32,
/*  9565*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9572*/   /*SwitchType*/ 12, MVT::i64,// ->9586
/*  9574*/    OPC_CheckAndImm, 63, 
/*  9576*/    OPC_RecordChild0, // #1 = $rhs
/*  9577*/    OPC_MoveParent,
/*  9578*/    OPC_CheckTypeI64,
/*  9579*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9586*/   0, // EndSwitchType
/*  9587*/  /*Scope*/ 23, /*->9611*/
/*  9588*/   OPC_RecordChild1, // #1 = $rhs
/*  9589*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9600
/*  9592*/    OPC_CheckChild1TypeI32,
/*  9593*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9600*/   /*SwitchType*/ 8, MVT::i64,// ->9610
/*  9602*/    OPC_CheckChild1TypeI64,
/*  9603*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9610*/   0, // EndSwitchType
/*  9611*/  0, /*End of Scope*/
/*  9612*/ /*SwitchOpcode*/ 23|128,4/*535*/, TARGET_VAL(ISD::SELECT),// ->10151
/*  9616*/  OPC_Scope, 127, /*->9745*/ // 8 children in Scope
/*  9618*/   OPC_MoveChild0,
/*  9619*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9622*/   OPC_RecordChild0, // #0 = $cond
/*  9623*/   OPC_CheckChild0TypeI32,
/*  9624*/   OPC_CheckChild1Integer, 0, 
/*  9626*/   OPC_CheckTypeI32,
/*  9627*/   OPC_Scope, 57, /*->9686*/ // 2 children in Scope
/*  9629*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9631*/    OPC_MoveParent,
/*  9632*/    OPC_RecordChild1, // #1 = $lhs
/*  9633*/    OPC_RecordChild2, // #2 = $rhs
/*  9634*/    OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9645
/*  9637*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9645*/    /*SwitchType*/ 8, MVT::i64,// ->9655
/*  9647*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9655*/    /*SwitchType*/ 8, MVT::funcref,// ->9665
/*  9657*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9665*/    /*SwitchType*/ 8, MVT::externref,// ->9675
/*  9667*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9675*/    /*SwitchType*/ 8, MVT::exnref,// ->9685
/*  9677*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   MVT::exnref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9685*/    0, // EndSwitchType
/*  9686*/   /*Scope*/ 57, /*->9744*/
/*  9687*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9689*/    OPC_MoveParent,
/*  9690*/    OPC_RecordChild1, // #1 = $lhs
/*  9691*/    OPC_RecordChild2, // #2 = $rhs
/*  9692*/    OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9703
/*  9695*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9703*/    /*SwitchType*/ 8, MVT::i64,// ->9713
/*  9705*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9713*/    /*SwitchType*/ 8, MVT::funcref,// ->9723
/*  9715*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9723*/    /*SwitchType*/ 8, MVT::externref,// ->9733
/*  9725*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9733*/    /*SwitchType*/ 8, MVT::exnref,// ->9743
/*  9735*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   MVT::exnref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$rhs, EXNREF:{ *:[exnref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9743*/    0, // EndSwitchType
/*  9744*/   0, /*End of Scope*/
/*  9745*/  /*Scope*/ 59, /*->9805*/
/*  9746*/   OPC_RecordChild0, // #0 = $cond
/*  9747*/   OPC_CheckChild0TypeI32,
/*  9748*/   OPC_RecordChild1, // #1 = $lhs
/*  9749*/   OPC_RecordChild2, // #2 = $rhs
/*  9750*/   OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9761
/*  9753*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  MVT::i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9761*/   /*SwitchType*/ 8, MVT::i64,// ->9771
/*  9763*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  MVT::i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9771*/   /*SwitchType*/ 9, MVT::funcref,// ->9782
/*  9773*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9774*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9782*/   /*SwitchType*/ 9, MVT::externref,// ->9793
/*  9784*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9785*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  MVT::externref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9793*/   /*SwitchType*/ 9, MVT::exnref,// ->9804
/*  9795*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9796*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  MVT::exnref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[exnref] } I32:{ *:[i32] }:$cond, EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9804*/   0, // EndSwitchType
/*  9805*/  /*Scope*/ 67, /*->9873*/
/*  9806*/   OPC_MoveChild0,
/*  9807*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9810*/   OPC_RecordChild0, // #0 = $cond
/*  9811*/   OPC_CheckChild0TypeI32,
/*  9812*/   OPC_CheckChild1Integer, 0, 
/*  9814*/   OPC_CheckTypeI32,
/*  9815*/   OPC_Scope, 27, /*->9844*/ // 2 children in Scope
/*  9817*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9819*/    OPC_MoveParent,
/*  9820*/    OPC_RecordChild1, // #1 = $lhs
/*  9821*/    OPC_RecordChild2, // #2 = $rhs
/*  9822*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9833
/*  9825*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9833*/    /*SwitchType*/ 8, MVT::f64,// ->9843
/*  9835*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9843*/    0, // EndSwitchType
/*  9844*/   /*Scope*/ 27, /*->9872*/
/*  9845*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9847*/    OPC_MoveParent,
/*  9848*/    OPC_RecordChild1, // #1 = $lhs
/*  9849*/    OPC_RecordChild2, // #2 = $rhs
/*  9850*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9861
/*  9853*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9861*/    /*SwitchType*/ 8, MVT::f64,// ->9871
/*  9863*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9871*/    0, // EndSwitchType
/*  9872*/   0, /*End of Scope*/
/*  9873*/  /*Scope*/ 26, /*->9900*/
/*  9874*/   OPC_RecordChild0, // #0 = $cond
/*  9875*/   OPC_CheckChild0TypeI32,
/*  9876*/   OPC_RecordChild1, // #1 = $lhs
/*  9877*/   OPC_RecordChild2, // #2 = $rhs
/*  9878*/   OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9889
/*  9881*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  MVT::f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9889*/   /*SwitchType*/ 8, MVT::f64,// ->9899
/*  9891*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  MVT::f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9899*/   0, // EndSwitchType
/*  9900*/  /*Scope*/ 107, /*->10008*/
/*  9901*/   OPC_MoveChild0,
/*  9902*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9905*/   OPC_RecordChild0, // #0 = $cond
/*  9906*/   OPC_CheckChild0TypeI32,
/*  9907*/   OPC_CheckChild1Integer, 0, 
/*  9909*/   OPC_CheckTypeI32,
/*  9910*/   OPC_Scope, 47, /*->9959*/ // 2 children in Scope
/*  9912*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9914*/    OPC_MoveParent,
/*  9915*/    OPC_RecordChild1, // #1 = $lhs
/*  9916*/    OPC_RecordChild2, // #2 = $rhs
/*  9917*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9928
/*  9920*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9928*/    /*SwitchType*/ 8, MVT::v8i16,// ->9938
/*  9930*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9938*/    /*SwitchType*/ 8, MVT::v4i32,// ->9948
/*  9940*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9948*/    /*SwitchType*/ 8, MVT::v2i64,// ->9958
/*  9950*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9958*/    0, // EndSwitchType
/*  9959*/   /*Scope*/ 47, /*->10007*/
/*  9960*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9962*/    OPC_MoveParent,
/*  9963*/    OPC_RecordChild1, // #1 = $lhs
/*  9964*/    OPC_RecordChild2, // #2 = $rhs
/*  9965*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9976
/*  9968*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9976*/    /*SwitchType*/ 8, MVT::v8i16,// ->9986
/*  9978*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9986*/    /*SwitchType*/ 8, MVT::v4i32,// ->9996
/*  9988*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9996*/    /*SwitchType*/ 8, MVT::v2i64,// ->10006
/*  9998*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10006*/    0, // EndSwitchType
/* 10007*/   0, /*End of Scope*/
/* 10008*/  /*Scope*/ 46, /*->10055*/
/* 10009*/   OPC_RecordChild0, // #0 = $cond
/* 10010*/   OPC_CheckChild0TypeI32,
/* 10011*/   OPC_RecordChild1, // #1 = $lhs
/* 10012*/   OPC_RecordChild2, // #2 = $rhs
/* 10013*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->10024
/* 10016*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10024*/   /*SwitchType*/ 8, MVT::v8i16,// ->10034
/* 10026*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10034*/   /*SwitchType*/ 8, MVT::v4i32,// ->10044
/* 10036*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10044*/   /*SwitchType*/ 8, MVT::v2i64,// ->10054
/* 10046*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10054*/   0, // EndSwitchType
/* 10055*/  /*Scope*/ 67, /*->10123*/
/* 10056*/   OPC_MoveChild0,
/* 10057*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10060*/   OPC_RecordChild0, // #0 = $cond
/* 10061*/   OPC_CheckChild0TypeI32,
/* 10062*/   OPC_CheckChild1Integer, 0, 
/* 10064*/   OPC_CheckTypeI32,
/* 10065*/   OPC_Scope, 27, /*->10094*/ // 2 children in Scope
/* 10067*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10069*/    OPC_MoveParent,
/* 10070*/    OPC_RecordChild1, // #1 = $lhs
/* 10071*/    OPC_RecordChild2, // #2 = $rhs
/* 10072*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10083
/* 10075*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10083*/    /*SwitchType*/ 8, MVT::v2f64,// ->10093
/* 10085*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10093*/    0, // EndSwitchType
/* 10094*/   /*Scope*/ 27, /*->10122*/
/* 10095*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10097*/    OPC_MoveParent,
/* 10098*/    OPC_RecordChild1, // #1 = $lhs
/* 10099*/    OPC_RecordChild2, // #2 = $rhs
/* 10100*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10111
/* 10103*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10111*/    /*SwitchType*/ 8, MVT::v2f64,// ->10121
/* 10113*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10121*/    0, // EndSwitchType
/* 10122*/   0, /*End of Scope*/
/* 10123*/  /*Scope*/ 26, /*->10150*/
/* 10124*/   OPC_RecordChild0, // #0 = $cond
/* 10125*/   OPC_CheckChild0TypeI32,
/* 10126*/   OPC_RecordChild1, // #1 = $lhs
/* 10127*/   OPC_RecordChild2, // #2 = $rhs
/* 10128*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10139
/* 10131*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10139*/   /*SwitchType*/ 8, MVT::v2f64,// ->10149
/* 10141*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10149*/   0, // EndSwitchType
/* 10150*/  0, /*End of Scope*/
/* 10151*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10284
/* 10155*/  OPC_Scope, 57, /*->10214*/ // 2 children in Scope
/* 10157*/   OPC_MoveChild0,
/* 10158*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10161*/   OPC_RecordChild0, // #0 = $vec
/* 10162*/   OPC_Scope, 24, /*->10188*/ // 2 children in Scope
/* 10164*/    OPC_CheckChild0Type, MVT::v16i8,
/* 10166*/    OPC_RecordChild1, // #1 = $idx
/* 10167*/    OPC_MoveChild1,
/* 10168*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10171*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 10173*/    OPC_CheckTypeI32,
/* 10174*/    OPC_MoveParent,
/* 10175*/    OPC_MoveSibling1,
/* 10176*/    OPC_CheckValueType, MVT::i8,
/* 10178*/    OPC_MoveParent,
/* 10179*/    OPC_CheckTypeI32,
/* 10180*/    OPC_EmitConvertToTarget1,
/* 10181*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10188*/   /*Scope*/ 24, /*->10213*/
/* 10189*/    OPC_CheckChild0Type, MVT::v8i16,
/* 10191*/    OPC_RecordChild1, // #1 = $idx
/* 10192*/    OPC_MoveChild1,
/* 10193*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10196*/    OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 10198*/    OPC_CheckTypeI32,
/* 10199*/    OPC_MoveParent,
/* 10200*/    OPC_MoveSibling1,
/* 10201*/    OPC_CheckValueType, MVT::i16,
/* 10203*/    OPC_MoveParent,
/* 10204*/    OPC_CheckTypeI32,
/* 10205*/    OPC_EmitConvertToTarget1,
/* 10206*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10213*/   0, /*End of Scope*/
/* 10214*/  /*Scope*/ 68, /*->10283*/
/* 10215*/   OPC_RecordChild0, // #0 = $src
/* 10216*/   OPC_MoveChild1,
/* 10217*/   OPC_Scope, 25, /*->10244*/ // 3 children in Scope
/* 10219*/    OPC_CheckValueType, MVT::i8,
/* 10221*/    OPC_MoveParent,
/* 10222*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10233
/* 10225*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10227*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10233*/    /*SwitchType*/ 8, MVT::i64,// ->10243
/* 10235*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10237*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10243*/    0, // EndSwitchType
/* 10244*/   /*Scope*/ 25, /*->10270*/
/* 10245*/    OPC_CheckValueType, MVT::i16,
/* 10247*/    OPC_MoveParent,
/* 10248*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10259
/* 10251*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10253*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10259*/    /*SwitchType*/ 8, MVT::i64,// ->10269
/* 10261*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10263*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10269*/    0, // EndSwitchType
/* 10270*/   /*Scope*/ 11, /*->10282*/
/* 10271*/    OPC_CheckValueType, MVT::i32,
/* 10273*/    OPC_MoveParent,
/* 10274*/    OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10276*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10282*/   0, /*End of Scope*/
/* 10283*/  0, /*End of Scope*/
/* 10284*/ /*SwitchOpcode*/ 38|128,1/*166*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10454
/* 10288*/  OPC_RecordMemRef,
/* 10289*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10290*/  OPC_MoveChild1,
/* 10291*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10294*/  OPC_RecordChild0, // #1 = $addr
/* 10295*/  OPC_MoveChild0,
/* 10296*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10299*/  OPC_MoveParent,
/* 10300*/  OPC_MoveParent,
/* 10301*/  OPC_SwitchType /*14 cases */, 8, MVT::i32,// ->10312
/* 10304*/   OPC_EmitMergeInputChains1_0,
/* 10305*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10312*/  /*SwitchType*/ 8, MVT::i64,// ->10322
/* 10314*/   OPC_EmitMergeInputChains1_0,
/* 10315*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10322*/  /*SwitchType*/ 9, MVT::funcref,// ->10333
/* 10324*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10325*/   OPC_EmitMergeInputChains1_0,
/* 10326*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10333*/  /*SwitchType*/ 9, MVT::externref,// ->10344
/* 10335*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10336*/   OPC_EmitMergeInputChains1_0,
/* 10337*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10344*/  /*SwitchType*/ 10, MVT::exnref,// ->10356
/* 10346*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10348*/   OPC_EmitMergeInputChains1_0,
/* 10349*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::exnref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10356*/  /*SwitchType*/ 8, MVT::f32,// ->10366
/* 10358*/   OPC_EmitMergeInputChains1_0,
/* 10359*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10366*/  /*SwitchType*/ 8, MVT::f64,// ->10376
/* 10368*/   OPC_EmitMergeInputChains1_0,
/* 10369*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10376*/  /*SwitchType*/ 9, MVT::v2i64,// ->10387
/* 10378*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10379*/   OPC_EmitMergeInputChains1_0,
/* 10380*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10387*/  /*SwitchType*/ 9, MVT::v4i32,// ->10398
/* 10389*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10390*/   OPC_EmitMergeInputChains1_0,
/* 10391*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10398*/  /*SwitchType*/ 9, MVT::v16i8,// ->10409
/* 10400*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10401*/   OPC_EmitMergeInputChains1_0,
/* 10402*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10409*/  /*SwitchType*/ 9, MVT::v8i16,// ->10420
/* 10411*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10412*/   OPC_EmitMergeInputChains1_0,
/* 10413*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10420*/  /*SwitchType*/ 9, MVT::v8f16,// ->10431
/* 10422*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10423*/   OPC_EmitMergeInputChains1_0,
/* 10424*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8f16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8f16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8f16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10431*/  /*SwitchType*/ 9, MVT::v4f32,// ->10442
/* 10433*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10434*/   OPC_EmitMergeInputChains1_0,
/* 10435*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10442*/  /*SwitchType*/ 9, MVT::v2f64,// ->10453
/* 10444*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10445*/   OPC_EmitMergeInputChains1_0,
/* 10446*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10453*/  0, // EndSwitchType
/* 10454*/ /*SwitchOpcode*/ 66|128,2/*322*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->10780
/* 10458*/  OPC_RecordMemRef,
/* 10459*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10460*/  OPC_RecordChild1, // #1 = $src
/* 10461*/  OPC_Scope, 20, /*->10483*/ // 14 children in Scope
/* 10463*/   OPC_CheckChild1TypeI32,
/* 10464*/   OPC_MoveChild2,
/* 10465*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10468*/   OPC_RecordChild0, // #2 = $addr
/* 10469*/   OPC_MoveChild0,
/* 10470*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10473*/   OPC_MoveParent,
/* 10474*/   OPC_MoveParent,
/* 10475*/   OPC_EmitMergeInputChains1_0,
/* 10476*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10483*/  /*Scope*/ 20, /*->10504*/
/* 10484*/   OPC_CheckChild1TypeI64,
/* 10485*/   OPC_MoveChild2,
/* 10486*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10489*/   OPC_RecordChild0, // #2 = $addr
/* 10490*/   OPC_MoveChild0,
/* 10491*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10494*/   OPC_MoveParent,
/* 10495*/   OPC_MoveParent,
/* 10496*/   OPC_EmitMergeInputChains1_0,
/* 10497*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10504*/  /*Scope*/ 21, /*->10526*/
/* 10505*/   OPC_CheckChild1Type, MVT::f32,
/* 10507*/   OPC_MoveChild2,
/* 10508*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10511*/   OPC_RecordChild0, // #2 = $addr
/* 10512*/   OPC_MoveChild0,
/* 10513*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10516*/   OPC_MoveParent,
/* 10517*/   OPC_MoveParent,
/* 10518*/   OPC_EmitMergeInputChains1_0,
/* 10519*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10526*/  /*Scope*/ 21, /*->10548*/
/* 10527*/   OPC_CheckChild1Type, MVT::f64,
/* 10529*/   OPC_MoveChild2,
/* 10530*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10533*/   OPC_RecordChild0, // #2 = $addr
/* 10534*/   OPC_MoveChild0,
/* 10535*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10538*/   OPC_MoveParent,
/* 10539*/   OPC_MoveParent,
/* 10540*/   OPC_EmitMergeInputChains1_0,
/* 10541*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10548*/  /*Scope*/ 22, /*->10571*/
/* 10549*/   OPC_CheckChild1Type, MVT::v8f16,
/* 10551*/   OPC_MoveChild2,
/* 10552*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10555*/   OPC_RecordChild0, // #2 = $addr
/* 10556*/   OPC_MoveChild0,
/* 10557*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10560*/   OPC_MoveParent,
/* 10561*/   OPC_MoveParent,
/* 10562*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10563*/   OPC_EmitMergeInputChains1_0,
/* 10564*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8f16:{ *:[v8f16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8f16:{ *:[v8f16] }:$src)
/* 10571*/  /*Scope*/ 22, /*->10594*/
/* 10572*/   OPC_CheckChild1Type, MVT::v4f32,
/* 10574*/   OPC_MoveChild2,
/* 10575*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10578*/   OPC_RecordChild0, // #2 = $addr
/* 10579*/   OPC_MoveChild0,
/* 10580*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10583*/   OPC_MoveParent,
/* 10584*/   OPC_MoveParent,
/* 10585*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10586*/   OPC_EmitMergeInputChains1_0,
/* 10587*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10594*/  /*Scope*/ 22, /*->10617*/
/* 10595*/   OPC_CheckChild1Type, MVT::v2f64,
/* 10597*/   OPC_MoveChild2,
/* 10598*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10601*/   OPC_RecordChild0, // #2 = $addr
/* 10602*/   OPC_MoveChild0,
/* 10603*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10606*/   OPC_MoveParent,
/* 10607*/   OPC_MoveParent,
/* 10608*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10609*/   OPC_EmitMergeInputChains1_0,
/* 10610*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10617*/  /*Scope*/ 22, /*->10640*/
/* 10618*/   OPC_CheckChild1Type, MVT::v2i64,
/* 10620*/   OPC_MoveChild2,
/* 10621*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10624*/   OPC_RecordChild0, // #2 = $addr
/* 10625*/   OPC_MoveChild0,
/* 10626*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10629*/   OPC_MoveParent,
/* 10630*/   OPC_MoveParent,
/* 10631*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10632*/   OPC_EmitMergeInputChains1_0,
/* 10633*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10640*/  /*Scope*/ 22, /*->10663*/
/* 10641*/   OPC_CheckChild1Type, MVT::v4i32,
/* 10643*/   OPC_MoveChild2,
/* 10644*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10647*/   OPC_RecordChild0, // #2 = $addr
/* 10648*/   OPC_MoveChild0,
/* 10649*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10652*/   OPC_MoveParent,
/* 10653*/   OPC_MoveParent,
/* 10654*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10655*/   OPC_EmitMergeInputChains1_0,
/* 10656*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10663*/  /*Scope*/ 22, /*->10686*/
/* 10664*/   OPC_CheckChild1Type, MVT::v16i8,
/* 10666*/   OPC_MoveChild2,
/* 10667*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10670*/   OPC_RecordChild0, // #2 = $addr
/* 10671*/   OPC_MoveChild0,
/* 10672*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10675*/   OPC_MoveParent,
/* 10676*/   OPC_MoveParent,
/* 10677*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10678*/   OPC_EmitMergeInputChains1_0,
/* 10679*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10686*/  /*Scope*/ 22, /*->10709*/
/* 10687*/   OPC_CheckChild1Type, MVT::v8i16,
/* 10689*/   OPC_MoveChild2,
/* 10690*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10693*/   OPC_RecordChild0, // #2 = $addr
/* 10694*/   OPC_MoveChild0,
/* 10695*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10698*/   OPC_MoveParent,
/* 10699*/   OPC_MoveParent,
/* 10700*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10701*/   OPC_EmitMergeInputChains1_0,
/* 10702*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 10709*/  /*Scope*/ 22, /*->10732*/
/* 10710*/   OPC_CheckChild1Type, MVT::funcref,
/* 10712*/   OPC_MoveChild2,
/* 10713*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10716*/   OPC_RecordChild0, // #2 = $addr
/* 10717*/   OPC_MoveChild0,
/* 10718*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10721*/   OPC_MoveParent,
/* 10722*/   OPC_MoveParent,
/* 10723*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10724*/   OPC_EmitMergeInputChains1_0,
/* 10725*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 10732*/  /*Scope*/ 22, /*->10755*/
/* 10733*/   OPC_CheckChild1Type, MVT::externref,
/* 10735*/   OPC_MoveChild2,
/* 10736*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10739*/   OPC_RecordChild0, // #2 = $addr
/* 10740*/   OPC_MoveChild0,
/* 10741*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10744*/   OPC_MoveParent,
/* 10745*/   OPC_MoveParent,
/* 10746*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10747*/   OPC_EmitMergeInputChains1_0,
/* 10748*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 10755*/  /*Scope*/ 23, /*->10779*/
/* 10756*/   OPC_CheckChild1Type, MVT::exnref,
/* 10758*/   OPC_MoveChild2,
/* 10759*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10762*/   OPC_RecordChild0, // #2 = $addr
/* 10763*/   OPC_MoveChild0,
/* 10764*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10767*/   OPC_MoveParent,
/* 10768*/   OPC_MoveParent,
/* 10769*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10771*/   OPC_EmitMergeInputChains1_0,
/* 10772*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set exnref:{ *:[exnref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXNREF (tglobaladdr:{ *:[i32] }):$addr, exnref:{ *:[exnref] }:$src)
/* 10779*/  0, /*End of Scope*/
/* 10780*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->10804
/* 10783*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 10784*/  OPC_RecordChild1, // #1 = $amt
/* 10785*/  OPC_MoveChild1,
/* 10786*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10789*/  OPC_MoveSibling2,
/* 10790*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10793*/  OPC_RecordNode, // #2 = $amt2
/* 10794*/  OPC_MoveParent,
/* 10795*/  OPC_EmitMergeInputChains1_0,
/* 10796*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10804*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->10829
/* 10807*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 10808*/  OPC_CaptureGlueInput,
/* 10809*/  OPC_RecordChild1, // #1 = $amt
/* 10810*/  OPC_MoveChild1,
/* 10811*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10814*/  OPC_MoveSibling2,
/* 10815*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10818*/  OPC_RecordNode, // #2 = $amt2
/* 10819*/  OPC_MoveParent,
/* 10820*/  OPC_EmitMergeInputChains1_0,
/* 10821*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10829*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->10889
/* 10832*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 10833*/  OPC_RecordChild1, // #1 = $src_idx
/* 10834*/  OPC_MoveChild1,
/* 10835*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10838*/  OPC_CheckTypeI32,
/* 10839*/  OPC_MoveSibling2,
/* 10840*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10843*/  OPC_RecordNode, // #2 = $dst_idx
/* 10844*/  OPC_CheckTypeI32,
/* 10845*/  OPC_MoveParent,
/* 10846*/  OPC_RecordChild3, // #3 = $dst
/* 10847*/  OPC_Scope, 19, /*->10868*/ // 2 children in Scope
/* 10849*/   OPC_CheckChild3TypeI32,
/* 10850*/   OPC_RecordChild4, // #4 = $src
/* 10851*/   OPC_CheckChild4TypeI32,
/* 10852*/   OPC_RecordChild5, // #5 = $len
/* 10853*/   OPC_CheckChild5TypeI32,
/* 10854*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10856*/   OPC_EmitMergeInputChains1_0,
/* 10857*/   OPC_EmitConvertToTarget1,
/* 10858*/   OPC_EmitConvertToTarget2,
/* 10859*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8877MEMORY_COPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_8877MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 10868*/  /*Scope*/ 19, /*->10888*/
/* 10869*/   OPC_CheckChild3TypeI64,
/* 10870*/   OPC_RecordChild4, // #4 = $src
/* 10871*/   OPC_CheckChild4TypeI64,
/* 10872*/   OPC_RecordChild5, // #5 = $len
/* 10873*/   OPC_CheckChild5TypeI64,
/* 10874*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10876*/   OPC_EmitMergeInputChains1_0,
/* 10877*/   OPC_EmitConvertToTarget1,
/* 10878*/   OPC_EmitConvertToTarget2,
/* 10879*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8878MEMORY_COPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_8878MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 10888*/  0, /*End of Scope*/
/* 10889*/ /*SwitchOpcode*/ 54, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->10946
/* 10892*/  OPC_RecordMemRef,
/* 10893*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 10894*/  OPC_MoveChild1,
/* 10895*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10898*/  OPC_RecordChild0, // #1 = $table
/* 10899*/  OPC_MoveChild0,
/* 10900*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10903*/  OPC_MoveParent,
/* 10904*/  OPC_MoveParent,
/* 10905*/  OPC_RecordChild2, // #2 = $idx
/* 10906*/  OPC_CheckChild2TypeI32,
/* 10907*/  OPC_SwitchType /*3 cases */, 10, MVT::funcref,// ->10920
/* 10910*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10911*/   OPC_EmitMergeInputChains1_0,
/* 10912*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10920*/  /*SwitchType*/ 10, MVT::externref,// ->10932
/* 10922*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10923*/   OPC_EmitMergeInputChains1_0,
/* 10924*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10932*/  /*SwitchType*/ 11, MVT::exnref,// ->10945
/* 10934*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10936*/   OPC_EmitMergeInputChains1_0,
/* 10937*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::exnref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10945*/  0, // EndSwitchType
/* 10946*/ /*SwitchOpcode*/ 83, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11032
/* 10949*/  OPC_RecordMemRef,
/* 10950*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 10951*/  OPC_Scope, 56, /*->11009*/ // 2 children in Scope
/* 10953*/   OPC_MoveChild1,
/* 10954*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10957*/   OPC_RecordChild0, // #1 = $table
/* 10958*/   OPC_MoveChild0,
/* 10959*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10962*/   OPC_MoveParent,
/* 10963*/   OPC_MoveParent,
/* 10964*/   OPC_RecordChild2, // #2 = $idx
/* 10965*/   OPC_CheckChild2TypeI32,
/* 10966*/   OPC_RecordChild3, // #3 = $src
/* 10967*/   OPC_Scope, 12, /*->10981*/ // 3 children in Scope
/* 10969*/    OPC_CheckChild3Type, MVT::funcref,
/* 10971*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10972*/    OPC_EmitMergeInputChains1_0,
/* 10973*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 10981*/   /*Scope*/ 12, /*->10994*/
/* 10982*/    OPC_CheckChild3Type, MVT::externref,
/* 10984*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10985*/    OPC_EmitMergeInputChains1_0,
/* 10986*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 10994*/   /*Scope*/ 13, /*->11008*/
/* 10995*/    OPC_CheckChild3Type, MVT::exnref,
/* 10997*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10999*/    OPC_EmitMergeInputChains1_0,
/* 11000*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src)
/* 11008*/   0, /*End of Scope*/
/* 11009*/  /*Scope*/ 21, /*->11031*/
/* 11010*/   OPC_RecordChild1, // #1 = $table
/* 11011*/   OPC_MoveChild1,
/* 11012*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11015*/   OPC_MoveParent,
/* 11016*/   OPC_RecordChild2, // #2 = $idx
/* 11017*/   OPC_CheckChild2TypeI32,
/* 11018*/   OPC_RecordChild3, // #3 = $r
/* 11019*/   OPC_CheckChild3Type, MVT::funcref,
/* 11021*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11022*/   OPC_EmitMergeInputChains1_0,
/* 11023*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11031*/  0, /*End of Scope*/
/* 11032*/ /*SwitchOpcode*/ 7|128,10/*1287*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12323
/* 11036*/  OPC_Scope, 49, /*->11087*/ // 40 children in Scope
/* 11038*/   OPC_CheckChild0Integer, 0|128,67|128,1/*24960*/, 
/* 11042*/   OPC_RecordChild1, // #0 = $src
/* 11043*/   OPC_Scope, 20, /*->11065*/ // 2 children in Scope
/* 11045*/    OPC_CheckChild1Type, MVT::f32,
/* 11047*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11056
/* 11050*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12480:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11056*/    /*SwitchType*/ 6, MVT::i64,// ->11064
/* 11058*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12480:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11064*/    0, // EndSwitchType
/* 11065*/   /*Scope*/ 20, /*->11086*/
/* 11066*/    OPC_CheckChild1Type, MVT::f64,
/* 11068*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11077
/* 11071*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12480:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11077*/    /*SwitchType*/ 6, MVT::i64,// ->11085
/* 11079*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12480:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11085*/    0, // EndSwitchType
/* 11086*/   0, /*End of Scope*/
/* 11087*/  /*Scope*/ 49, /*->11137*/
/* 11088*/   OPC_CheckChild0Integer, 2|128,67|128,1/*24962*/, 
/* 11092*/   OPC_RecordChild1, // #0 = $src
/* 11093*/   OPC_Scope, 20, /*->11115*/ // 2 children in Scope
/* 11095*/    OPC_CheckChild1Type, MVT::f32,
/* 11097*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11106
/* 11100*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12481:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11106*/    /*SwitchType*/ 6, MVT::i64,// ->11114
/* 11108*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12481:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11114*/    0, // EndSwitchType
/* 11115*/   /*Scope*/ 20, /*->11136*/
/* 11116*/    OPC_CheckChild1Type, MVT::f64,
/* 11118*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11127
/* 11121*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12481:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11127*/    /*SwitchType*/ 6, MVT::i64,// ->11135
/* 11129*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12481:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11135*/    0, // EndSwitchType
/* 11136*/   0, /*End of Scope*/
/* 11137*/  /*Scope*/ 43, /*->11181*/
/* 11138*/   OPC_CheckChild0Integer, 114|128,65|128,1/*24818*/, 
/* 11142*/   OPC_RecordChild1, // #0 = $vec
/* 11143*/   OPC_Scope, 8, /*->11153*/ // 4 children in Scope
/* 11145*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11147*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11153*/   /*Scope*/ 8, /*->11162*/
/* 11154*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11156*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11162*/   /*Scope*/ 8, /*->11171*/
/* 11163*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11165*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11171*/   /*Scope*/ 8, /*->11180*/
/* 11172*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11174*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12409:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11180*/   0, /*End of Scope*/
/* 11181*/  /*Scope*/ 47, /*->11229*/
/* 11182*/   OPC_CheckChild0Integer, 112|128,65|128,1/*24816*/, 
/* 11186*/   OPC_RecordChild1, // #0 = $vec
/* 11187*/   OPC_Scope, 9, /*->11198*/ // 4 children in Scope
/* 11189*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11191*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11192*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11198*/   /*Scope*/ 9, /*->11208*/
/* 11199*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11201*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11202*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11208*/   /*Scope*/ 9, /*->11218*/
/* 11209*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11211*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11212*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11218*/   /*Scope*/ 9, /*->11228*/
/* 11219*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11221*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11222*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12408:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11228*/   0, /*End of Scope*/
/* 11229*/  /*Scope*/ 47, /*->11277*/
/* 11230*/   OPC_CheckChild0Integer, 118|128,65|128,1/*24822*/, 
/* 11234*/   OPC_RecordChild1, // #0 = $vec
/* 11235*/   OPC_Scope, 9, /*->11246*/ // 4 children in Scope
/* 11237*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11239*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11240*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12411:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11246*/   /*Scope*/ 9, /*->11256*/
/* 11247*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11249*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11250*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12411:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11256*/   /*Scope*/ 9, /*->11266*/
/* 11257*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11259*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11260*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12411:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11266*/   /*Scope*/ 9, /*->11276*/
/* 11267*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11269*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11270*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12411:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11276*/   0, /*End of Scope*/
/* 11277*/  /*Scope*/ 10, /*->11288*/
/* 11278*/   OPC_CheckChild0Integer, 44|128,66|128,1/*24876*/, 
/* 11282*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11283*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 MVT::funcref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 12438:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11288*/  /*Scope*/ 12, /*->11301*/
/* 11289*/   OPC_CheckChild0Integer, 38|128,66|128,1/*24870*/, 
/* 11293*/   OPC_RecordChild1, // #0 = $ref
/* 11294*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11295*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12435:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11301*/  /*Scope*/ 10, /*->11312*/
/* 11302*/   OPC_CheckChild0Integer, 42|128,66|128,1/*24874*/, 
/* 11306*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11307*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 MVT::externref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 12437:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11312*/  /*Scope*/ 12, /*->11325*/
/* 11313*/   OPC_CheckChild0Integer, 36|128,66|128,1/*24868*/, 
/* 11317*/   OPC_RecordChild1, // #0 = $ref
/* 11318*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11319*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12434:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11325*/  /*Scope*/ 10, /*->11336*/
/* 11326*/   OPC_CheckChild0Integer, 40|128,66|128,1/*24872*/, 
/* 11330*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11331*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 MVT::exnref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[exnref] } 12436:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXNREF:{ *:[exnref] })
/* 11336*/  /*Scope*/ 12, /*->11349*/
/* 11337*/   OPC_CheckChild0Integer, 34|128,66|128,1/*24866*/, 
/* 11341*/   OPC_RecordChild1, // #0 = $ref
/* 11342*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11343*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12433:{ *:[iPTR] }, EXNREF:{ *:[exnref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXNREF:{ *:[i32] } EXNREF:{ *:[exnref] }:$ref)
/* 11349*/  /*Scope*/ 23, /*->11373*/
/* 11350*/   OPC_CheckChild0Integer, 2|128,66|128,1/*24834*/, 
/* 11354*/   OPC_RecordChild1, // #0 = $vec
/* 11355*/   OPC_RecordChild2, // #1 = $idx
/* 11356*/   OPC_MoveChild2,
/* 11357*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11360*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 11362*/   OPC_MoveParent,
/* 11363*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasHalfPrecision())
/* 11365*/   OPC_EmitConvertToTarget1,
/* 11366*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (intrinsic_wo_chain:{ *:[f32] } 12417:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 12
             // Dst: (EXTRACT_LANE_F16x8:{ *:[f32] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11373*/  /*Scope*/ 13, /*->11387*/
/* 11374*/   OPC_CheckChild0Integer, 86|128,66|128,1/*24918*/, 
/* 11378*/   OPC_RecordChild1, // #0 = $src
/* 11379*/   OPC_RecordChild2, // #1 = $mask
/* 11380*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12459:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11387*/  /*Scope*/ 115, /*->11503*/
/* 11388*/   OPC_CheckChild0Integer, 120|128,65|128,1/*24824*/, 
/* 11392*/   OPC_RecordChild1, // #0 = $v1
/* 11393*/   OPC_SwitchType /*6 cases */, 16, MVT::v16i8,// ->11412
/* 11396*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11398*/    OPC_RecordChild2, // #1 = $v2
/* 11399*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11401*/    OPC_RecordChild3, // #2 = $c
/* 11402*/    OPC_CheckChild3Type, MVT::v16i8,
/* 11404*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12412:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11412*/   /*SwitchType*/ 16, MVT::v8i16,// ->11430
/* 11414*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11416*/    OPC_RecordChild2, // #1 = $v2
/* 11417*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11419*/    OPC_RecordChild3, // #2 = $c
/* 11420*/    OPC_CheckChild3Type, MVT::v8i16,
/* 11422*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12412:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11430*/   /*SwitchType*/ 16, MVT::v4i32,// ->11448
/* 11432*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11434*/    OPC_RecordChild2, // #1 = $v2
/* 11435*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11437*/    OPC_RecordChild3, // #2 = $c
/* 11438*/    OPC_CheckChild3Type, MVT::v4i32,
/* 11440*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12412:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11448*/   /*SwitchType*/ 16, MVT::v2i64,// ->11466
/* 11450*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11452*/    OPC_RecordChild2, // #1 = $v2
/* 11453*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11455*/    OPC_RecordChild3, // #2 = $c
/* 11456*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11458*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12412:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11466*/   /*SwitchType*/ 16, MVT::v4f32,// ->11484
/* 11468*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11470*/    OPC_RecordChild2, // #1 = $v2
/* 11471*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11473*/    OPC_RecordChild3, // #2 = $c
/* 11474*/    OPC_CheckChild3Type, MVT::v4f32,
/* 11476*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12412:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11484*/   /*SwitchType*/ 16, MVT::v2f64,// ->11502
/* 11486*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11488*/    OPC_RecordChild2, // #1 = $v2
/* 11489*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11491*/    OPC_RecordChild3, // #2 = $c
/* 11492*/    OPC_CheckChild3Type, MVT::v2f64,
/* 11494*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12412:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11502*/   0, // EndSwitchType
/* 11503*/  /*Scope*/ 37, /*->11541*/
/* 11504*/   OPC_CheckChild0Integer, 82|128,66|128,1/*24914*/, 
/* 11508*/   OPC_RecordChild1, // #0 = $lhs
/* 11509*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11525
/* 11512*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11514*/    OPC_RecordChild2, // #1 = $rhs
/* 11515*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11517*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11518*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12457:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11525*/   /*SwitchType*/ 13, MVT::v8i16,// ->11540
/* 11527*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11529*/    OPC_RecordChild2, // #1 = $rhs
/* 11530*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11532*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11533*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12457:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11540*/   0, // EndSwitchType
/* 11541*/  /*Scope*/ 37, /*->11579*/
/* 11542*/   OPC_CheckChild0Integer, 84|128,66|128,1/*24916*/, 
/* 11546*/   OPC_RecordChild1, // #0 = $lhs
/* 11547*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11563
/* 11550*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11552*/    OPC_RecordChild2, // #1 = $rhs
/* 11553*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11555*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11556*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12458:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11563*/   /*SwitchType*/ 13, MVT::v8i16,// ->11578
/* 11565*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11567*/    OPC_RecordChild2, // #1 = $rhs
/* 11568*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11570*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11571*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12458:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11578*/   0, // EndSwitchType
/* 11579*/  /*Scope*/ 37, /*->11617*/
/* 11580*/   OPC_CheckChild0Integer, 116|128,65|128,1/*24820*/, 
/* 11584*/   OPC_RecordChild1, // #0 = $lhs
/* 11585*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11601
/* 11588*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11590*/    OPC_RecordChild2, // #1 = $rhs
/* 11591*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11593*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11594*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12410:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11601*/   /*SwitchType*/ 13, MVT::v8i16,// ->11616
/* 11603*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11605*/    OPC_RecordChild2, // #1 = $rhs
/* 11606*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11608*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11609*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12410:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11616*/   0, // EndSwitchType
/* 11617*/  /*Scope*/ 14, /*->11632*/
/* 11618*/   OPC_CheckChild0Integer, 124|128,65|128,1/*24828*/, 
/* 11622*/   OPC_RecordChild1, // #0 = $lhs
/* 11623*/   OPC_RecordChild2, // #1 = $rhs
/* 11624*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11625*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12414:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11632*/  /*Scope*/ 37, /*->11670*/
/* 11633*/   OPC_CheckChild0Integer, 24|128,66|128,1/*24856*/, 
/* 11637*/   OPC_RecordChild1, // #0 = $low
/* 11638*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11654
/* 11641*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11643*/    OPC_RecordChild2, // #1 = $high
/* 11644*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11646*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11647*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12428:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11654*/   /*SwitchType*/ 13, MVT::v8i16,// ->11669
/* 11656*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11658*/    OPC_RecordChild2, // #1 = $high
/* 11659*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11661*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11662*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12428:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11669*/   0, // EndSwitchType
/* 11670*/  /*Scope*/ 37, /*->11708*/
/* 11671*/   OPC_CheckChild0Integer, 26|128,66|128,1/*24858*/, 
/* 11675*/   OPC_RecordChild1, // #0 = $low
/* 11676*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11692
/* 11679*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11681*/    OPC_RecordChild2, // #1 = $high
/* 11682*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11684*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11685*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12429:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11692*/   /*SwitchType*/ 13, MVT::v8i16,// ->11707
/* 11694*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11696*/    OPC_RecordChild2, // #1 = $high
/* 11697*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11699*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11700*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12429:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11707*/   0, // EndSwitchType
/* 11708*/  /*Scope*/ 29, /*->11738*/
/* 11709*/   OPC_CheckChild0Integer, 126|128,65|128,1/*24830*/, 
/* 11713*/   OPC_RecordChild1, // #0 = $vec
/* 11714*/   OPC_SwitchType /*2 cases */, 9, MVT::v8i16,// ->11726
/* 11717*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11719*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11720*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12415:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11726*/   /*SwitchType*/ 9, MVT::v4i32,// ->11737
/* 11728*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11730*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11731*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12415:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11737*/   0, // EndSwitchType
/* 11738*/  /*Scope*/ 29, /*->11768*/
/* 11739*/   OPC_CheckChild0Integer, 0|128,66|128,1/*24832*/, 
/* 11743*/   OPC_RecordChild1, // #0 = $vec
/* 11744*/   OPC_SwitchType /*2 cases */, 9, MVT::v8i16,// ->11756
/* 11747*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11749*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11750*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12416:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11756*/   /*SwitchType*/ 9, MVT::v4i32,// ->11767
/* 11758*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11760*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11761*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12416:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11767*/   0, // EndSwitchType
/* 11768*/  /*Scope*/ 14, /*->11783*/
/* 11769*/   OPC_CheckChild0Integer, 32|128,66|128,1/*24864*/, 
/* 11773*/   OPC_RecordChild1, // #0 = $lhs
/* 11774*/   OPC_RecordChild2, // #1 = $rhs
/* 11775*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11776*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12432:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11783*/  /*Scope*/ 14, /*->11798*/
/* 11784*/   OPC_CheckChild0Integer, 64|128,66|128,1/*24896*/, 
/* 11788*/   OPC_RecordChild1, // #0 = $src
/* 11789*/   OPC_RecordChild2, // #1 = $mask
/* 11790*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11791*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12448:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 11798*/  /*Scope*/ 12, /*->11811*/
/* 11799*/   OPC_CheckChild0Integer, 66|128,66|128,1/*24898*/, 
/* 11803*/   OPC_RecordChild1, // #0 = $vec
/* 11804*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11805*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12449:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11811*/  /*Scope*/ 12, /*->11824*/
/* 11812*/   OPC_CheckChild0Integer, 70|128,66|128,1/*24902*/, 
/* 11816*/   OPC_RecordChild1, // #0 = $vec
/* 11817*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11818*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12451:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11824*/  /*Scope*/ 12, /*->11837*/
/* 11825*/   OPC_CheckChild0Integer, 68|128,66|128,1/*24900*/, 
/* 11829*/   OPC_RecordChild1, // #0 = $vec
/* 11830*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11831*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12450:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11837*/  /*Scope*/ 12, /*->11850*/
/* 11838*/   OPC_CheckChild0Integer, 72|128,66|128,1/*24904*/, 
/* 11842*/   OPC_RecordChild1, // #0 = $vec
/* 11843*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11844*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12452:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11850*/  /*Scope*/ 83, /*->11934*/
/* 11851*/   OPC_CheckChild0Integer, 52|128,66|128,1/*24884*/, 
/* 11855*/   OPC_RecordChild1, // #0 = $a
/* 11856*/   OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->11876
/* 11859*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11861*/    OPC_RecordChild2, // #1 = $b
/* 11862*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11864*/    OPC_RecordChild3, // #2 = $c
/* 11865*/    OPC_CheckChild3Type, MVT::v16i8,
/* 11867*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11868*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12442:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 11876*/   /*SwitchType*/ 17, MVT::v8i16,// ->11895
/* 11878*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11880*/    OPC_RecordChild2, // #1 = $b
/* 11881*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11883*/    OPC_RecordChild3, // #2 = $c
/* 11884*/    OPC_CheckChild3Type, MVT::v8i16,
/* 11886*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11887*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12442:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 11895*/   /*SwitchType*/ 17, MVT::v4i32,// ->11914
/* 11897*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11899*/    OPC_RecordChild2, // #1 = $b
/* 11900*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11902*/    OPC_RecordChild3, // #2 = $c
/* 11903*/    OPC_CheckChild3Type, MVT::v4i32,
/* 11905*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11906*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12442:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 11914*/   /*SwitchType*/ 17, MVT::v2i64,// ->11933
/* 11916*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11918*/    OPC_RecordChild2, // #1 = $b
/* 11919*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11921*/    OPC_RecordChild3, // #2 = $c
/* 11922*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11924*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11925*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12442:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 11933*/   0, // EndSwitchType
/* 11934*/  /*Scope*/ 14, /*->11949*/
/* 11935*/   OPC_CheckChild0Integer, 62|128,66|128,1/*24894*/, 
/* 11939*/   OPC_RecordChild1, // #0 = $lhs
/* 11940*/   OPC_RecordChild2, // #1 = $rhs
/* 11941*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11942*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12447:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11949*/  /*Scope*/ 14, /*->11964*/
/* 11950*/   OPC_CheckChild0Integer, 50|128,66|128,1/*24882*/, 
/* 11954*/   OPC_RecordChild1, // #0 = $lhs
/* 11955*/   OPC_RecordChild2, // #1 = $rhs
/* 11956*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11957*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12441:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11964*/  /*Scope*/ 16, /*->11981*/
/* 11965*/   OPC_CheckChild0Integer, 48|128,66|128,1/*24880*/, 
/* 11969*/   OPC_RecordChild1, // #0 = $lhs
/* 11970*/   OPC_RecordChild2, // #1 = $rhs
/* 11971*/   OPC_RecordChild3, // #2 = $acc
/* 11972*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11973*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12440:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 11981*/  /*Scope*/ 13, /*->11995*/
/* 11982*/   OPC_CheckChild0Integer, 78|128,66|128,1/*24910*/, 
/* 11986*/   OPC_RecordChild1, // #0 = $x
/* 11987*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasHalfPrecision())
/* 11989*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12455:{ *:[iPTR] }, F32:{ *:[f32] }:$x) - Complexity = 8
             // Dst: (SPLAT_F16x8:{ *:[v8f16] } F32:{ *:[f32] }:$x)
/* 11995*/  /*Scope*/ 49, /*->12045*/
/* 11996*/   OPC_CheckChild0Integer, 30|128,66|128,1/*24862*/, 
/* 12000*/   OPC_RecordChild1, // #0 = $lhs
/* 12001*/   OPC_SwitchType /*3 cases */, 12, MVT::v4f32,// ->12016
/* 12004*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12006*/    OPC_RecordChild2, // #1 = $rhs
/* 12007*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12009*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12431:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12016*/   /*SwitchType*/ 12, MVT::v2f64,// ->12030
/* 12018*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12020*/    OPC_RecordChild2, // #1 = $rhs
/* 12021*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12023*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12431:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12030*/   /*SwitchType*/ 12, MVT::v8f16,// ->12044
/* 12032*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12034*/    OPC_RecordChild2, // #1 = $rhs
/* 12035*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12037*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  MVT::v8f16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12431:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12044*/   0, // EndSwitchType
/* 12045*/  /*Scope*/ 49, /*->12095*/
/* 12046*/   OPC_CheckChild0Integer, 28|128,66|128,1/*24860*/, 
/* 12050*/   OPC_RecordChild1, // #0 = $lhs
/* 12051*/   OPC_SwitchType /*3 cases */, 12, MVT::v4f32,// ->12066
/* 12054*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12056*/    OPC_RecordChild2, // #1 = $rhs
/* 12057*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12059*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12430:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12066*/   /*SwitchType*/ 12, MVT::v2f64,// ->12080
/* 12068*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12070*/    OPC_RecordChild2, // #1 = $rhs
/* 12071*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12073*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12430:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12080*/   /*SwitchType*/ 12, MVT::v8f16,// ->12094
/* 12082*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12084*/    OPC_RecordChild2, // #1 = $rhs
/* 12085*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12087*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  MVT::v8f16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12430:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12094*/   0, // EndSwitchType
/* 12095*/  /*Scope*/ 66, /*->12162*/
/* 12096*/   OPC_CheckChild0Integer, 54|128,66|128,1/*24886*/, 
/* 12100*/   OPC_RecordChild1, // #0 = $a
/* 12101*/   OPC_SwitchType /*3 cases */, 18, MVT::v4f32,// ->12122
/* 12104*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12106*/    OPC_RecordChild2, // #1 = $b
/* 12107*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12109*/    OPC_RecordChild3, // #2 = $c
/* 12110*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12112*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12114*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12443:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12122*/   /*SwitchType*/ 18, MVT::v2f64,// ->12142
/* 12124*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12126*/    OPC_RecordChild2, // #1 = $b
/* 12127*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12129*/    OPC_RecordChild3, // #2 = $c
/* 12130*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12132*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12134*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12443:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12142*/   /*SwitchType*/ 17, MVT::v8f16,// ->12161
/* 12144*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12146*/    OPC_RecordChild2, // #1 = $b
/* 12147*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12149*/    OPC_RecordChild3, // #2 = $c
/* 12150*/    OPC_CheckChild3Type, MVT::v8f16,
/* 12152*/    OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 12153*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F16x8),
                  MVT::v8f16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12443:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (MADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12161*/   0, // EndSwitchType
/* 12162*/  /*Scope*/ 66, /*->12229*/
/* 12163*/   OPC_CheckChild0Integer, 60|128,66|128,1/*24892*/, 
/* 12167*/   OPC_RecordChild1, // #0 = $a
/* 12168*/   OPC_SwitchType /*3 cases */, 18, MVT::v4f32,// ->12189
/* 12171*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12173*/    OPC_RecordChild2, // #1 = $b
/* 12174*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12176*/    OPC_RecordChild3, // #2 = $c
/* 12177*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12179*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12181*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12446:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12189*/   /*SwitchType*/ 18, MVT::v2f64,// ->12209
/* 12191*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12193*/    OPC_RecordChild2, // #1 = $b
/* 12194*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12196*/    OPC_RecordChild3, // #2 = $c
/* 12197*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12199*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12201*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12446:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12209*/   /*SwitchType*/ 17, MVT::v8f16,// ->12228
/* 12211*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12213*/    OPC_RecordChild2, // #1 = $b
/* 12214*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12216*/    OPC_RecordChild3, // #2 = $c
/* 12217*/    OPC_CheckChild3Type, MVT::v8f16,
/* 12219*/    OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 12220*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F16x8),
                  MVT::v8f16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12446:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (NMADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12228*/   0, // EndSwitchType
/* 12229*/  /*Scope*/ 37, /*->12267*/
/* 12230*/   OPC_CheckChild0Integer, 58|128,66|128,1/*24890*/, 
/* 12234*/   OPC_RecordChild1, // #0 = $lhs
/* 12235*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->12251
/* 12238*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12240*/    OPC_RecordChild2, // #1 = $rhs
/* 12241*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12243*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12244*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12445:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12251*/   /*SwitchType*/ 13, MVT::v2f64,// ->12266
/* 12253*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12255*/    OPC_RecordChild2, // #1 = $rhs
/* 12256*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12258*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12259*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12445:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12266*/   0, // EndSwitchType
/* 12267*/  /*Scope*/ 37, /*->12305*/
/* 12268*/   OPC_CheckChild0Integer, 56|128,66|128,1/*24888*/, 
/* 12272*/   OPC_RecordChild1, // #0 = $lhs
/* 12273*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->12289
/* 12276*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12278*/    OPC_RecordChild2, // #1 = $rhs
/* 12279*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12281*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12282*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12444:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12289*/   /*SwitchType*/ 13, MVT::v2f64,// ->12304
/* 12291*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12293*/    OPC_RecordChild2, // #1 = $rhs
/* 12294*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12296*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12297*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12444:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12304*/   0, // EndSwitchType
/* 12305*/  /*Scope*/ 16, /*->12322*/
/* 12306*/   OPC_CheckChild0Integer, 46|128,66|128,1/*24878*/, 
/* 12310*/   OPC_RecordChild1, // #0 = $lhs
/* 12311*/   OPC_RecordChild2, // #1 = $rhs
/* 12312*/   OPC_RecordChild3, // #2 = $acc
/* 12313*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12314*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12439:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12322*/  0, /*End of Scope*/
/* 12323*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12458
/* 12327*/  OPC_RecordChild0, // #0 = $vec
/* 12328*/  OPC_Scope, 20, /*->12350*/ // 6 children in Scope
/* 12330*/   OPC_CheckChild0Type, MVT::v16i8,
/* 12332*/   OPC_RecordChild1, // #1 = $idx
/* 12333*/   OPC_MoveChild1,
/* 12334*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12337*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 12339*/   OPC_CheckTypeI32,
/* 12340*/   OPC_MoveParent,
/* 12341*/   OPC_CheckTypeI32,
/* 12342*/   OPC_EmitConvertToTarget1,
/* 12343*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12350*/  /*Scope*/ 20, /*->12371*/
/* 12351*/   OPC_CheckChild0Type, MVT::v8i16,
/* 12353*/   OPC_RecordChild1, // #1 = $idx
/* 12354*/   OPC_MoveChild1,
/* 12355*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12358*/   OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 12360*/   OPC_CheckTypeI32,
/* 12361*/   OPC_MoveParent,
/* 12362*/   OPC_CheckTypeI32,
/* 12363*/   OPC_EmitConvertToTarget1,
/* 12364*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12371*/  /*Scope*/ 20, /*->12392*/
/* 12372*/   OPC_CheckChild0Type, MVT::v4i32,
/* 12374*/   OPC_RecordChild1, // #1 = $idx
/* 12375*/   OPC_MoveChild1,
/* 12376*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12379*/   OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 12381*/   OPC_CheckTypeI32,
/* 12382*/   OPC_MoveParent,
/* 12383*/   OPC_CheckTypeI32,
/* 12384*/   OPC_EmitConvertToTarget1,
/* 12385*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12392*/  /*Scope*/ 20, /*->12413*/
/* 12393*/   OPC_CheckChild0Type, MVT::v2i64,
/* 12395*/   OPC_RecordChild1, // #1 = $idx
/* 12396*/   OPC_MoveChild1,
/* 12397*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12400*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 12402*/   OPC_CheckTypeI32,
/* 12403*/   OPC_MoveParent,
/* 12404*/   OPC_CheckTypeI64,
/* 12405*/   OPC_EmitConvertToTarget1,
/* 12406*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 MVT::i64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12413*/  /*Scope*/ 21, /*->12435*/
/* 12414*/   OPC_CheckChild0Type, MVT::v4f32,
/* 12416*/   OPC_RecordChild1, // #1 = $idx
/* 12417*/   OPC_MoveChild1,
/* 12418*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12421*/   OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 12423*/   OPC_CheckTypeI32,
/* 12424*/   OPC_MoveParent,
/* 12425*/   OPC_CheckType, MVT::f32,
/* 12427*/   OPC_EmitConvertToTarget1,
/* 12428*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12435*/  /*Scope*/ 21, /*->12457*/
/* 12436*/   OPC_CheckChild0Type, MVT::v2f64,
/* 12438*/   OPC_RecordChild1, // #1 = $idx
/* 12439*/   OPC_MoveChild1,
/* 12440*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12443*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 12445*/   OPC_CheckTypeI32,
/* 12446*/   OPC_MoveParent,
/* 12447*/   OPC_CheckType, MVT::f64,
/* 12449*/   OPC_EmitConvertToTarget1,
/* 12450*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 MVT::f64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12457*/  0, /*End of Scope*/
/* 12458*/ /*SwitchOpcode*/ 120, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12581
/* 12461*/  OPC_RecordChild0, // #0 = $argno
/* 12462*/  OPC_MoveChild0,
/* 12463*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12466*/  OPC_MoveParent,
/* 12467*/  OPC_SwitchType /*14 cases */, 6, MVT::i32,// ->12476
/* 12470*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12476*/  /*SwitchType*/ 6, MVT::i64,// ->12484
/* 12478*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12484*/  /*SwitchType*/ 6, MVT::funcref,// ->12492
/* 12486*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 MVT::funcref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12492*/  /*SwitchType*/ 6, MVT::externref,// ->12500
/* 12494*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 MVT::externref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12500*/  /*SwitchType*/ 6, MVT::exnref,// ->12508
/* 12502*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 MVT::exnref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[exnref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_exnref:{ *:[exnref] } (timm:{ *:[i32] }):$argno)
/* 12508*/  /*SwitchType*/ 6, MVT::f32,// ->12516
/* 12510*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 12516*/  /*SwitchType*/ 6, MVT::f64,// ->12524
/* 12518*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 12524*/  /*SwitchType*/ 6, MVT::v16i8,// ->12532
/* 12526*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 12532*/  /*SwitchType*/ 6, MVT::v8i16,// ->12540
/* 12534*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12540*/  /*SwitchType*/ 6, MVT::v4i32,// ->12548
/* 12542*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12548*/  /*SwitchType*/ 6, MVT::v2i64,// ->12556
/* 12550*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12556*/  /*SwitchType*/ 6, MVT::v4f32,// ->12564
/* 12558*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12564*/  /*SwitchType*/ 6, MVT::v2f64,// ->12572
/* 12566*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12572*/  /*SwitchType*/ 6, MVT::v8f16,// ->12580
/* 12574*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8f16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8f16:{ *:[v8f16] } (timm:{ *:[i32] }):$argno)
/* 12580*/  0, // EndSwitchType
/* 12581*/ /*SwitchOpcode*/ 18|128,1/*146*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->12731
/* 12585*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12586*/  OPC_RecordChild1, // #1 = $local
/* 12587*/  OPC_MoveChild1,
/* 12588*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12591*/  OPC_MoveParent,
/* 12592*/  OPC_SwitchType /*14 cases */, 7, MVT::i32,// ->12602
/* 12595*/   OPC_EmitMergeInputChains1_0,
/* 12596*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12602*/  /*SwitchType*/ 7, MVT::i64,// ->12611
/* 12604*/   OPC_EmitMergeInputChains1_0,
/* 12605*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12611*/  /*SwitchType*/ 8, MVT::funcref,// ->12621
/* 12613*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12614*/   OPC_EmitMergeInputChains1_0,
/* 12615*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12621*/  /*SwitchType*/ 8, MVT::externref,// ->12631
/* 12623*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12624*/   OPC_EmitMergeInputChains1_0,
/* 12625*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12631*/  /*SwitchType*/ 9, MVT::exnref,// ->12642
/* 12633*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12635*/   OPC_EmitMergeInputChains1_0,
/* 12636*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 MVT::exnref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[exnref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXNREF:{ *:[exnref] } (timm:{ *:[i32] }):$local)
/* 12642*/  /*SwitchType*/ 7, MVT::f32,// ->12651
/* 12644*/   OPC_EmitMergeInputChains1_0,
/* 12645*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12651*/  /*SwitchType*/ 7, MVT::f64,// ->12660
/* 12653*/   OPC_EmitMergeInputChains1_0,
/* 12654*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12660*/  /*SwitchType*/ 8, MVT::v2i64,// ->12670
/* 12662*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12663*/   OPC_EmitMergeInputChains1_0,
/* 12664*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12670*/  /*SwitchType*/ 8, MVT::v4i32,// ->12680
/* 12672*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12673*/   OPC_EmitMergeInputChains1_0,
/* 12674*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12680*/  /*SwitchType*/ 8, MVT::v16i8,// ->12690
/* 12682*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12683*/   OPC_EmitMergeInputChains1_0,
/* 12684*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 12690*/  /*SwitchType*/ 8, MVT::v8i16,// ->12700
/* 12692*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12693*/   OPC_EmitMergeInputChains1_0,
/* 12694*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 12700*/  /*SwitchType*/ 8, MVT::v8f16,// ->12710
/* 12702*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12703*/   OPC_EmitMergeInputChains1_0,
/* 12704*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v8f16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8f16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8f16] } (timm:{ *:[i32] }):$local)
/* 12710*/  /*SwitchType*/ 8, MVT::v4f32,// ->12720
/* 12712*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12713*/   OPC_EmitMergeInputChains1_0,
/* 12714*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 12720*/  /*SwitchType*/ 8, MVT::v2f64,// ->12730
/* 12722*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12723*/   OPC_EmitMergeInputChains1_0,
/* 12724*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 12730*/  0, // EndSwitchType
/* 12731*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->12894
/* 12735*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 12736*/  OPC_RecordChild1, // #1 = $local
/* 12737*/  OPC_MoveChild1,
/* 12738*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12741*/  OPC_MoveParent,
/* 12742*/  OPC_RecordChild2, // #2 = $src
/* 12743*/  OPC_Scope, 8, /*->12753*/ // 14 children in Scope
/* 12745*/   OPC_CheckChild2TypeI32,
/* 12746*/   OPC_EmitMergeInputChains1_0,
/* 12747*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 12753*/  /*Scope*/ 8, /*->12762*/
/* 12754*/   OPC_CheckChild2TypeI64,
/* 12755*/   OPC_EmitMergeInputChains1_0,
/* 12756*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 12762*/  /*Scope*/ 9, /*->12772*/
/* 12763*/   OPC_CheckChild2Type, MVT::f32,
/* 12765*/   OPC_EmitMergeInputChains1_0,
/* 12766*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 12772*/  /*Scope*/ 9, /*->12782*/
/* 12773*/   OPC_CheckChild2Type, MVT::f64,
/* 12775*/   OPC_EmitMergeInputChains1_0,
/* 12776*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 12782*/  /*Scope*/ 10, /*->12793*/
/* 12783*/   OPC_CheckChild2Type, MVT::v8f16,
/* 12785*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12786*/   OPC_EmitMergeInputChains1_0,
/* 12787*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src)
/* 12793*/  /*Scope*/ 10, /*->12804*/
/* 12794*/   OPC_CheckChild2Type, MVT::v4f32,
/* 12796*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12797*/   OPC_EmitMergeInputChains1_0,
/* 12798*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 12804*/  /*Scope*/ 10, /*->12815*/
/* 12805*/   OPC_CheckChild2Type, MVT::v2f64,
/* 12807*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12808*/   OPC_EmitMergeInputChains1_0,
/* 12809*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 12815*/  /*Scope*/ 10, /*->12826*/
/* 12816*/   OPC_CheckChild2Type, MVT::v2i64,
/* 12818*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12819*/   OPC_EmitMergeInputChains1_0,
/* 12820*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 12826*/  /*Scope*/ 10, /*->12837*/
/* 12827*/   OPC_CheckChild2Type, MVT::v4i32,
/* 12829*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12830*/   OPC_EmitMergeInputChains1_0,
/* 12831*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 12837*/  /*Scope*/ 10, /*->12848*/
/* 12838*/   OPC_CheckChild2Type, MVT::v16i8,
/* 12840*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12841*/   OPC_EmitMergeInputChains1_0,
/* 12842*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 12848*/  /*Scope*/ 10, /*->12859*/
/* 12849*/   OPC_CheckChild2Type, MVT::v8i16,
/* 12851*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12852*/   OPC_EmitMergeInputChains1_0,
/* 12853*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 12859*/  /*Scope*/ 10, /*->12870*/
/* 12860*/   OPC_CheckChild2Type, MVT::funcref,
/* 12862*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12863*/   OPC_EmitMergeInputChains1_0,
/* 12864*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 12870*/  /*Scope*/ 10, /*->12881*/
/* 12871*/   OPC_CheckChild2Type, MVT::externref,
/* 12873*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12874*/   OPC_EmitMergeInputChains1_0,
/* 12875*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 12881*/  /*Scope*/ 11, /*->12893*/
/* 12882*/   OPC_CheckChild2Type, MVT::exnref,
/* 12884*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12886*/   OPC_EmitMergeInputChains1_0,
/* 12887*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXNREF (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src)
/* 12893*/  0, /*End of Scope*/
/* 12894*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->13026
/* 12898*/  OPC_RecordChild0, // #0 = $addr
/* 12899*/  OPC_MoveChild0,
/* 12900*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->12951
/* 12904*/   OPC_MoveParent,
/* 12905*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->12928
/* 12908*/    OPC_Scope, 8, /*->12918*/ // 2 children in Scope
/* 12910*/     OPC_CheckPatternPredicate, 17, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12912*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12918*/    /*Scope*/ 8, /*->12927*/
/* 12919*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12921*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12927*/    0, /*End of Scope*/
/* 12928*/   /*SwitchType*/ 20, MVT::i64,// ->12950
/* 12930*/    OPC_Scope, 8, /*->12940*/ // 2 children in Scope
/* 12932*/     OPC_CheckPatternPredicate, 18, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12934*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12940*/    /*Scope*/ 8, /*->12949*/
/* 12941*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12943*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12949*/    0, /*End of Scope*/
/* 12950*/   0, // EndSwitchType
/* 12951*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->12975
/* 12954*/   OPC_MoveParent,
/* 12955*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12965
/* 12958*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 12959*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 12965*/   /*SwitchType*/ 7, MVT::i64,// ->12974
/* 12967*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 12968*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 12974*/   0, // EndSwitchType
/* 12975*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->13025
/* 12978*/   OPC_MoveParent,
/* 12979*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->13002
/* 12982*/    OPC_Scope, 8, /*->12992*/ // 2 children in Scope
/* 12984*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12986*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 12992*/    /*Scope*/ 8, /*->13001*/
/* 12993*/     OPC_CheckPatternPredicate, 17, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12995*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13001*/    0, /*End of Scope*/
/* 13002*/   /*SwitchType*/ 20, MVT::i64,// ->13024
/* 13004*/    OPC_Scope, 8, /*->13014*/ // 2 children in Scope
/* 13006*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13008*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13014*/    /*Scope*/ 8, /*->13023*/
/* 13015*/     OPC_CheckPatternPredicate, 18, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13017*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13023*/    0, /*End of Scope*/
/* 13024*/   0, // EndSwitchType
/* 13025*/  0, // EndSwitchOpcode
/* 13026*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13109
/* 13029*/  OPC_RecordChild0, // #0 = $addr
/* 13030*/  OPC_MoveChild0,
/* 13031*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13058
/* 13035*/   OPC_MoveParent,
/* 13036*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13047
/* 13039*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13041*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13047*/   /*SwitchType*/ 8, MVT::i64,// ->13057
/* 13049*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13051*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13057*/   0, // EndSwitchType
/* 13058*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13082
/* 13061*/   OPC_MoveParent,
/* 13062*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13072
/* 13065*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 13066*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13072*/   /*SwitchType*/ 7, MVT::i64,// ->13081
/* 13074*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 13075*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13081*/   0, // EndSwitchType
/* 13082*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13108
/* 13085*/   OPC_MoveParent,
/* 13086*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13097
/* 13089*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13091*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13097*/   /*SwitchType*/ 8, MVT::i64,// ->13107
/* 13099*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13101*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13107*/   0, // EndSwitchType
/* 13108*/  0, // EndSwitchOpcode
/* 13109*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->13159
/* 13112*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13113*/  OPC_RecordChild1, // #1 = $idx
/* 13114*/  OPC_MoveChild1,
/* 13115*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13118*/  OPC_CheckTypeI32,
/* 13119*/  OPC_MoveParent,
/* 13120*/  OPC_RecordChild2, // #2 = $dst
/* 13121*/  OPC_Scope, 17, /*->13140*/ // 2 children in Scope
/* 13123*/   OPC_CheckChild2TypeI32,
/* 13124*/   OPC_RecordChild3, // #3 = $value
/* 13125*/   OPC_CheckChild3TypeI32,
/* 13126*/   OPC_RecordChild4, // #4 = $size
/* 13127*/   OPC_CheckChild4TypeI32,
/* 13128*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13130*/   OPC_EmitMergeInputChains1_0,
/* 13131*/   OPC_EmitConvertToTarget1,
/* 13132*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8877MEMORY_FILL_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_8877MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13140*/  /*Scope*/ 17, /*->13158*/
/* 13141*/   OPC_CheckChild2TypeI64,
/* 13142*/   OPC_RecordChild3, // #3 = $value
/* 13143*/   OPC_CheckChild3TypeI32,
/* 13144*/   OPC_RecordChild4, // #4 = $size
/* 13145*/   OPC_CheckChild4TypeI64,
/* 13146*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13148*/   OPC_EmitMergeInputChains1_0,
/* 13149*/   OPC_EmitConvertToTarget1,
/* 13150*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8878MEMORY_FILL_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_8878MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13158*/  0, /*End of Scope*/
/* 13159*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13183
/* 13162*/  OPC_RecordNode, // #0 = $imm
/* 13163*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13173
/* 13166*/   OPC_EmitConvertToTarget0,
/* 13167*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13173*/  /*SwitchType*/ 7, MVT::i64,// ->13182
/* 13175*/   OPC_EmitConvertToTarget0,
/* 13176*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13182*/  0, // EndSwitchType
/* 13183*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13199
/* 13186*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13187*/  OPC_RecordChild1, // #1 = $dst
/* 13188*/  OPC_MoveChild1,
/* 13189*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13192*/  OPC_MoveParent,
/* 13193*/  OPC_EmitMergeInputChains1_0,
/* 13194*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13199*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13224
/* 13202*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13203*/  OPC_RecordChild1, // #1 = $index
/* 13204*/  OPC_Scope, 8, /*->13214*/ // 2 children in Scope
/* 13206*/   OPC_CheckChild1TypeI32,
/* 13207*/   OPC_EmitMergeInputChains1_0,
/* 13208*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13214*/  /*Scope*/ 8, /*->13223*/
/* 13215*/   OPC_CheckChild1TypeI64,
/* 13216*/   OPC_EmitMergeInputChains1_0,
/* 13217*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13223*/  0, /*End of Scope*/
/* 13224*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13234
/* 13227*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13228*/  OPC_EmitMergeInputChains1_0,
/* 13229*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13234*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13243
/* 13237*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13238*/  OPC_EmitMergeInputChains1_0,
/* 13239*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13243*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13252
/* 13246*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13247*/  OPC_EmitMergeInputChains1_0,
/* 13248*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13252*/ /*SwitchOpcode*/ 15, TARGET_VAL(ISD::CLEANUPRET),// ->13270
/* 13255*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13256*/  OPC_RecordChild1, // #1 = $ehpad
/* 13257*/  OPC_MoveChild1,
/* 13258*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13261*/  OPC_MoveParent,
/* 13262*/  OPC_CheckPatternPredicate, 19, // (Subtarget->hasExceptionHandling())
/* 13264*/  OPC_EmitMergeInputChains1_0,
/* 13265*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                1/*#Ops*/, 1, 
            // Src: (cleanupret (bb:{ *:[Other] }):$ehpad) - Complexity = 3
            // Dst: (CLEANUPRET (bb:{ *:[Other] }):$ehpad)
/* 13270*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13294
/* 13273*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13274*/  OPC_RecordChild1, // #1 = $dst
/* 13275*/  OPC_MoveChild1,
/* 13276*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13279*/  OPC_MoveSibling2,
/* 13280*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13283*/  OPC_RecordNode, // #2 = $from
/* 13284*/  OPC_MoveParent,
/* 13285*/  OPC_CheckPatternPredicate, 19, // (Subtarget->hasExceptionHandling())
/* 13287*/  OPC_EmitMergeInputChains1_0,
/* 13288*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13294*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->13359
/* 13297*/  OPC_RecordChild0, // #0 = $lhs
/* 13298*/  OPC_RecordChild1, // #1 = $rhs
/* 13299*/  OPC_SwitchType /*6 cases */, 7, MVT::i32,// ->13309
/* 13302*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13309*/  /*SwitchType*/ 7, MVT::i64,// ->13318
/* 13311*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13318*/  /*SwitchType*/ 8, MVT::v16i8,// ->13328
/* 13320*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13321*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13328*/  /*SwitchType*/ 8, MVT::v8i16,// ->13338
/* 13330*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13331*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13338*/  /*SwitchType*/ 8, MVT::v4i32,// ->13348
/* 13340*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13341*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13348*/  /*SwitchType*/ 8, MVT::v2i64,// ->13358
/* 13350*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13351*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 MVT::v2i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13358*/  0, // EndSwitchType
/* 13359*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->13475
/* 13362*/  OPC_Scope, 22, /*->13386*/ // 3 children in Scope
/* 13364*/   OPC_RecordChild0, // #0 = $lhs
/* 13365*/   OPC_RecordChild1, // #1 = $rhs
/* 13366*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13376
/* 13369*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13376*/   /*SwitchType*/ 7, MVT::i64,// ->13385
/* 13378*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13385*/   0, // EndSwitchType
/* 13386*/  /*Scope*/ 42, /*->13429*/
/* 13387*/   OPC_MoveChild0,
/* 13388*/   OPC_CheckImmAllZerosV,
/* 13389*/   OPC_MoveParent,
/* 13390*/   OPC_RecordChild1, // #0 = $v
/* 13391*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->13401
/* 13394*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13395*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13401*/   /*SwitchType*/ 7, MVT::v8i16,// ->13410
/* 13403*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13404*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13410*/   /*SwitchType*/ 7, MVT::v4i32,// ->13419
/* 13412*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13413*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13419*/   /*SwitchType*/ 7, MVT::v2i64,// ->13428
/* 13421*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13422*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13428*/   0, // EndSwitchType
/* 13429*/  /*Scope*/ 44, /*->13474*/
/* 13430*/   OPC_RecordChild0, // #0 = $lhs
/* 13431*/   OPC_RecordChild1, // #1 = $rhs
/* 13432*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13443
/* 13435*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13436*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13443*/   /*SwitchType*/ 8, MVT::v8i16,// ->13453
/* 13445*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13446*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13453*/   /*SwitchType*/ 8, MVT::v4i32,// ->13463
/* 13455*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13456*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13463*/   /*SwitchType*/ 8, MVT::v2i64,// ->13473
/* 13465*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13466*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13473*/   0, // EndSwitchType
/* 13474*/  0, /*End of Scope*/
/* 13475*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->13820
/* 13479*/  OPC_Scope, 22, /*->13503*/ // 3 children in Scope
/* 13481*/   OPC_RecordChild0, // #0 = $lhs
/* 13482*/   OPC_RecordChild1, // #1 = $rhs
/* 13483*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13493
/* 13486*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13493*/   /*SwitchType*/ 7, MVT::i64,// ->13502
/* 13495*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13502*/   0, // EndSwitchType
/* 13503*/  /*Scope*/ 23|128,2/*279*/, /*->13784*/
/* 13505*/   OPC_MoveChild0,
/* 13506*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->13576
/* 13510*/    OPC_RecordChild0, // #0 = $lhs
/* 13511*/    OPC_Scope, 20, /*->13533*/ // 3 children in Scope
/* 13513*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13515*/     OPC_MoveSibling1,
/* 13516*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13519*/     OPC_RecordChild0, // #1 = $rhs
/* 13520*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13522*/     OPC_MoveParent,
/* 13523*/     OPC_CheckType, MVT::v8i16,
/* 13525*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13526*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13533*/    /*Scope*/ 20, /*->13554*/
/* 13534*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13536*/     OPC_MoveSibling1,
/* 13537*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13540*/     OPC_RecordChild0, // #1 = $rhs
/* 13541*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13543*/     OPC_MoveParent,
/* 13544*/     OPC_CheckType, MVT::v4i32,
/* 13546*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13547*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13554*/    /*Scope*/ 20, /*->13575*/
/* 13555*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13557*/     OPC_MoveSibling1,
/* 13558*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13561*/     OPC_RecordChild0, // #1 = $rhs
/* 13562*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13564*/     OPC_MoveParent,
/* 13565*/     OPC_CheckType, MVT::v2i64,
/* 13567*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13568*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13575*/    0, /*End of Scope*/
/* 13576*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13645
/* 13579*/    OPC_RecordChild0, // #0 = $lhs
/* 13580*/    OPC_Scope, 20, /*->13602*/ // 3 children in Scope
/* 13582*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13584*/     OPC_MoveSibling1,
/* 13585*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13588*/     OPC_RecordChild0, // #1 = $rhs
/* 13589*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13591*/     OPC_MoveParent,
/* 13592*/     OPC_CheckType, MVT::v8i16,
/* 13594*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13595*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13602*/    /*Scope*/ 20, /*->13623*/
/* 13603*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13605*/     OPC_MoveSibling1,
/* 13606*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13609*/     OPC_RecordChild0, // #1 = $rhs
/* 13610*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13612*/     OPC_MoveParent,
/* 13613*/     OPC_CheckType, MVT::v4i32,
/* 13615*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13616*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13623*/    /*Scope*/ 20, /*->13644*/
/* 13624*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13626*/     OPC_MoveSibling1,
/* 13627*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13630*/     OPC_RecordChild0, // #1 = $rhs
/* 13631*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13633*/     OPC_MoveParent,
/* 13634*/     OPC_CheckType, MVT::v2i64,
/* 13636*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13637*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13644*/    0, /*End of Scope*/
/* 13645*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->13714
/* 13648*/    OPC_RecordChild0, // #0 = $lhs
/* 13649*/    OPC_Scope, 20, /*->13671*/ // 3 children in Scope
/* 13651*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13653*/     OPC_MoveSibling1,
/* 13654*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13657*/     OPC_RecordChild0, // #1 = $rhs
/* 13658*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13660*/     OPC_MoveParent,
/* 13661*/     OPC_CheckType, MVT::v8i16,
/* 13663*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13664*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13671*/    /*Scope*/ 20, /*->13692*/
/* 13672*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13674*/     OPC_MoveSibling1,
/* 13675*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13678*/     OPC_RecordChild0, // #1 = $rhs
/* 13679*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13681*/     OPC_MoveParent,
/* 13682*/     OPC_CheckType, MVT::v4i32,
/* 13684*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13685*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13692*/    /*Scope*/ 20, /*->13713*/
/* 13693*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13695*/     OPC_MoveSibling1,
/* 13696*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13699*/     OPC_RecordChild0, // #1 = $rhs
/* 13700*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13702*/     OPC_MoveParent,
/* 13703*/     OPC_CheckType, MVT::v2i64,
/* 13705*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13706*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13713*/    0, /*End of Scope*/
/* 13714*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->13783
/* 13717*/    OPC_RecordChild0, // #0 = $lhs
/* 13718*/    OPC_Scope, 20, /*->13740*/ // 3 children in Scope
/* 13720*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13722*/     OPC_MoveSibling1,
/* 13723*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13726*/     OPC_RecordChild0, // #1 = $rhs
/* 13727*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13729*/     OPC_MoveParent,
/* 13730*/     OPC_CheckType, MVT::v8i16,
/* 13732*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13733*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13740*/    /*Scope*/ 20, /*->13761*/
/* 13741*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13743*/     OPC_MoveSibling1,
/* 13744*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13747*/     OPC_RecordChild0, // #1 = $rhs
/* 13748*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13750*/     OPC_MoveParent,
/* 13751*/     OPC_CheckType, MVT::v4i32,
/* 13753*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13754*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13761*/    /*Scope*/ 20, /*->13782*/
/* 13762*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13764*/     OPC_MoveSibling1,
/* 13765*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13768*/     OPC_RecordChild0, // #1 = $rhs
/* 13769*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13771*/     OPC_MoveParent,
/* 13772*/     OPC_CheckType, MVT::v2i64,
/* 13774*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13775*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13782*/    0, /*End of Scope*/
/* 13783*/   0, // EndSwitchOpcode
/* 13784*/  /*Scope*/ 34, /*->13819*/
/* 13785*/   OPC_RecordChild0, // #0 = $lhs
/* 13786*/   OPC_RecordChild1, // #1 = $rhs
/* 13787*/   OPC_SwitchType /*3 cases */, 8, MVT::v8i16,// ->13798
/* 13790*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13791*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13798*/   /*SwitchType*/ 8, MVT::v4i32,// ->13808
/* 13800*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13801*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13808*/   /*SwitchType*/ 8, MVT::v2i64,// ->13818
/* 13810*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13811*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13818*/   0, // EndSwitchType
/* 13819*/  0, /*End of Scope*/
/* 13820*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->13845
/* 13823*/  OPC_RecordChild0, // #0 = $lhs
/* 13824*/  OPC_RecordChild1, // #1 = $rhs
/* 13825*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13835
/* 13828*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13835*/  /*SwitchType*/ 7, MVT::i64,// ->13844
/* 13837*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13844*/  0, // EndSwitchType
/* 13845*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->13870
/* 13848*/  OPC_RecordChild0, // #0 = $lhs
/* 13849*/  OPC_RecordChild1, // #1 = $rhs
/* 13850*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13860
/* 13853*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13860*/  /*SwitchType*/ 7, MVT::i64,// ->13869
/* 13862*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13869*/  0, // EndSwitchType
/* 13870*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->13895
/* 13873*/  OPC_RecordChild0, // #0 = $lhs
/* 13874*/  OPC_RecordChild1, // #1 = $rhs
/* 13875*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13885
/* 13878*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13885*/  /*SwitchType*/ 7, MVT::i64,// ->13894
/* 13887*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13894*/  0, // EndSwitchType
/* 13895*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->13920
/* 13898*/  OPC_RecordChild0, // #0 = $lhs
/* 13899*/  OPC_RecordChild1, // #1 = $rhs
/* 13900*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13910
/* 13903*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13910*/  /*SwitchType*/ 7, MVT::i64,// ->13919
/* 13912*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13919*/  0, // EndSwitchType
/* 13920*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->14748
/* 13924*/  OPC_Scope, 22, /*->13948*/ // 3 children in Scope
/* 13926*/   OPC_RecordChild0, // #0 = $lhs
/* 13927*/   OPC_RecordChild1, // #1 = $rhs
/* 13928*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13938
/* 13931*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13938*/   /*SwitchType*/ 7, MVT::i64,// ->13947
/* 13940*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13947*/   0, // EndSwitchType
/* 13948*/  /*Scope*/ 116|128,5/*756*/, /*->14706*/
/* 13950*/   OPC_MoveChild0,
/* 13951*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13954*/   OPC_Scope, 4|128,1/*132*/, /*->14089*/ // 9 children in Scope
/* 13957*/    OPC_RecordChild0, // #0 = $c
/* 13958*/    OPC_RecordChild1, // #1 = $v1
/* 13959*/    OPC_MoveSibling1,
/* 13960*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13963*/    OPC_Scope, 54, /*->14019*/ // 4 children in Scope
/* 13965*/     OPC_MoveChild0,
/* 13966*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13969*/     OPC_CheckChild0Same, 0,
/* 13971*/     OPC_MoveChild1,
/* 13972*/     OPC_CheckImmAllOnesV,
/* 13973*/     OPC_MoveParent,
/* 13974*/     OPC_MoveParent,
/* 13975*/     OPC_RecordChild1, // #2 = $v2
/* 13976*/     OPC_MoveParent,
/* 13977*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13988
/* 13980*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13988*/     /*SwitchType*/ 8, MVT::v8i16,// ->13998
/* 13990*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13998*/     /*SwitchType*/ 8, MVT::v4i32,// ->14008
/* 14000*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14008*/     /*SwitchType*/ 8, MVT::v2i64,// ->14018
/* 14010*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14018*/     0, // EndSwitchType
/* 14019*/    /*Scope*/ 22, /*->14042*/
/* 14020*/     OPC_RecordChild0, // #2 = $v2
/* 14021*/     OPC_MoveChild1,
/* 14022*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14025*/     OPC_CheckChild0Same, 0,
/* 14027*/     OPC_MoveChild1,
/* 14028*/     OPC_CheckImmAllOnesV,
/* 14029*/     OPC_MoveParent,
/* 14030*/     OPC_MoveParent,
/* 14031*/     OPC_MoveParent,
/* 14032*/     OPC_CheckType, MVT::v16i8,
/* 14034*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14042*/    /*Scope*/ 22, /*->14065*/
/* 14043*/     OPC_MoveChild0,
/* 14044*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14047*/     OPC_CheckChild0Same, 1,
/* 14049*/     OPC_MoveChild1,
/* 14050*/     OPC_CheckImmAllOnesV,
/* 14051*/     OPC_MoveParent,
/* 14052*/     OPC_MoveParent,
/* 14053*/     OPC_RecordChild1, // #2 = $v2
/* 14054*/     OPC_MoveParent,
/* 14055*/     OPC_CheckType, MVT::v16i8,
/* 14057*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14065*/    /*Scope*/ 22, /*->14088*/
/* 14066*/     OPC_RecordChild0, // #2 = $v2
/* 14067*/     OPC_MoveChild1,
/* 14068*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14071*/     OPC_CheckChild0Same, 1,
/* 14073*/     OPC_MoveChild1,
/* 14074*/     OPC_CheckImmAllOnesV,
/* 14075*/     OPC_MoveParent,
/* 14076*/     OPC_MoveParent,
/* 14077*/     OPC_MoveParent,
/* 14078*/     OPC_CheckType, MVT::v16i8,
/* 14080*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14088*/    0, /*End of Scope*/
/* 14089*/   /*Scope*/ 46, /*->14136*/
/* 14090*/    OPC_MoveChild0,
/* 14091*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14094*/    OPC_RecordChild0, // #0 = $c
/* 14095*/    OPC_MoveChild1,
/* 14096*/    OPC_CheckImmAllOnesV,
/* 14097*/    OPC_MoveParent,
/* 14098*/    OPC_MoveParent,
/* 14099*/    OPC_RecordChild1, // #1 = $v2
/* 14100*/    OPC_MoveSibling1,
/* 14101*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14104*/    OPC_Scope, 14, /*->14120*/ // 2 children in Scope
/* 14106*/     OPC_CheckChild0Same, 0,
/* 14108*/     OPC_RecordChild1, // #2 = $v1
/* 14109*/     OPC_MoveParent,
/* 14110*/     OPC_CheckType, MVT::v16i8,
/* 14112*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14120*/    /*Scope*/ 14, /*->14135*/
/* 14121*/     OPC_RecordChild0, // #2 = $v1
/* 14122*/     OPC_CheckChild1Same, 0,
/* 14124*/     OPC_MoveParent,
/* 14125*/     OPC_CheckType, MVT::v16i8,
/* 14127*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14135*/    0, /*End of Scope*/
/* 14136*/   /*Scope*/ 126, /*->14263*/
/* 14137*/    OPC_RecordChild0, // #0 = $v2
/* 14138*/    OPC_Scope, 45, /*->14185*/ // 2 children in Scope
/* 14140*/     OPC_MoveChild1,
/* 14141*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14144*/     OPC_RecordChild0, // #1 = $c
/* 14145*/     OPC_MoveChild1,
/* 14146*/     OPC_CheckImmAllOnesV,
/* 14147*/     OPC_MoveParent,
/* 14148*/     OPC_MoveParent,
/* 14149*/     OPC_MoveSibling1,
/* 14150*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14153*/     OPC_Scope, 14, /*->14169*/ // 2 children in Scope
/* 14155*/      OPC_CheckChild0Same, 1,
/* 14157*/      OPC_RecordChild1, // #2 = $v1
/* 14158*/      OPC_MoveParent,
/* 14159*/      OPC_CheckType, MVT::v16i8,
/* 14161*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14169*/     /*Scope*/ 14, /*->14184*/
/* 14170*/      OPC_RecordChild0, // #2 = $v1
/* 14171*/      OPC_CheckChild1Same, 1,
/* 14173*/      OPC_MoveParent,
/* 14174*/      OPC_CheckType, MVT::v16i8,
/* 14176*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14184*/     0, /*End of Scope*/
/* 14185*/    /*Scope*/ 76, /*->14262*/
/* 14186*/     OPC_RecordChild1, // #1 = $v1
/* 14187*/     OPC_MoveSibling1,
/* 14188*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14191*/     OPC_Scope, 22, /*->14215*/ // 3 children in Scope
/* 14193*/      OPC_RecordChild0, // #2 = $v2
/* 14194*/      OPC_MoveChild1,
/* 14195*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14198*/      OPC_CheckChild0Same, 0,
/* 14200*/      OPC_MoveChild1,
/* 14201*/      OPC_CheckImmAllOnesV,
/* 14202*/      OPC_MoveParent,
/* 14203*/      OPC_MoveParent,
/* 14204*/      OPC_MoveParent,
/* 14205*/      OPC_CheckType, MVT::v8i16,
/* 14207*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14215*/     /*Scope*/ 22, /*->14238*/
/* 14216*/      OPC_MoveChild0,
/* 14217*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14220*/      OPC_CheckChild0Same, 1,
/* 14222*/      OPC_MoveChild1,
/* 14223*/      OPC_CheckImmAllOnesV,
/* 14224*/      OPC_MoveParent,
/* 14225*/      OPC_MoveParent,
/* 14226*/      OPC_RecordChild1, // #2 = $v2
/* 14227*/      OPC_MoveParent,
/* 14228*/      OPC_CheckType, MVT::v8i16,
/* 14230*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14238*/     /*Scope*/ 22, /*->14261*/
/* 14239*/      OPC_RecordChild0, // #2 = $v2
/* 14240*/      OPC_MoveChild1,
/* 14241*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14244*/      OPC_CheckChild0Same, 1,
/* 14246*/      OPC_MoveChild1,
/* 14247*/      OPC_CheckImmAllOnesV,
/* 14248*/      OPC_MoveParent,
/* 14249*/      OPC_MoveParent,
/* 14250*/      OPC_MoveParent,
/* 14251*/      OPC_CheckType, MVT::v8i16,
/* 14253*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14261*/     0, /*End of Scope*/
/* 14262*/    0, /*End of Scope*/
/* 14263*/   /*Scope*/ 46, /*->14310*/
/* 14264*/    OPC_MoveChild0,
/* 14265*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14268*/    OPC_RecordChild0, // #0 = $c
/* 14269*/    OPC_MoveChild1,
/* 14270*/    OPC_CheckImmAllOnesV,
/* 14271*/    OPC_MoveParent,
/* 14272*/    OPC_MoveParent,
/* 14273*/    OPC_RecordChild1, // #1 = $v2
/* 14274*/    OPC_MoveSibling1,
/* 14275*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14278*/    OPC_Scope, 14, /*->14294*/ // 2 children in Scope
/* 14280*/     OPC_CheckChild0Same, 0,
/* 14282*/     OPC_RecordChild1, // #2 = $v1
/* 14283*/     OPC_MoveParent,
/* 14284*/     OPC_CheckType, MVT::v8i16,
/* 14286*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14294*/    /*Scope*/ 14, /*->14309*/
/* 14295*/     OPC_RecordChild0, // #2 = $v1
/* 14296*/     OPC_CheckChild1Same, 0,
/* 14298*/     OPC_MoveParent,
/* 14299*/     OPC_CheckType, MVT::v8i16,
/* 14301*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14309*/    0, /*End of Scope*/
/* 14310*/   /*Scope*/ 126, /*->14437*/
/* 14311*/    OPC_RecordChild0, // #0 = $v2
/* 14312*/    OPC_Scope, 45, /*->14359*/ // 2 children in Scope
/* 14314*/     OPC_MoveChild1,
/* 14315*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14318*/     OPC_RecordChild0, // #1 = $c
/* 14319*/     OPC_MoveChild1,
/* 14320*/     OPC_CheckImmAllOnesV,
/* 14321*/     OPC_MoveParent,
/* 14322*/     OPC_MoveParent,
/* 14323*/     OPC_MoveSibling1,
/* 14324*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14327*/     OPC_Scope, 14, /*->14343*/ // 2 children in Scope
/* 14329*/      OPC_CheckChild0Same, 1,
/* 14331*/      OPC_RecordChild1, // #2 = $v1
/* 14332*/      OPC_MoveParent,
/* 14333*/      OPC_CheckType, MVT::v8i16,
/* 14335*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14343*/     /*Scope*/ 14, /*->14358*/
/* 14344*/      OPC_RecordChild0, // #2 = $v1
/* 14345*/      OPC_CheckChild1Same, 1,
/* 14347*/      OPC_MoveParent,
/* 14348*/      OPC_CheckType, MVT::v8i16,
/* 14350*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14358*/     0, /*End of Scope*/
/* 14359*/    /*Scope*/ 76, /*->14436*/
/* 14360*/     OPC_RecordChild1, // #1 = $v1
/* 14361*/     OPC_MoveSibling1,
/* 14362*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14365*/     OPC_Scope, 22, /*->14389*/ // 3 children in Scope
/* 14367*/      OPC_RecordChild0, // #2 = $v2
/* 14368*/      OPC_MoveChild1,
/* 14369*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14372*/      OPC_CheckChild0Same, 0,
/* 14374*/      OPC_MoveChild1,
/* 14375*/      OPC_CheckImmAllOnesV,
/* 14376*/      OPC_MoveParent,
/* 14377*/      OPC_MoveParent,
/* 14378*/      OPC_MoveParent,
/* 14379*/      OPC_CheckType, MVT::v4i32,
/* 14381*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14389*/     /*Scope*/ 22, /*->14412*/
/* 14390*/      OPC_MoveChild0,
/* 14391*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14394*/      OPC_CheckChild0Same, 1,
/* 14396*/      OPC_MoveChild1,
/* 14397*/      OPC_CheckImmAllOnesV,
/* 14398*/      OPC_MoveParent,
/* 14399*/      OPC_MoveParent,
/* 14400*/      OPC_RecordChild1, // #2 = $v2
/* 14401*/      OPC_MoveParent,
/* 14402*/      OPC_CheckType, MVT::v4i32,
/* 14404*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14412*/     /*Scope*/ 22, /*->14435*/
/* 14413*/      OPC_RecordChild0, // #2 = $v2
/* 14414*/      OPC_MoveChild1,
/* 14415*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14418*/      OPC_CheckChild0Same, 1,
/* 14420*/      OPC_MoveChild1,
/* 14421*/      OPC_CheckImmAllOnesV,
/* 14422*/      OPC_MoveParent,
/* 14423*/      OPC_MoveParent,
/* 14424*/      OPC_MoveParent,
/* 14425*/      OPC_CheckType, MVT::v4i32,
/* 14427*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14435*/     0, /*End of Scope*/
/* 14436*/    0, /*End of Scope*/
/* 14437*/   /*Scope*/ 46, /*->14484*/
/* 14438*/    OPC_MoveChild0,
/* 14439*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14442*/    OPC_RecordChild0, // #0 = $c
/* 14443*/    OPC_MoveChild1,
/* 14444*/    OPC_CheckImmAllOnesV,
/* 14445*/    OPC_MoveParent,
/* 14446*/    OPC_MoveParent,
/* 14447*/    OPC_RecordChild1, // #1 = $v2
/* 14448*/    OPC_MoveSibling1,
/* 14449*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14452*/    OPC_Scope, 14, /*->14468*/ // 2 children in Scope
/* 14454*/     OPC_CheckChild0Same, 0,
/* 14456*/     OPC_RecordChild1, // #2 = $v1
/* 14457*/     OPC_MoveParent,
/* 14458*/     OPC_CheckType, MVT::v4i32,
/* 14460*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14468*/    /*Scope*/ 14, /*->14483*/
/* 14469*/     OPC_RecordChild0, // #2 = $v1
/* 14470*/     OPC_CheckChild1Same, 0,
/* 14472*/     OPC_MoveParent,
/* 14473*/     OPC_CheckType, MVT::v4i32,
/* 14475*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14483*/    0, /*End of Scope*/
/* 14484*/   /*Scope*/ 126, /*->14611*/
/* 14485*/    OPC_RecordChild0, // #0 = $v2
/* 14486*/    OPC_Scope, 45, /*->14533*/ // 2 children in Scope
/* 14488*/     OPC_MoveChild1,
/* 14489*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14492*/     OPC_RecordChild0, // #1 = $c
/* 14493*/     OPC_MoveChild1,
/* 14494*/     OPC_CheckImmAllOnesV,
/* 14495*/     OPC_MoveParent,
/* 14496*/     OPC_MoveParent,
/* 14497*/     OPC_MoveSibling1,
/* 14498*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14501*/     OPC_Scope, 14, /*->14517*/ // 2 children in Scope
/* 14503*/      OPC_CheckChild0Same, 1,
/* 14505*/      OPC_RecordChild1, // #2 = $v1
/* 14506*/      OPC_MoveParent,
/* 14507*/      OPC_CheckType, MVT::v4i32,
/* 14509*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14517*/     /*Scope*/ 14, /*->14532*/
/* 14518*/      OPC_RecordChild0, // #2 = $v1
/* 14519*/      OPC_CheckChild1Same, 1,
/* 14521*/      OPC_MoveParent,
/* 14522*/      OPC_CheckType, MVT::v4i32,
/* 14524*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14532*/     0, /*End of Scope*/
/* 14533*/    /*Scope*/ 76, /*->14610*/
/* 14534*/     OPC_RecordChild1, // #1 = $v1
/* 14535*/     OPC_MoveSibling1,
/* 14536*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14539*/     OPC_Scope, 22, /*->14563*/ // 3 children in Scope
/* 14541*/      OPC_RecordChild0, // #2 = $v2
/* 14542*/      OPC_MoveChild1,
/* 14543*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14546*/      OPC_CheckChild0Same, 0,
/* 14548*/      OPC_MoveChild1,
/* 14549*/      OPC_CheckImmAllOnesV,
/* 14550*/      OPC_MoveParent,
/* 14551*/      OPC_MoveParent,
/* 14552*/      OPC_MoveParent,
/* 14553*/      OPC_CheckType, MVT::v2i64,
/* 14555*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14563*/     /*Scope*/ 22, /*->14586*/
/* 14564*/      OPC_MoveChild0,
/* 14565*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14568*/      OPC_CheckChild0Same, 1,
/* 14570*/      OPC_MoveChild1,
/* 14571*/      OPC_CheckImmAllOnesV,
/* 14572*/      OPC_MoveParent,
/* 14573*/      OPC_MoveParent,
/* 14574*/      OPC_RecordChild1, // #2 = $v2
/* 14575*/      OPC_MoveParent,
/* 14576*/      OPC_CheckType, MVT::v2i64,
/* 14578*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14586*/     /*Scope*/ 22, /*->14609*/
/* 14587*/      OPC_RecordChild0, // #2 = $v2
/* 14588*/      OPC_MoveChild1,
/* 14589*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14592*/      OPC_CheckChild0Same, 1,
/* 14594*/      OPC_MoveChild1,
/* 14595*/      OPC_CheckImmAllOnesV,
/* 14596*/      OPC_MoveParent,
/* 14597*/      OPC_MoveParent,
/* 14598*/      OPC_MoveParent,
/* 14599*/      OPC_CheckType, MVT::v2i64,
/* 14601*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14609*/     0, /*End of Scope*/
/* 14610*/    0, /*End of Scope*/
/* 14611*/   /*Scope*/ 46, /*->14658*/
/* 14612*/    OPC_MoveChild0,
/* 14613*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14616*/    OPC_RecordChild0, // #0 = $c
/* 14617*/    OPC_MoveChild1,
/* 14618*/    OPC_CheckImmAllOnesV,
/* 14619*/    OPC_MoveParent,
/* 14620*/    OPC_MoveParent,
/* 14621*/    OPC_RecordChild1, // #1 = $v2
/* 14622*/    OPC_MoveSibling1,
/* 14623*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14626*/    OPC_Scope, 14, /*->14642*/ // 2 children in Scope
/* 14628*/     OPC_CheckChild0Same, 0,
/* 14630*/     OPC_RecordChild1, // #2 = $v1
/* 14631*/     OPC_MoveParent,
/* 14632*/     OPC_CheckType, MVT::v2i64,
/* 14634*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14642*/    /*Scope*/ 14, /*->14657*/
/* 14643*/     OPC_RecordChild0, // #2 = $v1
/* 14644*/     OPC_CheckChild1Same, 0,
/* 14646*/     OPC_MoveParent,
/* 14647*/     OPC_CheckType, MVT::v2i64,
/* 14649*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14657*/    0, /*End of Scope*/
/* 14658*/   /*Scope*/ 46, /*->14705*/
/* 14659*/    OPC_RecordChild0, // #0 = $v2
/* 14660*/    OPC_MoveChild1,
/* 14661*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14664*/    OPC_RecordChild0, // #1 = $c
/* 14665*/    OPC_MoveChild1,
/* 14666*/    OPC_CheckImmAllOnesV,
/* 14667*/    OPC_MoveParent,
/* 14668*/    OPC_MoveParent,
/* 14669*/    OPC_MoveSibling1,
/* 14670*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14673*/    OPC_Scope, 14, /*->14689*/ // 2 children in Scope
/* 14675*/     OPC_CheckChild0Same, 1,
/* 14677*/     OPC_RecordChild1, // #2 = $v1
/* 14678*/     OPC_MoveParent,
/* 14679*/     OPC_CheckType, MVT::v2i64,
/* 14681*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14689*/    /*Scope*/ 14, /*->14704*/
/* 14690*/     OPC_RecordChild0, // #2 = $v1
/* 14691*/     OPC_CheckChild1Same, 1,
/* 14693*/     OPC_MoveParent,
/* 14694*/     OPC_CheckType, MVT::v2i64,
/* 14696*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14704*/    0, /*End of Scope*/
/* 14705*/   0, /*End of Scope*/
/* 14706*/  /*Scope*/ 40, /*->14747*/
/* 14707*/   OPC_RecordChild0, // #0 = $lhs
/* 14708*/   OPC_RecordChild1, // #1 = $rhs
/* 14709*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->14719
/* 14712*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 14719*/   /*SwitchType*/ 7, MVT::v8i16,// ->14728
/* 14721*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 14728*/   /*SwitchType*/ 7, MVT::v4i32,// ->14737
/* 14730*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 14737*/   /*SwitchType*/ 7, MVT::v2i64,// ->14746
/* 14739*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 14746*/   0, // EndSwitchType
/* 14747*/  0, /*End of Scope*/
/* 14748*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16281
/* 14752*/  OPC_Scope, 22, /*->14776*/ // 17 children in Scope
/* 14754*/   OPC_RecordChild0, // #0 = $lhs
/* 14755*/   OPC_RecordChild1, // #1 = $rhs
/* 14756*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14766
/* 14759*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14766*/   /*SwitchType*/ 7, MVT::i64,// ->14775
/* 14768*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14775*/   0, // EndSwitchType
/* 14776*/  /*Scope*/ 121, /*->14898*/
/* 14777*/   OPC_MoveChild0,
/* 14778*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14781*/   OPC_MoveChild0,
/* 14782*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14785*/   OPC_RecordChild0, // #0 = $v1
/* 14786*/   OPC_Scope, 71, /*->14859*/ // 2 children in Scope
/* 14788*/    OPC_RecordChild1, // #1 = $v2
/* 14789*/    OPC_MoveSibling1,
/* 14790*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14793*/    OPC_RecordChild0, // #2 = $c
/* 14794*/    OPC_MoveChild1,
/* 14795*/    OPC_CheckImmAllOnesV,
/* 14796*/    OPC_MoveParent,
/* 14797*/    OPC_MoveParent,
/* 14798*/    OPC_MoveParent,
/* 14799*/    OPC_Scope, 44, /*->14845*/ // 2 children in Scope
/* 14801*/     OPC_CheckChild1Same, 1,
/* 14803*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->14814
/* 14806*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14814*/     /*SwitchType*/ 8, MVT::v8i16,// ->14824
/* 14816*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14824*/     /*SwitchType*/ 8, MVT::v4i32,// ->14834
/* 14826*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14834*/     /*SwitchType*/ 8, MVT::v2i64,// ->14844
/* 14836*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14844*/     0, // EndSwitchType
/* 14845*/    /*Scope*/ 12, /*->14858*/
/* 14846*/     OPC_CheckChild1Same, 0,
/* 14848*/     OPC_CheckType, MVT::v16i8,
/* 14850*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14858*/    0, /*End of Scope*/
/* 14859*/   /*Scope*/ 37, /*->14897*/
/* 14860*/    OPC_MoveChild1,
/* 14861*/    OPC_CheckImmAllOnesV,
/* 14862*/    OPC_MoveParent,
/* 14863*/    OPC_MoveSibling1,
/* 14864*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14867*/    OPC_RecordChild0, // #1 = $v1
/* 14868*/    OPC_RecordChild1, // #2 = $v2
/* 14869*/    OPC_MoveParent,
/* 14870*/    OPC_MoveParent,
/* 14871*/    OPC_CheckType, MVT::v16i8,
/* 14873*/    OPC_Scope, 10, /*->14885*/ // 2 children in Scope
/* 14875*/     OPC_CheckChild1Same, 2,
/* 14877*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14885*/    /*Scope*/ 10, /*->14896*/
/* 14886*/     OPC_CheckChild1Same, 1,
/* 14888*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14896*/    0, /*End of Scope*/
/* 14897*/   0, /*End of Scope*/
/* 14898*/  /*Scope*/ 102, /*->15001*/
/* 14899*/   OPC_RecordChild0, // #0 = $v2
/* 14900*/   OPC_MoveChild1,
/* 14901*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14904*/   OPC_MoveChild0,
/* 14905*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14908*/   OPC_Scope, 23, /*->14933*/ // 3 children in Scope
/* 14910*/    OPC_RecordChild0, // #1 = $v1
/* 14911*/    OPC_CheckChild1Same, 0,
/* 14913*/    OPC_MoveSibling1,
/* 14914*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14917*/    OPC_RecordChild0, // #2 = $c
/* 14918*/    OPC_MoveChild1,
/* 14919*/    OPC_CheckImmAllOnesV,
/* 14920*/    OPC_MoveParent,
/* 14921*/    OPC_MoveParent,
/* 14922*/    OPC_MoveParent,
/* 14923*/    OPC_CheckType, MVT::v16i8,
/* 14925*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14933*/   /*Scope*/ 23, /*->14957*/
/* 14934*/    OPC_CheckChild0Same, 0,
/* 14936*/    OPC_RecordChild1, // #1 = $v1
/* 14937*/    OPC_MoveSibling1,
/* 14938*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14941*/    OPC_RecordChild0, // #2 = $c
/* 14942*/    OPC_MoveChild1,
/* 14943*/    OPC_CheckImmAllOnesV,
/* 14944*/    OPC_MoveParent,
/* 14945*/    OPC_MoveParent,
/* 14946*/    OPC_MoveParent,
/* 14947*/    OPC_CheckType, MVT::v16i8,
/* 14949*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14957*/   /*Scope*/ 42, /*->15000*/
/* 14958*/    OPC_RecordChild0, // #1 = $c
/* 14959*/    OPC_MoveChild1,
/* 14960*/    OPC_CheckImmAllOnesV,
/* 14961*/    OPC_MoveParent,
/* 14962*/    OPC_MoveSibling1,
/* 14963*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14966*/    OPC_Scope, 15, /*->14983*/ // 2 children in Scope
/* 14968*/     OPC_RecordChild0, // #2 = $v1
/* 14969*/     OPC_CheckChild1Same, 0,
/* 14971*/     OPC_MoveParent,
/* 14972*/     OPC_MoveParent,
/* 14973*/     OPC_CheckType, MVT::v16i8,
/* 14975*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14983*/    /*Scope*/ 15, /*->14999*/
/* 14984*/     OPC_CheckChild0Same, 0,
/* 14986*/     OPC_RecordChild1, // #2 = $v1
/* 14987*/     OPC_MoveParent,
/* 14988*/     OPC_MoveParent,
/* 14989*/     OPC_CheckType, MVT::v16i8,
/* 14991*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14999*/    0, /*End of Scope*/
/* 15000*/   0, /*End of Scope*/
/* 15001*/  /*Scope*/ 73, /*->15075*/
/* 15002*/   OPC_MoveChild0,
/* 15003*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15006*/   OPC_MoveChild0,
/* 15007*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15010*/   OPC_RecordChild0, // #0 = $v2
/* 15011*/   OPC_Scope, 23, /*->15036*/ // 2 children in Scope
/* 15013*/    OPC_RecordChild1, // #1 = $v1
/* 15014*/    OPC_MoveSibling1,
/* 15015*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15018*/    OPC_RecordChild0, // #2 = $c
/* 15019*/    OPC_MoveChild1,
/* 15020*/    OPC_CheckImmAllOnesV,
/* 15021*/    OPC_MoveParent,
/* 15022*/    OPC_MoveParent,
/* 15023*/    OPC_MoveParent,
/* 15024*/    OPC_CheckChild1Same, 0,
/* 15026*/    OPC_CheckType, MVT::v8i16,
/* 15028*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15036*/   /*Scope*/ 37, /*->15074*/
/* 15037*/    OPC_MoveChild1,
/* 15038*/    OPC_CheckImmAllOnesV,
/* 15039*/    OPC_MoveParent,
/* 15040*/    OPC_MoveSibling1,
/* 15041*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15044*/    OPC_RecordChild0, // #1 = $v1
/* 15045*/    OPC_RecordChild1, // #2 = $v2
/* 15046*/    OPC_MoveParent,
/* 15047*/    OPC_MoveParent,
/* 15048*/    OPC_CheckType, MVT::v8i16,
/* 15050*/    OPC_Scope, 10, /*->15062*/ // 2 children in Scope
/* 15052*/     OPC_CheckChild1Same, 2,
/* 15054*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15062*/    /*Scope*/ 10, /*->15073*/
/* 15063*/     OPC_CheckChild1Same, 1,
/* 15065*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15073*/    0, /*End of Scope*/
/* 15074*/   0, /*End of Scope*/
/* 15075*/  /*Scope*/ 102, /*->15178*/
/* 15076*/   OPC_RecordChild0, // #0 = $v2
/* 15077*/   OPC_MoveChild1,
/* 15078*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15081*/   OPC_MoveChild0,
/* 15082*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15085*/   OPC_Scope, 23, /*->15110*/ // 3 children in Scope
/* 15087*/    OPC_RecordChild0, // #1 = $v1
/* 15088*/    OPC_CheckChild1Same, 0,
/* 15090*/    OPC_MoveSibling1,
/* 15091*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15094*/    OPC_RecordChild0, // #2 = $c
/* 15095*/    OPC_MoveChild1,
/* 15096*/    OPC_CheckImmAllOnesV,
/* 15097*/    OPC_MoveParent,
/* 15098*/    OPC_MoveParent,
/* 15099*/    OPC_MoveParent,
/* 15100*/    OPC_CheckType, MVT::v8i16,
/* 15102*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15110*/   /*Scope*/ 23, /*->15134*/
/* 15111*/    OPC_CheckChild0Same, 0,
/* 15113*/    OPC_RecordChild1, // #1 = $v1
/* 15114*/    OPC_MoveSibling1,
/* 15115*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15118*/    OPC_RecordChild0, // #2 = $c
/* 15119*/    OPC_MoveChild1,
/* 15120*/    OPC_CheckImmAllOnesV,
/* 15121*/    OPC_MoveParent,
/* 15122*/    OPC_MoveParent,
/* 15123*/    OPC_MoveParent,
/* 15124*/    OPC_CheckType, MVT::v8i16,
/* 15126*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15134*/   /*Scope*/ 42, /*->15177*/
/* 15135*/    OPC_RecordChild0, // #1 = $c
/* 15136*/    OPC_MoveChild1,
/* 15137*/    OPC_CheckImmAllOnesV,
/* 15138*/    OPC_MoveParent,
/* 15139*/    OPC_MoveSibling1,
/* 15140*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15143*/    OPC_Scope, 15, /*->15160*/ // 2 children in Scope
/* 15145*/     OPC_RecordChild0, // #2 = $v1
/* 15146*/     OPC_CheckChild1Same, 0,
/* 15148*/     OPC_MoveParent,
/* 15149*/     OPC_MoveParent,
/* 15150*/     OPC_CheckType, MVT::v8i16,
/* 15152*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15160*/    /*Scope*/ 15, /*->15176*/
/* 15161*/     OPC_CheckChild0Same, 0,
/* 15163*/     OPC_RecordChild1, // #2 = $v1
/* 15164*/     OPC_MoveParent,
/* 15165*/     OPC_MoveParent,
/* 15166*/     OPC_CheckType, MVT::v8i16,
/* 15168*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15176*/    0, /*End of Scope*/
/* 15177*/   0, /*End of Scope*/
/* 15178*/  /*Scope*/ 73, /*->15252*/
/* 15179*/   OPC_MoveChild0,
/* 15180*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15183*/   OPC_MoveChild0,
/* 15184*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15187*/   OPC_RecordChild0, // #0 = $v2
/* 15188*/   OPC_Scope, 23, /*->15213*/ // 2 children in Scope
/* 15190*/    OPC_RecordChild1, // #1 = $v1
/* 15191*/    OPC_MoveSibling1,
/* 15192*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15195*/    OPC_RecordChild0, // #2 = $c
/* 15196*/    OPC_MoveChild1,
/* 15197*/    OPC_CheckImmAllOnesV,
/* 15198*/    OPC_MoveParent,
/* 15199*/    OPC_MoveParent,
/* 15200*/    OPC_MoveParent,
/* 15201*/    OPC_CheckChild1Same, 0,
/* 15203*/    OPC_CheckType, MVT::v4i32,
/* 15205*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15213*/   /*Scope*/ 37, /*->15251*/
/* 15214*/    OPC_MoveChild1,
/* 15215*/    OPC_CheckImmAllOnesV,
/* 15216*/    OPC_MoveParent,
/* 15217*/    OPC_MoveSibling1,
/* 15218*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15221*/    OPC_RecordChild0, // #1 = $v1
/* 15222*/    OPC_RecordChild1, // #2 = $v2
/* 15223*/    OPC_MoveParent,
/* 15224*/    OPC_MoveParent,
/* 15225*/    OPC_CheckType, MVT::v4i32,
/* 15227*/    OPC_Scope, 10, /*->15239*/ // 2 children in Scope
/* 15229*/     OPC_CheckChild1Same, 2,
/* 15231*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15239*/    /*Scope*/ 10, /*->15250*/
/* 15240*/     OPC_CheckChild1Same, 1,
/* 15242*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15250*/    0, /*End of Scope*/
/* 15251*/   0, /*End of Scope*/
/* 15252*/  /*Scope*/ 102, /*->15355*/
/* 15253*/   OPC_RecordChild0, // #0 = $v2
/* 15254*/   OPC_MoveChild1,
/* 15255*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15258*/   OPC_MoveChild0,
/* 15259*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15262*/   OPC_Scope, 23, /*->15287*/ // 3 children in Scope
/* 15264*/    OPC_RecordChild0, // #1 = $v1
/* 15265*/    OPC_CheckChild1Same, 0,
/* 15267*/    OPC_MoveSibling1,
/* 15268*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15271*/    OPC_RecordChild0, // #2 = $c
/* 15272*/    OPC_MoveChild1,
/* 15273*/    OPC_CheckImmAllOnesV,
/* 15274*/    OPC_MoveParent,
/* 15275*/    OPC_MoveParent,
/* 15276*/    OPC_MoveParent,
/* 15277*/    OPC_CheckType, MVT::v4i32,
/* 15279*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15287*/   /*Scope*/ 23, /*->15311*/
/* 15288*/    OPC_CheckChild0Same, 0,
/* 15290*/    OPC_RecordChild1, // #1 = $v1
/* 15291*/    OPC_MoveSibling1,
/* 15292*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15295*/    OPC_RecordChild0, // #2 = $c
/* 15296*/    OPC_MoveChild1,
/* 15297*/    OPC_CheckImmAllOnesV,
/* 15298*/    OPC_MoveParent,
/* 15299*/    OPC_MoveParent,
/* 15300*/    OPC_MoveParent,
/* 15301*/    OPC_CheckType, MVT::v4i32,
/* 15303*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15311*/   /*Scope*/ 42, /*->15354*/
/* 15312*/    OPC_RecordChild0, // #1 = $c
/* 15313*/    OPC_MoveChild1,
/* 15314*/    OPC_CheckImmAllOnesV,
/* 15315*/    OPC_MoveParent,
/* 15316*/    OPC_MoveSibling1,
/* 15317*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15320*/    OPC_Scope, 15, /*->15337*/ // 2 children in Scope
/* 15322*/     OPC_RecordChild0, // #2 = $v1
/* 15323*/     OPC_CheckChild1Same, 0,
/* 15325*/     OPC_MoveParent,
/* 15326*/     OPC_MoveParent,
/* 15327*/     OPC_CheckType, MVT::v4i32,
/* 15329*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15337*/    /*Scope*/ 15, /*->15353*/
/* 15338*/     OPC_CheckChild0Same, 0,
/* 15340*/     OPC_RecordChild1, // #2 = $v1
/* 15341*/     OPC_MoveParent,
/* 15342*/     OPC_MoveParent,
/* 15343*/     OPC_CheckType, MVT::v4i32,
/* 15345*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15353*/    0, /*End of Scope*/
/* 15354*/   0, /*End of Scope*/
/* 15355*/  /*Scope*/ 73, /*->15429*/
/* 15356*/   OPC_MoveChild0,
/* 15357*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15360*/   OPC_MoveChild0,
/* 15361*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15364*/   OPC_RecordChild0, // #0 = $v2
/* 15365*/   OPC_Scope, 23, /*->15390*/ // 2 children in Scope
/* 15367*/    OPC_RecordChild1, // #1 = $v1
/* 15368*/    OPC_MoveSibling1,
/* 15369*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15372*/    OPC_RecordChild0, // #2 = $c
/* 15373*/    OPC_MoveChild1,
/* 15374*/    OPC_CheckImmAllOnesV,
/* 15375*/    OPC_MoveParent,
/* 15376*/    OPC_MoveParent,
/* 15377*/    OPC_MoveParent,
/* 15378*/    OPC_CheckChild1Same, 0,
/* 15380*/    OPC_CheckType, MVT::v2i64,
/* 15382*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15390*/   /*Scope*/ 37, /*->15428*/
/* 15391*/    OPC_MoveChild1,
/* 15392*/    OPC_CheckImmAllOnesV,
/* 15393*/    OPC_MoveParent,
/* 15394*/    OPC_MoveSibling1,
/* 15395*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15398*/    OPC_RecordChild0, // #1 = $v1
/* 15399*/    OPC_RecordChild1, // #2 = $v2
/* 15400*/    OPC_MoveParent,
/* 15401*/    OPC_MoveParent,
/* 15402*/    OPC_CheckType, MVT::v2i64,
/* 15404*/    OPC_Scope, 10, /*->15416*/ // 2 children in Scope
/* 15406*/     OPC_CheckChild1Same, 2,
/* 15408*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15416*/    /*Scope*/ 10, /*->15427*/
/* 15417*/     OPC_CheckChild1Same, 1,
/* 15419*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15427*/    0, /*End of Scope*/
/* 15428*/   0, /*End of Scope*/
/* 15429*/  /*Scope*/ 102, /*->15532*/
/* 15430*/   OPC_RecordChild0, // #0 = $v2
/* 15431*/   OPC_MoveChild1,
/* 15432*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15435*/   OPC_MoveChild0,
/* 15436*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15439*/   OPC_Scope, 23, /*->15464*/ // 3 children in Scope
/* 15441*/    OPC_RecordChild0, // #1 = $v1
/* 15442*/    OPC_CheckChild1Same, 0,
/* 15444*/    OPC_MoveSibling1,
/* 15445*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15448*/    OPC_RecordChild0, // #2 = $c
/* 15449*/    OPC_MoveChild1,
/* 15450*/    OPC_CheckImmAllOnesV,
/* 15451*/    OPC_MoveParent,
/* 15452*/    OPC_MoveParent,
/* 15453*/    OPC_MoveParent,
/* 15454*/    OPC_CheckType, MVT::v2i64,
/* 15456*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15464*/   /*Scope*/ 23, /*->15488*/
/* 15465*/    OPC_CheckChild0Same, 0,
/* 15467*/    OPC_RecordChild1, // #1 = $v1
/* 15468*/    OPC_MoveSibling1,
/* 15469*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15472*/    OPC_RecordChild0, // #2 = $c
/* 15473*/    OPC_MoveChild1,
/* 15474*/    OPC_CheckImmAllOnesV,
/* 15475*/    OPC_MoveParent,
/* 15476*/    OPC_MoveParent,
/* 15477*/    OPC_MoveParent,
/* 15478*/    OPC_CheckType, MVT::v2i64,
/* 15480*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15488*/   /*Scope*/ 42, /*->15531*/
/* 15489*/    OPC_RecordChild0, // #1 = $c
/* 15490*/    OPC_MoveChild1,
/* 15491*/    OPC_CheckImmAllOnesV,
/* 15492*/    OPC_MoveParent,
/* 15493*/    OPC_MoveSibling1,
/* 15494*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15497*/    OPC_Scope, 15, /*->15514*/ // 2 children in Scope
/* 15499*/     OPC_RecordChild0, // #2 = $v1
/* 15500*/     OPC_CheckChild1Same, 0,
/* 15502*/     OPC_MoveParent,
/* 15503*/     OPC_MoveParent,
/* 15504*/     OPC_CheckType, MVT::v2i64,
/* 15506*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15514*/    /*Scope*/ 15, /*->15530*/
/* 15515*/     OPC_CheckChild0Same, 0,
/* 15517*/     OPC_RecordChild1, // #2 = $v1
/* 15518*/     OPC_MoveParent,
/* 15519*/     OPC_MoveParent,
/* 15520*/     OPC_CheckType, MVT::v2i64,
/* 15522*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15530*/    0, /*End of Scope*/
/* 15531*/   0, /*End of Scope*/
/* 15532*/  /*Scope*/ 112, /*->15645*/
/* 15533*/   OPC_MoveChild0,
/* 15534*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15537*/   OPC_Scope, 69, /*->15608*/ // 2 children in Scope
/* 15539*/    OPC_MoveChild0,
/* 15540*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15543*/    OPC_RecordChild0, // #0 = $v1
/* 15544*/    OPC_RecordChild1, // #1 = $v2
/* 15545*/    OPC_MoveParent,
/* 15546*/    OPC_RecordChild1, // #2 = $c
/* 15547*/    OPC_MoveParent,
/* 15548*/    OPC_Scope, 44, /*->15594*/ // 2 children in Scope
/* 15550*/     OPC_CheckChild1Same, 1,
/* 15552*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->15563
/* 15555*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15563*/     /*SwitchType*/ 8, MVT::v8i16,// ->15573
/* 15565*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15573*/     /*SwitchType*/ 8, MVT::v4i32,// ->15583
/* 15575*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15583*/     /*SwitchType*/ 8, MVT::v2i64,// ->15593
/* 15585*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15593*/     0, // EndSwitchType
/* 15594*/    /*Scope*/ 12, /*->15607*/
/* 15595*/     OPC_CheckChild1Same, 0,
/* 15597*/     OPC_CheckType, MVT::v16i8,
/* 15599*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15607*/    0, /*End of Scope*/
/* 15608*/   /*Scope*/ 35, /*->15644*/
/* 15609*/    OPC_RecordChild0, // #0 = $c
/* 15610*/    OPC_MoveChild1,
/* 15611*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15614*/    OPC_RecordChild0, // #1 = $v1
/* 15615*/    OPC_RecordChild1, // #2 = $v2
/* 15616*/    OPC_MoveParent,
/* 15617*/    OPC_MoveParent,
/* 15618*/    OPC_CheckType, MVT::v16i8,
/* 15620*/    OPC_Scope, 10, /*->15632*/ // 2 children in Scope
/* 15622*/     OPC_CheckChild1Same, 2,
/* 15624*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15632*/    /*Scope*/ 10, /*->15643*/
/* 15633*/     OPC_CheckChild1Same, 1,
/* 15635*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15643*/    0, /*End of Scope*/
/* 15644*/   0, /*End of Scope*/
/* 15645*/  /*Scope*/ 88, /*->15734*/
/* 15646*/   OPC_RecordChild0, // #0 = $v2
/* 15647*/   OPC_MoveChild1,
/* 15648*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15651*/   OPC_Scope, 40, /*->15693*/ // 2 children in Scope
/* 15653*/    OPC_MoveChild0,
/* 15654*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15657*/    OPC_Scope, 16, /*->15675*/ // 2 children in Scope
/* 15659*/     OPC_RecordChild0, // #1 = $v1
/* 15660*/     OPC_CheckChild1Same, 0,
/* 15662*/     OPC_MoveParent,
/* 15663*/     OPC_RecordChild1, // #2 = $c
/* 15664*/     OPC_MoveParent,
/* 15665*/     OPC_CheckType, MVT::v16i8,
/* 15667*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15675*/    /*Scope*/ 16, /*->15692*/
/* 15676*/     OPC_CheckChild0Same, 0,
/* 15678*/     OPC_RecordChild1, // #1 = $v1
/* 15679*/     OPC_MoveParent,
/* 15680*/     OPC_RecordChild1, // #2 = $c
/* 15681*/     OPC_MoveParent,
/* 15682*/     OPC_CheckType, MVT::v16i8,
/* 15684*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15692*/    0, /*End of Scope*/
/* 15693*/   /*Scope*/ 39, /*->15733*/
/* 15694*/    OPC_RecordChild0, // #1 = $c
/* 15695*/    OPC_MoveChild1,
/* 15696*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15699*/    OPC_Scope, 15, /*->15716*/ // 2 children in Scope
/* 15701*/     OPC_RecordChild0, // #2 = $v1
/* 15702*/     OPC_CheckChild1Same, 0,
/* 15704*/     OPC_MoveParent,
/* 15705*/     OPC_MoveParent,
/* 15706*/     OPC_CheckType, MVT::v16i8,
/* 15708*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15716*/    /*Scope*/ 15, /*->15732*/
/* 15717*/     OPC_CheckChild0Same, 0,
/* 15719*/     OPC_RecordChild1, // #2 = $v1
/* 15720*/     OPC_MoveParent,
/* 15721*/     OPC_MoveParent,
/* 15722*/     OPC_CheckType, MVT::v16i8,
/* 15724*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15732*/    0, /*End of Scope*/
/* 15733*/   0, /*End of Scope*/
/* 15734*/  /*Scope*/ 64, /*->15799*/
/* 15735*/   OPC_MoveChild0,
/* 15736*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15739*/   OPC_Scope, 21, /*->15762*/ // 2 children in Scope
/* 15741*/    OPC_MoveChild0,
/* 15742*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15745*/    OPC_RecordChild0, // #0 = $v2
/* 15746*/    OPC_RecordChild1, // #1 = $v1
/* 15747*/    OPC_MoveParent,
/* 15748*/    OPC_RecordChild1, // #2 = $c
/* 15749*/    OPC_MoveParent,
/* 15750*/    OPC_CheckChild1Same, 0,
/* 15752*/    OPC_CheckType, MVT::v8i16,
/* 15754*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15762*/   /*Scope*/ 35, /*->15798*/
/* 15763*/    OPC_RecordChild0, // #0 = $c
/* 15764*/    OPC_MoveChild1,
/* 15765*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15768*/    OPC_RecordChild0, // #1 = $v1
/* 15769*/    OPC_RecordChild1, // #2 = $v2
/* 15770*/    OPC_MoveParent,
/* 15771*/    OPC_MoveParent,
/* 15772*/    OPC_CheckType, MVT::v8i16,
/* 15774*/    OPC_Scope, 10, /*->15786*/ // 2 children in Scope
/* 15776*/     OPC_CheckChild1Same, 2,
/* 15778*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15786*/    /*Scope*/ 10, /*->15797*/
/* 15787*/     OPC_CheckChild1Same, 1,
/* 15789*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15797*/    0, /*End of Scope*/
/* 15798*/   0, /*End of Scope*/
/* 15799*/  /*Scope*/ 88, /*->15888*/
/* 15800*/   OPC_RecordChild0, // #0 = $v2
/* 15801*/   OPC_MoveChild1,
/* 15802*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15805*/   OPC_Scope, 40, /*->15847*/ // 2 children in Scope
/* 15807*/    OPC_MoveChild0,
/* 15808*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15811*/    OPC_Scope, 16, /*->15829*/ // 2 children in Scope
/* 15813*/     OPC_RecordChild0, // #1 = $v1
/* 15814*/     OPC_CheckChild1Same, 0,
/* 15816*/     OPC_MoveParent,
/* 15817*/     OPC_RecordChild1, // #2 = $c
/* 15818*/     OPC_MoveParent,
/* 15819*/     OPC_CheckType, MVT::v8i16,
/* 15821*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15829*/    /*Scope*/ 16, /*->15846*/
/* 15830*/     OPC_CheckChild0Same, 0,
/* 15832*/     OPC_RecordChild1, // #1 = $v1
/* 15833*/     OPC_MoveParent,
/* 15834*/     OPC_RecordChild1, // #2 = $c
/* 15835*/     OPC_MoveParent,
/* 15836*/     OPC_CheckType, MVT::v8i16,
/* 15838*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15846*/    0, /*End of Scope*/
/* 15847*/   /*Scope*/ 39, /*->15887*/
/* 15848*/    OPC_RecordChild0, // #1 = $c
/* 15849*/    OPC_MoveChild1,
/* 15850*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15853*/    OPC_Scope, 15, /*->15870*/ // 2 children in Scope
/* 15855*/     OPC_RecordChild0, // #2 = $v1
/* 15856*/     OPC_CheckChild1Same, 0,
/* 15858*/     OPC_MoveParent,
/* 15859*/     OPC_MoveParent,
/* 15860*/     OPC_CheckType, MVT::v8i16,
/* 15862*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15870*/    /*Scope*/ 15, /*->15886*/
/* 15871*/     OPC_CheckChild0Same, 0,
/* 15873*/     OPC_RecordChild1, // #2 = $v1
/* 15874*/     OPC_MoveParent,
/* 15875*/     OPC_MoveParent,
/* 15876*/     OPC_CheckType, MVT::v8i16,
/* 15878*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15886*/    0, /*End of Scope*/
/* 15887*/   0, /*End of Scope*/
/* 15888*/  /*Scope*/ 64, /*->15953*/
/* 15889*/   OPC_MoveChild0,
/* 15890*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15893*/   OPC_Scope, 21, /*->15916*/ // 2 children in Scope
/* 15895*/    OPC_MoveChild0,
/* 15896*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15899*/    OPC_RecordChild0, // #0 = $v2
/* 15900*/    OPC_RecordChild1, // #1 = $v1
/* 15901*/    OPC_MoveParent,
/* 15902*/    OPC_RecordChild1, // #2 = $c
/* 15903*/    OPC_MoveParent,
/* 15904*/    OPC_CheckChild1Same, 0,
/* 15906*/    OPC_CheckType, MVT::v4i32,
/* 15908*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15916*/   /*Scope*/ 35, /*->15952*/
/* 15917*/    OPC_RecordChild0, // #0 = $c
/* 15918*/    OPC_MoveChild1,
/* 15919*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15922*/    OPC_RecordChild0, // #1 = $v1
/* 15923*/    OPC_RecordChild1, // #2 = $v2
/* 15924*/    OPC_MoveParent,
/* 15925*/    OPC_MoveParent,
/* 15926*/    OPC_CheckType, MVT::v4i32,
/* 15928*/    OPC_Scope, 10, /*->15940*/ // 2 children in Scope
/* 15930*/     OPC_CheckChild1Same, 2,
/* 15932*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15940*/    /*Scope*/ 10, /*->15951*/
/* 15941*/     OPC_CheckChild1Same, 1,
/* 15943*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15951*/    0, /*End of Scope*/
/* 15952*/   0, /*End of Scope*/
/* 15953*/  /*Scope*/ 88, /*->16042*/
/* 15954*/   OPC_RecordChild0, // #0 = $v2
/* 15955*/   OPC_MoveChild1,
/* 15956*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15959*/   OPC_Scope, 40, /*->16001*/ // 2 children in Scope
/* 15961*/    OPC_MoveChild0,
/* 15962*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15965*/    OPC_Scope, 16, /*->15983*/ // 2 children in Scope
/* 15967*/     OPC_RecordChild0, // #1 = $v1
/* 15968*/     OPC_CheckChild1Same, 0,
/* 15970*/     OPC_MoveParent,
/* 15971*/     OPC_RecordChild1, // #2 = $c
/* 15972*/     OPC_MoveParent,
/* 15973*/     OPC_CheckType, MVT::v4i32,
/* 15975*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15983*/    /*Scope*/ 16, /*->16000*/
/* 15984*/     OPC_CheckChild0Same, 0,
/* 15986*/     OPC_RecordChild1, // #1 = $v1
/* 15987*/     OPC_MoveParent,
/* 15988*/     OPC_RecordChild1, // #2 = $c
/* 15989*/     OPC_MoveParent,
/* 15990*/     OPC_CheckType, MVT::v4i32,
/* 15992*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16000*/    0, /*End of Scope*/
/* 16001*/   /*Scope*/ 39, /*->16041*/
/* 16002*/    OPC_RecordChild0, // #1 = $c
/* 16003*/    OPC_MoveChild1,
/* 16004*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16007*/    OPC_Scope, 15, /*->16024*/ // 2 children in Scope
/* 16009*/     OPC_RecordChild0, // #2 = $v1
/* 16010*/     OPC_CheckChild1Same, 0,
/* 16012*/     OPC_MoveParent,
/* 16013*/     OPC_MoveParent,
/* 16014*/     OPC_CheckType, MVT::v4i32,
/* 16016*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16024*/    /*Scope*/ 15, /*->16040*/
/* 16025*/     OPC_CheckChild0Same, 0,
/* 16027*/     OPC_RecordChild1, // #2 = $v1
/* 16028*/     OPC_MoveParent,
/* 16029*/     OPC_MoveParent,
/* 16030*/     OPC_CheckType, MVT::v4i32,
/* 16032*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16040*/    0, /*End of Scope*/
/* 16041*/   0, /*End of Scope*/
/* 16042*/  /*Scope*/ 64, /*->16107*/
/* 16043*/   OPC_MoveChild0,
/* 16044*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16047*/   OPC_Scope, 21, /*->16070*/ // 2 children in Scope
/* 16049*/    OPC_MoveChild0,
/* 16050*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16053*/    OPC_RecordChild0, // #0 = $v2
/* 16054*/    OPC_RecordChild1, // #1 = $v1
/* 16055*/    OPC_MoveParent,
/* 16056*/    OPC_RecordChild1, // #2 = $c
/* 16057*/    OPC_MoveParent,
/* 16058*/    OPC_CheckChild1Same, 0,
/* 16060*/    OPC_CheckType, MVT::v2i64,
/* 16062*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16070*/   /*Scope*/ 35, /*->16106*/
/* 16071*/    OPC_RecordChild0, // #0 = $c
/* 16072*/    OPC_MoveChild1,
/* 16073*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16076*/    OPC_RecordChild0, // #1 = $v1
/* 16077*/    OPC_RecordChild1, // #2 = $v2
/* 16078*/    OPC_MoveParent,
/* 16079*/    OPC_MoveParent,
/* 16080*/    OPC_CheckType, MVT::v2i64,
/* 16082*/    OPC_Scope, 10, /*->16094*/ // 2 children in Scope
/* 16084*/     OPC_CheckChild1Same, 2,
/* 16086*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16094*/    /*Scope*/ 10, /*->16105*/
/* 16095*/     OPC_CheckChild1Same, 1,
/* 16097*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16105*/    0, /*End of Scope*/
/* 16106*/   0, /*End of Scope*/
/* 16107*/  /*Scope*/ 43|128,1/*171*/, /*->16280*/
/* 16109*/   OPC_RecordChild0, // #0 = $v2
/* 16110*/   OPC_Scope, 127, /*->16239*/ // 2 children in Scope
/* 16112*/    OPC_MoveChild1,
/* 16113*/    OPC_Scope, 86, /*->16201*/ // 2 children in Scope
/* 16115*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16118*/     OPC_Scope, 40, /*->16160*/ // 2 children in Scope
/* 16120*/      OPC_MoveChild0,
/* 16121*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16124*/      OPC_Scope, 16, /*->16142*/ // 2 children in Scope
/* 16126*/       OPC_RecordChild0, // #1 = $v1
/* 16127*/       OPC_CheckChild1Same, 0,
/* 16129*/       OPC_MoveParent,
/* 16130*/       OPC_RecordChild1, // #2 = $c
/* 16131*/       OPC_MoveParent,
/* 16132*/       OPC_CheckType, MVT::v2i64,
/* 16134*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16142*/      /*Scope*/ 16, /*->16159*/
/* 16143*/       OPC_CheckChild0Same, 0,
/* 16145*/       OPC_RecordChild1, // #1 = $v1
/* 16146*/       OPC_MoveParent,
/* 16147*/       OPC_RecordChild1, // #2 = $c
/* 16148*/       OPC_MoveParent,
/* 16149*/       OPC_CheckType, MVT::v2i64,
/* 16151*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16159*/      0, /*End of Scope*/
/* 16160*/     /*Scope*/ 39, /*->16200*/
/* 16161*/      OPC_RecordChild0, // #1 = $c
/* 16162*/      OPC_MoveChild1,
/* 16163*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16166*/      OPC_Scope, 15, /*->16183*/ // 2 children in Scope
/* 16168*/       OPC_RecordChild0, // #2 = $v1
/* 16169*/       OPC_CheckChild1Same, 0,
/* 16171*/       OPC_MoveParent,
/* 16172*/       OPC_MoveParent,
/* 16173*/       OPC_CheckType, MVT::v2i64,
/* 16175*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16183*/      /*Scope*/ 15, /*->16199*/
/* 16184*/       OPC_CheckChild0Same, 0,
/* 16186*/       OPC_RecordChild1, // #2 = $v1
/* 16187*/       OPC_MoveParent,
/* 16188*/       OPC_MoveParent,
/* 16189*/       OPC_CheckType, MVT::v2i64,
/* 16191*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16199*/      0, /*End of Scope*/
/* 16200*/     0, /*End of Scope*/
/* 16201*/    /*Scope*/ 36, /*->16238*/
/* 16202*/     OPC_CheckImmAllOnesV,
/* 16203*/     OPC_MoveParent,
/* 16204*/     OPC_SwitchType /*4 cases */, 6, MVT::v16i8,// ->16213
/* 16207*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16213*/     /*SwitchType*/ 6, MVT::v8i16,// ->16221
/* 16215*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16221*/     /*SwitchType*/ 6, MVT::v4i32,// ->16229
/* 16223*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16229*/     /*SwitchType*/ 6, MVT::v2i64,// ->16237
/* 16231*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16237*/     0, // EndSwitchType
/* 16238*/    0, /*End of Scope*/
/* 16239*/   /*Scope*/ 39, /*->16279*/
/* 16240*/    OPC_RecordChild1, // #1 = $rhs
/* 16241*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->16251
/* 16244*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16251*/    /*SwitchType*/ 7, MVT::v8i16,// ->16260
/* 16253*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16260*/    /*SwitchType*/ 7, MVT::v4i32,// ->16269
/* 16262*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16269*/    /*SwitchType*/ 7, MVT::v2i64,// ->16278
/* 16271*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16278*/    0, // EndSwitchType
/* 16279*/   0, /*End of Scope*/
/* 16280*/  0, /*End of Scope*/
/* 16281*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16305
/* 16284*/  OPC_RecordChild0, // #0 = $src
/* 16285*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->16295
/* 16288*/   OPC_CheckChild0TypeI32,
/* 16289*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16295*/  /*SwitchType*/ 7, MVT::i64,// ->16304
/* 16297*/   OPC_CheckChild0TypeI64,
/* 16298*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16304*/  0, // EndSwitchType
/* 16305*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16329
/* 16308*/  OPC_RecordChild0, // #0 = $src
/* 16309*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->16319
/* 16312*/   OPC_CheckChild0TypeI32,
/* 16313*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16319*/  /*SwitchType*/ 7, MVT::i64,// ->16328
/* 16321*/   OPC_CheckChild0TypeI64,
/* 16322*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16328*/  0, // EndSwitchType
/* 16329*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->16364
/* 16332*/  OPC_RecordChild0, // #0 = $src
/* 16333*/  OPC_SwitchType /*3 cases */, 7, MVT::i32,// ->16343
/* 16336*/   OPC_CheckChild0TypeI32,
/* 16337*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16343*/  /*SwitchType*/ 7, MVT::i64,// ->16352
/* 16345*/   OPC_CheckChild0TypeI64,
/* 16346*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16352*/  /*SwitchType*/ 9, MVT::v16i8,// ->16363
/* 16354*/   OPC_CheckChild0Type, MVT::v16i8,
/* 16356*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16357*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16363*/  0, // EndSwitchType
/* 16364*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16374
/* 16367*/  OPC_RecordChild0, // #0 = $src
/* 16368*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                MVT::i32, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16374*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16384
/* 16377*/  OPC_RecordChild0, // #0 = $src
/* 16378*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16384*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->16508
/* 16387*/  OPC_RecordChild0, // #0 = $src
/* 16388*/  OPC_Scope, 48, /*->16438*/ // 4 children in Scope
/* 16390*/   OPC_CheckChild0Type, MVT::f32,
/* 16392*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16415
/* 16395*/    OPC_Scope, 8, /*->16405*/ // 2 children in Scope
/* 16397*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16399*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16405*/    /*Scope*/ 8, /*->16414*/
/* 16406*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16408*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16414*/    0, /*End of Scope*/
/* 16415*/   /*SwitchType*/ 20, MVT::i64,// ->16437
/* 16417*/    OPC_Scope, 8, /*->16427*/ // 2 children in Scope
/* 16419*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16421*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16427*/    /*Scope*/ 8, /*->16436*/
/* 16428*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16430*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16436*/    0, /*End of Scope*/
/* 16437*/   0, // EndSwitchType
/* 16438*/  /*Scope*/ 48, /*->16487*/
/* 16439*/   OPC_CheckChild0Type, MVT::f64,
/* 16441*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16464
/* 16444*/    OPC_Scope, 8, /*->16454*/ // 2 children in Scope
/* 16446*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16448*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16454*/    /*Scope*/ 8, /*->16463*/
/* 16455*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16457*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16463*/    0, /*End of Scope*/
/* 16464*/   /*SwitchType*/ 20, MVT::i64,// ->16486
/* 16466*/    OPC_Scope, 8, /*->16476*/ // 2 children in Scope
/* 16468*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16470*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16476*/    /*Scope*/ 8, /*->16485*/
/* 16477*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16479*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16485*/    0, /*End of Scope*/
/* 16486*/   0, // EndSwitchType
/* 16487*/  /*Scope*/ 9, /*->16497*/
/* 16488*/   OPC_CheckType, MVT::v4i32,
/* 16490*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16491*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16497*/  /*Scope*/ 9, /*->16507*/
/* 16498*/   OPC_CheckType, MVT::v8i16,
/* 16500*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 16501*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16507*/  0, /*End of Scope*/
/* 16508*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->16632
/* 16511*/  OPC_RecordChild0, // #0 = $src
/* 16512*/  OPC_Scope, 48, /*->16562*/ // 4 children in Scope
/* 16514*/   OPC_CheckChild0Type, MVT::f32,
/* 16516*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16539
/* 16519*/    OPC_Scope, 8, /*->16529*/ // 2 children in Scope
/* 16521*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16523*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16529*/    /*Scope*/ 8, /*->16538*/
/* 16530*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16532*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16538*/    0, /*End of Scope*/
/* 16539*/   /*SwitchType*/ 20, MVT::i64,// ->16561
/* 16541*/    OPC_Scope, 8, /*->16551*/ // 2 children in Scope
/* 16543*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16545*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16551*/    /*Scope*/ 8, /*->16560*/
/* 16552*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16554*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16560*/    0, /*End of Scope*/
/* 16561*/   0, // EndSwitchType
/* 16562*/  /*Scope*/ 48, /*->16611*/
/* 16563*/   OPC_CheckChild0Type, MVT::f64,
/* 16565*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16588
/* 16568*/    OPC_Scope, 8, /*->16578*/ // 2 children in Scope
/* 16570*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16572*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16578*/    /*Scope*/ 8, /*->16587*/
/* 16579*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16581*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16587*/    0, /*End of Scope*/
/* 16588*/   /*SwitchType*/ 20, MVT::i64,// ->16610
/* 16590*/    OPC_Scope, 8, /*->16600*/ // 2 children in Scope
/* 16592*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16594*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16600*/    /*Scope*/ 8, /*->16609*/
/* 16601*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16603*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16609*/    0, /*End of Scope*/
/* 16610*/   0, // EndSwitchType
/* 16611*/  /*Scope*/ 9, /*->16621*/
/* 16612*/   OPC_CheckType, MVT::v4i32,
/* 16614*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16615*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16621*/  /*Scope*/ 9, /*->16631*/
/* 16622*/   OPC_CheckType, MVT::v8i16,
/* 16624*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 16625*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16631*/  0, /*End of Scope*/
/* 16632*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->16707
/* 16635*/  OPC_RecordChild0, // #0 = $src
/* 16636*/  OPC_Scope, 27, /*->16665*/ // 3 children in Scope
/* 16638*/   OPC_CheckChild0Type, MVT::f32,
/* 16640*/   OPC_MoveChild1,
/* 16641*/   OPC_Scope, 10, /*->16653*/ // 2 children in Scope
/* 16643*/    OPC_CheckValueType, MVT::i32,
/* 16645*/    OPC_MoveParent,
/* 16646*/    OPC_CheckTypeI32,
/* 16647*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16653*/   /*Scope*/ 10, /*->16664*/
/* 16654*/    OPC_CheckValueType, MVT::i64,
/* 16656*/    OPC_MoveParent,
/* 16657*/    OPC_CheckTypeI64,
/* 16658*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16664*/   0, /*End of Scope*/
/* 16665*/  /*Scope*/ 27, /*->16693*/
/* 16666*/   OPC_CheckChild0Type, MVT::f64,
/* 16668*/   OPC_MoveChild1,
/* 16669*/   OPC_Scope, 10, /*->16681*/ // 2 children in Scope
/* 16671*/    OPC_CheckValueType, MVT::i32,
/* 16673*/    OPC_MoveParent,
/* 16674*/    OPC_CheckTypeI32,
/* 16675*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16681*/   /*Scope*/ 10, /*->16692*/
/* 16682*/    OPC_CheckValueType, MVT::i64,
/* 16684*/    OPC_MoveParent,
/* 16685*/    OPC_CheckTypeI64,
/* 16686*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16692*/   0, /*End of Scope*/
/* 16693*/  /*Scope*/ 12, /*->16706*/
/* 16694*/   OPC_MoveChild1,
/* 16695*/   OPC_CheckValueType, MVT::i32,
/* 16697*/   OPC_MoveParent,
/* 16698*/   OPC_CheckType, MVT::v4i32,
/* 16700*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16706*/  0, /*End of Scope*/
/* 16707*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->16782
/* 16710*/  OPC_RecordChild0, // #0 = $src
/* 16711*/  OPC_Scope, 27, /*->16740*/ // 3 children in Scope
/* 16713*/   OPC_CheckChild0Type, MVT::f32,
/* 16715*/   OPC_MoveChild1,
/* 16716*/   OPC_Scope, 10, /*->16728*/ // 2 children in Scope
/* 16718*/    OPC_CheckValueType, MVT::i32,
/* 16720*/    OPC_MoveParent,
/* 16721*/    OPC_CheckTypeI32,
/* 16722*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16728*/   /*Scope*/ 10, /*->16739*/
/* 16729*/    OPC_CheckValueType, MVT::i64,
/* 16731*/    OPC_MoveParent,
/* 16732*/    OPC_CheckTypeI64,
/* 16733*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16739*/   0, /*End of Scope*/
/* 16740*/  /*Scope*/ 27, /*->16768*/
/* 16741*/   OPC_CheckChild0Type, MVT::f64,
/* 16743*/   OPC_MoveChild1,
/* 16744*/   OPC_Scope, 10, /*->16756*/ // 2 children in Scope
/* 16746*/    OPC_CheckValueType, MVT::i32,
/* 16748*/    OPC_MoveParent,
/* 16749*/    OPC_CheckTypeI32,
/* 16750*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16756*/   /*Scope*/ 10, /*->16767*/
/* 16757*/    OPC_CheckValueType, MVT::i64,
/* 16759*/    OPC_MoveParent,
/* 16760*/    OPC_CheckTypeI64,
/* 16761*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16767*/   0, /*End of Scope*/
/* 16768*/  /*Scope*/ 12, /*->16781*/
/* 16769*/   OPC_MoveChild1,
/* 16770*/   OPC_CheckValueType, MVT::i32,
/* 16772*/   OPC_MoveParent,
/* 16773*/   OPC_CheckType, MVT::v4i32,
/* 16775*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16781*/  0, /*End of Scope*/
/* 16782*/ /*SwitchOpcode*/ 95|128,1/*223*/, TARGET_VAL(ISD::BITCAST),// ->17009
/* 16786*/  OPC_RecordChild0, // #0 = $src
/* 16787*/  OPC_Scope, 9, /*->16798*/ // 10 children in Scope
/* 16789*/   OPC_CheckChild0Type, MVT::f32,
/* 16791*/   OPC_CheckTypeI32,
/* 16792*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16798*/  /*Scope*/ 9, /*->16808*/
/* 16799*/   OPC_CheckChild0Type, MVT::f64,
/* 16801*/   OPC_CheckTypeI64,
/* 16802*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16808*/  /*Scope*/ 9, /*->16818*/
/* 16809*/   OPC_CheckChild0TypeI32,
/* 16810*/   OPC_CheckType, MVT::f32,
/* 16812*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 16818*/  /*Scope*/ 9, /*->16828*/
/* 16819*/   OPC_CheckChild0TypeI64,
/* 16820*/   OPC_CheckType, MVT::f64,
/* 16822*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 16828*/  /*Scope*/ 29, /*->16858*/
/* 16829*/   OPC_CheckChild0Type, MVT::v8i16,
/* 16831*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16837
/* 16834*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16837*/   /*SwitchType*/ 3, MVT::v4i32,// ->16842
/* 16839*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16842*/   /*SwitchType*/ 3, MVT::v2i64,// ->16847
/* 16844*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16847*/   /*SwitchType*/ 3, MVT::v4f32,// ->16852
/* 16849*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16852*/   /*SwitchType*/ 3, MVT::v2f64,// ->16857
/* 16854*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16857*/   0, // EndSwitchType
/* 16858*/  /*Scope*/ 29, /*->16888*/
/* 16859*/   OPC_CheckChild0Type, MVT::v4i32,
/* 16861*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16867
/* 16864*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16867*/   /*SwitchType*/ 3, MVT::v8i16,// ->16872
/* 16869*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16872*/   /*SwitchType*/ 3, MVT::v2i64,// ->16877
/* 16874*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16877*/   /*SwitchType*/ 3, MVT::v4f32,// ->16882
/* 16879*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16882*/   /*SwitchType*/ 3, MVT::v2f64,// ->16887
/* 16884*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16887*/   0, // EndSwitchType
/* 16888*/  /*Scope*/ 29, /*->16918*/
/* 16889*/   OPC_CheckChild0Type, MVT::v2i64,
/* 16891*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16897
/* 16894*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16897*/   /*SwitchType*/ 3, MVT::v8i16,// ->16902
/* 16899*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16902*/   /*SwitchType*/ 3, MVT::v4i32,// ->16907
/* 16904*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16907*/   /*SwitchType*/ 3, MVT::v4f32,// ->16912
/* 16909*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16912*/   /*SwitchType*/ 3, MVT::v2f64,// ->16917
/* 16914*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16917*/   0, // EndSwitchType
/* 16918*/  /*Scope*/ 29, /*->16948*/
/* 16919*/   OPC_CheckChild0Type, MVT::v4f32,
/* 16921*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16927
/* 16924*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16927*/   /*SwitchType*/ 3, MVT::v8i16,// ->16932
/* 16929*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16932*/   /*SwitchType*/ 3, MVT::v4i32,// ->16937
/* 16934*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16937*/   /*SwitchType*/ 3, MVT::v2i64,// ->16942
/* 16939*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16942*/   /*SwitchType*/ 3, MVT::v2f64,// ->16947
/* 16944*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16947*/   0, // EndSwitchType
/* 16948*/  /*Scope*/ 29, /*->16978*/
/* 16949*/   OPC_CheckChild0Type, MVT::v2f64,
/* 16951*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16957
/* 16954*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16957*/   /*SwitchType*/ 3, MVT::v8i16,// ->16962
/* 16959*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16962*/   /*SwitchType*/ 3, MVT::v4i32,// ->16967
/* 16964*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16967*/   /*SwitchType*/ 3, MVT::v2i64,// ->16972
/* 16969*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16972*/   /*SwitchType*/ 3, MVT::v4f32,// ->16977
/* 16974*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16977*/   0, // EndSwitchType
/* 16978*/  /*Scope*/ 29, /*->17008*/
/* 16979*/   OPC_CheckChild0Type, MVT::v16i8,
/* 16981*/   OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->16987
/* 16984*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16987*/   /*SwitchType*/ 3, MVT::v4i32,// ->16992
/* 16989*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16992*/   /*SwitchType*/ 3, MVT::v2i64,// ->16997
/* 16994*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16997*/   /*SwitchType*/ 3, MVT::v4f32,// ->17002
/* 16999*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17002*/   /*SwitchType*/ 3, MVT::v2f64,// ->17007
/* 17004*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17007*/   0, // EndSwitchType
/* 17008*/  0, /*End of Scope*/
/* 17009*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->17033
/* 17012*/  OPC_RecordNode, // #0 = $imm
/* 17013*/  OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->17023
/* 17016*/   OPC_EmitConvertToTarget0,
/* 17017*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 17023*/  /*SwitchType*/ 7, MVT::f64,// ->17032
/* 17025*/   OPC_EmitConvertToTarget0,
/* 17026*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 17032*/  0, // EndSwitchType
/* 17033*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::SINT_TO_FP),// ->17099
/* 17036*/  OPC_RecordChild0, // #0 = $src
/* 17037*/  OPC_Scope, 19, /*->17058*/ // 4 children in Scope
/* 17039*/   OPC_CheckChild0TypeI32,
/* 17040*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17049
/* 17043*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17049*/   /*SwitchType*/ 6, MVT::f64,// ->17057
/* 17051*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17057*/   0, // EndSwitchType
/* 17058*/  /*Scope*/ 19, /*->17078*/
/* 17059*/   OPC_CheckChild0TypeI64,
/* 17060*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17069
/* 17063*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17069*/   /*SwitchType*/ 6, MVT::f64,// ->17077
/* 17071*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17077*/   0, // EndSwitchType
/* 17078*/  /*Scope*/ 9, /*->17088*/
/* 17079*/   OPC_CheckType, MVT::v4f32,
/* 17081*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17082*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17088*/  /*Scope*/ 9, /*->17098*/
/* 17089*/   OPC_CheckType, MVT::v8f16,
/* 17091*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17092*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17098*/  0, /*End of Scope*/
/* 17099*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::UINT_TO_FP),// ->17165
/* 17102*/  OPC_RecordChild0, // #0 = $src
/* 17103*/  OPC_Scope, 19, /*->17124*/ // 4 children in Scope
/* 17105*/   OPC_CheckChild0TypeI32,
/* 17106*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17115
/* 17109*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17115*/   /*SwitchType*/ 6, MVT::f64,// ->17123
/* 17117*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17123*/   0, // EndSwitchType
/* 17124*/  /*Scope*/ 19, /*->17144*/
/* 17125*/   OPC_CheckChild0TypeI64,
/* 17126*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17135
/* 17129*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17135*/   /*SwitchType*/ 6, MVT::f64,// ->17143
/* 17137*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17143*/   0, // EndSwitchType
/* 17144*/  /*Scope*/ 9, /*->17154*/
/* 17145*/   OPC_CheckType, MVT::v4f32,
/* 17147*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17148*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17154*/  /*Scope*/ 9, /*->17164*/
/* 17155*/   OPC_CheckType, MVT::v8f16,
/* 17157*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17158*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17164*/  0, /*End of Scope*/
/* 17165*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17175
/* 17168*/  OPC_RecordChild0, // #0 = $src
/* 17169*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                MVT::f64, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17175*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17185
/* 17178*/  OPC_RecordChild0, // #0 = $src
/* 17179*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17185*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FADD),// ->17240
/* 17188*/  OPC_RecordChild0, // #0 = $lhs
/* 17189*/  OPC_RecordChild1, // #1 = $rhs
/* 17190*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17200
/* 17193*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17200*/  /*SwitchType*/ 7, MVT::f64,// ->17209
/* 17202*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17209*/  /*SwitchType*/ 8, MVT::v4f32,// ->17219
/* 17211*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17212*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17219*/  /*SwitchType*/ 8, MVT::v2f64,// ->17229
/* 17221*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17222*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17229*/  /*SwitchType*/ 8, MVT::v8f16,// ->17239
/* 17231*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17232*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (ADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17239*/  0, // EndSwitchType
/* 17240*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FSUB),// ->17295
/* 17243*/  OPC_RecordChild0, // #0 = $lhs
/* 17244*/  OPC_RecordChild1, // #1 = $rhs
/* 17245*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17255
/* 17248*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17255*/  /*SwitchType*/ 7, MVT::f64,// ->17264
/* 17257*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17264*/  /*SwitchType*/ 8, MVT::v4f32,// ->17274
/* 17266*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17267*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17274*/  /*SwitchType*/ 8, MVT::v2f64,// ->17284
/* 17276*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17277*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17284*/  /*SwitchType*/ 8, MVT::v8f16,// ->17294
/* 17286*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17287*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (SUB_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17294*/  0, // EndSwitchType
/* 17295*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMUL),// ->17350
/* 17298*/  OPC_RecordChild0, // #0 = $lhs
/* 17299*/  OPC_RecordChild1, // #1 = $rhs
/* 17300*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17310
/* 17303*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17310*/  /*SwitchType*/ 7, MVT::f64,// ->17319
/* 17312*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17319*/  /*SwitchType*/ 8, MVT::v4f32,// ->17329
/* 17321*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17322*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17329*/  /*SwitchType*/ 8, MVT::v2f64,// ->17339
/* 17331*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17332*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17339*/  /*SwitchType*/ 8, MVT::v8f16,// ->17349
/* 17341*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17342*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MUL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17349*/  0, // EndSwitchType
/* 17350*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FDIV),// ->17405
/* 17353*/  OPC_RecordChild0, // #0 = $lhs
/* 17354*/  OPC_RecordChild1, // #1 = $rhs
/* 17355*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17365
/* 17358*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17365*/  /*SwitchType*/ 7, MVT::f64,// ->17374
/* 17367*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17374*/  /*SwitchType*/ 8, MVT::v4f32,// ->17384
/* 17376*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17377*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17384*/  /*SwitchType*/ 8, MVT::v2f64,// ->17394
/* 17386*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17387*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17394*/  /*SwitchType*/ 8, MVT::v8f16,// ->17404
/* 17396*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17397*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (DIV_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17404*/  0, // EndSwitchType
/* 17405*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FSQRT),// ->17454
/* 17408*/  OPC_RecordChild0, // #0 = $src
/* 17409*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17418
/* 17412*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17418*/  /*SwitchType*/ 6, MVT::f64,// ->17426
/* 17420*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17426*/  /*SwitchType*/ 7, MVT::v4f32,// ->17435
/* 17428*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17429*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17435*/  /*SwitchType*/ 7, MVT::v2f64,// ->17444
/* 17437*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17438*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17444*/  /*SwitchType*/ 7, MVT::v8f16,// ->17453
/* 17446*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17447*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (SQRT_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17453*/  0, // EndSwitchType
/* 17454*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FABS),// ->17503
/* 17457*/  OPC_RecordChild0, // #0 = $src
/* 17458*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17467
/* 17461*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17467*/  /*SwitchType*/ 6, MVT::f64,// ->17475
/* 17469*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17475*/  /*SwitchType*/ 7, MVT::v4f32,// ->17484
/* 17477*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17478*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17484*/  /*SwitchType*/ 7, MVT::v2f64,// ->17493
/* 17486*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17487*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17493*/  /*SwitchType*/ 7, MVT::v8f16,// ->17502
/* 17495*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17496*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (ABS_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17502*/  0, // EndSwitchType
/* 17503*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FNEG),// ->17552
/* 17506*/  OPC_RecordChild0, // #0 = $src
/* 17507*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17516
/* 17510*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17516*/  /*SwitchType*/ 6, MVT::f64,// ->17524
/* 17518*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17524*/  /*SwitchType*/ 7, MVT::v4f32,// ->17533
/* 17526*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17527*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17533*/  /*SwitchType*/ 7, MVT::v2f64,// ->17542
/* 17535*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17536*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17542*/  /*SwitchType*/ 7, MVT::v8f16,// ->17551
/* 17544*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17545*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEG_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17551*/  0, // EndSwitchType
/* 17552*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->17617
/* 17555*/  OPC_RecordChild0, // #0 = $lhs
/* 17556*/  OPC_RecordChild1, // #1 = $rhs
/* 17557*/  OPC_Scope, 28, /*->17587*/ // 2 children in Scope
/* 17559*/   OPC_CheckChild1Type, MVT::f32,
/* 17561*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->17571
/* 17564*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17571*/   /*SwitchType*/ 13, MVT::f64,// ->17586
/* 17573*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 17579*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 17586*/   0, // EndSwitchType
/* 17587*/  /*Scope*/ 28, /*->17616*/
/* 17588*/   OPC_CheckChild1Type, MVT::f64,
/* 17590*/   OPC_SwitchType /*2 cases */, 7, MVT::f64,// ->17600
/* 17593*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17600*/   /*SwitchType*/ 13, MVT::f32,// ->17615
/* 17602*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 17608*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 17615*/   0, // EndSwitchType
/* 17616*/  0, /*End of Scope*/
/* 17617*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMINIMUM),// ->17672
/* 17620*/  OPC_RecordChild0, // #0 = $lhs
/* 17621*/  OPC_RecordChild1, // #1 = $rhs
/* 17622*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17632
/* 17625*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17632*/  /*SwitchType*/ 7, MVT::f64,// ->17641
/* 17634*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17641*/  /*SwitchType*/ 8, MVT::v4f32,// ->17651
/* 17643*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17644*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17651*/  /*SwitchType*/ 8, MVT::v2f64,// ->17661
/* 17653*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17654*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17661*/  /*SwitchType*/ 8, MVT::v8f16,// ->17671
/* 17663*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17664*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17671*/  0, // EndSwitchType
/* 17672*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMAXIMUM),// ->17727
/* 17675*/  OPC_RecordChild0, // #0 = $lhs
/* 17676*/  OPC_RecordChild1, // #1 = $rhs
/* 17677*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17687
/* 17680*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17687*/  /*SwitchType*/ 7, MVT::f64,// ->17696
/* 17689*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17696*/  /*SwitchType*/ 8, MVT::v4f32,// ->17706
/* 17698*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17699*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17706*/  /*SwitchType*/ 8, MVT::v2f64,// ->17716
/* 17708*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17709*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17716*/  /*SwitchType*/ 8, MVT::v8f16,// ->17726
/* 17718*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17719*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17726*/  0, // EndSwitchType
/* 17727*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FCEIL),// ->17776
/* 17730*/  OPC_RecordChild0, // #0 = $src
/* 17731*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17740
/* 17734*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17740*/  /*SwitchType*/ 6, MVT::f64,// ->17748
/* 17742*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17748*/  /*SwitchType*/ 7, MVT::v4f32,// ->17757
/* 17750*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17751*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17757*/  /*SwitchType*/ 7, MVT::v2f64,// ->17766
/* 17759*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17760*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17766*/  /*SwitchType*/ 7, MVT::v8f16,// ->17775
/* 17768*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17769*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (CEIL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17775*/  0, // EndSwitchType
/* 17776*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FFLOOR),// ->17825
/* 17779*/  OPC_RecordChild0, // #0 = $src
/* 17780*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17789
/* 17783*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17789*/  /*SwitchType*/ 6, MVT::f64,// ->17797
/* 17791*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17797*/  /*SwitchType*/ 7, MVT::v4f32,// ->17806
/* 17799*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17800*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17806*/  /*SwitchType*/ 7, MVT::v2f64,// ->17815
/* 17808*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17809*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17815*/  /*SwitchType*/ 7, MVT::v8f16,// ->17824
/* 17817*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17818*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (FLOOR_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17824*/  0, // EndSwitchType
/* 17825*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FTRUNC),// ->17874
/* 17828*/  OPC_RecordChild0, // #0 = $src
/* 17829*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17838
/* 17832*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17838*/  /*SwitchType*/ 6, MVT::f64,// ->17846
/* 17840*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17846*/  /*SwitchType*/ 7, MVT::v4f32,// ->17855
/* 17848*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17849*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17855*/  /*SwitchType*/ 7, MVT::v2f64,// ->17864
/* 17857*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17858*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17864*/  /*SwitchType*/ 7, MVT::v8f16,// ->17873
/* 17866*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17867*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (TRUNC_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17873*/  0, // EndSwitchType
/* 17874*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FNEARBYINT),// ->17923
/* 17877*/  OPC_RecordChild0, // #0 = $src
/* 17878*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17887
/* 17881*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17887*/  /*SwitchType*/ 6, MVT::f64,// ->17895
/* 17889*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17895*/  /*SwitchType*/ 7, MVT::v4f32,// ->17904
/* 17897*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17898*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17904*/  /*SwitchType*/ 7, MVT::v2f64,// ->17913
/* 17906*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17907*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17913*/  /*SwitchType*/ 7, MVT::v8f16,// ->17922
/* 17915*/   OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17916*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17922*/  0, // EndSwitchType
/* 17923*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FRINT),// ->17969
/* 17926*/  OPC_RecordChild0, // #0 = $src
/* 17927*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17936
/* 17930*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 17936*/  /*SwitchType*/ 6, MVT::f64,// ->17944
/* 17938*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 17944*/  /*SwitchType*/ 6, MVT::v4f32,// ->17952
/* 17946*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 17952*/  /*SwitchType*/ 6, MVT::v2f64,// ->17960
/* 17954*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 17960*/  /*SwitchType*/ 6, MVT::v8f16,// ->17968
/* 17962*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 17968*/  0, // EndSwitchType
/* 17969*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FROUNDEVEN),// ->18015
/* 17972*/  OPC_RecordChild0, // #0 = $src
/* 17973*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17982
/* 17976*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 17982*/  /*SwitchType*/ 6, MVT::f64,// ->17990
/* 17984*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 17990*/  /*SwitchType*/ 6, MVT::v4f32,// ->17998
/* 17992*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 17998*/  /*SwitchType*/ 6, MVT::v2f64,// ->18006
/* 18000*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18006*/  /*SwitchType*/ 6, MVT::v8f16,// ->18014
/* 18008*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18014*/  0, // EndSwitchType
/* 18015*/ /*SwitchOpcode*/ 20|128,3/*404*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18423
/* 18019*/  OPC_RecordChild0, // #0 = $i0
/* 18020*/  OPC_MoveChild0,
/* 18021*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->18355
/* 18026*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, MVT::i32,// ->18333
/* 18030*/    OPC_Scope, 51|128,1/*179*/, /*->18212*/ // 3 children in Scope
/* 18033*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18035*/     OPC_MoveSibling1,
/* 18036*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18039*/     OPC_RecordNode, // #1 = $i1
/* 18040*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18042*/     OPC_CheckTypeI32,
/* 18043*/     OPC_MoveSibling2,
/* 18044*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18047*/     OPC_RecordNode, // #2 = $i2
/* 18048*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18050*/     OPC_CheckTypeI32,
/* 18051*/     OPC_MoveSibling3,
/* 18052*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18055*/     OPC_RecordNode, // #3 = $i3
/* 18056*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18058*/     OPC_CheckTypeI32,
/* 18059*/     OPC_MoveSibling4,
/* 18060*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18063*/     OPC_RecordNode, // #4 = $i4
/* 18064*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18066*/     OPC_CheckTypeI32,
/* 18067*/     OPC_MoveSibling5,
/* 18068*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18071*/     OPC_RecordNode, // #5 = $i5
/* 18072*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18074*/     OPC_CheckTypeI32,
/* 18075*/     OPC_MoveSibling6,
/* 18076*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18079*/     OPC_RecordNode, // #6 = $i6
/* 18080*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18082*/     OPC_CheckTypeI32,
/* 18083*/     OPC_MoveSibling7,
/* 18084*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18087*/     OPC_RecordNode, // #7 = $i7
/* 18088*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18090*/     OPC_CheckTypeI32,
/* 18091*/     OPC_MoveSibling, 8,
/* 18093*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18096*/     OPC_RecordNode, // #8 = $i8
/* 18097*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18099*/     OPC_CheckTypeI32,
/* 18100*/     OPC_MoveSibling, 9,
/* 18102*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18105*/     OPC_RecordNode, // #9 = $i9
/* 18106*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18108*/     OPC_CheckTypeI32,
/* 18109*/     OPC_MoveSibling, 10,
/* 18111*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18114*/     OPC_RecordNode, // #10 = $iA
/* 18115*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18117*/     OPC_CheckTypeI32,
/* 18118*/     OPC_MoveSibling, 11,
/* 18120*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18123*/     OPC_RecordNode, // #11 = $iB
/* 18124*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18126*/     OPC_CheckTypeI32,
/* 18127*/     OPC_MoveSibling, 12,
/* 18129*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18132*/     OPC_RecordNode, // #12 = $iC
/* 18133*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18135*/     OPC_CheckTypeI32,
/* 18136*/     OPC_MoveSibling, 13,
/* 18138*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18141*/     OPC_RecordNode, // #13 = $iD
/* 18142*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18144*/     OPC_CheckTypeI32,
/* 18145*/     OPC_MoveSibling, 14,
/* 18147*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18150*/     OPC_RecordNode, // #14 = $iE
/* 18151*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18153*/     OPC_CheckTypeI32,
/* 18154*/     OPC_MoveSibling, 15,
/* 18156*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18159*/     OPC_RecordNode, // #15 = $iF
/* 18160*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18162*/     OPC_CheckTypeI32,
/* 18163*/     OPC_MoveParent,
/* 18164*/     OPC_CheckType, MVT::v16i8,
/* 18166*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18167*/     OPC_EmitConvertToTarget0,
/* 18168*/     OPC_EmitConvertToTarget1,
/* 18169*/     OPC_EmitConvertToTarget2,
/* 18170*/     OPC_EmitConvertToTarget3,
/* 18171*/     OPC_EmitConvertToTarget4,
/* 18172*/     OPC_EmitConvertToTarget5,
/* 18173*/     OPC_EmitConvertToTarget6,
/* 18174*/     OPC_EmitConvertToTarget7,
/* 18175*/     OPC_EmitConvertToTarget, 8,
/* 18177*/     OPC_EmitConvertToTarget, 9,
/* 18179*/     OPC_EmitConvertToTarget, 10,
/* 18181*/     OPC_EmitConvertToTarget, 11,
/* 18183*/     OPC_EmitConvertToTarget, 12,
/* 18185*/     OPC_EmitConvertToTarget, 13,
/* 18187*/     OPC_EmitConvertToTarget, 14,
/* 18189*/     OPC_EmitConvertToTarget, 15,
/* 18191*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18212*/    /*Scope*/ 83, /*->18296*/
/* 18213*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18215*/     OPC_MoveSibling1,
/* 18216*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18219*/     OPC_RecordNode, // #1 = $i1
/* 18220*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18222*/     OPC_CheckTypeI32,
/* 18223*/     OPC_MoveSibling2,
/* 18224*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18227*/     OPC_RecordNode, // #2 = $i2
/* 18228*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18230*/     OPC_CheckTypeI32,
/* 18231*/     OPC_MoveSibling3,
/* 18232*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18235*/     OPC_RecordNode, // #3 = $i3
/* 18236*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18238*/     OPC_CheckTypeI32,
/* 18239*/     OPC_MoveSibling4,
/* 18240*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18243*/     OPC_RecordNode, // #4 = $i4
/* 18244*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18246*/     OPC_CheckTypeI32,
/* 18247*/     OPC_MoveSibling5,
/* 18248*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18251*/     OPC_RecordNode, // #5 = $i5
/* 18252*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18254*/     OPC_CheckTypeI32,
/* 18255*/     OPC_MoveSibling6,
/* 18256*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18259*/     OPC_RecordNode, // #6 = $i6
/* 18260*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18262*/     OPC_CheckTypeI32,
/* 18263*/     OPC_MoveSibling7,
/* 18264*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18267*/     OPC_RecordNode, // #7 = $i7
/* 18268*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18270*/     OPC_CheckTypeI32,
/* 18271*/     OPC_MoveParent,
/* 18272*/     OPC_CheckType, MVT::v8i16,
/* 18274*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18275*/     OPC_EmitConvertToTarget0,
/* 18276*/     OPC_EmitConvertToTarget1,
/* 18277*/     OPC_EmitConvertToTarget2,
/* 18278*/     OPC_EmitConvertToTarget3,
/* 18279*/     OPC_EmitConvertToTarget4,
/* 18280*/     OPC_EmitConvertToTarget5,
/* 18281*/     OPC_EmitConvertToTarget6,
/* 18282*/     OPC_EmitConvertToTarget7,
/* 18283*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18296*/    /*Scope*/ 35, /*->18332*/
/* 18297*/     OPC_MoveSibling1,
/* 18298*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18301*/     OPC_RecordNode, // #1 = $i1
/* 18302*/     OPC_CheckTypeI32,
/* 18303*/     OPC_MoveSibling2,
/* 18304*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18307*/     OPC_RecordNode, // #2 = $i2
/* 18308*/     OPC_CheckTypeI32,
/* 18309*/     OPC_MoveSibling3,
/* 18310*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18313*/     OPC_RecordNode, // #3 = $i3
/* 18314*/     OPC_CheckTypeI32,
/* 18315*/     OPC_MoveParent,
/* 18316*/     OPC_CheckType, MVT::v4i32,
/* 18318*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18319*/     OPC_EmitConvertToTarget0,
/* 18320*/     OPC_EmitConvertToTarget1,
/* 18321*/     OPC_EmitConvertToTarget2,
/* 18322*/     OPC_EmitConvertToTarget3,
/* 18323*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18332*/    0, /*End of Scope*/
/* 18333*/   /*SwitchType*/ 19, MVT::i64,// ->18354
/* 18335*/    OPC_MoveSibling1,
/* 18336*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18339*/    OPC_RecordNode, // #1 = $i1
/* 18340*/    OPC_CheckTypeI64,
/* 18341*/    OPC_MoveParent,
/* 18342*/    OPC_CheckType, MVT::v2i64,
/* 18344*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18345*/    OPC_EmitConvertToTarget0,
/* 18346*/    OPC_EmitConvertToTarget1,
/* 18347*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18354*/   0, // EndSwitchType
/* 18355*/  /*SwitchOpcode*/ 64, TARGET_VAL(ISD::ConstantFP),// ->18422
/* 18358*/   OPC_SwitchType /*2 cases */, 38, MVT::f32,// ->18399
/* 18361*/    OPC_MoveSibling1,
/* 18362*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18365*/    OPC_RecordNode, // #1 = $i1
/* 18366*/    OPC_CheckType, MVT::f32,
/* 18368*/    OPC_MoveSibling2,
/* 18369*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18372*/    OPC_RecordNode, // #2 = $i2
/* 18373*/    OPC_CheckType, MVT::f32,
/* 18375*/    OPC_MoveSibling3,
/* 18376*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18379*/    OPC_RecordNode, // #3 = $i3
/* 18380*/    OPC_CheckType, MVT::f32,
/* 18382*/    OPC_MoveParent,
/* 18383*/    OPC_CheckType, MVT::v4f32,
/* 18385*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18386*/    OPC_EmitConvertToTarget0,
/* 18387*/    OPC_EmitConvertToTarget1,
/* 18388*/    OPC_EmitConvertToTarget2,
/* 18389*/    OPC_EmitConvertToTarget3,
/* 18390*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18399*/   /*SwitchType*/ 20, MVT::f64,// ->18421
/* 18401*/    OPC_MoveSibling1,
/* 18402*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18405*/    OPC_RecordNode, // #1 = $i1
/* 18406*/    OPC_CheckType, MVT::f64,
/* 18408*/    OPC_MoveParent,
/* 18409*/    OPC_CheckType, MVT::v2f64,
/* 18411*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18412*/    OPC_EmitConvertToTarget0,
/* 18413*/    OPC_EmitConvertToTarget1,
/* 18414*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18421*/   0, // EndSwitchType
/* 18422*/  0, // EndSwitchOpcode
/* 18423*/ /*SwitchOpcode*/ 1|128,16/*2049*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->20476
/* 18427*/  OPC_RecordChild0, // #0 = $x
/* 18428*/  OPC_Scope, 83|128,2/*339*/, /*->18770*/ // 6 children in Scope
/* 18431*/   OPC_CheckChild0Type, MVT::v16i8,
/* 18433*/   OPC_RecordChild1, // #1 = $y
/* 18434*/   OPC_CheckChild1Type, MVT::v16i8,
/* 18436*/   OPC_RecordChild2, // #2 = $m0
/* 18437*/   OPC_MoveChild2,
/* 18438*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18612
/* 18443*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18444*/    OPC_CheckTypeI32,
/* 18445*/    OPC_MoveSibling3,
/* 18446*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18449*/    OPC_RecordNode, // #3 = $m1
/* 18450*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18451*/    OPC_CheckTypeI32,
/* 18452*/    OPC_MoveSibling4,
/* 18453*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18456*/    OPC_RecordNode, // #4 = $m2
/* 18457*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18458*/    OPC_CheckTypeI32,
/* 18459*/    OPC_MoveSibling5,
/* 18460*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18463*/    OPC_RecordNode, // #5 = $m3
/* 18464*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18465*/    OPC_CheckTypeI32,
/* 18466*/    OPC_MoveSibling6,
/* 18467*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18470*/    OPC_RecordNode, // #6 = $m4
/* 18471*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18472*/    OPC_CheckTypeI32,
/* 18473*/    OPC_MoveSibling7,
/* 18474*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18477*/    OPC_RecordNode, // #7 = $m5
/* 18478*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18479*/    OPC_CheckTypeI32,
/* 18480*/    OPC_MoveSibling, 8,
/* 18482*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18485*/    OPC_RecordNode, // #8 = $m6
/* 18486*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18487*/    OPC_CheckTypeI32,
/* 18488*/    OPC_MoveSibling, 9,
/* 18490*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18493*/    OPC_RecordNode, // #9 = $m7
/* 18494*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18495*/    OPC_CheckTypeI32,
/* 18496*/    OPC_MoveSibling, 10,
/* 18498*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18501*/    OPC_RecordNode, // #10 = $m8
/* 18502*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18503*/    OPC_CheckTypeI32,
/* 18504*/    OPC_MoveSibling, 11,
/* 18506*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18509*/    OPC_RecordNode, // #11 = $m9
/* 18510*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18511*/    OPC_CheckTypeI32,
/* 18512*/    OPC_MoveSibling, 12,
/* 18514*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18517*/    OPC_RecordNode, // #12 = $mA
/* 18518*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18519*/    OPC_CheckTypeI32,
/* 18520*/    OPC_MoveSibling, 13,
/* 18522*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18525*/    OPC_RecordNode, // #13 = $mB
/* 18526*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18527*/    OPC_CheckTypeI32,
/* 18528*/    OPC_MoveSibling, 14,
/* 18530*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18533*/    OPC_RecordNode, // #14 = $mC
/* 18534*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18535*/    OPC_CheckTypeI32,
/* 18536*/    OPC_MoveSibling, 15,
/* 18538*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18541*/    OPC_RecordNode, // #15 = $mD
/* 18542*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18543*/    OPC_CheckTypeI32,
/* 18544*/    OPC_MoveSibling, 16,
/* 18546*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18549*/    OPC_RecordNode, // #16 = $mE
/* 18550*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18551*/    OPC_CheckTypeI32,
/* 18552*/    OPC_MoveSibling, 17,
/* 18554*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18557*/    OPC_RecordNode, // #17 = $mF
/* 18558*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18559*/    OPC_CheckTypeI32,
/* 18560*/    OPC_MoveParent,
/* 18561*/    OPC_CheckType, MVT::v16i8,
/* 18563*/    OPC_EmitConvertToTarget2,
/* 18564*/    OPC_EmitConvertToTarget3,
/* 18565*/    OPC_EmitConvertToTarget4,
/* 18566*/    OPC_EmitConvertToTarget5,
/* 18567*/    OPC_EmitConvertToTarget6,
/* 18568*/    OPC_EmitConvertToTarget7,
/* 18569*/    OPC_EmitConvertToTarget, 8,
/* 18571*/    OPC_EmitConvertToTarget, 9,
/* 18573*/    OPC_EmitConvertToTarget, 10,
/* 18575*/    OPC_EmitConvertToTarget, 11,
/* 18577*/    OPC_EmitConvertToTarget, 12,
/* 18579*/    OPC_EmitConvertToTarget, 13,
/* 18581*/    OPC_EmitConvertToTarget, 14,
/* 18583*/    OPC_EmitConvertToTarget, 15,
/* 18585*/    OPC_EmitConvertToTarget, 16,
/* 18587*/    OPC_EmitConvertToTarget, 17,
/* 18589*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18612*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->18769
/* 18616*/    OPC_CheckTypeI32,
/* 18617*/    OPC_MoveSibling3,
/* 18618*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18621*/    OPC_RecordNode, // #3 = $m1
/* 18622*/    OPC_CheckTypeI32,
/* 18623*/    OPC_MoveSibling4,
/* 18624*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18627*/    OPC_RecordNode, // #4 = $m2
/* 18628*/    OPC_CheckTypeI32,
/* 18629*/    OPC_MoveSibling5,
/* 18630*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18633*/    OPC_RecordNode, // #5 = $m3
/* 18634*/    OPC_CheckTypeI32,
/* 18635*/    OPC_MoveSibling6,
/* 18636*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18639*/    OPC_RecordNode, // #6 = $m4
/* 18640*/    OPC_CheckTypeI32,
/* 18641*/    OPC_MoveSibling7,
/* 18642*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18645*/    OPC_RecordNode, // #7 = $m5
/* 18646*/    OPC_CheckTypeI32,
/* 18647*/    OPC_MoveSibling, 8,
/* 18649*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18652*/    OPC_RecordNode, // #8 = $m6
/* 18653*/    OPC_CheckTypeI32,
/* 18654*/    OPC_MoveSibling, 9,
/* 18656*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18659*/    OPC_RecordNode, // #9 = $m7
/* 18660*/    OPC_CheckTypeI32,
/* 18661*/    OPC_MoveSibling, 10,
/* 18663*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18666*/    OPC_RecordNode, // #10 = $m8
/* 18667*/    OPC_CheckTypeI32,
/* 18668*/    OPC_MoveSibling, 11,
/* 18670*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18673*/    OPC_RecordNode, // #11 = $m9
/* 18674*/    OPC_CheckTypeI32,
/* 18675*/    OPC_MoveSibling, 12,
/* 18677*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18680*/    OPC_RecordNode, // #12 = $mA
/* 18681*/    OPC_CheckTypeI32,
/* 18682*/    OPC_MoveSibling, 13,
/* 18684*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18687*/    OPC_RecordNode, // #13 = $mB
/* 18688*/    OPC_CheckTypeI32,
/* 18689*/    OPC_MoveSibling, 14,
/* 18691*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18694*/    OPC_RecordNode, // #14 = $mC
/* 18695*/    OPC_CheckTypeI32,
/* 18696*/    OPC_MoveSibling, 15,
/* 18698*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18701*/    OPC_RecordNode, // #15 = $mD
/* 18702*/    OPC_CheckTypeI32,
/* 18703*/    OPC_MoveSibling, 16,
/* 18705*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18708*/    OPC_RecordNode, // #16 = $mE
/* 18709*/    OPC_CheckTypeI32,
/* 18710*/    OPC_MoveSibling, 17,
/* 18712*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18715*/    OPC_RecordNode, // #17 = $mF
/* 18716*/    OPC_CheckTypeI32,
/* 18717*/    OPC_MoveParent,
/* 18718*/    OPC_CheckType, MVT::v16i8,
/* 18720*/    OPC_EmitConvertToTarget2,
/* 18721*/    OPC_EmitConvertToTarget3,
/* 18722*/    OPC_EmitConvertToTarget4,
/* 18723*/    OPC_EmitConvertToTarget5,
/* 18724*/    OPC_EmitConvertToTarget6,
/* 18725*/    OPC_EmitConvertToTarget7,
/* 18726*/    OPC_EmitConvertToTarget, 8,
/* 18728*/    OPC_EmitConvertToTarget, 9,
/* 18730*/    OPC_EmitConvertToTarget, 10,
/* 18732*/    OPC_EmitConvertToTarget, 11,
/* 18734*/    OPC_EmitConvertToTarget, 12,
/* 18736*/    OPC_EmitConvertToTarget, 13,
/* 18738*/    OPC_EmitConvertToTarget, 14,
/* 18740*/    OPC_EmitConvertToTarget, 15,
/* 18742*/    OPC_EmitConvertToTarget, 16,
/* 18744*/    OPC_EmitConvertToTarget, 17,
/* 18746*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18769*/   0, // EndSwitchOpcode
/* 18770*/  /*Scope*/ 83|128,2/*339*/, /*->19111*/
/* 18772*/   OPC_CheckChild0Type, MVT::v8i16,
/* 18774*/   OPC_RecordChild1, // #1 = $y
/* 18775*/   OPC_CheckChild1Type, MVT::v8i16,
/* 18777*/   OPC_RecordChild2, // #2 = $m0
/* 18778*/   OPC_MoveChild2,
/* 18779*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18953
/* 18784*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18785*/    OPC_CheckTypeI32,
/* 18786*/    OPC_MoveSibling3,
/* 18787*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18790*/    OPC_RecordNode, // #3 = $m1
/* 18791*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18792*/    OPC_CheckTypeI32,
/* 18793*/    OPC_MoveSibling4,
/* 18794*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18797*/    OPC_RecordNode, // #4 = $m2
/* 18798*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18799*/    OPC_CheckTypeI32,
/* 18800*/    OPC_MoveSibling5,
/* 18801*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18804*/    OPC_RecordNode, // #5 = $m3
/* 18805*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18806*/    OPC_CheckTypeI32,
/* 18807*/    OPC_MoveSibling6,
/* 18808*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18811*/    OPC_RecordNode, // #6 = $m4
/* 18812*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18813*/    OPC_CheckTypeI32,
/* 18814*/    OPC_MoveSibling7,
/* 18815*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18818*/    OPC_RecordNode, // #7 = $m5
/* 18819*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18820*/    OPC_CheckTypeI32,
/* 18821*/    OPC_MoveSibling, 8,
/* 18823*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18826*/    OPC_RecordNode, // #8 = $m6
/* 18827*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18828*/    OPC_CheckTypeI32,
/* 18829*/    OPC_MoveSibling, 9,
/* 18831*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18834*/    OPC_RecordNode, // #9 = $m7
/* 18835*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18836*/    OPC_CheckTypeI32,
/* 18837*/    OPC_MoveSibling, 10,
/* 18839*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18842*/    OPC_RecordNode, // #10 = $m8
/* 18843*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18844*/    OPC_CheckTypeI32,
/* 18845*/    OPC_MoveSibling, 11,
/* 18847*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18850*/    OPC_RecordNode, // #11 = $m9
/* 18851*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18852*/    OPC_CheckTypeI32,
/* 18853*/    OPC_MoveSibling, 12,
/* 18855*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18858*/    OPC_RecordNode, // #12 = $mA
/* 18859*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18860*/    OPC_CheckTypeI32,
/* 18861*/    OPC_MoveSibling, 13,
/* 18863*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18866*/    OPC_RecordNode, // #13 = $mB
/* 18867*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18868*/    OPC_CheckTypeI32,
/* 18869*/    OPC_MoveSibling, 14,
/* 18871*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18874*/    OPC_RecordNode, // #14 = $mC
/* 18875*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18876*/    OPC_CheckTypeI32,
/* 18877*/    OPC_MoveSibling, 15,
/* 18879*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18882*/    OPC_RecordNode, // #15 = $mD
/* 18883*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18884*/    OPC_CheckTypeI32,
/* 18885*/    OPC_MoveSibling, 16,
/* 18887*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18890*/    OPC_RecordNode, // #16 = $mE
/* 18891*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18892*/    OPC_CheckTypeI32,
/* 18893*/    OPC_MoveSibling, 17,
/* 18895*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18898*/    OPC_RecordNode, // #17 = $mF
/* 18899*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18900*/    OPC_CheckTypeI32,
/* 18901*/    OPC_MoveParent,
/* 18902*/    OPC_CheckType, MVT::v8i16,
/* 18904*/    OPC_EmitConvertToTarget2,
/* 18905*/    OPC_EmitConvertToTarget3,
/* 18906*/    OPC_EmitConvertToTarget4,
/* 18907*/    OPC_EmitConvertToTarget5,
/* 18908*/    OPC_EmitConvertToTarget6,
/* 18909*/    OPC_EmitConvertToTarget7,
/* 18910*/    OPC_EmitConvertToTarget, 8,
/* 18912*/    OPC_EmitConvertToTarget, 9,
/* 18914*/    OPC_EmitConvertToTarget, 10,
/* 18916*/    OPC_EmitConvertToTarget, 11,
/* 18918*/    OPC_EmitConvertToTarget, 12,
/* 18920*/    OPC_EmitConvertToTarget, 13,
/* 18922*/    OPC_EmitConvertToTarget, 14,
/* 18924*/    OPC_EmitConvertToTarget, 15,
/* 18926*/    OPC_EmitConvertToTarget, 16,
/* 18928*/    OPC_EmitConvertToTarget, 17,
/* 18930*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18953*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19110
/* 18957*/    OPC_CheckTypeI32,
/* 18958*/    OPC_MoveSibling3,
/* 18959*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18962*/    OPC_RecordNode, // #3 = $m1
/* 18963*/    OPC_CheckTypeI32,
/* 18964*/    OPC_MoveSibling4,
/* 18965*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18968*/    OPC_RecordNode, // #4 = $m2
/* 18969*/    OPC_CheckTypeI32,
/* 18970*/    OPC_MoveSibling5,
/* 18971*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18974*/    OPC_RecordNode, // #5 = $m3
/* 18975*/    OPC_CheckTypeI32,
/* 18976*/    OPC_MoveSibling6,
/* 18977*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18980*/    OPC_RecordNode, // #6 = $m4
/* 18981*/    OPC_CheckTypeI32,
/* 18982*/    OPC_MoveSibling7,
/* 18983*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18986*/    OPC_RecordNode, // #7 = $m5
/* 18987*/    OPC_CheckTypeI32,
/* 18988*/    OPC_MoveSibling, 8,
/* 18990*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18993*/    OPC_RecordNode, // #8 = $m6
/* 18994*/    OPC_CheckTypeI32,
/* 18995*/    OPC_MoveSibling, 9,
/* 18997*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19000*/    OPC_RecordNode, // #9 = $m7
/* 19001*/    OPC_CheckTypeI32,
/* 19002*/    OPC_MoveSibling, 10,
/* 19004*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19007*/    OPC_RecordNode, // #10 = $m8
/* 19008*/    OPC_CheckTypeI32,
/* 19009*/    OPC_MoveSibling, 11,
/* 19011*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19014*/    OPC_RecordNode, // #11 = $m9
/* 19015*/    OPC_CheckTypeI32,
/* 19016*/    OPC_MoveSibling, 12,
/* 19018*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19021*/    OPC_RecordNode, // #12 = $mA
/* 19022*/    OPC_CheckTypeI32,
/* 19023*/    OPC_MoveSibling, 13,
/* 19025*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19028*/    OPC_RecordNode, // #13 = $mB
/* 19029*/    OPC_CheckTypeI32,
/* 19030*/    OPC_MoveSibling, 14,
/* 19032*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19035*/    OPC_RecordNode, // #14 = $mC
/* 19036*/    OPC_CheckTypeI32,
/* 19037*/    OPC_MoveSibling, 15,
/* 19039*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19042*/    OPC_RecordNode, // #15 = $mD
/* 19043*/    OPC_CheckTypeI32,
/* 19044*/    OPC_MoveSibling, 16,
/* 19046*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19049*/    OPC_RecordNode, // #16 = $mE
/* 19050*/    OPC_CheckTypeI32,
/* 19051*/    OPC_MoveSibling, 17,
/* 19053*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19056*/    OPC_RecordNode, // #17 = $mF
/* 19057*/    OPC_CheckTypeI32,
/* 19058*/    OPC_MoveParent,
/* 19059*/    OPC_CheckType, MVT::v8i16,
/* 19061*/    OPC_EmitConvertToTarget2,
/* 19062*/    OPC_EmitConvertToTarget3,
/* 19063*/    OPC_EmitConvertToTarget4,
/* 19064*/    OPC_EmitConvertToTarget5,
/* 19065*/    OPC_EmitConvertToTarget6,
/* 19066*/    OPC_EmitConvertToTarget7,
/* 19067*/    OPC_EmitConvertToTarget, 8,
/* 19069*/    OPC_EmitConvertToTarget, 9,
/* 19071*/    OPC_EmitConvertToTarget, 10,
/* 19073*/    OPC_EmitConvertToTarget, 11,
/* 19075*/    OPC_EmitConvertToTarget, 12,
/* 19077*/    OPC_EmitConvertToTarget, 13,
/* 19079*/    OPC_EmitConvertToTarget, 14,
/* 19081*/    OPC_EmitConvertToTarget, 15,
/* 19083*/    OPC_EmitConvertToTarget, 16,
/* 19085*/    OPC_EmitConvertToTarget, 17,
/* 19087*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19110*/   0, // EndSwitchOpcode
/* 19111*/  /*Scope*/ 83|128,2/*339*/, /*->19452*/
/* 19113*/   OPC_CheckChild0Type, MVT::v4i32,
/* 19115*/   OPC_RecordChild1, // #1 = $y
/* 19116*/   OPC_CheckChild1Type, MVT::v4i32,
/* 19118*/   OPC_RecordChild2, // #2 = $m0
/* 19119*/   OPC_MoveChild2,
/* 19120*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19294
/* 19125*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19126*/    OPC_CheckTypeI32,
/* 19127*/    OPC_MoveSibling3,
/* 19128*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19131*/    OPC_RecordNode, // #3 = $m1
/* 19132*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19133*/    OPC_CheckTypeI32,
/* 19134*/    OPC_MoveSibling4,
/* 19135*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19138*/    OPC_RecordNode, // #4 = $m2
/* 19139*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19140*/    OPC_CheckTypeI32,
/* 19141*/    OPC_MoveSibling5,
/* 19142*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19145*/    OPC_RecordNode, // #5 = $m3
/* 19146*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19147*/    OPC_CheckTypeI32,
/* 19148*/    OPC_MoveSibling6,
/* 19149*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19152*/    OPC_RecordNode, // #6 = $m4
/* 19153*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19154*/    OPC_CheckTypeI32,
/* 19155*/    OPC_MoveSibling7,
/* 19156*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19159*/    OPC_RecordNode, // #7 = $m5
/* 19160*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19161*/    OPC_CheckTypeI32,
/* 19162*/    OPC_MoveSibling, 8,
/* 19164*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19167*/    OPC_RecordNode, // #8 = $m6
/* 19168*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19169*/    OPC_CheckTypeI32,
/* 19170*/    OPC_MoveSibling, 9,
/* 19172*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19175*/    OPC_RecordNode, // #9 = $m7
/* 19176*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19177*/    OPC_CheckTypeI32,
/* 19178*/    OPC_MoveSibling, 10,
/* 19180*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19183*/    OPC_RecordNode, // #10 = $m8
/* 19184*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19185*/    OPC_CheckTypeI32,
/* 19186*/    OPC_MoveSibling, 11,
/* 19188*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19191*/    OPC_RecordNode, // #11 = $m9
/* 19192*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19193*/    OPC_CheckTypeI32,
/* 19194*/    OPC_MoveSibling, 12,
/* 19196*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19199*/    OPC_RecordNode, // #12 = $mA
/* 19200*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19201*/    OPC_CheckTypeI32,
/* 19202*/    OPC_MoveSibling, 13,
/* 19204*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19207*/    OPC_RecordNode, // #13 = $mB
/* 19208*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19209*/    OPC_CheckTypeI32,
/* 19210*/    OPC_MoveSibling, 14,
/* 19212*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19215*/    OPC_RecordNode, // #14 = $mC
/* 19216*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19217*/    OPC_CheckTypeI32,
/* 19218*/    OPC_MoveSibling, 15,
/* 19220*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19223*/    OPC_RecordNode, // #15 = $mD
/* 19224*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19225*/    OPC_CheckTypeI32,
/* 19226*/    OPC_MoveSibling, 16,
/* 19228*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19231*/    OPC_RecordNode, // #16 = $mE
/* 19232*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19233*/    OPC_CheckTypeI32,
/* 19234*/    OPC_MoveSibling, 17,
/* 19236*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19239*/    OPC_RecordNode, // #17 = $mF
/* 19240*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19241*/    OPC_CheckTypeI32,
/* 19242*/    OPC_MoveParent,
/* 19243*/    OPC_CheckType, MVT::v4i32,
/* 19245*/    OPC_EmitConvertToTarget2,
/* 19246*/    OPC_EmitConvertToTarget3,
/* 19247*/    OPC_EmitConvertToTarget4,
/* 19248*/    OPC_EmitConvertToTarget5,
/* 19249*/    OPC_EmitConvertToTarget6,
/* 19250*/    OPC_EmitConvertToTarget7,
/* 19251*/    OPC_EmitConvertToTarget, 8,
/* 19253*/    OPC_EmitConvertToTarget, 9,
/* 19255*/    OPC_EmitConvertToTarget, 10,
/* 19257*/    OPC_EmitConvertToTarget, 11,
/* 19259*/    OPC_EmitConvertToTarget, 12,
/* 19261*/    OPC_EmitConvertToTarget, 13,
/* 19263*/    OPC_EmitConvertToTarget, 14,
/* 19265*/    OPC_EmitConvertToTarget, 15,
/* 19267*/    OPC_EmitConvertToTarget, 16,
/* 19269*/    OPC_EmitConvertToTarget, 17,
/* 19271*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19294*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19451
/* 19298*/    OPC_CheckTypeI32,
/* 19299*/    OPC_MoveSibling3,
/* 19300*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19303*/    OPC_RecordNode, // #3 = $m1
/* 19304*/    OPC_CheckTypeI32,
/* 19305*/    OPC_MoveSibling4,
/* 19306*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19309*/    OPC_RecordNode, // #4 = $m2
/* 19310*/    OPC_CheckTypeI32,
/* 19311*/    OPC_MoveSibling5,
/* 19312*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19315*/    OPC_RecordNode, // #5 = $m3
/* 19316*/    OPC_CheckTypeI32,
/* 19317*/    OPC_MoveSibling6,
/* 19318*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19321*/    OPC_RecordNode, // #6 = $m4
/* 19322*/    OPC_CheckTypeI32,
/* 19323*/    OPC_MoveSibling7,
/* 19324*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19327*/    OPC_RecordNode, // #7 = $m5
/* 19328*/    OPC_CheckTypeI32,
/* 19329*/    OPC_MoveSibling, 8,
/* 19331*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19334*/    OPC_RecordNode, // #8 = $m6
/* 19335*/    OPC_CheckTypeI32,
/* 19336*/    OPC_MoveSibling, 9,
/* 19338*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19341*/    OPC_RecordNode, // #9 = $m7
/* 19342*/    OPC_CheckTypeI32,
/* 19343*/    OPC_MoveSibling, 10,
/* 19345*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19348*/    OPC_RecordNode, // #10 = $m8
/* 19349*/    OPC_CheckTypeI32,
/* 19350*/    OPC_MoveSibling, 11,
/* 19352*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19355*/    OPC_RecordNode, // #11 = $m9
/* 19356*/    OPC_CheckTypeI32,
/* 19357*/    OPC_MoveSibling, 12,
/* 19359*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19362*/    OPC_RecordNode, // #12 = $mA
/* 19363*/    OPC_CheckTypeI32,
/* 19364*/    OPC_MoveSibling, 13,
/* 19366*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19369*/    OPC_RecordNode, // #13 = $mB
/* 19370*/    OPC_CheckTypeI32,
/* 19371*/    OPC_MoveSibling, 14,
/* 19373*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19376*/    OPC_RecordNode, // #14 = $mC
/* 19377*/    OPC_CheckTypeI32,
/* 19378*/    OPC_MoveSibling, 15,
/* 19380*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19383*/    OPC_RecordNode, // #15 = $mD
/* 19384*/    OPC_CheckTypeI32,
/* 19385*/    OPC_MoveSibling, 16,
/* 19387*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19390*/    OPC_RecordNode, // #16 = $mE
/* 19391*/    OPC_CheckTypeI32,
/* 19392*/    OPC_MoveSibling, 17,
/* 19394*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19397*/    OPC_RecordNode, // #17 = $mF
/* 19398*/    OPC_CheckTypeI32,
/* 19399*/    OPC_MoveParent,
/* 19400*/    OPC_CheckType, MVT::v4i32,
/* 19402*/    OPC_EmitConvertToTarget2,
/* 19403*/    OPC_EmitConvertToTarget3,
/* 19404*/    OPC_EmitConvertToTarget4,
/* 19405*/    OPC_EmitConvertToTarget5,
/* 19406*/    OPC_EmitConvertToTarget6,
/* 19407*/    OPC_EmitConvertToTarget7,
/* 19408*/    OPC_EmitConvertToTarget, 8,
/* 19410*/    OPC_EmitConvertToTarget, 9,
/* 19412*/    OPC_EmitConvertToTarget, 10,
/* 19414*/    OPC_EmitConvertToTarget, 11,
/* 19416*/    OPC_EmitConvertToTarget, 12,
/* 19418*/    OPC_EmitConvertToTarget, 13,
/* 19420*/    OPC_EmitConvertToTarget, 14,
/* 19422*/    OPC_EmitConvertToTarget, 15,
/* 19424*/    OPC_EmitConvertToTarget, 16,
/* 19426*/    OPC_EmitConvertToTarget, 17,
/* 19428*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19451*/   0, // EndSwitchOpcode
/* 19452*/  /*Scope*/ 83|128,2/*339*/, /*->19793*/
/* 19454*/   OPC_CheckChild0Type, MVT::v2i64,
/* 19456*/   OPC_RecordChild1, // #1 = $y
/* 19457*/   OPC_CheckChild1Type, MVT::v2i64,
/* 19459*/   OPC_RecordChild2, // #2 = $m0
/* 19460*/   OPC_MoveChild2,
/* 19461*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19635
/* 19466*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19467*/    OPC_CheckTypeI32,
/* 19468*/    OPC_MoveSibling3,
/* 19469*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19472*/    OPC_RecordNode, // #3 = $m1
/* 19473*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19474*/    OPC_CheckTypeI32,
/* 19475*/    OPC_MoveSibling4,
/* 19476*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19479*/    OPC_RecordNode, // #4 = $m2
/* 19480*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19481*/    OPC_CheckTypeI32,
/* 19482*/    OPC_MoveSibling5,
/* 19483*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19486*/    OPC_RecordNode, // #5 = $m3
/* 19487*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19488*/    OPC_CheckTypeI32,
/* 19489*/    OPC_MoveSibling6,
/* 19490*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19493*/    OPC_RecordNode, // #6 = $m4
/* 19494*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19495*/    OPC_CheckTypeI32,
/* 19496*/    OPC_MoveSibling7,
/* 19497*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19500*/    OPC_RecordNode, // #7 = $m5
/* 19501*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19502*/    OPC_CheckTypeI32,
/* 19503*/    OPC_MoveSibling, 8,
/* 19505*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19508*/    OPC_RecordNode, // #8 = $m6
/* 19509*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19510*/    OPC_CheckTypeI32,
/* 19511*/    OPC_MoveSibling, 9,
/* 19513*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19516*/    OPC_RecordNode, // #9 = $m7
/* 19517*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19518*/    OPC_CheckTypeI32,
/* 19519*/    OPC_MoveSibling, 10,
/* 19521*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19524*/    OPC_RecordNode, // #10 = $m8
/* 19525*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19526*/    OPC_CheckTypeI32,
/* 19527*/    OPC_MoveSibling, 11,
/* 19529*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19532*/    OPC_RecordNode, // #11 = $m9
/* 19533*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19534*/    OPC_CheckTypeI32,
/* 19535*/    OPC_MoveSibling, 12,
/* 19537*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19540*/    OPC_RecordNode, // #12 = $mA
/* 19541*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19542*/    OPC_CheckTypeI32,
/* 19543*/    OPC_MoveSibling, 13,
/* 19545*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19548*/    OPC_RecordNode, // #13 = $mB
/* 19549*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19550*/    OPC_CheckTypeI32,
/* 19551*/    OPC_MoveSibling, 14,
/* 19553*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19556*/    OPC_RecordNode, // #14 = $mC
/* 19557*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19558*/    OPC_CheckTypeI32,
/* 19559*/    OPC_MoveSibling, 15,
/* 19561*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19564*/    OPC_RecordNode, // #15 = $mD
/* 19565*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19566*/    OPC_CheckTypeI32,
/* 19567*/    OPC_MoveSibling, 16,
/* 19569*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19572*/    OPC_RecordNode, // #16 = $mE
/* 19573*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19574*/    OPC_CheckTypeI32,
/* 19575*/    OPC_MoveSibling, 17,
/* 19577*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19580*/    OPC_RecordNode, // #17 = $mF
/* 19581*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19582*/    OPC_CheckTypeI32,
/* 19583*/    OPC_MoveParent,
/* 19584*/    OPC_CheckType, MVT::v2i64,
/* 19586*/    OPC_EmitConvertToTarget2,
/* 19587*/    OPC_EmitConvertToTarget3,
/* 19588*/    OPC_EmitConvertToTarget4,
/* 19589*/    OPC_EmitConvertToTarget5,
/* 19590*/    OPC_EmitConvertToTarget6,
/* 19591*/    OPC_EmitConvertToTarget7,
/* 19592*/    OPC_EmitConvertToTarget, 8,
/* 19594*/    OPC_EmitConvertToTarget, 9,
/* 19596*/    OPC_EmitConvertToTarget, 10,
/* 19598*/    OPC_EmitConvertToTarget, 11,
/* 19600*/    OPC_EmitConvertToTarget, 12,
/* 19602*/    OPC_EmitConvertToTarget, 13,
/* 19604*/    OPC_EmitConvertToTarget, 14,
/* 19606*/    OPC_EmitConvertToTarget, 15,
/* 19608*/    OPC_EmitConvertToTarget, 16,
/* 19610*/    OPC_EmitConvertToTarget, 17,
/* 19612*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19635*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19792
/* 19639*/    OPC_CheckTypeI32,
/* 19640*/    OPC_MoveSibling3,
/* 19641*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19644*/    OPC_RecordNode, // #3 = $m1
/* 19645*/    OPC_CheckTypeI32,
/* 19646*/    OPC_MoveSibling4,
/* 19647*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19650*/    OPC_RecordNode, // #4 = $m2
/* 19651*/    OPC_CheckTypeI32,
/* 19652*/    OPC_MoveSibling5,
/* 19653*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19656*/    OPC_RecordNode, // #5 = $m3
/* 19657*/    OPC_CheckTypeI32,
/* 19658*/    OPC_MoveSibling6,
/* 19659*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19662*/    OPC_RecordNode, // #6 = $m4
/* 19663*/    OPC_CheckTypeI32,
/* 19664*/    OPC_MoveSibling7,
/* 19665*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19668*/    OPC_RecordNode, // #7 = $m5
/* 19669*/    OPC_CheckTypeI32,
/* 19670*/    OPC_MoveSibling, 8,
/* 19672*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19675*/    OPC_RecordNode, // #8 = $m6
/* 19676*/    OPC_CheckTypeI32,
/* 19677*/    OPC_MoveSibling, 9,
/* 19679*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19682*/    OPC_RecordNode, // #9 = $m7
/* 19683*/    OPC_CheckTypeI32,
/* 19684*/    OPC_MoveSibling, 10,
/* 19686*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19689*/    OPC_RecordNode, // #10 = $m8
/* 19690*/    OPC_CheckTypeI32,
/* 19691*/    OPC_MoveSibling, 11,
/* 19693*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19696*/    OPC_RecordNode, // #11 = $m9
/* 19697*/    OPC_CheckTypeI32,
/* 19698*/    OPC_MoveSibling, 12,
/* 19700*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19703*/    OPC_RecordNode, // #12 = $mA
/* 19704*/    OPC_CheckTypeI32,
/* 19705*/    OPC_MoveSibling, 13,
/* 19707*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19710*/    OPC_RecordNode, // #13 = $mB
/* 19711*/    OPC_CheckTypeI32,
/* 19712*/    OPC_MoveSibling, 14,
/* 19714*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19717*/    OPC_RecordNode, // #14 = $mC
/* 19718*/    OPC_CheckTypeI32,
/* 19719*/    OPC_MoveSibling, 15,
/* 19721*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19724*/    OPC_RecordNode, // #15 = $mD
/* 19725*/    OPC_CheckTypeI32,
/* 19726*/    OPC_MoveSibling, 16,
/* 19728*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19731*/    OPC_RecordNode, // #16 = $mE
/* 19732*/    OPC_CheckTypeI32,
/* 19733*/    OPC_MoveSibling, 17,
/* 19735*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19738*/    OPC_RecordNode, // #17 = $mF
/* 19739*/    OPC_CheckTypeI32,
/* 19740*/    OPC_MoveParent,
/* 19741*/    OPC_CheckType, MVT::v2i64,
/* 19743*/    OPC_EmitConvertToTarget2,
/* 19744*/    OPC_EmitConvertToTarget3,
/* 19745*/    OPC_EmitConvertToTarget4,
/* 19746*/    OPC_EmitConvertToTarget5,
/* 19747*/    OPC_EmitConvertToTarget6,
/* 19748*/    OPC_EmitConvertToTarget7,
/* 19749*/    OPC_EmitConvertToTarget, 8,
/* 19751*/    OPC_EmitConvertToTarget, 9,
/* 19753*/    OPC_EmitConvertToTarget, 10,
/* 19755*/    OPC_EmitConvertToTarget, 11,
/* 19757*/    OPC_EmitConvertToTarget, 12,
/* 19759*/    OPC_EmitConvertToTarget, 13,
/* 19761*/    OPC_EmitConvertToTarget, 14,
/* 19763*/    OPC_EmitConvertToTarget, 15,
/* 19765*/    OPC_EmitConvertToTarget, 16,
/* 19767*/    OPC_EmitConvertToTarget, 17,
/* 19769*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19792*/   0, // EndSwitchOpcode
/* 19793*/  /*Scope*/ 83|128,2/*339*/, /*->20134*/
/* 19795*/   OPC_CheckChild0Type, MVT::v4f32,
/* 19797*/   OPC_RecordChild1, // #1 = $y
/* 19798*/   OPC_CheckChild1Type, MVT::v4f32,
/* 19800*/   OPC_RecordChild2, // #2 = $m0
/* 19801*/   OPC_MoveChild2,
/* 19802*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19976
/* 19807*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19808*/    OPC_CheckTypeI32,
/* 19809*/    OPC_MoveSibling3,
/* 19810*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19813*/    OPC_RecordNode, // #3 = $m1
/* 19814*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19815*/    OPC_CheckTypeI32,
/* 19816*/    OPC_MoveSibling4,
/* 19817*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19820*/    OPC_RecordNode, // #4 = $m2
/* 19821*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19822*/    OPC_CheckTypeI32,
/* 19823*/    OPC_MoveSibling5,
/* 19824*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19827*/    OPC_RecordNode, // #5 = $m3
/* 19828*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19829*/    OPC_CheckTypeI32,
/* 19830*/    OPC_MoveSibling6,
/* 19831*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19834*/    OPC_RecordNode, // #6 = $m4
/* 19835*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19836*/    OPC_CheckTypeI32,
/* 19837*/    OPC_MoveSibling7,
/* 19838*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19841*/    OPC_RecordNode, // #7 = $m5
/* 19842*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19843*/    OPC_CheckTypeI32,
/* 19844*/    OPC_MoveSibling, 8,
/* 19846*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19849*/    OPC_RecordNode, // #8 = $m6
/* 19850*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19851*/    OPC_CheckTypeI32,
/* 19852*/    OPC_MoveSibling, 9,
/* 19854*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19857*/    OPC_RecordNode, // #9 = $m7
/* 19858*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19859*/    OPC_CheckTypeI32,
/* 19860*/    OPC_MoveSibling, 10,
/* 19862*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19865*/    OPC_RecordNode, // #10 = $m8
/* 19866*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19867*/    OPC_CheckTypeI32,
/* 19868*/    OPC_MoveSibling, 11,
/* 19870*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19873*/    OPC_RecordNode, // #11 = $m9
/* 19874*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19875*/    OPC_CheckTypeI32,
/* 19876*/    OPC_MoveSibling, 12,
/* 19878*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19881*/    OPC_RecordNode, // #12 = $mA
/* 19882*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19883*/    OPC_CheckTypeI32,
/* 19884*/    OPC_MoveSibling, 13,
/* 19886*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19889*/    OPC_RecordNode, // #13 = $mB
/* 19890*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19891*/    OPC_CheckTypeI32,
/* 19892*/    OPC_MoveSibling, 14,
/* 19894*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19897*/    OPC_RecordNode, // #14 = $mC
/* 19898*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19899*/    OPC_CheckTypeI32,
/* 19900*/    OPC_MoveSibling, 15,
/* 19902*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19905*/    OPC_RecordNode, // #15 = $mD
/* 19906*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19907*/    OPC_CheckTypeI32,
/* 19908*/    OPC_MoveSibling, 16,
/* 19910*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19913*/    OPC_RecordNode, // #16 = $mE
/* 19914*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19915*/    OPC_CheckTypeI32,
/* 19916*/    OPC_MoveSibling, 17,
/* 19918*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19921*/    OPC_RecordNode, // #17 = $mF
/* 19922*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19923*/    OPC_CheckTypeI32,
/* 19924*/    OPC_MoveParent,
/* 19925*/    OPC_CheckType, MVT::v4f32,
/* 19927*/    OPC_EmitConvertToTarget2,
/* 19928*/    OPC_EmitConvertToTarget3,
/* 19929*/    OPC_EmitConvertToTarget4,
/* 19930*/    OPC_EmitConvertToTarget5,
/* 19931*/    OPC_EmitConvertToTarget6,
/* 19932*/    OPC_EmitConvertToTarget7,
/* 19933*/    OPC_EmitConvertToTarget, 8,
/* 19935*/    OPC_EmitConvertToTarget, 9,
/* 19937*/    OPC_EmitConvertToTarget, 10,
/* 19939*/    OPC_EmitConvertToTarget, 11,
/* 19941*/    OPC_EmitConvertToTarget, 12,
/* 19943*/    OPC_EmitConvertToTarget, 13,
/* 19945*/    OPC_EmitConvertToTarget, 14,
/* 19947*/    OPC_EmitConvertToTarget, 15,
/* 19949*/    OPC_EmitConvertToTarget, 16,
/* 19951*/    OPC_EmitConvertToTarget, 17,
/* 19953*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19976*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20133
/* 19980*/    OPC_CheckTypeI32,
/* 19981*/    OPC_MoveSibling3,
/* 19982*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19985*/    OPC_RecordNode, // #3 = $m1
/* 19986*/    OPC_CheckTypeI32,
/* 19987*/    OPC_MoveSibling4,
/* 19988*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19991*/    OPC_RecordNode, // #4 = $m2
/* 19992*/    OPC_CheckTypeI32,
/* 19993*/    OPC_MoveSibling5,
/* 19994*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19997*/    OPC_RecordNode, // #5 = $m3
/* 19998*/    OPC_CheckTypeI32,
/* 19999*/    OPC_MoveSibling6,
/* 20000*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20003*/    OPC_RecordNode, // #6 = $m4
/* 20004*/    OPC_CheckTypeI32,
/* 20005*/    OPC_MoveSibling7,
/* 20006*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20009*/    OPC_RecordNode, // #7 = $m5
/* 20010*/    OPC_CheckTypeI32,
/* 20011*/    OPC_MoveSibling, 8,
/* 20013*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20016*/    OPC_RecordNode, // #8 = $m6
/* 20017*/    OPC_CheckTypeI32,
/* 20018*/    OPC_MoveSibling, 9,
/* 20020*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20023*/    OPC_RecordNode, // #9 = $m7
/* 20024*/    OPC_CheckTypeI32,
/* 20025*/    OPC_MoveSibling, 10,
/* 20027*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20030*/    OPC_RecordNode, // #10 = $m8
/* 20031*/    OPC_CheckTypeI32,
/* 20032*/    OPC_MoveSibling, 11,
/* 20034*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20037*/    OPC_RecordNode, // #11 = $m9
/* 20038*/    OPC_CheckTypeI32,
/* 20039*/    OPC_MoveSibling, 12,
/* 20041*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20044*/    OPC_RecordNode, // #12 = $mA
/* 20045*/    OPC_CheckTypeI32,
/* 20046*/    OPC_MoveSibling, 13,
/* 20048*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20051*/    OPC_RecordNode, // #13 = $mB
/* 20052*/    OPC_CheckTypeI32,
/* 20053*/    OPC_MoveSibling, 14,
/* 20055*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20058*/    OPC_RecordNode, // #14 = $mC
/* 20059*/    OPC_CheckTypeI32,
/* 20060*/    OPC_MoveSibling, 15,
/* 20062*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20065*/    OPC_RecordNode, // #15 = $mD
/* 20066*/    OPC_CheckTypeI32,
/* 20067*/    OPC_MoveSibling, 16,
/* 20069*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20072*/    OPC_RecordNode, // #16 = $mE
/* 20073*/    OPC_CheckTypeI32,
/* 20074*/    OPC_MoveSibling, 17,
/* 20076*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20079*/    OPC_RecordNode, // #17 = $mF
/* 20080*/    OPC_CheckTypeI32,
/* 20081*/    OPC_MoveParent,
/* 20082*/    OPC_CheckType, MVT::v4f32,
/* 20084*/    OPC_EmitConvertToTarget2,
/* 20085*/    OPC_EmitConvertToTarget3,
/* 20086*/    OPC_EmitConvertToTarget4,
/* 20087*/    OPC_EmitConvertToTarget5,
/* 20088*/    OPC_EmitConvertToTarget6,
/* 20089*/    OPC_EmitConvertToTarget7,
/* 20090*/    OPC_EmitConvertToTarget, 8,
/* 20092*/    OPC_EmitConvertToTarget, 9,
/* 20094*/    OPC_EmitConvertToTarget, 10,
/* 20096*/    OPC_EmitConvertToTarget, 11,
/* 20098*/    OPC_EmitConvertToTarget, 12,
/* 20100*/    OPC_EmitConvertToTarget, 13,
/* 20102*/    OPC_EmitConvertToTarget, 14,
/* 20104*/    OPC_EmitConvertToTarget, 15,
/* 20106*/    OPC_EmitConvertToTarget, 16,
/* 20108*/    OPC_EmitConvertToTarget, 17,
/* 20110*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20133*/   0, // EndSwitchOpcode
/* 20134*/  /*Scope*/ 83|128,2/*339*/, /*->20475*/
/* 20136*/   OPC_CheckChild0Type, MVT::v2f64,
/* 20138*/   OPC_RecordChild1, // #1 = $y
/* 20139*/   OPC_CheckChild1Type, MVT::v2f64,
/* 20141*/   OPC_RecordChild2, // #2 = $m0
/* 20142*/   OPC_MoveChild2,
/* 20143*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20317
/* 20148*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20149*/    OPC_CheckTypeI32,
/* 20150*/    OPC_MoveSibling3,
/* 20151*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20154*/    OPC_RecordNode, // #3 = $m1
/* 20155*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20156*/    OPC_CheckTypeI32,
/* 20157*/    OPC_MoveSibling4,
/* 20158*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20161*/    OPC_RecordNode, // #4 = $m2
/* 20162*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20163*/    OPC_CheckTypeI32,
/* 20164*/    OPC_MoveSibling5,
/* 20165*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20168*/    OPC_RecordNode, // #5 = $m3
/* 20169*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20170*/    OPC_CheckTypeI32,
/* 20171*/    OPC_MoveSibling6,
/* 20172*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20175*/    OPC_RecordNode, // #6 = $m4
/* 20176*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20177*/    OPC_CheckTypeI32,
/* 20178*/    OPC_MoveSibling7,
/* 20179*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20182*/    OPC_RecordNode, // #7 = $m5
/* 20183*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20184*/    OPC_CheckTypeI32,
/* 20185*/    OPC_MoveSibling, 8,
/* 20187*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20190*/    OPC_RecordNode, // #8 = $m6
/* 20191*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20192*/    OPC_CheckTypeI32,
/* 20193*/    OPC_MoveSibling, 9,
/* 20195*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20198*/    OPC_RecordNode, // #9 = $m7
/* 20199*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20200*/    OPC_CheckTypeI32,
/* 20201*/    OPC_MoveSibling, 10,
/* 20203*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20206*/    OPC_RecordNode, // #10 = $m8
/* 20207*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20208*/    OPC_CheckTypeI32,
/* 20209*/    OPC_MoveSibling, 11,
/* 20211*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20214*/    OPC_RecordNode, // #11 = $m9
/* 20215*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20216*/    OPC_CheckTypeI32,
/* 20217*/    OPC_MoveSibling, 12,
/* 20219*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20222*/    OPC_RecordNode, // #12 = $mA
/* 20223*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20224*/    OPC_CheckTypeI32,
/* 20225*/    OPC_MoveSibling, 13,
/* 20227*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20230*/    OPC_RecordNode, // #13 = $mB
/* 20231*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20232*/    OPC_CheckTypeI32,
/* 20233*/    OPC_MoveSibling, 14,
/* 20235*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20238*/    OPC_RecordNode, // #14 = $mC
/* 20239*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20240*/    OPC_CheckTypeI32,
/* 20241*/    OPC_MoveSibling, 15,
/* 20243*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20246*/    OPC_RecordNode, // #15 = $mD
/* 20247*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20248*/    OPC_CheckTypeI32,
/* 20249*/    OPC_MoveSibling, 16,
/* 20251*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20254*/    OPC_RecordNode, // #16 = $mE
/* 20255*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20256*/    OPC_CheckTypeI32,
/* 20257*/    OPC_MoveSibling, 17,
/* 20259*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20262*/    OPC_RecordNode, // #17 = $mF
/* 20263*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20264*/    OPC_CheckTypeI32,
/* 20265*/    OPC_MoveParent,
/* 20266*/    OPC_CheckType, MVT::v2f64,
/* 20268*/    OPC_EmitConvertToTarget2,
/* 20269*/    OPC_EmitConvertToTarget3,
/* 20270*/    OPC_EmitConvertToTarget4,
/* 20271*/    OPC_EmitConvertToTarget5,
/* 20272*/    OPC_EmitConvertToTarget6,
/* 20273*/    OPC_EmitConvertToTarget7,
/* 20274*/    OPC_EmitConvertToTarget, 8,
/* 20276*/    OPC_EmitConvertToTarget, 9,
/* 20278*/    OPC_EmitConvertToTarget, 10,
/* 20280*/    OPC_EmitConvertToTarget, 11,
/* 20282*/    OPC_EmitConvertToTarget, 12,
/* 20284*/    OPC_EmitConvertToTarget, 13,
/* 20286*/    OPC_EmitConvertToTarget, 14,
/* 20288*/    OPC_EmitConvertToTarget, 15,
/* 20290*/    OPC_EmitConvertToTarget, 16,
/* 20292*/    OPC_EmitConvertToTarget, 17,
/* 20294*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20317*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20474
/* 20321*/    OPC_CheckTypeI32,
/* 20322*/    OPC_MoveSibling3,
/* 20323*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20326*/    OPC_RecordNode, // #3 = $m1
/* 20327*/    OPC_CheckTypeI32,
/* 20328*/    OPC_MoveSibling4,
/* 20329*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20332*/    OPC_RecordNode, // #4 = $m2
/* 20333*/    OPC_CheckTypeI32,
/* 20334*/    OPC_MoveSibling5,
/* 20335*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20338*/    OPC_RecordNode, // #5 = $m3
/* 20339*/    OPC_CheckTypeI32,
/* 20340*/    OPC_MoveSibling6,
/* 20341*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20344*/    OPC_RecordNode, // #6 = $m4
/* 20345*/    OPC_CheckTypeI32,
/* 20346*/    OPC_MoveSibling7,
/* 20347*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20350*/    OPC_RecordNode, // #7 = $m5
/* 20351*/    OPC_CheckTypeI32,
/* 20352*/    OPC_MoveSibling, 8,
/* 20354*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20357*/    OPC_RecordNode, // #8 = $m6
/* 20358*/    OPC_CheckTypeI32,
/* 20359*/    OPC_MoveSibling, 9,
/* 20361*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20364*/    OPC_RecordNode, // #9 = $m7
/* 20365*/    OPC_CheckTypeI32,
/* 20366*/    OPC_MoveSibling, 10,
/* 20368*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20371*/    OPC_RecordNode, // #10 = $m8
/* 20372*/    OPC_CheckTypeI32,
/* 20373*/    OPC_MoveSibling, 11,
/* 20375*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20378*/    OPC_RecordNode, // #11 = $m9
/* 20379*/    OPC_CheckTypeI32,
/* 20380*/    OPC_MoveSibling, 12,
/* 20382*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20385*/    OPC_RecordNode, // #12 = $mA
/* 20386*/    OPC_CheckTypeI32,
/* 20387*/    OPC_MoveSibling, 13,
/* 20389*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20392*/    OPC_RecordNode, // #13 = $mB
/* 20393*/    OPC_CheckTypeI32,
/* 20394*/    OPC_MoveSibling, 14,
/* 20396*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20399*/    OPC_RecordNode, // #14 = $mC
/* 20400*/    OPC_CheckTypeI32,
/* 20401*/    OPC_MoveSibling, 15,
/* 20403*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20406*/    OPC_RecordNode, // #15 = $mD
/* 20407*/    OPC_CheckTypeI32,
/* 20408*/    OPC_MoveSibling, 16,
/* 20410*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20413*/    OPC_RecordNode, // #16 = $mE
/* 20414*/    OPC_CheckTypeI32,
/* 20415*/    OPC_MoveSibling, 17,
/* 20417*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20420*/    OPC_RecordNode, // #17 = $mF
/* 20421*/    OPC_CheckTypeI32,
/* 20422*/    OPC_MoveParent,
/* 20423*/    OPC_CheckType, MVT::v2f64,
/* 20425*/    OPC_EmitConvertToTarget2,
/* 20426*/    OPC_EmitConvertToTarget3,
/* 20427*/    OPC_EmitConvertToTarget4,
/* 20428*/    OPC_EmitConvertToTarget5,
/* 20429*/    OPC_EmitConvertToTarget6,
/* 20430*/    OPC_EmitConvertToTarget7,
/* 20431*/    OPC_EmitConvertToTarget, 8,
/* 20433*/    OPC_EmitConvertToTarget, 9,
/* 20435*/    OPC_EmitConvertToTarget, 10,
/* 20437*/    OPC_EmitConvertToTarget, 11,
/* 20439*/    OPC_EmitConvertToTarget, 12,
/* 20441*/    OPC_EmitConvertToTarget, 13,
/* 20443*/    OPC_EmitConvertToTarget, 14,
/* 20445*/    OPC_EmitConvertToTarget, 15,
/* 20447*/    OPC_EmitConvertToTarget, 16,
/* 20449*/    OPC_EmitConvertToTarget, 17,
/* 20451*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20474*/   0, // EndSwitchOpcode
/* 20475*/  0, /*End of Scope*/
/* 20476*/ /*SwitchOpcode*/ 41|128,5/*681*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->21161
/* 20480*/  OPC_Scope, 6|128,1/*134*/, /*->20617*/ // 2 children in Scope
/* 20483*/   OPC_MoveChild0,
/* 20484*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 20487*/   OPC_CheckChild0Integer, 0, 
/* 20489*/   OPC_Scope, 62, /*->20553*/ // 2 children in Scope
/* 20491*/    OPC_CheckChild0TypeI32,
/* 20492*/    OPC_MoveSibling1,
/* 20493*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20496*/    OPC_RecordMemRef,
/* 20497*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20498*/    OPC_CheckFoldableChainNode,
/* 20499*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20500*/    OPC_CheckTypeI32,
/* 20501*/    OPC_Scope, 24, /*->20527*/ // 2 children in Scope
/* 20503*/     OPC_CheckChild1TypeI32,
/* 20504*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20506*/     OPC_CheckPredicate7,  // Predicate_load
/* 20507*/     OPC_MoveParent,
/* 20508*/     OPC_CheckChild2Integer, 0, 
/* 20510*/     OPC_CheckType, MVT::v4i32,
/* 20512*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20513*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20515*/     OPC_EmitMergeInputChains1_0,
/* 20516*/     OPC_EmitInteger32, 0, 
/* 20518*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20527*/    /*Scope*/ 24, /*->20552*/
/* 20528*/     OPC_CheckChild1TypeI64,
/* 20529*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20531*/     OPC_CheckPredicate7,  // Predicate_load
/* 20532*/     OPC_MoveParent,
/* 20533*/     OPC_CheckChild2Integer, 0, 
/* 20535*/     OPC_CheckType, MVT::v4i32,
/* 20537*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20538*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20540*/     OPC_EmitMergeInputChains1_0,
/* 20541*/     OPC_EmitInteger32, 0, 
/* 20543*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20552*/    0, /*End of Scope*/
/* 20553*/   /*Scope*/ 62, /*->20616*/
/* 20554*/    OPC_CheckChild0TypeI64,
/* 20555*/    OPC_MoveSibling1,
/* 20556*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20559*/    OPC_RecordMemRef,
/* 20560*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20561*/    OPC_CheckFoldableChainNode,
/* 20562*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20563*/    OPC_CheckTypeI64,
/* 20564*/    OPC_Scope, 24, /*->20590*/ // 2 children in Scope
/* 20566*/     OPC_CheckChild1TypeI32,
/* 20567*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20569*/     OPC_CheckPredicate7,  // Predicate_load
/* 20570*/     OPC_MoveParent,
/* 20571*/     OPC_CheckChild2Integer, 0, 
/* 20573*/     OPC_CheckType, MVT::v2i64,
/* 20575*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20576*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20578*/     OPC_EmitMergeInputChains1_0,
/* 20579*/     OPC_EmitInteger32, 0, 
/* 20581*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20590*/    /*Scope*/ 24, /*->20615*/
/* 20591*/     OPC_CheckChild1TypeI64,
/* 20592*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20594*/     OPC_CheckPredicate7,  // Predicate_load
/* 20595*/     OPC_MoveParent,
/* 20596*/     OPC_CheckChild2Integer, 0, 
/* 20598*/     OPC_CheckType, MVT::v2i64,
/* 20600*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20601*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20603*/     OPC_EmitMergeInputChains1_0,
/* 20604*/     OPC_EmitInteger32, 0, 
/* 20606*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20615*/    0, /*End of Scope*/
/* 20616*/   0, /*End of Scope*/
/* 20617*/  /*Scope*/ 29|128,4/*541*/, /*->21160*/
/* 20619*/   OPC_RecordChild0, // #0 = $vec
/* 20620*/   OPC_Scope, 36|128,2/*292*/, /*->20915*/ // 2 children in Scope
/* 20623*/    OPC_MoveChild1,
/* 20624*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20627*/    OPC_RecordMemRef,
/* 20628*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 20629*/    OPC_CheckFoldableChainNode,
/* 20630*/    OPC_RecordChild1, // #2 = $addr
/* 20631*/    OPC_Scope, 11|128,1/*139*/, /*->20773*/ // 2 children in Scope
/* 20634*/     OPC_CheckChild1TypeI32,
/* 20635*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20637*/     OPC_Scope, 67, /*->20706*/ // 2 children in Scope
/* 20639*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 20641*/      OPC_CheckTypeI32,
/* 20642*/      OPC_Scope, 30, /*->20674*/ // 2 children in Scope
/* 20644*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20645*/       OPC_MoveSibling2,
/* 20646*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20649*/       OPC_RecordNode, // #3 = $idx
/* 20650*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20652*/       OPC_CheckTypeI32,
/* 20653*/       OPC_MoveParent,
/* 20654*/       OPC_CheckType, MVT::v16i8,
/* 20656*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20657*/       OPC_EmitMergeInputChains1_1,
/* 20658*/       OPC_EmitInteger32, 0, 
/* 20660*/       OPC_EmitInteger32, 0, 
/* 20662*/       OPC_EmitConvertToTarget3,
/* 20663*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 20674*/      /*Scope*/ 30, /*->20705*/
/* 20675*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20676*/       OPC_MoveSibling2,
/* 20677*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20680*/       OPC_RecordNode, // #3 = $idx
/* 20681*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20683*/       OPC_CheckTypeI32,
/* 20684*/       OPC_MoveParent,
/* 20685*/       OPC_CheckType, MVT::v8i16,
/* 20687*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20688*/       OPC_EmitMergeInputChains1_1,
/* 20689*/       OPC_EmitInteger32, 0, 
/* 20691*/       OPC_EmitInteger32, 0, 
/* 20693*/       OPC_EmitConvertToTarget3,
/* 20694*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 20705*/      0, /*End of Scope*/
/* 20706*/     /*Scope*/ 65, /*->20772*/
/* 20707*/      OPC_CheckPredicate7,  // Predicate_load
/* 20708*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->20740
/* 20711*/       OPC_MoveSibling2,
/* 20712*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20715*/       OPC_RecordNode, // #3 = $idx
/* 20716*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20718*/       OPC_CheckTypeI32,
/* 20719*/       OPC_MoveParent,
/* 20720*/       OPC_CheckType, MVT::v4i32,
/* 20722*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20723*/       OPC_EmitMergeInputChains1_1,
/* 20724*/       OPC_EmitInteger32, 0, 
/* 20726*/       OPC_EmitInteger32, 0, 
/* 20728*/       OPC_EmitConvertToTarget3,
/* 20729*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 20740*/      /*SwitchType*/ 29, MVT::i64,// ->20771
/* 20742*/       OPC_MoveSibling2,
/* 20743*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20746*/       OPC_RecordNode, // #3 = $idx
/* 20747*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20749*/       OPC_CheckTypeI32,
/* 20750*/       OPC_MoveParent,
/* 20751*/       OPC_CheckType, MVT::v2i64,
/* 20753*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20754*/       OPC_EmitMergeInputChains1_1,
/* 20755*/       OPC_EmitInteger32, 0, 
/* 20757*/       OPC_EmitInteger32, 0, 
/* 20759*/       OPC_EmitConvertToTarget3,
/* 20760*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 20771*/      0, // EndSwitchType
/* 20772*/     0, /*End of Scope*/
/* 20773*/    /*Scope*/ 11|128,1/*139*/, /*->20914*/
/* 20775*/     OPC_CheckChild1TypeI64,
/* 20776*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20778*/     OPC_Scope, 67, /*->20847*/ // 2 children in Scope
/* 20780*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 20782*/      OPC_CheckTypeI32,
/* 20783*/      OPC_Scope, 30, /*->20815*/ // 2 children in Scope
/* 20785*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20786*/       OPC_MoveSibling2,
/* 20787*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20790*/       OPC_RecordNode, // #3 = $idx
/* 20791*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20793*/       OPC_CheckTypeI32,
/* 20794*/       OPC_MoveParent,
/* 20795*/       OPC_CheckType, MVT::v16i8,
/* 20797*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20798*/       OPC_EmitMergeInputChains1_1,
/* 20799*/       OPC_EmitInteger32, 0, 
/* 20801*/       OPC_EmitInteger64, 0, 
/* 20803*/       OPC_EmitConvertToTarget3,
/* 20804*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 20815*/      /*Scope*/ 30, /*->20846*/
/* 20816*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20817*/       OPC_MoveSibling2,
/* 20818*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20821*/       OPC_RecordNode, // #3 = $idx
/* 20822*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20824*/       OPC_CheckTypeI32,
/* 20825*/       OPC_MoveParent,
/* 20826*/       OPC_CheckType, MVT::v8i16,
/* 20828*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20829*/       OPC_EmitMergeInputChains1_1,
/* 20830*/       OPC_EmitInteger32, 0, 
/* 20832*/       OPC_EmitInteger64, 0, 
/* 20834*/       OPC_EmitConvertToTarget3,
/* 20835*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 20846*/      0, /*End of Scope*/
/* 20847*/     /*Scope*/ 65, /*->20913*/
/* 20848*/      OPC_CheckPredicate7,  // Predicate_load
/* 20849*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->20881
/* 20852*/       OPC_MoveSibling2,
/* 20853*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20856*/       OPC_RecordNode, // #3 = $idx
/* 20857*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20859*/       OPC_CheckTypeI32,
/* 20860*/       OPC_MoveParent,
/* 20861*/       OPC_CheckType, MVT::v4i32,
/* 20863*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20864*/       OPC_EmitMergeInputChains1_1,
/* 20865*/       OPC_EmitInteger32, 0, 
/* 20867*/       OPC_EmitInteger64, 0, 
/* 20869*/       OPC_EmitConvertToTarget3,
/* 20870*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 20881*/      /*SwitchType*/ 29, MVT::i64,// ->20912
/* 20883*/       OPC_MoveSibling2,
/* 20884*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20887*/       OPC_RecordNode, // #3 = $idx
/* 20888*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20890*/       OPC_CheckTypeI32,
/* 20891*/       OPC_MoveParent,
/* 20892*/       OPC_CheckType, MVT::v2i64,
/* 20894*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20895*/       OPC_EmitMergeInputChains1_1,
/* 20896*/       OPC_EmitInteger32, 0, 
/* 20898*/       OPC_EmitInteger64, 0, 
/* 20900*/       OPC_EmitConvertToTarget3,
/* 20901*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 20912*/      0, // EndSwitchType
/* 20913*/     0, /*End of Scope*/
/* 20914*/    0, /*End of Scope*/
/* 20915*/   /*Scope*/ 114|128,1/*242*/, /*->21159*/
/* 20917*/    OPC_RecordChild1, // #1 = $x
/* 20918*/    OPC_Scope, 104, /*->21024*/ // 4 children in Scope
/* 20920*/     OPC_CheckChild1TypeI32,
/* 20921*/     OPC_Scope, 56, /*->20979*/ // 2 children in Scope
/* 20923*/      OPC_RecordChild2, // #2 = $idx
/* 20924*/      OPC_MoveChild2,
/* 20925*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20928*/      OPC_CheckTypeI32,
/* 20929*/      OPC_Scope, 15, /*->20946*/ // 3 children in Scope
/* 20931*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20933*/       OPC_MoveParent,
/* 20934*/       OPC_CheckType, MVT::v16i8,
/* 20936*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20937*/       OPC_EmitConvertToTarget2,
/* 20938*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20946*/      /*Scope*/ 15, /*->20962*/
/* 20947*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20949*/       OPC_MoveParent,
/* 20950*/       OPC_CheckType, MVT::v8i16,
/* 20952*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20953*/       OPC_EmitConvertToTarget2,
/* 20954*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20962*/      /*Scope*/ 15, /*->20978*/
/* 20963*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20965*/       OPC_MoveParent,
/* 20966*/       OPC_CheckType, MVT::v4i32,
/* 20968*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20969*/       OPC_EmitConvertToTarget2,
/* 20970*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20978*/      0, /*End of Scope*/
/* 20979*/     /*Scope*/ 43, /*->21023*/
/* 20980*/      OPC_MoveChild2,
/* 20981*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 20984*/      OPC_MoveParent,
/* 20985*/      OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->20998
/* 20988*/       OPC_EmitInteger32, 0, 
/* 20990*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20998*/      /*SwitchType*/ 10, MVT::v8i16,// ->21010
/* 21000*/       OPC_EmitInteger32, 0, 
/* 21002*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21010*/      /*SwitchType*/ 10, MVT::v4i32,// ->21022
/* 21012*/       OPC_EmitInteger32, 0, 
/* 21014*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21022*/      0, // EndSwitchType
/* 21023*/     0, /*End of Scope*/
/* 21024*/    /*Scope*/ 43, /*->21068*/
/* 21025*/     OPC_CheckChild1TypeI64,
/* 21026*/     OPC_Scope, 21, /*->21049*/ // 2 children in Scope
/* 21028*/      OPC_RecordChild2, // #2 = $idx
/* 21029*/      OPC_MoveChild2,
/* 21030*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21033*/      OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 21035*/      OPC_CheckTypeI32,
/* 21036*/      OPC_MoveParent,
/* 21037*/      OPC_CheckType, MVT::v2i64,
/* 21039*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21040*/      OPC_EmitConvertToTarget2,
/* 21041*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 21049*/     /*Scope*/ 17, /*->21067*/
/* 21050*/      OPC_MoveChild2,
/* 21051*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21054*/      OPC_MoveParent,
/* 21055*/      OPC_CheckType, MVT::v2i64,
/* 21057*/      OPC_EmitInteger32, 0, 
/* 21059*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 21067*/     0, /*End of Scope*/
/* 21068*/    /*Scope*/ 44, /*->21113*/
/* 21069*/     OPC_CheckChild1Type, MVT::f32,
/* 21071*/     OPC_Scope, 21, /*->21094*/ // 2 children in Scope
/* 21073*/      OPC_RecordChild2, // #2 = $idx
/* 21074*/      OPC_MoveChild2,
/* 21075*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21078*/      OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 21080*/      OPC_CheckTypeI32,
/* 21081*/      OPC_MoveParent,
/* 21082*/      OPC_CheckType, MVT::v4f32,
/* 21084*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21085*/      OPC_EmitConvertToTarget2,
/* 21086*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 21094*/     /*Scope*/ 17, /*->21112*/
/* 21095*/      OPC_MoveChild2,
/* 21096*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21099*/      OPC_MoveParent,
/* 21100*/      OPC_CheckType, MVT::v4f32,
/* 21102*/      OPC_EmitInteger32, 0, 
/* 21104*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 21112*/     0, /*End of Scope*/
/* 21113*/    /*Scope*/ 44, /*->21158*/
/* 21114*/     OPC_CheckChild1Type, MVT::f64,
/* 21116*/     OPC_Scope, 21, /*->21139*/ // 2 children in Scope
/* 21118*/      OPC_RecordChild2, // #2 = $idx
/* 21119*/      OPC_MoveChild2,
/* 21120*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21123*/      OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 21125*/      OPC_CheckTypeI32,
/* 21126*/      OPC_MoveParent,
/* 21127*/      OPC_CheckType, MVT::v2f64,
/* 21129*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21130*/      OPC_EmitConvertToTarget2,
/* 21131*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 21139*/     /*Scope*/ 17, /*->21157*/
/* 21140*/      OPC_MoveChild2,
/* 21141*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21144*/      OPC_MoveParent,
/* 21145*/      OPC_CheckType, MVT::v2f64,
/* 21147*/      OPC_EmitInteger32, 0, 
/* 21149*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 21157*/     0, /*End of Scope*/
/* 21158*/    0, /*End of Scope*/
/* 21159*/   0, /*End of Scope*/
/* 21160*/  0, /*End of Scope*/
/* 21161*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->21389
/* 21165*/  OPC_Scope, 87, /*->21254*/ // 2 children in Scope
/* 21167*/   OPC_MoveChild0,
/* 21168*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21171*/   OPC_MoveChild0,
/* 21172*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->21213
/* 21176*/    OPC_RecordChild0, // #0 = $lhs
/* 21177*/    OPC_RecordChild1, // #1 = $rhs
/* 21178*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21180*/    OPC_MoveSibling1,
/* 21181*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21184*/    OPC_CheckChild0Integer, 2, 
/* 21186*/    OPC_CheckChild0TypeI32,
/* 21187*/    OPC_MoveParent,
/* 21188*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21190*/    OPC_MoveParent,
/* 21191*/    OPC_CheckChild1Integer, 2, 
/* 21193*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->21203
/* 21196*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21203*/    /*SwitchType*/ 7, MVT::v8i16,// ->21212
/* 21205*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21212*/    0, // EndSwitchType
/* 21213*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21253
/* 21216*/    OPC_CheckChild0Integer, 2, 
/* 21218*/    OPC_CheckChild0TypeI32,
/* 21219*/    OPC_MoveSibling1,
/* 21220*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21223*/    OPC_RecordChild0, // #0 = $lhs
/* 21224*/    OPC_RecordChild1, // #1 = $rhs
/* 21225*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21227*/    OPC_MoveParent,
/* 21228*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21230*/    OPC_MoveParent,
/* 21231*/    OPC_CheckChild1Integer, 2, 
/* 21233*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->21243
/* 21236*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21243*/    /*SwitchType*/ 7, MVT::v8i16,// ->21252
/* 21245*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21252*/    0, // EndSwitchType
/* 21253*/   0, // EndSwitchOpcode
/* 21254*/  /*Scope*/ 4|128,1/*132*/, /*->21388*/
/* 21256*/   OPC_RecordChild0, // #0 = $lhs
/* 21257*/   OPC_Scope, 84, /*->21343*/ // 2 children in Scope
/* 21259*/    OPC_MoveChild1,
/* 21260*/    OPC_Scope, 24, /*->21286*/ // 5 children in Scope
/* 21262*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21265*/     OPC_MoveChild0,
/* 21266*/     OPC_CheckAndImm, 63, 
/* 21268*/     OPC_RecordChild0, // #1 = $rhs
/* 21269*/     OPC_MoveParent,
/* 21270*/     OPC_MoveParent,
/* 21271*/     OPC_CheckType, MVT::v2i64,
/* 21273*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 21279*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 21286*/    /*Scope*/ 13, /*->21300*/
/* 21287*/     OPC_CheckAndImm, 7, 
/* 21289*/     OPC_RecordChild0, // #1 = $rhs
/* 21290*/     OPC_MoveParent,
/* 21291*/     OPC_CheckType, MVT::v16i8,
/* 21293*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21300*/    /*Scope*/ 13, /*->21314*/
/* 21301*/     OPC_CheckAndImm, 15, 
/* 21303*/     OPC_RecordChild0, // #1 = $rhs
/* 21304*/     OPC_MoveParent,
/* 21305*/     OPC_CheckType, MVT::v8i16,
/* 21307*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21314*/    /*Scope*/ 13, /*->21328*/
/* 21315*/     OPC_CheckAndImm, 31, 
/* 21317*/     OPC_RecordChild0, // #1 = $rhs
/* 21318*/     OPC_MoveParent,
/* 21319*/     OPC_CheckType, MVT::v4i32,
/* 21321*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21328*/    /*Scope*/ 13, /*->21342*/
/* 21329*/     OPC_CheckAndImm, 63, 
/* 21331*/     OPC_RecordChild0, // #1 = $rhs
/* 21332*/     OPC_MoveParent,
/* 21333*/     OPC_CheckType, MVT::v2i64,
/* 21335*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21342*/    0, /*End of Scope*/
/* 21343*/   /*Scope*/ 43, /*->21387*/
/* 21344*/    OPC_RecordChild1, // #1 = $x
/* 21345*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->21356
/* 21348*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21349*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 21356*/    /*SwitchType*/ 8, MVT::v8i16,// ->21366
/* 21358*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21359*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 21366*/    /*SwitchType*/ 8, MVT::v4i32,// ->21376
/* 21368*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21369*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 21376*/    /*SwitchType*/ 8, MVT::v2i64,// ->21386
/* 21378*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21379*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 21386*/    0, // EndSwitchType
/* 21387*/   0, /*End of Scope*/
/* 21388*/  0, /*End of Scope*/
/* 21389*/ /*SwitchOpcode*/ 14|128,4/*526*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21919
/* 21393*/  OPC_Scope, 73|128,1/*201*/, /*->21597*/ // 4 children in Scope
/* 21396*/   OPC_MoveChild0,
/* 21397*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21400*/   OPC_RecordMemRef,
/* 21401*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21402*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21403*/   OPC_Scope, 95, /*->21500*/ // 2 children in Scope
/* 21405*/    OPC_CheckChild1TypeI32,
/* 21406*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21408*/    OPC_Scope, 45, /*->21455*/ // 2 children in Scope
/* 21410*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 21412*/     OPC_CheckTypeI32,
/* 21413*/     OPC_Scope, 19, /*->21434*/ // 2 children in Scope
/* 21415*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21416*/      OPC_MoveParent,
/* 21417*/      OPC_CheckType, MVT::v16i8,
/* 21419*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21420*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21422*/      OPC_EmitMergeInputChains1_0,
/* 21423*/      OPC_EmitInteger32, 0, 
/* 21425*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21434*/     /*Scope*/ 19, /*->21454*/
/* 21435*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21436*/      OPC_MoveParent,
/* 21437*/      OPC_CheckType, MVT::v8i16,
/* 21439*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21440*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21442*/      OPC_EmitMergeInputChains1_0,
/* 21443*/      OPC_EmitInteger32, 0, 
/* 21445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21454*/     0, /*End of Scope*/
/* 21455*/    /*Scope*/ 43, /*->21499*/
/* 21456*/     OPC_CheckPredicate7,  // Predicate_load
/* 21457*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21478
/* 21460*/      OPC_MoveParent,
/* 21461*/      OPC_CheckType, MVT::v4i32,
/* 21463*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21464*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21466*/      OPC_EmitMergeInputChains1_0,
/* 21467*/      OPC_EmitInteger32, 0, 
/* 21469*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21478*/     /*SwitchType*/ 18, MVT::i64,// ->21498
/* 21480*/      OPC_MoveParent,
/* 21481*/      OPC_CheckType, MVT::v2i64,
/* 21483*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21484*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21486*/      OPC_EmitMergeInputChains1_0,
/* 21487*/      OPC_EmitInteger32, 0, 
/* 21489*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21498*/     0, // EndSwitchType
/* 21499*/    0, /*End of Scope*/
/* 21500*/   /*Scope*/ 95, /*->21596*/
/* 21501*/    OPC_CheckChild1TypeI64,
/* 21502*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21504*/    OPC_Scope, 45, /*->21551*/ // 2 children in Scope
/* 21506*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 21508*/     OPC_CheckTypeI32,
/* 21509*/     OPC_Scope, 19, /*->21530*/ // 2 children in Scope
/* 21511*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21512*/      OPC_MoveParent,
/* 21513*/      OPC_CheckType, MVT::v16i8,
/* 21515*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21516*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21518*/      OPC_EmitMergeInputChains1_0,
/* 21519*/      OPC_EmitInteger32, 0, 
/* 21521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21530*/     /*Scope*/ 19, /*->21550*/
/* 21531*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21532*/      OPC_MoveParent,
/* 21533*/      OPC_CheckType, MVT::v8i16,
/* 21535*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21536*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21538*/      OPC_EmitMergeInputChains1_0,
/* 21539*/      OPC_EmitInteger32, 0, 
/* 21541*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21550*/     0, /*End of Scope*/
/* 21551*/    /*Scope*/ 43, /*->21595*/
/* 21552*/     OPC_CheckPredicate7,  // Predicate_load
/* 21553*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21574
/* 21556*/      OPC_MoveParent,
/* 21557*/      OPC_CheckType, MVT::v4i32,
/* 21559*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21560*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21562*/      OPC_EmitMergeInputChains1_0,
/* 21563*/      OPC_EmitInteger32, 0, 
/* 21565*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21574*/     /*SwitchType*/ 18, MVT::i64,// ->21594
/* 21576*/      OPC_MoveParent,
/* 21577*/      OPC_CheckType, MVT::v2i64,
/* 21579*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21580*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21582*/      OPC_EmitMergeInputChains1_0,
/* 21583*/      OPC_EmitInteger32, 0, 
/* 21585*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21594*/     0, // EndSwitchType
/* 21595*/    0, /*End of Scope*/
/* 21596*/   0, /*End of Scope*/
/* 21597*/  /*Scope*/ 20|128,1/*148*/, /*->21747*/
/* 21599*/   OPC_RecordChild0, // #0 = $x
/* 21600*/   OPC_Scope, 102, /*->21704*/ // 3 children in Scope
/* 21602*/    OPC_MoveChild0,
/* 21603*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21606*/    OPC_SwitchType /*2 cases */, 80, MVT::i32,// ->21689
/* 21609*/     OPC_MoveParent,
/* 21610*/     OPC_SwitchType /*3 cases */, 37, MVT::v16i8,// ->21650
/* 21613*/      OPC_EmitConvertToTarget0,
/* 21614*/      OPC_EmitConvertToTarget0,
/* 21615*/      OPC_EmitConvertToTarget0,
/* 21616*/      OPC_EmitConvertToTarget0,
/* 21617*/      OPC_EmitConvertToTarget0,
/* 21618*/      OPC_EmitConvertToTarget0,
/* 21619*/      OPC_EmitConvertToTarget0,
/* 21620*/      OPC_EmitConvertToTarget0,
/* 21621*/      OPC_EmitConvertToTarget0,
/* 21622*/      OPC_EmitConvertToTarget0,
/* 21623*/      OPC_EmitConvertToTarget0,
/* 21624*/      OPC_EmitConvertToTarget0,
/* 21625*/      OPC_EmitConvertToTarget0,
/* 21626*/      OPC_EmitConvertToTarget0,
/* 21627*/      OPC_EmitConvertToTarget0,
/* 21628*/      OPC_EmitConvertToTarget0,
/* 21629*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    MVT::v16i8, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21650*/     /*SwitchType*/ 21, MVT::v8i16,// ->21673
/* 21652*/      OPC_EmitConvertToTarget0,
/* 21653*/      OPC_EmitConvertToTarget0,
/* 21654*/      OPC_EmitConvertToTarget0,
/* 21655*/      OPC_EmitConvertToTarget0,
/* 21656*/      OPC_EmitConvertToTarget0,
/* 21657*/      OPC_EmitConvertToTarget0,
/* 21658*/      OPC_EmitConvertToTarget0,
/* 21659*/      OPC_EmitConvertToTarget0,
/* 21660*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    MVT::v8i16, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21673*/     /*SwitchType*/ 13, MVT::v4i32,// ->21688
/* 21675*/      OPC_EmitConvertToTarget0,
/* 21676*/      OPC_EmitConvertToTarget0,
/* 21677*/      OPC_EmitConvertToTarget0,
/* 21678*/      OPC_EmitConvertToTarget0,
/* 21679*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    MVT::v4i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21688*/     0, // EndSwitchType
/* 21689*/    /*SwitchType*/ 12, MVT::i64,// ->21703
/* 21691*/     OPC_MoveParent,
/* 21692*/     OPC_CheckType, MVT::v2i64,
/* 21694*/     OPC_EmitConvertToTarget0,
/* 21695*/     OPC_EmitConvertToTarget0,
/* 21696*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 21703*/    0, // EndSwitchType
/* 21704*/   /*Scope*/ 30, /*->21735*/
/* 21705*/    OPC_CheckChild0TypeI32,
/* 21706*/    OPC_SwitchType /*3 cases */, 7, MVT::v16i8,// ->21716
/* 21709*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21710*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 21716*/    /*SwitchType*/ 7, MVT::v8i16,// ->21725
/* 21718*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21719*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 21725*/    /*SwitchType*/ 7, MVT::v4i32,// ->21734
/* 21727*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21728*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 21734*/    0, // EndSwitchType
/* 21735*/   /*Scope*/ 10, /*->21746*/
/* 21736*/    OPC_CheckChild0TypeI64,
/* 21737*/    OPC_CheckType, MVT::v2i64,
/* 21739*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21740*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 21746*/   0, /*End of Scope*/
/* 21747*/  /*Scope*/ 103, /*->21851*/
/* 21748*/   OPC_MoveChild0,
/* 21749*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21752*/   OPC_RecordMemRef,
/* 21753*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21754*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21755*/   OPC_Scope, 46, /*->21803*/ // 2 children in Scope
/* 21757*/    OPC_CheckChild1TypeI32,
/* 21758*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21760*/    OPC_CheckPredicate7,  // Predicate_load
/* 21761*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->21782
/* 21764*/     OPC_MoveParent,
/* 21765*/     OPC_CheckType, MVT::v4f32,
/* 21767*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21768*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21770*/     OPC_EmitMergeInputChains1_0,
/* 21771*/     OPC_EmitInteger32, 0, 
/* 21773*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21782*/    /*SwitchType*/ 18, MVT::f64,// ->21802
/* 21784*/     OPC_MoveParent,
/* 21785*/     OPC_CheckType, MVT::v2f64,
/* 21787*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21788*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21790*/     OPC_EmitMergeInputChains1_0,
/* 21791*/     OPC_EmitInteger32, 0, 
/* 21793*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21802*/    0, // EndSwitchType
/* 21803*/   /*Scope*/ 46, /*->21850*/
/* 21804*/    OPC_CheckChild1TypeI64,
/* 21805*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21807*/    OPC_CheckPredicate7,  // Predicate_load
/* 21808*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->21829
/* 21811*/     OPC_MoveParent,
/* 21812*/     OPC_CheckType, MVT::v4f32,
/* 21814*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21815*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21817*/     OPC_EmitMergeInputChains1_0,
/* 21818*/     OPC_EmitInteger32, 0, 
/* 21820*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21829*/    /*SwitchType*/ 18, MVT::f64,// ->21849
/* 21831*/     OPC_MoveParent,
/* 21832*/     OPC_CheckType, MVT::v2f64,
/* 21834*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21835*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21837*/     OPC_EmitMergeInputChains1_0,
/* 21838*/     OPC_EmitInteger32, 0, 
/* 21840*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21849*/    0, // EndSwitchType
/* 21850*/   0, /*End of Scope*/
/* 21851*/  /*Scope*/ 66, /*->21918*/
/* 21852*/   OPC_RecordChild0, // #0 = $x
/* 21853*/   OPC_Scope, 38, /*->21893*/ // 3 children in Scope
/* 21855*/    OPC_MoveChild0,
/* 21856*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 21859*/    OPC_SwitchType /*2 cases */, 16, MVT::f32,// ->21878
/* 21862*/     OPC_MoveParent,
/* 21863*/     OPC_CheckType, MVT::v4f32,
/* 21865*/     OPC_EmitConvertToTarget0,
/* 21866*/     OPC_EmitConvertToTarget0,
/* 21867*/     OPC_EmitConvertToTarget0,
/* 21868*/     OPC_EmitConvertToTarget0,
/* 21869*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   MVT::v4f32, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 21878*/    /*SwitchType*/ 12, MVT::f64,// ->21892
/* 21880*/     OPC_MoveParent,
/* 21881*/     OPC_CheckType, MVT::v2f64,
/* 21883*/     OPC_EmitConvertToTarget0,
/* 21884*/     OPC_EmitConvertToTarget0,
/* 21885*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   MVT::v2f64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 21892*/    0, // EndSwitchType
/* 21893*/   /*Scope*/ 11, /*->21905*/
/* 21894*/    OPC_CheckChild0Type, MVT::f32,
/* 21896*/    OPC_CheckType, MVT::v4f32,
/* 21898*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21899*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 21905*/   /*Scope*/ 11, /*->21917*/
/* 21906*/    OPC_CheckChild0Type, MVT::f64,
/* 21908*/    OPC_CheckType, MVT::v2f64,
/* 21910*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21911*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 21917*/   0, /*End of Scope*/
/* 21918*/  0, /*End of Scope*/
/* 21919*/ /*SwitchOpcode*/ 42|128,1/*170*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->22093
/* 21923*/  OPC_Scope, 103, /*->22028*/ // 2 children in Scope
/* 21925*/   OPC_MoveChild0,
/* 21926*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21929*/   OPC_RecordMemRef,
/* 21930*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21931*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21932*/   OPC_Scope, 46, /*->21980*/ // 2 children in Scope
/* 21934*/    OPC_CheckChild1TypeI32,
/* 21935*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21937*/    OPC_CheckPredicate7,  // Predicate_load
/* 21938*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21959
/* 21941*/     OPC_MoveParent,
/* 21942*/     OPC_CheckType, MVT::v4i32,
/* 21944*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21945*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21947*/     OPC_EmitMergeInputChains1_0,
/* 21948*/     OPC_EmitInteger32, 0, 
/* 21950*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21959*/    /*SwitchType*/ 18, MVT::i64,// ->21979
/* 21961*/     OPC_MoveParent,
/* 21962*/     OPC_CheckType, MVT::v2i64,
/* 21964*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21965*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21967*/     OPC_EmitMergeInputChains1_0,
/* 21968*/     OPC_EmitInteger32, 0, 
/* 21970*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21979*/    0, // EndSwitchType
/* 21980*/   /*Scope*/ 46, /*->22027*/
/* 21981*/    OPC_CheckChild1TypeI64,
/* 21982*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21984*/    OPC_CheckPredicate7,  // Predicate_load
/* 21985*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->22006
/* 21988*/     OPC_MoveParent,
/* 21989*/     OPC_CheckType, MVT::v4i32,
/* 21991*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21992*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21994*/     OPC_EmitMergeInputChains1_0,
/* 21995*/     OPC_EmitInteger32, 0, 
/* 21997*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22006*/    /*SwitchType*/ 18, MVT::i64,// ->22026
/* 22008*/     OPC_MoveParent,
/* 22009*/     OPC_CheckType, MVT::v2i64,
/* 22011*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 22012*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22014*/     OPC_EmitMergeInputChains1_0,
/* 22015*/     OPC_EmitInteger32, 0, 
/* 22017*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22026*/    0, // EndSwitchType
/* 22027*/   0, /*End of Scope*/
/* 22028*/  /*Scope*/ 63, /*->22092*/
/* 22029*/   OPC_RecordChild0, // #0 = $x
/* 22030*/   OPC_Scope, 27, /*->22059*/ // 4 children in Scope
/* 22032*/    OPC_CheckChild0TypeI32,
/* 22033*/    OPC_SwitchType /*3 cases */, 6, MVT::v16i8,// ->22042
/* 22036*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 22042*/    /*SwitchType*/ 6, MVT::v8i16,// ->22050
/* 22044*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 22050*/    /*SwitchType*/ 6, MVT::v4i32,// ->22058
/* 22052*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 22058*/    0, // EndSwitchType
/* 22059*/   /*Scope*/ 9, /*->22069*/
/* 22060*/    OPC_CheckChild0TypeI64,
/* 22061*/    OPC_CheckType, MVT::v2i64,
/* 22063*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 22069*/   /*Scope*/ 10, /*->22080*/
/* 22070*/    OPC_CheckChild0Type, MVT::f32,
/* 22072*/    OPC_CheckType, MVT::v4f32,
/* 22074*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 22080*/   /*Scope*/ 10, /*->22091*/
/* 22081*/    OPC_CheckChild0Type, MVT::f64,
/* 22083*/    OPC_CheckType, MVT::v2f64,
/* 22085*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 22091*/   0, /*End of Scope*/
/* 22092*/  0, /*End of Scope*/
/* 22093*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->22229
/* 22097*/  OPC_RecordChild0, // #0 = $lhs
/* 22098*/  OPC_Scope, 84, /*->22184*/ // 2 children in Scope
/* 22100*/   OPC_MoveChild1,
/* 22101*/   OPC_Scope, 24, /*->22127*/ // 5 children in Scope
/* 22103*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22106*/    OPC_MoveChild0,
/* 22107*/    OPC_CheckAndImm, 63, 
/* 22109*/    OPC_RecordChild0, // #1 = $rhs
/* 22110*/    OPC_MoveParent,
/* 22111*/    OPC_MoveParent,
/* 22112*/    OPC_CheckType, MVT::v2i64,
/* 22114*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22120*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22127*/   /*Scope*/ 13, /*->22141*/
/* 22128*/    OPC_CheckAndImm, 7, 
/* 22130*/    OPC_RecordChild0, // #1 = $rhs
/* 22131*/    OPC_MoveParent,
/* 22132*/    OPC_CheckType, MVT::v16i8,
/* 22134*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22141*/   /*Scope*/ 13, /*->22155*/
/* 22142*/    OPC_CheckAndImm, 15, 
/* 22144*/    OPC_RecordChild0, // #1 = $rhs
/* 22145*/    OPC_MoveParent,
/* 22146*/    OPC_CheckType, MVT::v8i16,
/* 22148*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22155*/   /*Scope*/ 13, /*->22169*/
/* 22156*/    OPC_CheckAndImm, 31, 
/* 22158*/    OPC_RecordChild0, // #1 = $rhs
/* 22159*/    OPC_MoveParent,
/* 22160*/    OPC_CheckType, MVT::v4i32,
/* 22162*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22169*/   /*Scope*/ 13, /*->22183*/
/* 22170*/    OPC_CheckAndImm, 63, 
/* 22172*/    OPC_RecordChild0, // #1 = $rhs
/* 22173*/    OPC_MoveParent,
/* 22174*/    OPC_CheckType, MVT::v2i64,
/* 22176*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22183*/   0, /*End of Scope*/
/* 22184*/  /*Scope*/ 43, /*->22228*/
/* 22185*/   OPC_RecordChild1, // #1 = $x
/* 22186*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22197
/* 22189*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22190*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22197*/   /*SwitchType*/ 8, MVT::v8i16,// ->22207
/* 22199*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22200*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22207*/   /*SwitchType*/ 8, MVT::v4i32,// ->22217
/* 22209*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22210*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22217*/   /*SwitchType*/ 8, MVT::v2i64,// ->22227
/* 22219*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22220*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22227*/   0, // EndSwitchType
/* 22228*/  0, /*End of Scope*/
/* 22229*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->22365
/* 22233*/  OPC_RecordChild0, // #0 = $lhs
/* 22234*/  OPC_Scope, 84, /*->22320*/ // 2 children in Scope
/* 22236*/   OPC_MoveChild1,
/* 22237*/   OPC_Scope, 24, /*->22263*/ // 5 children in Scope
/* 22239*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22242*/    OPC_MoveChild0,
/* 22243*/    OPC_CheckAndImm, 63, 
/* 22245*/    OPC_RecordChild0, // #1 = $rhs
/* 22246*/    OPC_MoveParent,
/* 22247*/    OPC_MoveParent,
/* 22248*/    OPC_CheckType, MVT::v2i64,
/* 22250*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22256*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22263*/   /*Scope*/ 13, /*->22277*/
/* 22264*/    OPC_CheckAndImm, 7, 
/* 22266*/    OPC_RecordChild0, // #1 = $rhs
/* 22267*/    OPC_MoveParent,
/* 22268*/    OPC_CheckType, MVT::v16i8,
/* 22270*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22277*/   /*Scope*/ 13, /*->22291*/
/* 22278*/    OPC_CheckAndImm, 15, 
/* 22280*/    OPC_RecordChild0, // #1 = $rhs
/* 22281*/    OPC_MoveParent,
/* 22282*/    OPC_CheckType, MVT::v8i16,
/* 22284*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22291*/   /*Scope*/ 13, /*->22305*/
/* 22292*/    OPC_CheckAndImm, 31, 
/* 22294*/    OPC_RecordChild0, // #1 = $rhs
/* 22295*/    OPC_MoveParent,
/* 22296*/    OPC_CheckType, MVT::v4i32,
/* 22298*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22305*/   /*Scope*/ 13, /*->22319*/
/* 22306*/    OPC_CheckAndImm, 63, 
/* 22308*/    OPC_RecordChild0, // #1 = $rhs
/* 22309*/    OPC_MoveParent,
/* 22310*/    OPC_CheckType, MVT::v2i64,
/* 22312*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22319*/   0, /*End of Scope*/
/* 22320*/  /*Scope*/ 43, /*->22364*/
/* 22321*/   OPC_RecordChild1, // #1 = $x
/* 22322*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22333
/* 22325*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22326*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22333*/   /*SwitchType*/ 8, MVT::v8i16,// ->22343
/* 22335*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22336*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22343*/   /*SwitchType*/ 8, MVT::v4i32,// ->22353
/* 22345*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22346*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22353*/   /*SwitchType*/ 8, MVT::v2i64,// ->22363
/* 22355*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22356*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22363*/   0, // EndSwitchType
/* 22364*/  0, /*End of Scope*/
/* 22365*/ /*SwitchOpcode*/ 14|128,5/*654*/, TARGET_VAL(ISD::VSELECT),// ->23023
/* 22369*/  OPC_Scope, 12|128,1/*140*/, /*->22512*/ // 4 children in Scope
/* 22372*/   OPC_MoveChild0,
/* 22373*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 22376*/   OPC_MoveChild0,
/* 22377*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22380*/   OPC_RecordChild0, // #0 = $rhs
/* 22381*/   OPC_SwitchType /*3 cases */, 41, MVT::v4f32,// ->22425
/* 22384*/    OPC_CheckChild0Type, MVT::v4i32,
/* 22386*/    OPC_MoveSibling1,
/* 22387*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22390*/    OPC_RecordChild0, // #1 = $lhs
/* 22391*/    OPC_CheckChild0Type, MVT::v4i32,
/* 22393*/    OPC_MoveParent,
/* 22394*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22396*/    OPC_MoveParent,
/* 22397*/    OPC_CheckType, MVT::v4i32,
/* 22399*/    OPC_Scope, 11, /*->22412*/ // 2 children in Scope
/* 22401*/     OPC_CheckChild1Same, 0,
/* 22403*/     OPC_CheckChild2Same, 1,
/* 22405*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 22412*/    /*Scope*/ 11, /*->22424*/
/* 22413*/     OPC_CheckChild1Same, 1,
/* 22415*/     OPC_CheckChild2Same, 0,
/* 22417*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 22424*/    0, /*End of Scope*/
/* 22425*/   /*SwitchType*/ 41, MVT::v2f64,// ->22468
/* 22427*/    OPC_CheckChild0Type, MVT::v2i64,
/* 22429*/    OPC_MoveSibling1,
/* 22430*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22433*/    OPC_RecordChild0, // #1 = $lhs
/* 22434*/    OPC_CheckChild0Type, MVT::v2i64,
/* 22436*/    OPC_MoveParent,
/* 22437*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22439*/    OPC_MoveParent,
/* 22440*/    OPC_CheckType, MVT::v2i64,
/* 22442*/    OPC_Scope, 11, /*->22455*/ // 2 children in Scope
/* 22444*/     OPC_CheckChild1Same, 0,
/* 22446*/     OPC_CheckChild2Same, 1,
/* 22448*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 22455*/    /*Scope*/ 11, /*->22467*/
/* 22456*/     OPC_CheckChild1Same, 1,
/* 22458*/     OPC_CheckChild2Same, 0,
/* 22460*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 22467*/    0, /*End of Scope*/
/* 22468*/   /*SwitchType*/ 41, MVT::v8f16,// ->22511
/* 22470*/    OPC_CheckChild0Type, MVT::v8i16,
/* 22472*/    OPC_MoveSibling1,
/* 22473*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22476*/    OPC_RecordChild0, // #1 = $lhs
/* 22477*/    OPC_CheckChild0Type, MVT::v8i16,
/* 22479*/    OPC_MoveParent,
/* 22480*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22482*/    OPC_MoveParent,
/* 22483*/    OPC_CheckType, MVT::v8i16,
/* 22485*/    OPC_Scope, 11, /*->22498*/ // 2 children in Scope
/* 22487*/     OPC_CheckChild1Same, 0,
/* 22489*/     OPC_CheckChild2Same, 1,
/* 22491*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   MVT::v8i16, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22498*/    /*Scope*/ 11, /*->22510*/
/* 22499*/     OPC_CheckChild1Same, 1,
/* 22501*/     OPC_CheckChild2Same, 0,
/* 22503*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22510*/    0, /*End of Scope*/
/* 22511*/   0, // EndSwitchType
/* 22512*/  /*Scope*/ 45, /*->22558*/
/* 22513*/   OPC_RecordChild0, // #0 = $c
/* 22514*/   OPC_RecordChild1, // #1 = $v1
/* 22515*/   OPC_RecordChild2, // #2 = $v2
/* 22516*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22527
/* 22519*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 22527*/   /*SwitchType*/ 8, MVT::v8i16,// ->22537
/* 22529*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 22537*/   /*SwitchType*/ 8, MVT::v4i32,// ->22547
/* 22539*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 22547*/   /*SwitchType*/ 8, MVT::v2i64,// ->22557
/* 22549*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 22557*/   0, // EndSwitchType
/* 22558*/  /*Scope*/ 52|128,3/*436*/, /*->22996*/
/* 22560*/   OPC_MoveChild0,
/* 22561*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 22564*/   OPC_RecordChild0, // #0 = $rhs
/* 22565*/   OPC_Scope, 13|128,1/*141*/, /*->22709*/ // 3 children in Scope
/* 22568*/    OPC_CheckChild0Type, MVT::v4f32,
/* 22570*/    OPC_RecordChild1, // #1 = $lhs
/* 22571*/    OPC_Scope, 33, /*->22606*/ // 4 children in Scope
/* 22573*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22575*/     OPC_MoveParent,
/* 22576*/     OPC_CheckType, MVT::v4f32,
/* 22578*/     OPC_Scope, 12, /*->22592*/ // 2 children in Scope
/* 22580*/      OPC_CheckChild1Same, 0,
/* 22582*/      OPC_CheckChild2Same, 1,
/* 22584*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22585*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22592*/     /*Scope*/ 12, /*->22605*/
/* 22593*/      OPC_CheckChild1Same, 1,
/* 22595*/      OPC_CheckChild2Same, 0,
/* 22597*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22598*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22605*/     0, /*End of Scope*/
/* 22606*/    /*Scope*/ 33, /*->22640*/
/* 22607*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22609*/     OPC_MoveParent,
/* 22610*/     OPC_CheckType, MVT::v4f32,
/* 22612*/     OPC_Scope, 12, /*->22626*/ // 2 children in Scope
/* 22614*/      OPC_CheckChild1Same, 0,
/* 22616*/      OPC_CheckChild2Same, 1,
/* 22618*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22619*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22626*/     /*Scope*/ 12, /*->22639*/
/* 22627*/      OPC_CheckChild1Same, 1,
/* 22629*/      OPC_CheckChild2Same, 0,
/* 22631*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22632*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22639*/     0, /*End of Scope*/
/* 22640*/    /*Scope*/ 33, /*->22674*/
/* 22641*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22643*/     OPC_MoveParent,
/* 22644*/     OPC_CheckType, MVT::v4f32,
/* 22646*/     OPC_Scope, 12, /*->22660*/ // 2 children in Scope
/* 22648*/      OPC_CheckChild1Same, 1,
/* 22650*/      OPC_CheckChild2Same, 0,
/* 22652*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22653*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22660*/     /*Scope*/ 12, /*->22673*/
/* 22661*/      OPC_CheckChild1Same, 0,
/* 22663*/      OPC_CheckChild2Same, 1,
/* 22665*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22666*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22673*/     0, /*End of Scope*/
/* 22674*/    /*Scope*/ 33, /*->22708*/
/* 22675*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22677*/     OPC_MoveParent,
/* 22678*/     OPC_CheckType, MVT::v4f32,
/* 22680*/     OPC_Scope, 12, /*->22694*/ // 2 children in Scope
/* 22682*/      OPC_CheckChild1Same, 1,
/* 22684*/      OPC_CheckChild2Same, 0,
/* 22686*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22687*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22694*/     /*Scope*/ 12, /*->22707*/
/* 22695*/      OPC_CheckChild1Same, 0,
/* 22697*/      OPC_CheckChild2Same, 1,
/* 22699*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22700*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22707*/     0, /*End of Scope*/
/* 22708*/    0, /*End of Scope*/
/* 22709*/   /*Scope*/ 13|128,1/*141*/, /*->22852*/
/* 22711*/    OPC_CheckChild0Type, MVT::v2f64,
/* 22713*/    OPC_RecordChild1, // #1 = $lhs
/* 22714*/    OPC_Scope, 33, /*->22749*/ // 4 children in Scope
/* 22716*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22718*/     OPC_MoveParent,
/* 22719*/     OPC_CheckType, MVT::v2f64,
/* 22721*/     OPC_Scope, 12, /*->22735*/ // 2 children in Scope
/* 22723*/      OPC_CheckChild1Same, 0,
/* 22725*/      OPC_CheckChild2Same, 1,
/* 22727*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22728*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22735*/     /*Scope*/ 12, /*->22748*/
/* 22736*/      OPC_CheckChild1Same, 1,
/* 22738*/      OPC_CheckChild2Same, 0,
/* 22740*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22741*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22748*/     0, /*End of Scope*/
/* 22749*/    /*Scope*/ 33, /*->22783*/
/* 22750*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22752*/     OPC_MoveParent,
/* 22753*/     OPC_CheckType, MVT::v2f64,
/* 22755*/     OPC_Scope, 12, /*->22769*/ // 2 children in Scope
/* 22757*/      OPC_CheckChild1Same, 0,
/* 22759*/      OPC_CheckChild2Same, 1,
/* 22761*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22762*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22769*/     /*Scope*/ 12, /*->22782*/
/* 22770*/      OPC_CheckChild1Same, 1,
/* 22772*/      OPC_CheckChild2Same, 0,
/* 22774*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22775*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22782*/     0, /*End of Scope*/
/* 22783*/    /*Scope*/ 33, /*->22817*/
/* 22784*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22786*/     OPC_MoveParent,
/* 22787*/     OPC_CheckType, MVT::v2f64,
/* 22789*/     OPC_Scope, 12, /*->22803*/ // 2 children in Scope
/* 22791*/      OPC_CheckChild1Same, 1,
/* 22793*/      OPC_CheckChild2Same, 0,
/* 22795*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22796*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22803*/     /*Scope*/ 12, /*->22816*/
/* 22804*/      OPC_CheckChild1Same, 0,
/* 22806*/      OPC_CheckChild2Same, 1,
/* 22808*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22809*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22816*/     0, /*End of Scope*/
/* 22817*/    /*Scope*/ 33, /*->22851*/
/* 22818*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22820*/     OPC_MoveParent,
/* 22821*/     OPC_CheckType, MVT::v2f64,
/* 22823*/     OPC_Scope, 12, /*->22837*/ // 2 children in Scope
/* 22825*/      OPC_CheckChild1Same, 1,
/* 22827*/      OPC_CheckChild2Same, 0,
/* 22829*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22830*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22837*/     /*Scope*/ 12, /*->22850*/
/* 22838*/      OPC_CheckChild1Same, 0,
/* 22840*/      OPC_CheckChild2Same, 1,
/* 22842*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22843*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22850*/     0, /*End of Scope*/
/* 22851*/    0, /*End of Scope*/
/* 22852*/   /*Scope*/ 13|128,1/*141*/, /*->22995*/
/* 22854*/    OPC_CheckChild0Type, MVT::v8f16,
/* 22856*/    OPC_RecordChild1, // #1 = $lhs
/* 22857*/    OPC_Scope, 33, /*->22892*/ // 4 children in Scope
/* 22859*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22861*/     OPC_MoveParent,
/* 22862*/     OPC_CheckType, MVT::v8f16,
/* 22864*/     OPC_Scope, 12, /*->22878*/ // 2 children in Scope
/* 22866*/      OPC_CheckChild1Same, 0,
/* 22868*/      OPC_CheckChild2Same, 1,
/* 22870*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22871*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22878*/     /*Scope*/ 12, /*->22891*/
/* 22879*/      OPC_CheckChild1Same, 1,
/* 22881*/      OPC_CheckChild2Same, 0,
/* 22883*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22884*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22891*/     0, /*End of Scope*/
/* 22892*/    /*Scope*/ 33, /*->22926*/
/* 22893*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22895*/     OPC_MoveParent,
/* 22896*/     OPC_CheckType, MVT::v8f16,
/* 22898*/     OPC_Scope, 12, /*->22912*/ // 2 children in Scope
/* 22900*/      OPC_CheckChild1Same, 0,
/* 22902*/      OPC_CheckChild2Same, 1,
/* 22904*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22905*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22912*/     /*Scope*/ 12, /*->22925*/
/* 22913*/      OPC_CheckChild1Same, 1,
/* 22915*/      OPC_CheckChild2Same, 0,
/* 22917*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22918*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22925*/     0, /*End of Scope*/
/* 22926*/    /*Scope*/ 33, /*->22960*/
/* 22927*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22929*/     OPC_MoveParent,
/* 22930*/     OPC_CheckType, MVT::v8f16,
/* 22932*/     OPC_Scope, 12, /*->22946*/ // 2 children in Scope
/* 22934*/      OPC_CheckChild1Same, 1,
/* 22936*/      OPC_CheckChild2Same, 0,
/* 22938*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22939*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22946*/     /*Scope*/ 12, /*->22959*/
/* 22947*/      OPC_CheckChild1Same, 0,
/* 22949*/      OPC_CheckChild2Same, 1,
/* 22951*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22952*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22959*/     0, /*End of Scope*/
/* 22960*/    /*Scope*/ 33, /*->22994*/
/* 22961*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22963*/     OPC_MoveParent,
/* 22964*/     OPC_CheckType, MVT::v8f16,
/* 22966*/     OPC_Scope, 12, /*->22980*/ // 2 children in Scope
/* 22968*/      OPC_CheckChild1Same, 1,
/* 22970*/      OPC_CheckChild2Same, 0,
/* 22972*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22973*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22980*/     /*Scope*/ 12, /*->22993*/
/* 22981*/      OPC_CheckChild1Same, 0,
/* 22983*/      OPC_CheckChild2Same, 1,
/* 22985*/      OPC_CheckPatternPredicate5, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22986*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22993*/     0, /*End of Scope*/
/* 22994*/    0, /*End of Scope*/
/* 22995*/   0, /*End of Scope*/
/* 22996*/  /*Scope*/ 25, /*->23022*/
/* 22997*/   OPC_RecordChild0, // #0 = $c
/* 22998*/   OPC_RecordChild1, // #1 = $v1
/* 22999*/   OPC_RecordChild2, // #2 = $v2
/* 23000*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->23011
/* 23003*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23011*/   /*SwitchType*/ 8, MVT::v2f64,// ->23021
/* 23013*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23021*/   0, // EndSwitchType
/* 23022*/  0, /*End of Scope*/
/* 23023*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->23042
/* 23026*/  OPC_RecordChild0, // #0 = $src
/* 23027*/  OPC_CheckChild0Type, MVT::v16i8,
/* 23029*/  OPC_RecordChild1, // #1 = $mask
/* 23030*/  OPC_CheckChild1Type, MVT::v16i8,
/* 23032*/  OPC_CheckType, MVT::v16i8,
/* 23034*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23035*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                MVT::v16i8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 23042*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->23084
/* 23045*/  OPC_RecordChild0, // #0 = $v
/* 23046*/  OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->23056
/* 23049*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23050*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 23056*/  /*SwitchType*/ 7, MVT::v8i16,// ->23065
/* 23058*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23059*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 23065*/  /*SwitchType*/ 7, MVT::v4i32,// ->23074
/* 23067*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23068*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 23074*/  /*SwitchType*/ 7, MVT::v2i64,// ->23083
/* 23076*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23077*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 23083*/  0, // EndSwitchType
/* 23084*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->23111
/* 23087*/  OPC_RecordChild0, // #0 = $lhs
/* 23088*/  OPC_RecordChild1, // #1 = $rhs
/* 23089*/  OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->23100
/* 23092*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23093*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23100*/  /*SwitchType*/ 8, MVT::v8i16,// ->23110
/* 23102*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23103*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23110*/  0, // EndSwitchType
/* 23111*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->23138
/* 23114*/  OPC_RecordChild0, // #0 = $lhs
/* 23115*/  OPC_RecordChild1, // #1 = $rhs
/* 23116*/  OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->23127
/* 23119*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23120*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23127*/  /*SwitchType*/ 8, MVT::v8i16,// ->23137
/* 23129*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23130*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23137*/  0, // EndSwitchType
/* 23138*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->23175
/* 23141*/  OPC_RecordChild0, // #0 = $lhs
/* 23142*/  OPC_RecordChild1, // #1 = $rhs
/* 23143*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23154
/* 23146*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23147*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23154*/  /*SwitchType*/ 8, MVT::v8i16,// ->23164
/* 23156*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23157*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23164*/  /*SwitchType*/ 8, MVT::v4i32,// ->23174
/* 23166*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23167*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23174*/  0, // EndSwitchType
/* 23175*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->23212
/* 23178*/  OPC_RecordChild0, // #0 = $lhs
/* 23179*/  OPC_RecordChild1, // #1 = $rhs
/* 23180*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23191
/* 23183*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23184*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23191*/  /*SwitchType*/ 8, MVT::v8i16,// ->23201
/* 23193*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23201*/  /*SwitchType*/ 8, MVT::v4i32,// ->23211
/* 23203*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23204*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23211*/  0, // EndSwitchType
/* 23212*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->23249
/* 23215*/  OPC_RecordChild0, // #0 = $lhs
/* 23216*/  OPC_RecordChild1, // #1 = $rhs
/* 23217*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23228
/* 23220*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23221*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23228*/  /*SwitchType*/ 8, MVT::v8i16,// ->23238
/* 23230*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23231*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23238*/  /*SwitchType*/ 8, MVT::v4i32,// ->23248
/* 23240*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23241*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23248*/  0, // EndSwitchType
/* 23249*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->23286
/* 23252*/  OPC_RecordChild0, // #0 = $lhs
/* 23253*/  OPC_RecordChild1, // #1 = $rhs
/* 23254*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23265
/* 23257*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23258*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23265*/  /*SwitchType*/ 8, MVT::v8i16,// ->23275
/* 23267*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23268*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23275*/  /*SwitchType*/ 8, MVT::v4i32,// ->23285
/* 23277*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23278*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23285*/  0, // EndSwitchType
/* 23286*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->23301
/* 23289*/  OPC_RecordChild0, // #0 = $vec
/* 23290*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23292*/  OPC_CheckType, MVT::v4i32,
/* 23294*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23295*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 23301*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->23316
/* 23304*/  OPC_RecordChild0, // #0 = $vec
/* 23305*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23307*/  OPC_CheckType, MVT::v4i32,
/* 23309*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23310*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 23316*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->23355
/* 23319*/  OPC_RecordChild0, // #0 = $vec
/* 23320*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23332
/* 23323*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23325*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23326*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23332*/  /*SwitchType*/ 9, MVT::v4i32,// ->23343
/* 23334*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23336*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23337*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23343*/  /*SwitchType*/ 9, MVT::v2i64,// ->23354
/* 23345*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23347*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23348*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23354*/  0, // EndSwitchType
/* 23355*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->23394
/* 23358*/  OPC_RecordChild0, // #0 = $vec
/* 23359*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23371
/* 23362*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23364*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23365*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23371*/  /*SwitchType*/ 9, MVT::v4i32,// ->23382
/* 23373*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23375*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23376*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23382*/  /*SwitchType*/ 9, MVT::v2i64,// ->23393
/* 23384*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23386*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23387*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23393*/  0, // EndSwitchType
/* 23394*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->23433
/* 23397*/  OPC_RecordChild0, // #0 = $vec
/* 23398*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23410
/* 23401*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23403*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23404*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23410*/  /*SwitchType*/ 9, MVT::v4i32,// ->23421
/* 23412*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23414*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23415*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23421*/  /*SwitchType*/ 9, MVT::v2i64,// ->23432
/* 23423*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23425*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23426*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23432*/  0, // EndSwitchType
/* 23433*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->23472
/* 23436*/  OPC_RecordChild0, // #0 = $vec
/* 23437*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23449
/* 23440*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23442*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23443*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23449*/  /*SwitchType*/ 9, MVT::v4i32,// ->23460
/* 23451*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23453*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23454*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23460*/  /*SwitchType*/ 9, MVT::v2i64,// ->23471
/* 23462*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23464*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23465*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23471*/  0, // EndSwitchType
/* 23472*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->23506
/* 23475*/  OPC_RecordChild0, // #0 = $left
/* 23476*/  OPC_SwitchType /*2 cases */, 12, MVT::v16i8,// ->23491
/* 23479*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23481*/   OPC_RecordChild1, // #1 = $right
/* 23482*/   OPC_CheckChild1Type, MVT::v8i16,
/* 23484*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 23491*/  /*SwitchType*/ 12, MVT::v8i16,// ->23505
/* 23493*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23495*/   OPC_RecordChild1, // #1 = $right
/* 23496*/   OPC_CheckChild1Type, MVT::v4i32,
/* 23498*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 23505*/  0, // EndSwitchType
/* 23506*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->23521
/* 23509*/  OPC_RecordChild0, // #0 = $vec
/* 23510*/  OPC_CheckChild0Type, MVT::v4i32,
/* 23512*/  OPC_CheckType, MVT::v2f64,
/* 23514*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23515*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 23521*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->23536
/* 23524*/  OPC_RecordChild0, // #0 = $vec
/* 23525*/  OPC_CheckChild0Type, MVT::v4i32,
/* 23527*/  OPC_CheckType, MVT::v2f64,
/* 23529*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23530*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 23536*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->23551
/* 23539*/  OPC_RecordChild0, // #0 = $vec
/* 23540*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23542*/  OPC_CheckType, MVT::v4f32,
/* 23544*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23545*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                MVT::v4f32, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 23551*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->23566
/* 23554*/  OPC_RecordChild0, // #0 = $vec
/* 23555*/  OPC_CheckChild0Type, MVT::v4f32,
/* 23557*/  OPC_CheckType, MVT::v2f64,
/* 23559*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23560*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 23566*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 23568 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 342
  // #OPC_RecordNode                           = 285
  // #OPC_RecordChild                          = 741
  // #OPC_RecordMemRef                         = 41
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 295
  // #OPC_MoveSibling                          = 285
  // #OPC_MoveParent                           = 581
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 147
  // #OPC_CheckPatternPredicate                = 716
  // #OPC_CheckPredicate                       = 532
  // #OPC_CheckOpcode                          = 504
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 526
  // #OPC_SwitchType                           = 178
  // #OPC_CheckChildType                       = 456
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 106
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 153
  // #OPC_CheckValueType                       = 15
  // #OPC_CheckComplexPat                      = 322
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 5
  // #OPC_EmitInteger                          = 348
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 311
  // #OPC_EmitMergeInputChains                 = 431
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 32
  // #OPC_MorphNodeTo                          = 1214

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 2: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 3: return (!Subtarget->hasAddr64());
  case 4: return (Subtarget->hasAddr64());
  case 5: return (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128());
  case 6: return (Subtarget->hasReferenceTypes());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemory());
  case 13: return (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128());
  case 14: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 16: return (Subtarget->hasHalfPrecision());
  case 17: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 18: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 19: return (Subtarget->hasExceptionHandling());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_i8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_i8
    // Predicate_atomic_load_and_i8
    // Predicate_atomic_load_or_i8
    // Predicate_atomic_load_sub_i8
    // Predicate_atomic_load_xor_i8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_i8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_i16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_i16
    // Predicate_atomic_load_and_i16
    // Predicate_atomic_load_or_i16
    // Predicate_atomic_load_sub_i16
    // Predicate_atomic_load_xor_i16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_i16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_i32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_i32
    // Predicate_atomic_load_and_i32
    // Predicate_atomic_load_or_i32
    // Predicate_atomic_load_sub_i32
    // Predicate_atomic_load_xor_i32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_i32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_atomic_cmp_swap_i64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_i64
    // Predicate_atomic_load_and_i64
    // Predicate_atomic_load_or_i64
    // Predicate_atomic_load_sub_i64
    // Predicate_atomic_load_xor_i64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_i64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 7: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 8: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 9: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 12: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 13: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 14: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 15: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 16: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 17: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 18: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
